﻿<%@ Control Language="C#" AutoEventWireup="true" Inherits="Bitrix.UI.Wizards.BXWizardStepStandardHtmlControl" %>
<%@ Import Namespace="Bitrix.UI.Wizards" %>

<script runat="server">
	protected override void OnWizardInit()
	{
		if (Bitrix.Install.BXInstaller.CheckKey("")) 
		{
			Bitrix.DataTypes.BXParamsBag<object> bag = new Bitrix.DataTypes.BXParamsBag<object>();
			WizardContext.State["LicenseKey"] = bag;
			bag["Key"] = "DEMO";
		}
	}
	
	protected override BXWizardResult OnActionShow(Bitrix.DataTypes.BXCommonBag parameters)
	{
		WizardContext.Navigation.Selected = "licensekey";	
	
		UI.Load("LicenseKey");
		BXWizardResultView view = Result.Render(GetMessage("Title"));
		view.Buttons.Add("prev", null);
		view.Buttons.Add("next", null);
		return view;
	}

	protected override BXWizardResult OnActionNext(Bitrix.DataTypes.BXCommonBag parameters)
	{
		UI.LoadValues(parameters);
		System.Collections.Generic.List<string> errors = new System.Collections.Generic.List<string>();
		if (!Validate(errors))
		{
			BXWizardResultView view = Result.Render(GetMessage("Title"), errors);
			view.Buttons.Add("prev", null);
			view.Buttons.Add("next", null);
			return view;
		}

		UI.Overwrite("LicenseKey");
		WizardContext.State["Install.LicenseKey"] = UI.Data.GetString("Key");
		return Result.Next();
	}
	
	protected override BXWizardResult OnActionPrevious(Bitrix.DataTypes.BXCommonBag parameters)
	{
		return Result.Previous();
	}

	private bool Validate(System.Collections.Generic.List<string> errors)
	{
		if (!Bitrix.Install.BXInstaller.CheckKey(UI.Data.GetString("Key") ?? ""))
		{
			errors.Add(GetMessage("Error.IncorrectLicenseKey"));
			return false;
		}
		return true;
	}
</script>
<table border="0" class="data-table">
	<tr>
		<td colspan="2" class="header"><%= GetMessage("Header.LicenseKey") %></td>
	</tr>
	<tr>
		<td nowrap align="right" width="40%" valign="top"><% if (!Bitrix.Install.BXInstaller.CheckKey("")) { %><span style="color: red">*</span><% } %><%= GetMessage("Label.LicenseKey") %>:</td>
		<td width="60%" valign="top">
			<% UI.InputText("Key", null); %>
			<br/>
			<% if (!Bitrix.Install.BXInstaller.CheckKey("")) { %>
			<small><%= GetMessage("Hint.LicenseKey") %></small>
			<% } %>
		</td>
	</tr>
</table>
