﻿<%@ Control Language="C#" AutoEventWireup="false"  CodeFile="product_settings.ascx.cs" Inherits="Bitrix.Wizards.Solutions.ProductSettings" %>
<div>
    <table id="propertyTab" cellpadding="0" cellspacing="0">
        <tbody>
            <tr style="background-color: rgb(240, 240, 240); font-weight: bold;">
                <th style="width:40%;padding:5px 0px;"><%= GetMessage("PropName") %></th>
                <th style="width:20%;padding:5px 0px;"><%= GetMessage("PropType") %></th>
                <th style="width:40%;padding:5px 0px;"><%= GetMessage("PropValues") %></th>
                <th style="padding:5px 0px;"></th>
            </tr>
            <tr id="firstPropContainer" valign="top">
                <td style="padding:6px 4px 6px 0;">
                    <input id="firstPropName" type="text" style="width:100%;" />
                </td>
                <td style="padding:6px 4px 6px 0;">
                    <select id="firstPropType" style="width:100%;">
                        <option value="single"><%= GetMessage("PropTypeString") %></option>
                        <option value="list"><%= GetMessage("PropTypeList") %></option>
                        <option value="flag"><%= GetMessage("PropTypeFlags") %></option>
                    </select>
                </td>
                <td id="firstPropValueContainer" style="padding:6px 4px 6px 0;">
                    <input type="text" id="firstPropValue" style="width:100%;" />
                    <br/>
                    <a id="firstPropAddValueButton" href="javascript:void(0);" ><%= GetMessage("AddPropValue") %></a>
                </td>
                <td style="padding:6px 0;">
					<img id="firstPropDelButton" alt="<%= GetMessage("RemoveProp") %>" style="cursor:pointer;" alt="<%= GetMessage("RemoveValue") %>" src="<%= VirtualPathUtility.ToAbsolute("~/bitrix/modules/Bitrix.CommerceSite/catalog_wizard/images/delete.gif") %>" />
                </td>
            </tr>
        </tbody>
    </table>
    <a href="javascript:void(0);" id="addPropBtn" ><%= GetMessage("AddProp") %></a>
	<% UI.InputHidden("PropertyData", new KeyValuePair<string, string>[] { new KeyValuePair<string, string>("id", "propertyData") }); %>
</div>
<script type="text/javascript">
    if (typeof (Bitrix) == "undefined") Bitrix = {};
    Bitrix.CatalogWizardProductSettingsEditor = function Bitrix$CatalogWizardProductSettingsEditor() {
        this._props = [];
    }

    Bitrix.CatalogWizardProductSettingsEditor.prototype = {
    	initialize: function () {
    		var addBtn = document.getElementById("addPropBtn");
    		if (!addBtn) return;
    		Bitrix.EventUtility.addEventListener(addBtn, "click", Bitrix.TypeUtility.createDelegate(this, this._handleAddButtonClick));

    		var firstProp = Bitrix.CatalogWizardProductPropertyEditor.create({ "name": document.getElementById("firstPropName"), "typeList": document.getElementById("firstPropType"), "valueContainer": document.getElementById("firstPropValueContainer"), "values": [document.getElementById("firstPropValue")], "addButton": document.getElementById("firstPropAddValueButton"), "delButton": document.getElementById("firstPropDelButton"), "container": document.getElementById("firstPropContainer") });
    		this._props.push(firstProp);
			
    		WizardSubmitSubscribers["ProductSettings"] = Bitrix.TypeUtility.createDelegate(this, this._handleSubmit);
    	},
    	_handleAddButtonClick: function () {
    		var prop = Bitrix.CatalogWizardProductPropertyEditor.create();
    		this._props.push(prop);
    		return false;
    	},
    	handlePropertyDeletion: function(prop) {
    		for (var i = 0; i < this._props.length; i++) {
    			if(this._props[i] != prop) continue;
    			this._props.splice(i, 1);
    			break;
    		}
    	},
    	_handleSubmit: function () {
			try
			{
				var data = document.getElementById("propertyData");
				if (!data) return;
				var r = "";
				for (var i = 0; i < this._props.length; i++) {
					var s = this._props[i].toJson();
					if (s.length == 0) continue;
					if (r.length > 0) r += ",";
					r += s;
				}
				data.value = "[" + r + "]";
			}
			catch(e)
			{
				alert(e);
			}
    	}
    }

    Bitrix.CatalogWizardProductSettingsEditor._instance = null;
    Bitrix.CatalogWizardProductSettingsEditor.getInstance = function () { return this.instantiate(); }
    Bitrix.CatalogWizardProductSettingsEditor.instantiate = function () {
        if (!this._instance) {
            this._instance = new Bitrix.CatalogWizardProductSettingsEditor();
            this._instance.initialize();
        }
        return this._instance;        
    }

    Bitrix.CatalogWizardProductPropertyEditor = function Bitrix$CatalogWizardProductPropertyEditor() {
        this._container = this._nameTbx = this._typeLst = this._addBtn = this._valueCont = this._delBtn = null;
        this._values = [];
    }
    Bitrix.CatalogWizardProductPropertyEditor.prototype = {
    	initialize: function(elements) {

    		if (elements) {
    			this._container = elements["container"];
    			this._nameTbx = elements["name"];
    			this._typeLst = elements["typeList"];
    			this._valueCont = elements["valueContainer"];
    			this._values = elements["values"];
    			this._addBtn = elements["addButton"];
    			this._delBtn = elements["delButton"];
				Bitrix.EventUtility.addEventListener(this._delBtn, "click", Bitrix.TypeUtility.createDelegate(this, this._handlePropertyDelete));			
    			Bitrix.EventUtility.addEventListener(this._addBtn, "click", Bitrix.TypeUtility.createDelegate(this, this._handleAddButtonClick));
    			Bitrix.DomHelper.selectOption(this._typeLst, "single");
    			Bitrix.EventUtility.addEventListener(this._typeLst, "change", Bitrix.TypeUtility.createDelegate(this, this._handleTypeChange));
    			this._addBtn.style.display = "none";
    			for (var i = 0; i < this._values.length; i++)
    				this._values[i].style.display = "none";
    			return;
    		}

    		var tbl = document.getElementById("propertyTab");
    		var r = this._container = tbl.insertRow(-1);
    		r.vAlign = "top";

    		var cName = r.insertCell(-1);
    		cName.style.padding = "6px 4px 6px 0";
    		var name = this._nameTbx = document.createElement("INPUT");
    		name.type = "text";
    		name.style.width="100%";
    		cName.appendChild(name);

    		var cType = r.insertCell(-1);
    		cType.style.padding = "6px 4px 6px 0";
    		var type = this._typeLst = document.createElement("SELECT");
    		type.style.width="100%";
    		Bitrix.DomHelper.addToSelect(type, [{ "value": "single", "text": "<%= GetMessage("PropTypeString") %>" }, { "value": "list", "text": "<%= GetMessage("PropTypeList") %>" }, { "value": "flag", "text": "<%= GetMessage("PropTypeFlags") %>"}]);
    		Bitrix.DomHelper.selectOption(type, "single");
    		Bitrix.EventUtility.addEventListener(type, "change", Bitrix.TypeUtility.createDelegate(this, this._handleTypeChange));

    		cType.appendChild(type);

    		var cValues = this._valueCont = r.insertCell(-1);
    		cValues.style.padding = "6px 4px 6px 0";
    		var val = document.createElement("INPUT");
    		this._values.push(val);
    		val.type = "text";
    		val.style.width="100%";
    		val.style.display = "none";
    		cValues.appendChild(val);

    		cValues.appendChild(document.createElement("BR"));
    		var addBtn = this._addBtn = document.createElement("A");
    		addBtn.href = "javascript:void(0);";
    		addBtn.innerHTML = "<%= GetMessage("AddPropValue") %>";
    		addBtn.style.display = "none";
    		cValues.appendChild(addBtn);
    		Bitrix.EventUtility.addEventListener(addBtn, "click", Bitrix.TypeUtility.createDelegate(this, this._handleAddButtonClick));

    		var cAct = r.insertCell(-1);
    		cAct.style.padding = "6px 0";
    		var delBtn = this._delBtn = document.createElement("IMG");
    		cAct.appendChild(delBtn);
    		delBtn.src = "<%= VirtualPathUtility.ToAbsolute("~/bitrix/modules/Bitrix.CommerceSite/catalog_wizard/images/delete.gif") %>";
    		delBtn.alt = "<%= GetMessage("RemoveProp") %>";
    		delBtn.style.cursor = "pointer";
			Bitrix.EventUtility.addEventListener(delBtn, "click", Bitrix.TypeUtility.createDelegate(this, this._handlePropertyDelete));
    	},
    	_handleAddButtonClick: function() {
    		var val = document.createElement("INPUT");
    		val.style.width="100%";
    		this._values.push(val);
    		this._valueCont.insertBefore(val, this._addBtn);
    		this._valueCont.insertBefore(document.createElement("BR"), this._addBtn);
    		return false;
    	},
    	_handleTypeChange: function() {
    		var type = this._typeLst;
    		var showValues = type.value != "single";
    		this._addBtn.style.display = showValues ? "" : "none";
    		for (var i = 0; i < this._values.length; i++)
    			this._values[i].style.display = showValues ? "" : "none";
    	},
    	_handlePropertyDelete: function() {
    		Bitrix.CatalogWizardProductSettingsEditor.getInstance().handlePropertyDeletion(this);
    		var tbl = document.getElementById("propertyTab");
    		tbl.deleteRow(this._container.rowIndex);	
    	},
    	toJson: function() {
    		if (!this._nameTbx || !Bitrix.TypeUtility.isNotEmptyString(this._nameTbx.value)) return "";
    		var r = "";
    		r += "\"name\":\"" + Bitrix.HttpUtility.jsonEncode(this._nameTbx.value) + "\"";
    		var type = Bitrix.TypeUtility.isNotEmptyString(this._typeLst.value) ? this._typeLst.value : "single";
    		r += ",\"type\":\"" + type + "\"";
    		if(type != "single") {
    			var values = "";
    			for (var i = 0; i < this._values.length; i++) {
    				var v = this._values[i];
    				if (!Bitrix.TypeUtility.isNotEmptyString(v.value)) continue;
    				if (values.length > 0) values += ",";
    				values += "\"" + Bitrix.HttpUtility.jsonEncode(v.value) + "\"";
    			}
    			if (values.length > 0) r += ", \"values\":[" + values + "]";
    		}
    		return "{" + r + "}";
    	}
    }

    Bitrix.CatalogWizardProductPropertyEditor.create = function (elements) {
        var self = new Bitrix.CatalogWizardProductPropertyEditor();
        self.initialize(elements);
        return self;
    }

   Bitrix.CatalogWizardProductSettingsEditor.instantiate();
</script>
							