﻿<%@ Page Language="C#" %>
<%@ Reference VirtualPath="controls/Main/AdminWizardHost.ascx" %>
<%@ Register Src="controls/Main/AdminWizard.ascx" TagName="Wizard" TagPrefix="bx" %>
<bx:Wizard ID="Wizard" runat="server" WizardPath="~/bitrix/modules/Bitrix.CommerceSite/catalog_wizard"  OnInitState="Installer_InitState" />
<script runat="server">
	protected override void OnPreInit(EventArgs e)
	{
		base.OnPreInit(e);
		if (!Bitrix.Security.BXPrincipal.Current.IsCanOperate(Bitrix.Security.BXRoleOperation.Operations.ProductSettingsManage)
			|| !Bitrix.Security.BXPrincipal.Current.IsCanOperate(Bitrix.Security.BXRoleOperation.Operations.SystemMaintenance))
		{
			Bitrix.Security.BXAuthentication.AuthenticationRequired();
			return;
		}
			
		Wizard.Locale = Bitrix.Services.BXLoc.CurrentLocale;
		Wizard.Url = Request.Url.PathAndQuery;
	}
	
	protected override void OnPreRender(EventArgs e)
	{
		base.OnPreRender(e);
		
		Response.Cache.SetExpires(DateTime.UtcNow.AddDays(-1));
		Response.Cache.SetValidUntilExpires(false); 
		Response.Cache.SetRevalidation(HttpCacheRevalidation.AllCaches);
		Response.Cache.SetCacheability(HttpCacheability.NoCache);
		Response.Cache.SetNoStore();
	}
	
	void Installer_InitState(object sender, Bitrix.UI.AdminWizardHostInitStateEventArgs e)
	{
		string siteId = Request.QueryString["site"];
		if (!string.IsNullOrEmpty(siteId))
		    e.State["Installer.SiteId"] = siteId;				
		e.State["Installer.UserId"] = Bitrix.Security.BXIdentity.Current.Id;
	}
</script>