﻿using Bitrix.IO;
using Bitrix.UI.Wizards;
using Bitrix.DataTypes;
using Bitrix.UI;
using System.Web;
using System.Web.UI;
using Bitrix.Services.Text;

namespace Bitrix.Wizards.Solutions
{
    public partial class CommerceSiteClientTypeSettingsStep : BXWizardStepStandardHtmlControl
	{
		protected override void OnWizardInit()
		{
			UI.Load("CommerceSiteClientTypeSettings");

			UI.Data["EnablePhysicalPerson"] = WizardContext.State.GetBool("EnablePhysicalPerson", true);
			UI.Data["EnableJuristicPerson"] = WizardContext.State.GetBool("EnableJuristicPerson", true);

			UI.Overwrite("CommerceSiteClientTypeSettings");
		}

		protected override BXWizardResult OnActionShow(BXCommonBag parameters)
		{
			UI.Load("CommerceSiteClientTypeSettings");

            WizardContext.Navigation.Selected = "client_type_settings";
			BXWizardResultView view = Result.Render(GetMessage("Title"), null);

            view.Buttons.Add("prev", null);
            view.Buttons.Add("next", null);
			return view;
		}

        protected override BXWizardResult OnActionPrevious(BXCommonBag parameters)
        {
            return Result.Previous();
        }

		protected override BXWizardResult OnActionNext(BXCommonBag parameters)
		{
			UI.LoadValues(parameters);

			WizardContext.State["EnablePhysicalPerson"] = UI.Data.GetBool("EnablePhysicalPerson", false);
			WizardContext.State["EnableJuristicPerson"] = UI.Data.GetBool("EnableJuristicPerson", false);

			UI.Overwrite("CommerceSiteClientTypeSettings");
			return Result.Next();
		}
	}
}