﻿using Bitrix.IO;
using Bitrix.UI.Wizards;
using Bitrix.DataTypes;

namespace Bitrix.Wizards.Solutions
{
	public partial class CommerceSiteSefStep : BXWizardStepStandardHtmlControl
	{
		protected override BXWizardResult OnActionShow(Bitrix.DataTypes.BXCommonBag parameters)
		{
			var view = Result.Render(GetMessage("Setup"));
			view.AutoRedirect = true;
			view.RedirectAction = "next";
			return view;
		}

		protected override BXWizardResult OnActionNext(Bitrix.DataTypes.BXCommonBag parameters)
		{
			var siteId = WizardContext.State.GetString("Installer.SiteId");
			Bitrix.Services.BXSefUrlManager.RefreshComponentSefState(siteId);
			UI.SetProgressBarValue("Installer.ProgressBar", "Bitrix.CommerceSite", 6);
			return Result.Next();
		}
	}
}