﻿<%@ Reference Control="~/bitrix/components/bitrix/catalogue.compare.result/component.ascx" %>
<%@ Import Namespace="Bitrix.IBlock.Components" %>
<%@ Control Language="C#" ClassName="template" Inherits="Bitrix.IBlock.Components.CatalogueCompareResultTemplate" %>

    <%if(Component.ElementDataList.Count == 0) {%>
        <div class="notetext">
            <%= string.Format(GetMessageRaw("Message.ListIsEmpty"), Component.GetElementListUrl()) %>
        </div>
        <% return;%>
    <%} %>
<div class="compare-list-result">
	
	<div class="inline-filter compare-filter">
        <%if(Component.DisplayDifferenceOnly) {%>
			<%= string.Format(GetMessageRaw("Header.DifferenceOnly"), HttpUtility.HtmlAttributeEncode(Component.GetDisplayDifferenceOnlyUrl(false))) %>
        <%} %>
        <%else {%>
			<%= string.Format(GetMessageRaw("Header.All"), HttpUtility.HtmlAttributeEncode(Component.GetDisplayDifferenceOnlyUrl(true))) %>
        <%} %>
    </div>    
<% 
	var itemsInRow = 3;
	var itemsCount = 0;  
	if(Component.DisplayFields.Count > 0){ %>
	<div class="compare-props">
		<table cellspacing="0" class="compare-props">
		   <% 
	
		   	foreach (string fieldName in Component.DisplayFields)
		{
			string fieldNameUpper = fieldName.ToUpperInvariant();
			%>
                <% if (!fieldName.StartsWith("-", StringComparison.Ordinal)) continue; %>
                
            <% if (itemsCount % itemsInRow == 0 && itemsCount != 0)
			   { %>
			</tr>  
			<%} %> 
                
                <% itemsCount++; %>
  
            <% if (itemsCount % itemsInRow == 1)
			   { %>
			<tr>  
			<%} %>
			
			<td><input type="checkbox" id="<%=ClientID %>pr-<%= itemsCount.ToString() %>" onclick="SaveState(this);"/><label for="<%=ClientID %>pr-<%= itemsCount.ToString() %>"><%= Component.GetCustomPropertyDisplayName(fieldNameUpper)%></label></td>

			<%} %>
			</tr>												
		</table>
	</div>
	<%} %>
<%
	var elCount = Component.ElementDataList.Count;
	var width = elCount >= 4 ? 25 : Math.Round((decimal)(100 / elCount), 2);
 %>
	<div class="compare-grid">
		<table class="compare-grid" id="<%= ClientID %>_comp_table" cellspacing="0">
		<col />
		<% for ( var i = 0 ; i < elCount; i++){ %>
		<col width="<%=width %>%"/>
		<%} %>
		<thead>
			<tr>
				<td class="compare-property"><%= GetMessage("Column.ProductName") %></td>
				<% foreach (CatalogueCompareResultComponent.ElementData data in Component.ElementDataList) {%>
                <td class="bx-catalogue-compare-result-grid-header">
                    <a class="compare-delete-item" href="<%= data.GetDeleteUrl(false) %>" title="<%= GetMessage("ButtonHint.DeteleItem") %>"></a>
                    <a href="<%= data.DetailUrl %>" title="<%= GetMessage("LinkHint.Go2Item")%>" ><%= data.Name %></a>
                </td>    
                <%} %>
			</tr>
		</thead>
		<tbody>
			  <%
				  var count = 0;
			  	foreach (string fieldName in Component.DisplayFields) {
					count++;
					%>
                <% if(fieldName.StartsWith("-", StringComparison.Ordinal)) continue; %>
                <% string fieldNameUc = fieldName.ToUpperInvariant(); %>
                <tr <%= ( count % 2 == 1 ? "class=\"alt\"":"") %>>
                    <td class="compare-property">
                     <% if (string.Equals(fieldNameUc, "ID", StringComparison.Ordinal)) {%>
                       <%= GetMessage("FieldName.ID")%>
                     <%} %>
                     <% else if (string.Equals(fieldNameUc, "PREVIEWIMAGE", StringComparison.Ordinal)) {%>
                        <%= GetMessage("FieldName.PreviewImage")%>
                     <%} %>                      
                     <% else if (string.Equals(fieldNameUc, "PREVIEWTEXT", StringComparison.Ordinal)) {%>
                        <%= GetMessage("FieldName.PreviewText")%>
                     <%} %>                                          
                     <% else if (string.Equals(fieldNameUc, "DETAILIMAGE", StringComparison.Ordinal)) {%>
                        <%= GetMessage("FieldName.DetailImage")%>
                     <%} %>                      
                     <% else if (string.Equals(fieldNameUc, "DETAILTEXT", StringComparison.Ordinal)) {%>
                        <%= GetMessage("FieldName.DetailText")%>
                     <%} %>                     
                     <% else if (string.Equals(fieldNameUc, "ACTIVEFROMDATE", StringComparison.Ordinal)) {%>
                        <%= GetMessage("FieldName.ActiveFromDate")%>
                     <%} %>                      
                     <% else if (string.Equals(fieldNameUc, "ACTIVETODATE", StringComparison.Ordinal)) {%>
                        <%= GetMessage("FieldName.ActiveToDate")%>
                     <%} %>                                           
                    </td>
                <% foreach (CatalogueCompareResultComponent.ElementData data in Component.ElementDataList){%>
                     <td style="width:<%= width%>">
                     <% if (string.Equals(fieldNameUc, "ID", StringComparison.Ordinal)) {%>
                        <a href="<%= data.DetailUrl %>" title="<%= GetMessage("LinkHint.Go2Item")%>"><%= data.ID %></a>
                     <%} %>
                     <% else if (string.Equals(fieldNameUc, "PREVIEWIMAGE", StringComparison.Ordinal)) {%>
                        <a href="<%= data.DetailUrl %>" title="<%= GetMessage("LinkHint.Go2Item")%>"><img style="border:0 none;" src="<%= data.PreviewImageUrl%>" /></a>
                     <%} %>                      
                     <% else if (string.Equals(fieldNameUc, "PREVIEWTEXT", StringComparison.Ordinal)) {%>
                        <%= data.PreviewText%>
                     <%} %>                                          
                     <% else if (string.Equals(fieldNameUc, "DETAILIMAGE", StringComparison.Ordinal)) {%>
                        <a href="<%= data.DetailUrl %>" title="<%= GetMessage("LinkHint.Go2Item")%>"><img style="border:0 none;" src="<%= data.DetailImageUrl%>" /></a>
                     <%} %>                      
                     <% else if (string.Equals(fieldNameUc, "DETAILTEXT", StringComparison.Ordinal)) {%>
                        <%= data.DetailText%>
                     <%} %>                     
                     <% else if (string.Equals(fieldNameUc, "ACTIVEFROMDATE", StringComparison.Ordinal)) {%>
                        <%= data.ActiveFromDate%>
                     <%} %>                      
                     <% else if (string.Equals(fieldNameUc, "ACTIVETODATE", StringComparison.Ordinal)) {%>
                        <%= data.ActiveToDate%>
                     <%} %>
                     </td>                                   
                <%} %>                
                </tr>
            <%} %>
            <%if(Component.DisplayStockCatalogData && Component.PriceTypes.Count > 0) {%>
                <%foreach(CatalogueCompareResultComponent.CatalogPriceTypeInfo priceTypeInfo in Component.PriceTypeInfos) {
                count++;
					  %>
                <tr <%= ( count % 2 == 1 ? "class=\"alt\"":"") %>>
                    <td class="compare-property">
                        <%= HttpUtility.HtmlEncode(priceTypeInfo.Name) %>
                    </td>
                    <% foreach (CatalogueCompareResultComponent.ElementData data in Component.ElementDataList){%>
                    <td>
                        <% CatalogueCompareResultComponent.CatalogClientPriceInfo priceInfo = data.GetPriceInfoByPriceTypeId(priceTypeInfo.Id); %>
                        <% if(priceInfo != null) {%>
                            <%= priceInfo.SellingPriceHtml %>
                        <%} %>
                        <% else {%>
                            &mdash; 	
                        <%} %>
                    </td>
                    <%} %>                    
                </tr>                    
                <%} %>
            <%} %>
            <%
            	itemsCount = 0;
            	foreach (string fieldName in Component.DisplayFields) {%>
                <% if(!fieldName.StartsWith("-", StringComparison.Ordinal)) continue; %>
                <% count++;  itemsCount++; %>
                <% string fieldNameUc = fieldName.ToUpperInvariant(); %>
                <tr id="<%= ClientID %>tpr-<%= itemsCount %>" <%= ( count % 2 == 1 ? "class=\"alt\"":"") %> style="display:none;">
                    <td class="compare-property">
                        <%= Component.GetCustomPropertyDisplayName(fieldNameUc) %>
                    </td>
                    <% foreach (CatalogueCompareResultComponent.ElementData data in Component.ElementDataList){%>
                    <td style="width:<%= width%>">
                        <% CatalogueCompareResultComponent.ElementCustomPropertyData propertyData = data.GetPropertyData(fieldNameUc); %>
                        <% if(propertyData != null) {%>
                        <%= propertyData.GetHtml() %>
                        <%} %>                    
                    </td>
                    <%} %>
                </tr>
            <%} %>             
		</tbody>
	</table>								
	</div>
	<p>
	<a href="<%= Component.GetDeleteAllElementsUrl(false) %>"><%= GetMessage("DeleteAllElements") %></a>
	</p>
</div>


<script type="text/javascript">

function ReadCookie(cookieName) {
	var theCookie=""+document.cookie;
	var ind=theCookie.indexOf(cookieName);
	if (ind==-1 || cookieName=="") return ""; 
	var ind1=theCookie.indexOf(';',ind);
	if (ind1==-1) ind1=theCookie.length; 
	return unescape(theCookie.substring(ind+cookieName.length+1,ind1));
}

function LoadState() {
	var cookie = ReadCookie("BX_COMPARE_LIST_STATE");
	if (cookie == "") {
		var cbId;
		for ( var k =1; k <= <%= itemsCount %>; k++)
		{
			cbId = "pr-" + k;
			cookie+="," + cbId;
			var cb_ = document.getElementById('<%= ClientID %>'+cbId);
			if ( cb_ != null )
				cb_.checked = "checked";
		}
		document.cookie = "BX_COMPARE_LIST_STATE" + "=" + cookie + "; path=/";
		var table = document.getElementById('<%= ClientID %>_comp_table');
		if(table)
		{
			var trs = table.getElementsByTagName('TR');
			for ( var i =0; i < trs.length; i++){
				trs[i].style.display="";
			}
		}
		return;
	}
	var ids = cookie.split(",");

	for ( var i = 0;i < ids.length; i++)
	{
		var cb = document.getElementById('<%= ClientID %>'+ids[i]);
		if (cb == null)
			continue;
		var tr = document.getElementById('<%= ClientID %>'+'t'+ids[i]);
		if(tr!=null)
			tr.style.display="";
		cb.checked = "checked";
	}
	
	InitClasses();
}

function SaveState(sender) {
	var cookie = ReadCookie("BX_COMPARE_LIST_STATE");
	var sId = sender.id.replace('<%= ClientID %>','');
	var tr = document.getElementById('<%= ClientID %>'+'t'+sId);
	if (sender.checked) {
		
		if(tr!=null)
			tr.style.display = "";
		cookie += "," + sId;
	}
	else {
		var index = cookie.indexOf(sId);
		if (index != -1)
			cookie = cookie.replace(sId, "").replace(",,", ",");
			
		if(tr!=null)
			tr.style.display = "none";
	}
	
	document.cookie = "BX_COMPARE_LIST_STATE"+ "=" + cookie + "; path=/";
	
	InitClasses();
}

function InitClasses()
{
	var table = document.getElementById('<%= ClientID %>_comp_table');
	if(table){

		var items = table.getElementsByTagName('tr');
		var k = 0;
		for ( var i =0; i < items.length; i++){
			if(items[i].style.display=="" || items[i].style.display==undefined){
			items[i].className = k % 2 == 1 ? "":"alt";
			k++;
			}
		}
	}
}

$(document).ready(LoadState);

</script>