﻿<%@ Reference Control="~/bitrix/components/bitrix/catalogue.element.detail/component.ascx" %>
<%@ Control Language="C#" AutoEventWireup="true" Inherits="Bitrix.IBlock.Components.CatalogueElementDetailTemplate" %>
<%@ Import Namespace="Bitrix.IBlock.Components" %>
<%@ Import Namespace="Bitrix.UI" %>
<%@ Import Namespace="Bitrix.Services" %>

<script runat="server">	
	protected override void OnLoad(EventArgs e)
	{
		var prop = Component.Properties != null ? Component.Properties.Find(x => x.Code == "NEWPRODUCT") : null;
		var isNewProduct = prop != null && !String.IsNullOrEmpty(prop.DisplayValue) && prop.Values.Count == 1 ? (bool)prop.Values[0] : false;

		prop = Component.Properties != null ? Component.Properties.Find(x => x.Code == "SALELEADER") : null;
		var isLeader = prop != null && !String.IsNullOrEmpty(prop.DisplayValue) && prop.Values.Count == 1 ? (bool)prop.Values[0] : false;

		prop = Component.Properties != null ? Component.Properties.Find(x => x.Code == "SPECIALOFFER") : null;
		var isOffer = prop != null && !String.IsNullOrEmpty(prop.DisplayValue) && prop.Values.Count == 1 ? (bool)prop.Values[0] : false;

		string addition = string.Empty;
		if (isNewProduct)
			addition += "&nbsp;<span class=\"sticker\">" + GetMessage("NewProduct") +"</span>";
		if (isLeader)
			addition += "&nbsp;<span class=\"sticker\">" + GetMessage("SaleLeader") + "</span>";
		if (isOffer)
			addition += "&nbsp;<span class=\"sticker\">" + GetMessage("SpecialOffer") + "</span>";

		Page.Items["BXPublicPageTitleAddition"] = addition;
	}

</script>

<%
if (!String.IsNullOrEmpty(Component.errorMessage))
{ 
	%><span class="errortext"><%=Component.errorMessage%></span><%
}
else if (Component.Element != null)
{
	string title = Parameters.Get("Template_BackTitle");
	string url = Parameters.Get("Template_BackUrlTemplate");
	bool link = false;
	if (!string.IsNullOrEmpty(title) && !string.IsNullOrEmpty(url))
	{
		Bitrix.DataTypes.BXParamsBag<object> replace = new Bitrix.DataTypes.BXParamsBag<object>();
		
		replace["ElementId"] = replace["ELEMENT_ID"] = Component.ElementId;
		replace["ElementCode"] = replace["ELEMENT_CODE"] = Component.ElementCode;
		
		int sectionId = Parameters.GetInt("SectionId");
		if (sectionId == 0 && Component.Element != null &&  Component.Element.Sections.Count != 0)
			sectionId = Component.Element.Sections[0].SectionId;
		replace["SectionId"] = replace["SECTION_ID"] = sectionId;
		
		replace["SectionCode"] = replace["SECTION_CODE"] = Parameters.GetString("SectionCode", "");
		url = Component.ResolveTemplateUrl(url, replace);
		link = true;
	}
%>

<%
	
	CatalogDiscountInfo discount = Component.GetDiscountByPriceInfo(null);
		
	var photosProp = Component.Properties != null ? Component.Properties.Find(x => x.Code == "MORE_PHOTO") : null;

	var files = new Bitrix.IO.BXFileCollection();

	if (photosProp != null && photosProp.Property!=null && photosProp.Property.Values!=null)
	{
		files = Bitrix.IO.BXFile.GetList(
			new Bitrix.DataLayer.BXFilter(
				new Bitrix.DataLayer.BXFilterItem(
					Bitrix.IO.BXFile.Fields.Id, 
					Bitrix.DataLayer.BXSqlFilterOperators.In, 
					photosProp.Property.Values)
				), 
			null);
	}
	
	var detailImage = Component.Element.DetailImage;	
	if(detailImage == null)
		detailImage = files.Count > 0 ? files[0] : null;

	var resizedDetailImage = detailImage != null ? Bitrix.Services.Image.BXImageUtility.GetResizedImage(detailImage, 350, 1000) : null;

	var resizedDetailPath = resizedDetailImage!=null ? Bitrix.IO.BXPath.ToUri(resizedDetailImage.FilePath, false) : String.Empty;
	
	Dictionary<string, string> smallPhotos = new Dictionary<string,string>();
	
	Bitrix.Services.Image.BXImageInfo resizedImage;

	if (files.Count > 1)
		for (var k = 0; k < files.Count; k++ )
		{
			resizedImage = Bitrix.Services.Image.BXImageUtility.GetResizedImage(files[k], 50, 50);
			if (resizedImage != null)
				smallPhotos[files[k].FilePath] = Bitrix.IO.BXPath.ToUri(resizedImage.FilePath, false);
		}

 %>

<div class="catalog-detail">
	
	<table class="catalog-detail" cellspacing="0">
		<tr>				
		<% if (resizedDetailImage!=null){ %>
			<td class="catalog-detail-image">
				<div class="catalog-detail-image" id="catalog-detail-main-image"><a rel="catalog-detail-images" 
					href="<%=detailImage.FilePath %>" title="<%= Component.Element.Name %>">
					<img src="<%=resizedDetailPath %>" width="<%=resizedDetailImage.Width %>" height="<%=resizedDetailImage.Height %>" /></a>
				</div>

				<% if (smallPhotos.Count > 0) { %>
				<div class="catalog-detail-images">
					<% foreach (var pair in smallPhotos){ %>
					<div class="catalog-detail-image"><a rel="catalog-detail-images" href="<%= pair.Key %>" title="<%= Component.Element.Name %>">
					<img src="<%= pair.Value %>" /></a></div>
					<%} %>
				</div>
				<%} %>
		<%} %>

				
			</td>
			<td class="catalog-detail-desc">
				
				<% 
	if (Component.Element.PreviewText.Length > 0) {%>
				<%= Component.Element.PreviewText%>
				<div class="catalog-detail-line"></div>
				<%} %>
				<% if (Component.CurrentSellingPrice != null) {  %>
				<div class="catalog-detail-price">
					<label><%= GetMessage("YourPrice")%>:</label>
					<%if(discount !=null && discount.HasInfo){ %>
						 <p><%= discount.DisplayHtml %>&nbsp;
						 <s><%=Component.CurrentSellingPrice.SellingPriceHtml %></s></p>
                    <%} else { %>
                     <p><%= Component.CurrentSellingPrice.SellingPriceHtml%></p>
                    <%} %>
					
				</div>
				<%} %>
				<div class="catalog-detail-buttons">
				<% if (Component.IsInStock) { %>
					<a href="" <%=(Component.IsInCart ? "class=\"disabled\" style=\"cursor:default;\" ":"") %> 
					title="<%=(Component.IsInCart ? GetMessage("AlreadyInCart") : GetMessage("Add2CartBtnText")) %>" id="<%= GetItemControlClientId("Add2CartBtn") %>"><span><%=(Component.IsInCart ? GetMessage("AlreadyInCart") : GetMessage("Add2CartBtnText"))%></span></a>
				<% } %>
				</div>
				
				<div class="catalog-item-links">
				<% if (!Component.IsInStock){ %>
					<span class="catalog-item-not-available"><%= GetMessage("NotAvailable") %></span>
				<%} %>
				</div>
				
			</td>
		</tr>
	</table>
	<% if ((Component.Properties != null && Component.Properties.Count > 0) || Component.CatalogItemProperties.Count > 0)
	{%>
	<div class="catalog-detail-properties">
	 
		<h4><%= GetMessage("Parameters") %></h4>
		<div class="catalog-detail-line"></div>
	
	  <% foreach (CatalogueElementDetailComponent.ElementDetailProperty property in Component.Properties)
	  {
		  var exists = Component.ShowProperties.Find(x => x.Equals(property.Code, StringComparison.OrdinalIgnoreCase));
		  if (exists== null)
			  continue;
		  if (property.Code.Equals("MORE_PHOTO", StringComparison.OrdinalIgnoreCase))
			  continue;
		  if (String.IsNullOrEmpty(property.DisplayValue))
			  continue;
		  %>
	  	<div class="catalog-detail-property">
			<span><%= property.Name%></span>
			<b><%= property.DisplayValue%></b>
		</div>
	  <%} %>
	  
	  <% foreach (CatalogueElementDetailComponent.ElementDetailProperty property in Component.CatalogItemProperties)
	  {
		  if (property.Code.Equals("MORE_PHOTO", StringComparison.OrdinalIgnoreCase))
			  continue;
		  
		  if (String.IsNullOrEmpty(property.DisplayValue))
			  continue;
		  %>
	  	<div class="catalog-detail-property">
			<span><%= property.Name%></span>
			<b><%= property.DisplayValue%></b>
		</div>
	  <%} %>	  
	  	    	
	</div>
	<%} %>
	<% if (!String.IsNullOrEmpty(Component.Element.DetailText))
	{ %>
	<div class="catalog-detail-full-desc">
		<h4><%= GetMessage("Description") %></h4>
		<div class="catalog-detail-line"></div>
		<%= Component.Element.DetailText %>						
	</div>							
	<%} %>
	<% if(Component.CanModifyElement) {%>
	<div class="catalog-admin-links">
		<a href="<%= Component.GetElementEditUrl() %>" title="<%= GetMessage("EditProduct") %>"><%= GetMessage("Edit") %></a>
		<a href="#" onclick="Bitrix.CatalogElementPanel.getInstance().processItemDeletion('<%= JSEncode(Component.Element.Name) %>', '<%= JSEncode(Component.GetElementDeleteUrl()) %>'); return false;" title=""><%= GetMessage("Remove") %></a>
	</div>									
	<%} %>		
</div>
<%} %>

<script type="text/javascript">
	$(function() {
		$('div.catalog-detail-image a').fancybox({
			'transitionIn': 'elastic',
			'transitionOut': 'elastic',
			'speedIn': 600,
			'speedOut': 200,
			'overlayShow': false,
			'cyclic' : true ,
			'padding': 20,
			'titlePosition': 'over',
			'onComplete': function() {
				$("#fancybox-title").css({ 'top': '100%', 'bottom': 'auto' });
			} 
		});
	});
</script>

<script type="text/javascript">
	$(function() {
		//Add to cart
		<% if (Component.IsInStock) { %>
		$('#<%= GetItemControlClientId("Add2CartBtn") %>').click(function() {
			<% if (!Component.IsInCart){ %>
			var button = $(this);
			
			button.toggleClass("disabled").unbind('click').css("cursor", "default");
			button.click(function() { return false; });
//							$.get(
//								button.get(0).href,
//								$.proxy(
//									function(data) {
						button.removeAttr("href").html("<span><%= GetMessage("AlreadyInCart") %></span>");

						var sourceImage = $("#catalog-detail-main-image img");
						if (!sourceImage.length){
							var cartStatus = $("#cart-status a");
							var products = cartStatus.find("span");
							var productsCnt = products.text();

							if (productsCnt)
								products.html(++productsCnt);
							else
								cartStatus.html("<%= GetMessageRaw("YourCartSingleItem") %>");
							return;
						}

						<% if(Component.CanModifyElement) {%>
						var wrapper = button.parents("div.catalog-detail");
						wrapper.unbind("mouseenter").unbind("mouseleave").removeClass("catalog-detail-hover");
						<%} %>
						var position = sourceImage.position();
						var flyImage = sourceImage.clone().insertBefore(sourceImage);

						flyImage.css({ "position": "absolute", "left": position.left, "top": position.top });
						flyImage.animate({ width: 0, height: 0, left: 948, top: -58 }, 500, 'linear');
						flyImage.queue(function() {
							$(this).remove();

							var cartStatus = $("#cart-status a");
							var products = cartStatus.find("span");
							var productsCnt = products.text();

							if (productsCnt)
								products.html(++productsCnt);
							else
								cartStatus.html("<%= GetMessageRaw("YourCartSingleItem") %>");
							
							<% if(Component.CanModifyElement) {%>
							wrapper.addClass("catalog-detail-hover").hover(
								function() { wrapper.removeClass("catalog-detail-hover").addClass("catalog-detail-hover"); },
								function() { wrapper.removeClass("catalog-detail-hover"); }
							);
							<%} %>
						});
//									},
//									button
//								)
//							);
		<%} %>
			return false;
		});
		
		<% } %>
		
		//Add to comparation
		$("a.catalog-item-compare").click(function() {

			var button = $(this);
			var href = button.attr("href");
			button.removeClass("catalog-item-compare").addClass("catalog-item-compared").unbind('click').removeAttr("href").css("cursor", "default");

//							$.get(
//								href,
//								$.proxy(
//									function(data) {
						button.text("<%= GetMessageRaw("ProductAddedToCompareList") %>");

						var compare = $("#compare");
						var compareItems = $("span", compare);
						var compateItemsCnt = compareItems.text();

						compateItemsCnt = compateItemsCnt ? ++compateItemsCnt : 1;
						compareItems.html(compateItemsCnt);

						if (compare.css("display") == "none") {
							compare.css({ "display": "block", "height": "0" });
							compare.animate({ "height": "22px" }, 500);
						}
//									}, button
//								)
//							);

			return false;
		});
		
		<% if(Component.CanModifyElement) {%>
		$("#workarea div.catalog-detail").hover(
			function() { $(this).removeClass("catalog-detail-hover").addClass("catalog-detail-hover"); },
			function() { $(this).removeClass("catalog-detail-hover"); }
		);
		<%} %>


	});
</script>


<script runat="server">


    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        Bitrix.UI.BXPage.Scripts.RequireUtils();
        
        if (!Component.IsSellingAllowed || Component.CurrentSellingPrice == null)
            return;

        ClientScriptManager sm = Page.ClientScript;
        if (sm == null)
            return;        
        
        StringBuilder sb = new StringBuilder();
        sb.Append("elementId:\"").Append(Component.ElementId).Append("\"");
        sb.Append(", userCartUrl:\"").Append(Component.UserCartUrl).Append("\"");
        sb.Append(", isInCart:").Append(Component.IsInCart.ToString().ToLowerInvariant());
        sb.Append(", qtyTbxId:\"").Append(GetItemControlClientId("QtyTbx")).Append("\"");
        sb.Append(", qtyContainerId:\"").Append(GetItemControlClientId("QtyContainer")).Append("\"");
        sb.Append(", add2CartBtnId:\"").Append(GetItemControlClientId("Add2CartBtn")).Append("\"");
        sb.Append(", buyBtnId:\"").Append(GetItemControlClientId("BuyBtn")).Append("\"");
        sb.Append(", inCartLbl:\"").Append(GetItemControlClientId("InCartLbl")).Append("\"");
        sb.Append(", qtyParamName:\"").Append(Component.CatalogItemQuantityParamName).Append("\"");        
        sb.Append(", callBackScript:\"").Append(Component.GetAddToCartUrl(true)).Append("\"");

        sb.Append("}").Insert(0, "{");

        string options = sb.ToString();

        string id = string.Concat(Component.ClientID, "_", Component.ElementId.ToString());
        sb.Length = 0;
        sb.AppendFormat("Bitrix.CatalogueElementDetail.create(\"{0}\", {1});", id, options);
        
        sm.RegisterStartupScript(
            Component.GetType(),
            id,
            sb.ToString(),
            true
            ); 
		 
		BXPage.RegisterScriptInclude("~/bitrix/controls/Main/dialog/js/messages.js.aspx?lang=" + HttpUtility.UrlEncode(BXLoc.CurrentLocale));
		BXPage.RegisterScriptInclude("~/bitrix/controls/Main/dialog/js/dialog_base.js");
		BXPage.RegisterScriptInclude("~/bitrix/controls/Bitrix.CommerceSite/dialogs/dialog_del_confirm.js");
		BXPage.RegisterScriptInclude("~/bitrix/controls/Bitrix.CommerceSite/dialogs/messages.js.aspx?lang=" + HttpUtility.UrlEncode(BXLoc.CurrentLocale));		
		BXPage.RegisterStyle("~/bitrix/controls/Main/dialog/css/dialog_base.css");
		      
    }

	protected override void OnInit(EventArgs e)
	{
		base.OnInit(e);
		Page.Items["CatalogIBlockId"] = Component.IBlockId;

		try
		{
			Page.Items["CatalogCompareUrl"] = VirtualPathUtility.ToAbsolute("~/" + Component.Parameters.GetString("SefFolder", "") + Component.Parameters.GetString("ComparisonResultTemplate", ""));
		}
		catch { }
	}

    protected string GetItemControlClientId(string id)
    {
        return string.Concat(ClientID, ClientIDSeparator, Component.ElementId.ToString(), ClientIDSeparator, id);
    }    
    
	protected override void PreLoadTemplateDefinition(Bitrix.Components.BXParametersDefinition def)
	{
		def["Template_BackTitle"] = new Bitrix.Components.BXParamText(GetMessageRaw("Param.BackTitle"), GetMessageRaw("DefaultBackTitle"), Bitrix.Components.BXCategory.UrlSettings);
		def["Template_BackUrlTemplate"] = new Bitrix.Components.BXParamText(GetMessageRaw("Param.BackUrlTemplate"), "", Bitrix.Components.BXCategory.UrlSettings);
	}           
</script>