﻿<%@ Reference Control="~/bitrix/components/bitrix/catalogue.element.list/component.ascx" %>
<%@ Control Language="C#" AutoEventWireup="true" Inherits="Bitrix.IBlock.Components.CatalogueElementListTemplate" %>
<%@ Import Namespace="Bitrix.UI" %>
<%@ Import Namespace="Bitrix.Services" %>
<%@ Import Namespace="Bitrix.IBlock.Components" %>
<%@ Import Namespace="Bitrix.Configuration" %>

<script runat="server">
	//Template name
	public override string Title
	{
		get { return GetMessageRaw("TemplateTitle");}
	}

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        if (IsComponentDesignMode || Component.isErrorOccured || Component.Items == null)
            return;

        BXPage.Scripts.RequireUtils();
                
        ClientScriptManager sm = Page.ClientScript;
        if (sm == null)
            return;


        foreach (CatalogueElementListComponent.ElementListItem item in Component.Items)
        {
            if (!item.IsSellingAllowed || item.CurrentSellingPrice == null)
                continue;
                
            StringBuilder sb = new StringBuilder();
            sb.Append("elementId:\"").Append(item.ElementId).Append("\"");
            sb.Append(", userCartUrl:\"").Append(Component.UserCartUrl).Append("\"");
            sb.Append(", isInCart:").Append(item.InCart.ToString().ToLowerInvariant());
            sb.Append(", qtyContainerId:\"").Append(GetItemControlClientId(item.ElementId, "QtyContainer")).Append("\"");
            sb.Append(", qtyTbxId:\"").Append(GetItemControlClientId(item.ElementId, "QtyTbx")).Append("\"");
            sb.Append(", add2CartBtnId:\"").Append(GetItemControlClientId(item.ElementId, "Add2CartBtn")).Append("\"");
            sb.Append(", buyBtnId:\"").Append(GetItemControlClientId(item.ElementId, "BuyBtn")).Append("\"");
            sb.Append(", inCartLbl:\"").Append(GetItemControlClientId(item.ElementId, "InCartLbl")).Append("\"");
            sb.Append(", qtyParamName:\"").Append(Component.CatalogItemQuantityParamName).Append("\"");
            sb.Append(", callBackScript:\"").Append(Component.GetAddToCartUrl(item.ElementId, item.ElementDetailUrl, true)).Append("\"");

            sb.Append("}").Insert(0, "{");

            string options = sb.ToString();


            string id = string.Concat(Component.ClientID, "_", item.ElementId.ToString());
            sb.Length = 0;
            sb.AppendFormat("Bitrix.CatalogueElementListItem.create(\"{0}\", {1});", id, options);

            sm.RegisterStartupScript(
                Component.GetType(),
                id,
                sb.ToString(),
                true
                );			
        }
		
		BXPage.RegisterScriptInclude("~/bitrix/controls/Main/dialog/js/messages.js.aspx?lang=" + HttpUtility.UrlEncode(BXLoc.CurrentLocale));
		BXPage.RegisterScriptInclude("~/bitrix/controls/Main/dialog/js/dialog_base.js");
		BXPage.RegisterScriptInclude("~/bitrix/controls/Bitrix.CommerceSite/dialogs/dialog_del_confirm.js");
		BXPage.RegisterScriptInclude("~/bitrix/controls/Bitrix.CommerceSite/dialogs/messages.js.aspx?lang=" + HttpUtility.UrlEncode(BXLoc.CurrentLocale));		
		BXPage.RegisterStyle("~/bitrix/controls/Main/dialog/css/dialog_base.css");		
    }

	protected override void OnInit(EventArgs e)
	{
		base.OnInit(e);
		Page.Items["CatalogIBlockId"] = Component.IBlockId;

		try
		{
			Page.Items["CatalogCompareUrl"] = VirtualPathUtility.ToAbsolute("~/" + Component.Parameters.GetString("SefFolder", "") + Component.Parameters.GetString("ComparisonResultTemplate", ""));
		}
		catch { }
	}

    protected string GetItemControlClientId(int itemId, string id)
    {
        return string.Concat(ClientID, ClientIDSeparator, itemId.ToString(), ClientIDSeparator, id);
    }	
</script>

<%
if (Component.isErrorOccured)
{
	%><span class="errortext"><%= Component.errorMessage%></span><%
	return;
}
else if (Component.Items == null)
   return;
%>

<div class="news-list-pager">
<bx:IncludeComponent runat="server" ID="HeaderPager" ComponentName="bitrix:system.pager" Template="<%$ Parameters:PagingTemplate %>" CurrentPosition="top" />
</div>

<% if(!IsComponentDesignMode && Component.CanModifyElements) {%>
<div class="catalog-admin-buttons">
	<a href="<%= Component.GetElementAddUrl() %>"><span><%= GetMessage("AddProduct") %></span></a>
	<a href="<%= Component.GetSectionAddUrl() %>"><span><%= GetMessage("AddSection") %></span></a>
	<%if(Component.Section != null) {%>
		<a href="<%= Component.GetSectionEditUrl() %>"><span><%= GetMessage("Edit") %></span></a>
		<a href="#" onclick="Bitrix.CatalogElementPanel.getInstance().processItemDeletion('<%= JSEncode(Component.Section.Name) %>', '<%= JSEncode(Component.GetSectionDeleteUrl()) %>', 'SEC'); return false;" title=""><span><%= GetMessage("Remove") %></span></a>	
	<%} %>
</div>
<%} %>
<div class="catalog-item-list">
	<% foreach (CatalogueElementListComponent.ElementListItem listItem in Component.Items)
	{
		Bitrix.IO.BXFile elementImage = listItem.Element.DetailImage;	
		
		if(elementImage == null)
		{
			var photosProp = listItem.Properties.Find(x => x.Code == "MORE_PHOTO");
			if (photosProp != null)
			{
				elementImage = Bitrix.IO.BXFile.GetList(
					new Bitrix.DataLayer.BXFilter(
						new Bitrix.DataLayer.BXFilterItem(
							Bitrix.IO.BXFile.Fields.Id,
							Bitrix.DataLayer.BXSqlFilterOperators.In,
							photosProp.Property.Values)
						),
					null,
					null,
					new Bitrix.DataLayer.BXQueryParams(new Bitrix.DataLayer.BXPagingOptions(0, 1))
				).FirstOrDefault();
			}
		}
		
		if( elementImage == null )
			elementImage = listItem.Element.PreviewImage;

		var image = elementImage != null ?
			Bitrix.Services.Image.BXImageUtility.GetResizedImage(elementImage, 75, 200) : null;
		
		var imagePath = image != null ? Bitrix.IO.BXPath.ToUri( image.FilePath, false) : String.Empty;
		
		var prop = listItem.Properties.Find(x=>x.Code=="NEWPRODUCT");
		var isNewProduct = prop != null && !String.IsNullOrEmpty(prop.DisplayValue) && prop.Values.Count==1 ? (bool)prop.Values[0] : false;

		prop = listItem.Properties.Find(x => x.Code == "SALELEADER");
		var isLeader = prop != null && !String.IsNullOrEmpty(prop.DisplayValue) && prop.Values.Count == 1 ? (bool)prop.Values[0] : false;

		prop = listItem.Properties.Find(x => x.Code == "SPECIALOFFER");
		var isOffer = prop != null && !String.IsNullOrEmpty(prop.DisplayValue) && prop.Values.Count == 1 ? (bool)prop.Values[0] : false;
		%>
	<div class="catalog-item<%= image!=null ? "" : " no-picture-mode" %>">
		<div class="catalog-item-info">
		<% if(image!=null){ %>
			<div class="catalog-item-image"><a href="<%= listItem.ElementDetailUrl %>"><img src="<%=imagePath%>" /></a></div>
			<%} %>
			<div class="catalog-item-desc">
				<div class="catalog-item-title"><a href="<%= listItem.ElementDetailUrl %>"><%= listItem.Element.Name%></a><% if (isOffer){ %>&nbsp;<span class="sticker"><%= GetMessage("SpecialOffer") %></span><%} %>
				<% if (isNewProduct){ %>&nbsp;<span class="sticker"><%= GetMessage("NewPoduct") %></span><%} %><% if (isLeader){ %>&nbsp;<span class="sticker"><%= GetMessage("SaleLeader") %></span><%} %>
	   </div>
				<div class="catalog-item-preview-text"><%= listItem.Element.PreviewText%></div>
				<% if (listItem.IsSellingAllowed && listItem.CurrentSellingPrice != null) {%>
				
	               <% if (listItem.DiscountInfo.HasInfo)
					   { %>
					     <div class="catalog-item-price"><span><%=listItem.DiscountInfo.DisplayHtml%></span>&nbsp;<s><%= listItem.CurrentSellingPrice.SellingPriceHtml %></s></div>
                    <%}
					   else
					   { %>
					     <div class="catalog-item-price"><span><%= listItem.CurrentSellingPrice.SellingPriceHtml %></span></div>
                    <%} %>
				
				
				<%} %>
			</div>
		</div>	
		<% if(!IsComponentDesignMode) 
		{ %>
		<div class="catalog-item-links">
		<% if (listItem.IsSellingAllowed && listItem.CurrentSellingPrice != null && listItem.CanPutInCart)
		{ %>
			<a href="<%= Bitrix.Services.BXSefUrlManager.CurrentUrl.ToString() %>" id="<%= GetItemControlClientId(listItem.ElementId, "Add2CartBtn") %>" <%=( listItem.InCart ? "style=\"cursor:default;\"":"")%> class="<%=( listItem.InCart ? "catalog-item-in-the-cart" : "catalog-item-buy") %>" 
			title="<%= GetMessage("Add2Cart") %>"><%= (listItem.InCart ? GetMessage("AlreadyInCart") : GetMessage("Add2CartBtnText"))%></a>
			<%}
		else
		{ %>
		<span class="catalog-item-not-available"><%= GetMessage("NotAvailable") %></span>
			<%} %>	
			  <% if ( listItem.InComparisonList ){ %>
				<a class="catalog-item-compared" style="cursor:default" onclick="return false;" href="#"><%= GetMessage("AlreadyInComparison") %></a>
			  <%} else { %>
				<a class="catalog-item-compare" href="<%= listItem.ElementAdd2ComparisonListUrl%>"><%=GetMessage("Add2ComparisonList") %></a>
			  <%} %>
		
		</div>
		<% } %>
		<%if(!IsComponentDesignMode && Component.CanModifyElements) {%>
		<div class="catalog-admin-links">
			<a href="<%= Component.GetElementEditUrl(listItem.ElementId) %>" title="<%= GetMessage("EditProduct") %>"><%= GetMessage("Edit") %></a>
			<a href="#" onclick="Bitrix.CatalogElementPanel.getInstance().processItemDeletion('<%= JSEncode(listItem.Element.Name) %>', '<%= JSEncode(Component.GetElementDeleteUrl(listItem.ElementId)) %>', 'PROD'); return false;" title=""><%= GetMessage("Remove") %></a>
		</div>									
		<%} %>
	</div>
	<div class="catalog-item-separator"></div>	
<%} %>
	
</div>
<div class="news-list-pager">
<bx:IncludeComponent runat="server" ID="IncludeComponent1" ComponentName="bitrix:system.pager" CurrentPosition="bottom" Template="<%$ Parameters:PagingTemplate %>"/>
</div>
<% if(!IsComponentDesignMode) 
{%>
<script type="text/javascript">
	$(function() {

		$("#workarea a.catalog-item-in-the-cart").click(function() { return false; });
		//Add to cart
		$("#workarea a.catalog-item-buy").click(function() {

			var button = $(this);
			button.removeClass("catalog-item-buy").addClass("catalog-item-in-the-cart").unbind('click').css("cursor", "default");
			button.click(function() { return false; });

			button.removeAttr("href").html("<%= GetMessage("ProductAlreadyInCart") %>");

			var sourceImage = button.parent().parent().find("img");
			if (!sourceImage.length) {
				var cartStatus = $("#cart-status a");
				var products = cartStatus.find("span");
				var productsCnt = products.text();

				if (productsCnt)
					products.html(++productsCnt);
				else
					cartStatus.html("<%= GetMessageRaw("YourCartSingleItem") %>");
				return;
			}

			<% if(Component.CanModifyElements) {%>
			var wrapper = button.parents("div.catalog-item");
			wrapper.unbind("mouseenter").unbind("mouseleave").removeClass("catalog-item-hover");
			<%} %>
			var position = sourceImage.position();
			var flyImage = sourceImage.clone().insertBefore(sourceImage);

			flyImage.css({ "position": "absolute", "left": position.left, "top": position.top });
			flyImage.animate({ width: 0, height: 0, left: 948, top: -58 }, 500, 'linear');
			flyImage.queue(function() {
				$(this).remove();

				var cartStatus = $("#cart-status a");
				var products = cartStatus.find("span");
				var productsCnt = products.text();

				if (productsCnt)
					products.html(++productsCnt);
				else
					cartStatus.html("<%= GetMessageRaw("YourCartSingleItem") %>");
				
				<% if(Component.CanModifyElements) {%>
				wrapper.addClass("catalog-item-hover").hover(
					function() { $(this).removeClass("catalog-item-hover").addClass("catalog-item-hover"); },
					function() { $(this).removeClass("catalog-item-hover"); }
				);
				<%} %>

			});

			return false;
		});

		//Add to comparation
		$("a.catalog-item-compare").click(function() {

			var button = $(this);
			var href = button.attr("href");
			button.removeClass("catalog-item-compare").addClass("catalog-item-compared").unbind('click').removeAttr("href").css("cursor", "default");
			button.click(function() { return false; });
			$.get(
				href,
				$.proxy(
					function(data) {
						this.text("<%= GetMessageRaw("ProductAddedToCompareList") %>");
						var compare = $("#compare");
						var compareItems = $("span", compare);
						var compateItemsCnt = compareItems.text();

						compateItemsCnt = compateItemsCnt ? ++compateItemsCnt : 1;
						compareItems.html(compateItemsCnt);

						if (compare.css("display") == "none") {
							compare.css({ "display": "block", "height": "0" });
							compare.animate({ "height": "22px" }, 500);
						}
					}, button
				)
			);

			return false;
		});

		<% if(Component.CanModifyElements) {%>
		$("#workarea div.catalog-item-list > div.catalog-item").hover(
			function() { $(this).removeClass("catalog-item-hover").addClass("catalog-item-hover"); },
			function() { $(this).removeClass("catalog-item-hover"); }
		);
		<%} %>
	});
</script>
<%} %>