﻿<%@ Reference Control="~/bitrix/components/bitrix/catalogue.section.tree/component.ascx"%>
<%@ Control Language="C#" AutoEventWireup="true" Inherits="Bitrix.IBlock.Components.CatalogueSectionTreeTemplate"%>
<%@ Import Namespace="Bitrix.IBlock.Components" %>
<%@ Import Namespace="Bitrix.UI" %>
<%@ Import Namespace="Bitrix.Services" %>
<% 
if (Component.TreeItems == null)
	return;
%>

<% if(Component.CanModifySections) {%>
<div class="catalog-admin-buttons">
	<a href="<%= Component.GetSectionAddUrl() %>"><span><%= GetMessage("AddSection") %></span></a>
	<% if(Component.SectionId > 0) {%>
	<a href="<%= Component.GetSectionEditUrl(Component.SectionId) %>"><span><%= GetMessage("Edit") %></span></a>
	<a href="<%= Component.GetSectionDeleteUrl(Component.SectionId) %>"><span><%= GetMessage("Remove") %></span></a>
	<%} %>
</div>
<%} %>
<div class="catalog-section-list">
<%
	var childsCount = 0;
	var itemsInRow = 3;
	var oldDepthLevel = 0;
	Bitrix.IBlock.Components.CatalogueSectionTreeComponent.SectionTreeItem parent = null, prevItem = null;
	foreach (var item in Component.TreeItems)
	{
		if (item.Section.DepthLevel > 2)
			continue;
		
		var image = item.Section.Image != null ? Bitrix.Services.Image.BXImageUtility.GetResizedImage(item.Section.Image, 75, 75) : null;
		var imagePath = image != null ? Bitrix.IO.BXPath.ToUri(image.FilePath, false) : String.Empty;
		%>
	 
	 <% if (oldDepthLevel ==2 && item.Section.DepthLevel == 1) {%>
	 
			<% var emptyColCount = itemsInRow - childsCount % itemsInRow;
	  for (var i = 0; i < emptyColCount; i++)
	  {
		 %>
		 <td>&nbsp;</td>
		 <%} %>
				</table>
			</div>
	 <%} %>
	 
	 <% if(oldDepthLevel > 0 && item.Section.DepthLevel == 1){ %>
		</div>
		<% if(prevItem != null && Component.CanModifySections) {%>
		<div class="catalog-admin-links">
			<a href="<%= Component.GetSectionEditUrl(prevItem.Section.Id) %>" title="<%= GetMessage("EditSection") %>"><%= GetMessage("Edit") %></a>
			<a href="#" onclick="Bitrix.CatalogSectionPanel.getInstance().processItemDeletion('<%= JSEncode(prevItem.Section.Name) %>', '<%= JSEncode(Component.GetSectionDeleteUrl(prevItem.Section.Id)) %>'); return false;" title=""><%= GetMessage("Remove") %></a>
		</div>									
		<%} %>		
		</div>
		<div class="catalog-section-separator"></div>
	 <%} %>
	 
		 <% if (item.Section.DepthLevel == 1)
		 {
			 childsCount = 0; 
			 parent = item;
			  %>
		<div class="catalog-section<%=(image != null ? "":" no-picture-mode")%>">
		<% if (image != null){ %>
			<div class="catalog-section-image"><a href="<%=item.SectionDetailUrl %>"><img src="<%= imagePath %>" /></a></div>
		<%} %>
			<div class="catalog-section-info">
				<div class="catalog-section-title"><a href="<%=item.SectionDetailUrl %>" ><%= item.Section.Name%></a></div>
				<div class="catalog-section-desc"><%= item.Section.Description%></div>
		 <%} %>
		 
		 <% if (item.Section.DepthLevel == 2)
	  {
		  childsCount++;
		  %>
		  
	<% if (item.Section.DepthLevel == 2 && childsCount == 1)
	{ %>
		<div class="catalog-section-childs">
					<table cellspacing="0" class="catalog-section-childs">
	<%} %>
		  
		<% if (childsCount % itemsInRow == 1)
	 {  %>
		 <tr>
		 <%} %>
		<td><a href="<%=item.SectionDetailUrl %>" ><%= item.Section.Name%></a></td>
		<% if (childsCount % itemsInRow == itemsInRow )
	   {  %>
		 </tr>
		 <%}%>
	  <%}
		   %> 
		 
	 <%
		oldDepthLevel = item.Section.DepthLevel;
		if(item.Section.DepthLevel == 1)
			prevItem = item;
	} %>
	
	<% if (oldDepthLevel ==2) {%>
				</table>
			</div>
	 <%
		 oldDepthLevel = 1;   
	   } %>
	 
	 <% if(oldDepthLevel == 1){ %>
		</div>
		<% if(prevItem != null && Component.CanModifySections) {%>
		<div class="catalog-admin-links">
			<a href="<%= Component.GetSectionEditUrl(prevItem.Section.Id) %>" title="<%= GetMessage("EditSection") %>"><%= GetMessage("Edit") %></a>
			<a href="#" onclick="Bitrix.CatalogSectionPanel.getInstance().processItemDeletion('<%= JSEncode(prevItem.Section.Name) %>', '<%= JSEncode(Component.GetSectionDeleteUrl(prevItem.Section.Id)) %>'); return false;" title=""><%= GetMessage("Remove") %></a>
		</div>									
		<%} %>			
		</div>
		<div class="catalog-section-separator"></div>
	 <%} %>
	
</div>

<script runat="server">
	
	protected override void OnInit(EventArgs e)
	{
		base.OnInit(e);
		Page.Items["CatalogIBlockId"] = Component.IBlockId;
		try
		{
			Page.Items["CatalogCompareUrl"] = VirtualPathUtility.ToAbsolute( "~/"+ Component.Parameters.GetString("SefFolder", " ") + Component.Parameters.GetString("ComparisonResultTemplate", ""));
		}
		catch { }
	}
	
	protected override void PreLoadTemplateDefinition(Bitrix.Components.BXParametersDefinition def)
	{
		def["Template_RootTitle"] = new Bitrix.Components.BXParamText(GetMessageRaw("Param.RootTitle"), "", Bitrix.Components.BXCategory.AdditionalSettings);
		def["Template_RootUrl"] = new Bitrix.Components.BXParamText(GetMessageRaw("Param.RootUrl"), "", Bitrix.Components.BXCategory.AdditionalSettings);
	}
	
    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        BXPage.Scripts.RequireUtils();

		BXPage.RegisterScriptInclude("~/bitrix/controls/Main/dialog/js/messages.js.aspx?lang=" + HttpUtility.UrlEncode(BXLoc.CurrentLocale));
		BXPage.RegisterScriptInclude("~/bitrix/controls/Main/dialog/js/dialog_base.js");
		BXPage.RegisterScriptInclude("~/bitrix/controls/Bitrix.CommerceSite/dialogs/dialog_del_confirm.js");
		BXPage.RegisterScriptInclude("~/bitrix/controls/Bitrix.CommerceSite/dialogs/messages.js.aspx?lang=" + HttpUtility.UrlEncode(BXLoc.CurrentLocale));		
		BXPage.RegisterStyle("~/bitrix/controls/Main/dialog/css/dialog_base.css");
    }	
	
</script>
<script type="text/javascript">
	$(function() {
		<% if(Component.CanModifySections) {%>
		$("#workarea div.catalog-section-list > div.catalog-section").hover(
			function() { $(this).removeClass("catalog-section-hover").addClass("catalog-section-hover"); },
			function() { $(this).removeClass("catalog-section-hover"); }
		);
		<%} %>	
	});
</script>