﻿<%@ Reference Control="~/bitrix/components/bitrix/iblock.element.random/component.ascx" %>
<%@ Control Language="C#" AutoEventWireup="true" Inherits="Bitrix.IBlock.Components.IBlockElementRandomTemplate" %>

<bx:BXValidationSummary ID="errorMessage" runat="server" CssClass="errortext" ValidationGroup="" Visible="false" HeaderText="<%$ Loc:Kernel.Error %>" />

<script runat="server">
	
	protected void Page_Load(object sender, EventArgs e)
	{
		if (Component.Error != Bitrix.IBlock.Components.IBlockElementRandomComponentError.None)
			errorMessage.Visible = true;
		errorMessage.ValidationGroup = ClientID;
	}

protected void Page_PreRender(object sender, EventArgs e)
{
	if (Component.Error != Bitrix.IBlock.Components.IBlockElementRandomComponentError.None)
	{
		errorMessage.AddErrorMessage(Component.GetErrorMessage());
		return;
	}
}

</script>

<% if (Component.Error != Bitrix.IBlock.Components.IBlockElementRandomComponentError.None) return; %>

<% if (Component.Elements.Count > 0){
	   %>
<h5><%= GetMessage("Label.Header") %></h5>

<% 

    for ( var i = 0; i < Component.Elements.Count; i+=2){
		var first = Component.Elements[i];
		var fImage = first.Image != null ? Bitrix.Services.Image.BXImageUtility.GetResizedImage(first.Image, 75, 100) : null;
		var fImagePath = fImage != null ? Bitrix.IO.BXPath.ToUri(fImage.FilePath, false) : String.Empty;

		var second = i >= Component.Elements.Count-1 ? null : Component.Elements[i + 1];

		var sImage = second!=null ? second.Image != null ? Bitrix.Services.Image.BXImageUtility.GetResizedImage(second.Image, 75, 100) : null : null;
		var sImagePath = sImage != null ? Bitrix.IO.BXPath.ToUri(sImage.FilePath, false) : String.Empty;
		%>

	<div class="catalog-item-cards">
		<table class="catalog-item-card" cellspacing="0">
		<tr class="top">
			<td><div class="corner left-top"></div><div class="corner right-top"></div><div class="border-top"></div></td>
			<% if (second != null) { %>
			<td class="delimeter"></td>
			<td><div class="corner left-top"></div><div class="corner right-top"></div><div class="border-top"></div></td>
			<%} %>
		</tr>
		<tr>
			<td>
				<div class="catalog-item-card<%= (fImage != null ? "" : " no-picture-mode") %>">
					<% if (fImage != null){ %>
					<div class="item-image"><a href="<%= first.DetailUrl %>"><img src="<%= fImagePath %>" /></a></div>
					<%} %>
					<div class="item-info">
						<p class="item-title"><a href="<%= first.DetailUrl %>" ><%= first.Element.Name %></a></p>
						<p class="item-desc"><%= first.Element.PreviewText %><span class="item-desc-overlay"></span></p>
						<% if (!String.IsNullOrEmpty(first.PriceHtml)){ %>
						<p class="item-price"><span><%= first.PriceHtml %></span></p>
						<%} %>
					</div>
				</div>
			</td>
			
			<td class="delimeter"></td>
			<% if(second != null ){ %>
			<td>
			
				<div class="catalog-item-card<%= (sImage != null ? "" : " no-picture-mode") %>">
					<% if (sImage != null){ %>
					<div class="item-image"><a href="<%= second.DetailUrl %>"><img src="<%= sImagePath %>" /></a></div>
					<%} %>
					<div class="item-info">
						<p class="item-title"><a href="<%= second.DetailUrl %>" ><%= second.Element.Name%></a></p>
						<p class="item-desc"><%= second.Element.PreviewText%><span class="item-desc-overlay"></span></p>
						<% if (!String.IsNullOrEmpty(second.PriceHtml)) { %>
						<p class="item-price"><span><%= second.PriceHtml%></span></p>
						<%} %>
					</div>
				</div>
				
			</td>
			<%} %>
			</tr>
			<tr class="bottom">
				<td><div class="corner left-bottom"></div><div class="corner right-bottom"></div><div class="border-bottom"></div></td>
				<% if(second != null ){ %>
				<td class="delimeter"></td>
				<td><div class="corner left-bottom"></div><div class="corner right-bottom"></div><div class="border-bottom"></div></td>
				<%} %>
			</tr>
		</table>
	</div>
<%} %>

		
<%} %>