﻿using Bitrix.UI;
using System;
using Bitrix.Sale.Components;
using System.Collections.Generic;
using Bitrix.DataTypes;
using Bitrix.Services;
using Bitrix.Security;
using System.Collections.Specialized;
using System.Web;

public partial class bitrix_components_bitrix_sale_cart_templates__default_template : BXComponentTemplate<SaleCartComponent>
{
	public string Location { get; set; }

    protected void Page_Load(object sender, EventArgs e)
    {

		var action = Request.QueryString["action"];
		var id = Request.QueryString["id"];
		Location = Request.QueryString["location"] ?? "av";
		if (action != null && (action.Equals("shelve",StringComparison.OrdinalIgnoreCase) 
			|| action.Equals("UnShelve",StringComparison.OrdinalIgnoreCase)
			|| action.Equals("Delete", StringComparison.OrdinalIgnoreCase)
			|| action.Equals("Notify", StringComparison.OrdinalIgnoreCase)
			|| action.Equals("UnNotify", StringComparison.OrdinalIgnoreCase)
			) && id != null && BXCsrfToken.CheckTokenFromRequest(Request.QueryString))
		{
				var parameters = new BXParamsBag<object>();
				parameters["cartItemId"] = id;
				var errors = new List<string>();
				if (Component.ProcessCommand(action, parameters, errors))
				{
					try
					{
						Response.Redirect(BXSefUrlManager.CurrentUrl.AbsolutePath.ToString() + "?location=" + Location);
					}
					catch
					{
					}
				}
				else
				{
					foreach (var err in errors)
						errorMessage.AddErrorMessage(err);
				}

		}

		CouponString.Attributes.Add("onkeypress", String.Format("return {0}Component_FireDefaultButton(event, '{0}')", Recalc.ClientID));
	}

	protected void FormOrderClick(object sender, EventArgs e)
	{
		int quantity;
		Dictionary<int, int> items = new Dictionary<int, int>();
		foreach (var prod in Component.ReadyProducts)
		{
			if (int.TryParse(Request.Form[ClientID + "Quantity" + prod.CartItemId.ToString()], out quantity))
			{
				items[prod.CartItemId] = quantity;
			}
		}
		var parameters = new BXParamsBag<object>();
		parameters["cartItems"] = items;
		var errors = new List<string>();

		if (Component.ProcessCommand("FormOrder", parameters, errors))
		{
			try
			{
				Response.Redirect(Component.OrderFormUrl);
			}
			catch
			{
			}
		}
		else
		{
			foreach (var err in errors)
				errorMessage.AddErrorMessage(err);
		}
	}

	protected void RecalcClick(object sender, EventArgs e)
	{
		int quantity;
		Dictionary<int, int> items = new Dictionary<int, int>();
		foreach (var prod in Component.ReadyProducts)
		{
			if (int.TryParse(Request.Form[ClientID + "Quantity" + prod.CartItemId.ToString()], out quantity))
			{
				items[prod.CartItemId] = quantity;
			}
		}

		if ( items.Count > 0 )
		{
			var parameters = new BXParamsBag<object>();
			parameters["cartItems"] = items;
			parameters["newCouponString"] = CouponString.Text.Trim() == GetMessage("Message.EnterCouponString") ? "" : CouponString.Text.Trim();
			var errors = new List<string>();
			if (Component.ProcessCommand("UpdateQuantity", parameters, errors))
			{
				try
				{
					NameValueCollection qs = HttpUtility.ParseQueryString(BXSefUrlManager.CurrentUrl.Query);
					qs["location"] = "av";
					Response.Redirect(BXSefUrlManager.CurrentUrl.AbsolutePath + "?" + qs.ToString());
				}
				catch
				{
				}
			}
			else
			{
				foreach (var err in errors)
					errorMessage.AddErrorMessage(err);
			}
				
		}
	}
}
