﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="template.ascx.cs" Inherits="bitrix_components_bitrix_sale_order_detail_templates__default_template" %>
<%@ Reference Control="~/bitrix/components/bitrix/sale.order.detail/component.ascx"%>

<script type="text/C#" runat="server">
    protected override void OnLoad(EventArgs e)
    {
        orderPayment.Component.Parameters["OrderId"] = Component.OrderId.ToString();
        base.OnLoad(e);
    }
</script>
<div class="order-full-summary">
<bx:BXValidationSummary ID="errorMessage" runat="server" CssClass="errortext" ValidationGroup="" HeaderText="<%$ Loc:Kernel.Error %>" />
<% 
	if (Component.Error == Bitrix.Sale.Components.SaleOrderDetailComponentError.None)
{ %>
<a class="order-back-link" href="<%= Component.OrderListUrl %>"><%=GetMessage("Label.ToOrderList") %></a>
<br />
<br />
<!-- Basic info -->
<div class="order-item">
	<div class="order-title">
		<b class="r2"></b><b class="r1"></b><b class="r0"></b>
		<div class="order-title-inner">
			<span><%=String.Format(GetMessage("Label.Order"),Component.Order.Id, Component.Order.Created.ToString("g"))%></span>
		</div>
	</div>
	<div class="order-info">
			<table class="order-properties" cellspacing="0">
				<tbody>
				<tr>
					<td class="field-name"><%= GetMessage("Label.OrderStatus")%>:</td>
					<td class="field-value"><%=Component.OrderStatusLocalizedName%>&nbsp;(<%=GetMessage("Label.From")%>&nbsp;
					<%= Component.Order.StatusSetDate.ToString("g")%>)</td>
				</tr>
				<tr>
					<td class="field-name"><%=GetMessage("Label.OrderSum")%>:</td>
					<td class="field-value"><b><%=Component.FormattedOrderSum %></b></td>
				</tr>
				<tr>
					<td class="field-name"><%= GetMessage("Label.OrderCancelled") %>:</td>
					<td class="field-value"><%= Component.Order.Cancelled ? GetMessage("Label.Yes") : GetMessage("Label.No")%></td>
				</tr>
				</tbody>
			</table>
		</div>

</div>

<!--User Info-->

<div class="order-item">
			<div class="order-title">
				<b class="r2"></b><b class="r1"></b><b class="r0"></b>
				<div class="order-title-inner">
					<span><%= GetMessage("Label.UserInfo")%></span>
				</div>
			</div>
			<div class="order-info">
				<table class="order-properties" cellspacing="0">
					<tbody>
					<tr>
						<td class="field-name"><%= GetMessage("Label.UserName") %>:</td>
						<td class="field-value"><%=Component.User != null ? Component.User.UserName : String.Empty%></td>
					</tr>
					<tr>
						<td class="field-name"><%= GetMessage("Label.UserEmail")%>:</td>

						<td class="field-value"><%=Component.User != null ? Component.User.Email : String.Empty%></td>
					</tr>
				</tbody></table>
			</div>
		</div>
	
<!--Order Parameters -->

<div class="order-item">
	<div class="order-title">
		<b class="r2"></b><b class="r1"></b><b class="r0"></b>
		<div class="order-title-inner">
			<span><%=GetMessage("Label.OrderProps")%></span>
		</div>
	</div>
	<div class="order-info">
		<table class="order-properties" cellspacing="0">
			<tbody>
			<%
		Bitrix.Sale.Components.SaleOrderDetailComponent.CustomProperty c;
		foreach (var prop in Component.DisplayCustomPropsCodes)
	  { 
		  if ( Component.StrCustomProperties.TryGetValue(prop, out c)) {%>
			<tr>
				<td class="field-name"><%= c.Title%>:</td>
				<td class="field-value"><%=c.Html %></td>
			</tr>
			<%}
}		 %>
<% if (!String.IsNullOrEmpty(Component.Order.CustomerComments))
	 { %>
			<tr>
				<td class="field-name"><%= GetMessage("Label.Comments")%>:</td>
				<td class="field-value"><%=Component.Order.CustomerComments%></td>
			</tr>
		<%} %>
			</tbody>
		</table>
	</div>
</div>
	
<!-- Order Payment and Delivery -->

<div class="order-item">
	<div class="order-title">
		<b class="r2"></b><b class="r1"></b><b class="r0"></b>
		<div class="order-title-inner">
			<span><%=GetMessage("Label.PaymentAndDelivery")%></span>
		</div>
	</div>
	<div class="order-info">
	<table class="order-properties" cellspacing="0">
		<tbody>
			<tr>
				<td class="field-name"><%= GetMessage("Label.PaymentSystem")%>:</td>
				<td class="field-value"><%= Component.PaymentSystemName %></td>
			</tr>
			<tr>
				<td class="field-name"><%= GetMessage("Label.Payed")%>:</td>
				<td class="field-value">
				    <%= Component.Order.Paid ? GetMessage("Label.Yes") : GetMessage("Label.No") %>
				</td>
			</tr>
            <%if(!Component.Order.Paid) {%>			
			<tr>
			    <td class="field-name"></td>
			    <td class="field-value">
                    <bx:IncludeComponent 
                        ID="orderPayment"
                        runat="server"
                        componentName="bitrix:sale.order.payment"
                        template=".default"
                        orderId="<%$ Request:orderId%>" />			        
			    </td>
			</tr>
			<%} %>
			<tr>
				<td class="field-name"><%= GetMessage("Label.DeliveryService")%>:</td>
				<td class="field-value"><%= Component.DeliveryServiceName %></td>
			</tr>
		</tbody>
	</table>
	</div>
</div>

<!-- Order Contents -->
<div class="order-item">
	<div class="order-title">
		<b class="r2"></b><b class="r1"></b><b class="r0"></b>
		<div class="order-title-inner">
			<span><%=GetMessage("Label.Title")%></span>
		</div>
	</div>
	<div class="order-info">

	<table class="cart-items" cellspacing="0">
	<thead>
		<tr>
				<td class="cart-itemname"><%= GetMessage("Label.ItemName")%></td>
				<td class="cart-itemprice"><%= GetMessage("Label.Price")%></td>
				<td class="cart-itemprice"><%= GetMessage("Label.Discount")%></td>
				<td class="cart-itemweight"><%= GetMessage("Label.Weight") %></td>
				<td class="cart-itemquantity"><%= GetMessage("Label.Quantity")%></td>
		</tr>
	</thead>
	<tbody>
	<%
	foreach(var prod in Component.Products)
	{
		
		%>
		<tr>
			<td class="cart-itemname"><a href="<%=prod.DetailUrl %>"><%=prod.Name%></a></td>
			<td class="cart-itemprice"><%=Component.Currency.MoneyToString(prod.GetConvertedCost(Component.Currency))%></td>
			<td class="cart-itemprice"><%=Component.Currency.MoneyToString(Bitrix.Currency.BXCurrency.ConvertMoney(prod.DiscountValue, Component.Order.Currency, Component.Currency))%></td>
			<td class="cart-itemweight"><%=prod.Weight.ToString() %>&nbsp;<%=GetMessage("Label.Gramm") %></td>
			<td class="cart-itemquantity"><%=prod.Quantity.ToString()%></td>
		</tr>
		<%
	}
	%>
	</tbody>
	<tfoot>   
	    <tr>
	        <td class="cart-itemname">
				<p><%=GetMessage("Label.DeliveryCost") %>:</p>
								<% 
					if (Component.Order.DiscountValue > 0)
				   { %>
				<p><%= Component.Order.DiscountName %>:</p>
				<%} %>
				<p><b><%=GetMessage("Label.Sum") %>:</b></p>
	        </td>
	        <td class="cart-itemprice">
				<p><%= Component.FormattedOrderDeliveryCost%></p>
							<% 
				if (Component.Order.DiscountValue > 0)
				{ %>
				<p><%=Component.Currency.MoneyToString(Bitrix.Currency.BXCurrency.ConvertMoney(Component.Order.DiscountValue, Component.Order.Currency, Component.Currency))%></p>
				<%} %>
				<p><b><%=Component.FormattedOrderSum%></b></p>
	        </td>
	        <td class="cart-itemweight">&nbsp;</td>
	        <td class="cart-itemquantity">&nbsp;</td>	  	        
	    </tr>	
	</tfoot>
</table>
	</div>
</div>
<%} %>

</div>

