﻿<%@ Reference VirtualPath="~/bitrix/components/bitrix/system.PublicMenu/component.ascx" %>
<%@ Control Language="C#" ClassName="template" Inherits="Bitrix.Main.Components.SystemPublicMenuTemplate" %>
<%@ Import Namespace="Bitrix" %>
<%  if (Component.Menu != null) { %>
	<% 
		var uriComparer = new BXUriComparer();

		Action<BXPublicMenuItemCollection, int, BXPublicMenuItem, BXPublicMenuItem> render = null;
		bool showAll = Parameters.GetBool("Template_ShowAllLevels");
		bool oneParent = Component.Menu.Count == 1;
        render = delegate(BXPublicMenuItemCollection items,int level, BXPublicMenuItem selectedParent,BXPublicMenuItem parent)
        {
            int firstNum = 0; int lastNum = 0;
			bool isRoot = level == 0;
			
            BXPublicMenuItem selected = null;
            for (int i = 0; i < items.Count; i++)
            {
                if (!items[i].IsAccessible) continue;

                if (items[i].IsSelected && (selected == null || uriComparer.Compare(items[i].Link, selected.Link) >= 0))
                    selected = items[i];
			}
           
            for (int i = 0; i < items.Count;i++ )
            {
                var item = items[i];
                if (!item.IsAccessible) continue;
                string cssClass = String.Empty;
				bool isFull = false;
				bool tAccessible = showAll || isRoot || parent == selectedParent || (level ==1 && !oneParent);
				if (!tAccessible) continue;
				
				bool containsSelectedChildren = item.Children!=null && item.Children.Exists(x => x.IsSelected);
				
				if (items[i].IsSelected && (containsSelectedChildren || isRoot) )
					cssClass = "selected";
				else 
					if (items[i]==selected && ! containsSelectedChildren )
						cssClass = "current";
                %>
                <% if (!isRoot || items.Count != 1)
				   { %>
					<li  <% if (cssClass!=String.Empty) { %> class="<%=cssClass %>"<% } %>><a href=<%= item.Href %> <%= (items[i].IsSelected && (parent==null || parent.Href!=item.Href) ? "class=\"selected\"":"") %>><%= Encode(item.Title)%></a>
				<%} %>
					<% if (item.Children != null && item.Children.Count> 0) { %> 
						 <% if (!isRoot || items.Count != 1)
				   { %>
						<ul>
					<%} %>	
						<% render(item.Children, isRoot && items.Count==1 ? 0 : level+1, selected, item); %>
						 <% if (!isRoot || items.Count != 1)
				   { %>
						</ul>
			<%} %>	
					<% } %>
		     <% if (!isRoot || items.Count != 1)
				   { %>
		            </li>
			<%} %>
				<%
			} 
        };
    %>
    <ul id="left-menu">
    <% render(Component.Menu, 0, null, null); %>
    </ul>
<% } %>
<script runat="server">
	protected override void PreLoadTemplateDefinition(Bitrix.Components.BXParametersDefinition def)
	{
		def["Template_ShowAllLevels"] = new Bitrix.Components.BXParamYesNo(GetMessageRaw("DisplayAllMenuLevels"), false, Bitrix.Components.BXCategory.AdditionalSettings);
	}
</script>
