﻿<%@ Control Language="C#" AutoEventWireup="false" EnableViewState="false" CodeFile="Options.ascx.cs" Inherits="bitrix_modules_Catalog_Options" %>
<bx:BXValidationSummary ID="errorMessage" runat="server" CssClass="errorSummary" ValidationGroup="InnerForm" HeaderText="<%$ Loc:Kernel.Error %>" />
<bx:BXMessage ID="successMessage" runat="server" CssClass="ok" IconClass="ok" Title="<%$ Loc:Kernel.Information %>"
	Visible="False" Content="<%$ Loc:Message.SettingsHasBeenSavedSuccessfully %>" />
	
<bx:BXTabControl ID="tabContainer" ValidationGroup="InnerForm" runat="server" OnCommand="OnTabCommand">
	<bx:BXTabControlTab ID="CatalogTab" runat="server" Selected="True" Text="<%$ Loc:TabText.Catalog %>"
		Title="<%$ Loc:TabTitle.Catalog %>">
        <bx:BXAdminNote ID="AdminNote1" runat="server">
            <%= GetMessageRaw("FieldHint")%>
        </bx:BXAdminNote>  		
		<table border="0" cellpadding="0" cellspacing="0" class="edit-table"><tbody><tr><td>
		    <table id="catalogTable" class="internal" border="0" cellspacing="0" cellpadding="0" style="width:100%;">
		        <tbody>
		            <tr class="heading">
		                <td valign="top"><asp:Literal runat="server" Text="<%$ LocRaw:CatalogTabColHead.IBlock %>" /></td>
		                <td valign="top"><asp:Literal runat="server" Text="<%$ LocRaw:CatalogTabColHead.IsPersistent %>" /></td>
		                <td valign="top"><asp:Literal runat="server" Text="<%$ LocRaw:CatalogTabColHead.SkuIBlock %>" /></td>
		                <td valign="top"><asp:Literal runat="server" Text="<%$ LocRaw:CatalogTabColHead.CheckStockAvailability %>" /></td>
		                <td valign="top"><asp:Literal runat="server" Text="<%$ LocRaw:CatalogTabColHead.VATRate %>" /></td>
		            </tr>
		            <tr>
						<td colspan="5" align="center">
							<%= GetMessage("Message.Loading") %>
						</td>
		            </tr>
		        </tbody>
		    </table>
		</td></tr></tbody></table>
        <bx:BXAdminNote ID="AdminNote2" runat="server">
            <%= GetMessageRaw("FieldLegend")%>
        </bx:BXAdminNote>		
	</bx:BXTabControlTab>
</bx:BXTabControl>
<asp:HiddenField ID="InitCatalogState" runat="server" />
<asp:HiddenField ID="FinalCatalogState" runat="server" />

<script type="text/javascript">
    if (typeof (Bitrix) == "undefined") { var Bitrix = {}; }
    Bitrix.VATRate = function Bitrix$VATRate() {
        this._id = 0;
        this._descr = "";
    }

    Bitrix.VATRate.prototype = {
        initialize: function(id, descr) {
            this._id = id;
            this._descr = descr;
        }
    }

    Bitrix.VATRate._items = [];
    Bitrix.VATRate.create = function(id, descr) {
        var self = new Bitrix.VATRate();
        self.initialize(id, descr);
        this._items.push(self);
        return self;
    }

    Bitrix.VATRate.createSelectElement = function(selectedValue) {
        var select = document.createElement("SELECT");
        var ary = [];
        for (var i = 0; i < this._items.length; i++)
            ary.push({ text: this._items[i]._descr, value: this._items[i]._id });
        Bitrix.DomHelper.addToSelect(select, ary);
        Bitrix.DomHelper.selectOption(select, selectedValue > 0 ? selectedValue : "0");
        return select;
    }

    Bitrix.Catalog = function Bitrix$Catalog() {
        this._initialized = false;
        this._iblockId = this._catalogId = this._skuIBlockId = this._vatRateId = 0;
        this._descr = this._editUrl = "";
        this._enabled = false;
        this._checkStockAvailability = true;
        this._enabledEl = this._checkStockAvailabilityEl = this._vatRateEl = this._skuEl = null;
        this._enabledChangeHandler = Bitrix.TypeUtility.createDelegate(this, this._handleEnabledChange);
    }
    Bitrix.Catalog.prototype = {
    	initialize: function() {
    		this._initialized = true;
    	},
    	createHtml: function() {
    		var tab = document.getElementById("catalogTable");
    		if (!tab) return;
    		    		
    		var r = tab.insertRow(-1);
    		var iblockC = r.insertCell(-1);
    		iblockC.innerHTML = "<a href=\"" + Bitrix.HttpUtility.htmlEncode(this._editUrl) + "\">" + Bitrix.HttpUtility.htmlEncode(this._descr) + "</a>";

    		var enablC = r.insertCell(-1);
    		enablC.align = "center";
    		var enablEl = this._enabledEl = document.createElement("INPUT");   		
    		enablEl.type = "checkbox";
    		enablC.appendChild(enablEl);
    		enablEl.checked = enablEl.defaultChecked = this._enabled;
    		Bitrix.EventUtility.addEventListener(enablEl, "click", this._enabledChangeHandler, false);

    		var skuC = r.insertCell(-1);
    		skuC.align = "center";
    		var skuEl = this._skuEl = document.createElement("SELECT");
    		var skuOptionAry = [{ "text":"<%= GetMessageRaw("NotSelectedMasculine") %>", "value":"0" }];   		
    		for (var i = 0; i < Bitrix.Catalog.IBlockAry.length; i++) {
    			var block = Bitrix.Catalog.IBlockAry[i];
    			skuOptionAry.push({ "text": block.descr, "value": block.id.toString() });
    		}

    		Bitrix.DomHelper.addToSelect(skuEl, skuOptionAry);
    		Bitrix.DomHelper.selectOption(skuEl, this._skuIBlockId.toString());
    		skuC.appendChild(skuEl);

    		var checkC = r.insertCell(-1);
    		checkC.align = "center";
    		var checkEl = this._checkStockAvailabilityEl = document.createElement("INPUT");
    		checkEl.type = "checkbox";
    		checkC.appendChild(checkEl);
    		checkEl.checked = checkEl.defaultChecked = this._checkStockAvailability; //only after added in DOM - for IE

    		var vatC = r.insertCell(-1);
    		vatC.align = "center";
    		var vatEl = this._vatRateEl = Bitrix.VATRate.createSelectElement(this._vatRateId.toString());
    		vatC.appendChild(vatEl);

    		this.layout();
    	},
    	isEnabled: function() { return this._enabled; },
    	getCatalogId: function() { return this._catalogId; },
    	_handleEnabledChange: function() {
    		this._enabled = this._enabledEl.checked;
    		this.layout();
    	},
    	layout: function() {
    		this._checkStockAvailabilityEl.style.display = this._vatRateEl.style.display = this._skuEl.style.display = this._enabled ? "" : "none";
    	},
    	synchronize: function() {
    		this._enabled = this._enabledEl.checked;
    		this._checkStockAvailability = this._checkStockAvailabilityEl.checked;
    		this._vatRateId = this._vatRateEl.value;
    		this._skuIBlockId = this._skuEl.value;
    	},
    	toString: function() {
    		var r = "";
    		r += "iblockId:" + this._iblockId;
    		r += ",catalogId:" + this._catalogId;
    		r += ",skuIBlockId:" + this._skuIBlockId;
    		r += ",enabled:" + this._enabled;
    		r += ",checkStockAvailability:" + this._checkStockAvailability;
    		r += ",vatRateId:" + this._vatRateId;

    		return "{" + r + "}";
    	}
    }
    Bitrix.Catalog._items = {};
    Bitrix.Catalog.constructFromObject = function(obj) {
        if (!obj) return null;
        var r = new Bitrix.Catalog();
        r.initialize();
        r._iblockId = "iblockId" in obj ? obj.iblockId : 0;
        r._catalogId = "catalogId" in obj ? obj.catalogId : 0;
        r._skuIBlockId = "skuIBlockId" in obj ? obj.skuIBlockId : 0;
        
        r._descr = "descr" in obj ? obj.descr : "";
        r._editUrl = "editUrl" in obj ? obj.editUrl : "";

        r._enabled = "enabled" in obj ? obj.enabled: false;
        r._checkStockAvailability = "checkStockAvailability" in obj ? obj.checkStockAvailability : false;
        r._vatRateId = "vatRateId" in obj ? obj.vatRateId : 0;
        
        r.createHtml();
        
        this._items[r._iblockId] = r;
        return r;
    }
    Bitrix.Catalog.constructFromString = function(str) {
        if (!Bitrix.TypeUtility.isNotEmptyString(str)) return null;
        
    	var tab = document.getElementById("catalogTable");
    	if (!tab) return;
    	tab.deleteRow(1);        
        
        var obj = eval("(" + str + ")");
        if (!(obj instanceof Array))
            return this.constructFromObject(obj);
        var r = [];
        for (var i = 0; i < obj.length; i++)
            r.push(this.constructFromObject(obj[i]));
        return r;
    }

    Bitrix.Catalog.saveToString = function() {
        var r = "";
        for (var key in this._items) {
            var item = this._items[key];
            item.synchronize();
            if (item.getCatalogId() <= 0 && !item.isEnabled()) continue;
            if (r.length > 0) r += ",";
            r += item.toString();
        }
        return r.length > 0 ? "[" + r + "]" : "";
    }    
</script>	