﻿<%@ Page Language="C#" MasterPageFile="AdminMasterPage.master" AutoEventWireup="true"
    CodeFile="CatalogDiscountEdit.aspx.cs" Inherits="bitrix_admin_CatalogDiscountEdit" %>    


<%@ Register Assembly="Main" Namespace="Bitrix.UI" TagPrefix="bx" %>
<%@ Register Src="~/bitrix/controls/Main/TimeInterval.ascx" TagName="TimeInterval" TagPrefix="ti" %>
<%@ Import Namespace="Bitrix.Services" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
<style type="text/css">
	a.rule-prop 
	{
		cursor:pointer;
		text-decoration: underline;
	}
	a.rule-prop-delete
	{
		cursor:pointer;
		text-decoration: underline;
		font-size:80%;
		color:red;
	}

	div.condition-container
	{
		margin-left:15px;
		padding-top:5px;
	}
	div.condition-list
	{
		border-left:1px dotted #888888;
	}
</style>
	<bx:BXContextMenuToolbar ID="SaleDiscountCouponEditToolbar" runat="server" OnCommandClick="OnToolBarButtonClick">
		<Items>
			<bx:BXCmSeparator ID="BXCmSeparator1" runat="server" SectionSeparator="true" />
			<bx:BXCmImageButton CssClass="context-button icon btn_list" CommandName="list"
				Text="<%$ LocRaw:ActionText.GoBack %>" Title="<%$ LocRaw:ActionTitle.GoBack %>" Href="CatalogDiscountList.aspx" />
		
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton ID="AddButton"
				CommandName="add" Text="<%$ LocRaw:Kernel.Add %>" Title="<%$ LocRaw:ActionTitle.Add %>"
				CssClass="context-button icon btn_new" Href="CatalogDiscountEdit.aspx" />
				
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton ID="DeleteButton"
				CommandName="delete" Text="<%$ LocRaw:Kernel.Delete %>" Title="<%$ LocRaw:ActionTitle.Delete %>"
				CssClass="context-button icon btn_delete" ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>" />
		</Items>
	</bx:BXContextMenuToolbar>
	<bx:BXValidationSummary ID="Summary" runat="server" CssClass="errorSummary" HeaderText="<%$ Loc:Kernel.Error %>" ValidationGroup="Main" />
	<bx:BXTabControl ID="TabControl" runat="server" OnCommand="OnEditCommand" ValidationGroup="Main">
		<bx:BXTabControlTab ID="MainSettingsTab" runat="server" Selected="True" Text="<%$ LocRaw:TabText.MainSettings %>" Title="<%$ LocRaw:TabTitle.MainSettings %>">	
			<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
				
				<tr valign="top">
					<td class="field-name">ID:</td>
					<td width="60%"><%= (Discount != null ? Discount.Id.ToString() : "") %></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><span class="required">*</span><%=GetMessage("Label.Name") %>:</td>
					<td width="60%"><asp:TextBox ID="Name" runat="server"></asp:TextBox>
					<asp:RequiredFieldValidator ID="NameRV" runat="server" ValidationGroup="Main" 
					ControlToValidate="Name" ErrorMessage="<%$ Loc:Error.NameIsRequired %>" Display="Dynamic">*</asp:RequiredFieldValidator></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><span class="required">*</span><%=GetMessage("Label.Site") %>:</td>
					<td width="60%"><asp:DropDownList ID="Site" runat="server"></asp:DropDownList></td>
				</tr>
	
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.Active") %>:</td>
					<td width="60%"><asp:CheckBox ID="Active" runat="server" Checked="true" /></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name" width="40%">
						<%= GetMessage("Label.ActivePeriod") + ":" %></td>
					<td width="60%">
						<ti:TimeInterval ID="tiActive" runat="server" />
					</td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.Sort") %>:</td>
					<td width="60%"><asp:TextBox ID="Sort" runat="server"></asp:TextBox></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.DiscountType") %>:</td>
					<td width="60%"><asp:DropDownList ID="DiscountType" runat="server"></asp:DropDownList></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><span class="required">*</span><%=GetMessage("Label.DiscountValue") %>:</td>
					<td width="60%"><asp:TextBox ID="Value" runat="server"></asp:TextBox>
					<asp:RequiredFieldValidator ID="ValueRV" runat="server" ValidationGroup="Main" 
					ControlToValidate="Value" ErrorMessage="<%$ Loc: Error.ValueIsRequired %>" Display="Dynamic">*</asp:RequiredFieldValidator>
					<asp:RegularExpressionValidator ID="ValueRegV" runat="server" ValidationGroup="Main" 
					ControlToValidate="Value" ErrorMessage="<%$ Loc:Error.ValueHaveToBeDecimal %>" Display="Dynamic" ValidationExpression="\d+([\.,]\d*)?">*
					</asp:RegularExpressionValidator>
					</td>
				</tr>	
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.DiscountCurrency") %>:</td>
					<td width="60%"><asp:DropDownList ID="Currency" runat="server"></asp:DropDownList></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.MaxSum") %>:</td>
					<td width="60%"><asp:TextBox ID="MaxSum" runat="server" Text="0"></asp:TextBox></td>
					<asp:RegularExpressionValidator ID="MaxSumRegV" runat="server" ValidationGroup="Main" 
					ControlToValidate="MaxSum" ErrorMessage="<%$ Loc:Error.MaxSumMustToBeDecimal %>" Display="Dynamic" ValidationExpression="\d+([\.,]\d*)?">*
					</asp:RegularExpressionValidator>					
				</tr>	
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.Description") %>:</td>
					<td width="60%"><asp:TextBox TextMode="MultiLine" ID="Description" runat="server"></asp:TextBox></td>
				</tr>												
			</table>
		
		</bx:BXTabControlTab>
		<bx:BXTabControlTab ID="ConditionsTab" runat="server" Text="<%$ LocRaw:TabText.Conditions %>" Title="<%$ LocRaw:TabTitle.Conditions %>">	
		<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
			<tr class="heading">
				<td colspan="2"><%=GetMessage("Label.UserRolesPriceTypes") %></td>
			</tr>
			<tr valign="top">
				<td class="field-name"><%=GetMessage("Label.UserRoles") %>:</td>
				<td width="60%"><asp:ListBox runat="server" ID="UserRoles" SelectionMode = "Multiple" ></asp:ListBox></td>
			</tr>
			<tr valign="top">
				<td class="field-name"><%=GetMessage("Label.PriceTypes") %>:</td>
				<td width="60%"><asp:ListBox runat="server" ID="PriceTypes" SelectionMode = "Multiple" ></asp:ListBox></td>
			</tr>
			<tr class="heading">
				<td colspan="2"><%=GetMessage("Label.DiscountConditions") %></td>
			</tr>
			<tr>
				<td colspan="2">
					<div id="mytest"></div>
					<asp:HiddenField ID="hdDiscountTree" runat="server"/>
				</td>
			</tr>
		</table>
		</bx:BXTabControlTab>
	</bx:BXTabControl>
	
	
<script type="text/javascript">

/***************** misc *******************/
function ProductSearchOpen(id)
{
	window.open('SaleProductSearch.aspx?site=<%= JSEncode(UrlEncode(siteId ?? "")) %>&currency=<%= currencyCode %>&onselect=ProductSearchSelect&returnparams='+id, '', 'scrollbars=yes,resizable=yes,width=600,height=500,top='+parseInt((screen.height - 500)/2-14)+',left='+parseInt((screen.width - 600)/2-5));
}
					
function ProductSearchSelect(data, params)
{
	var input = BX(params);
	input.value = data.id;
	input.valuesContainer[input.typeId] = data.id;
	
	var link = BX(params+"_link");
	link.innerHTML = data.name;
	input.valuesContainer[input.typeId+"Name"] = data.name;
	return true;
}

function SectionSearchOpen(id)
{
	window.open('CatalogSectionSearch.aspx?site=<%= JSEncode(UrlEncode(siteId ?? "")) %>&onselect=SectionSearchSelect&returnparams='+id, '', 'scrollbars=yes,resizable=yes,width=600,height=500,top='+parseInt((screen.height - 500)/2-14)+',left='+parseInt((screen.width - 600)/2-5));
}

function SectionSearchSelect(data, params)
{
	var input = BX(params);
	input.value = data.id;
	input.valuesContainer[input.typeId] = data.id;
	
	var link = BX(params+"_link");
	link.innerHTML = data.name;
	input.valuesContainer[input.typeId+"Name"] = data.name;
	return true;
}
	
var variants = <%= VariantsJSON %>;

var state = <%= DiscountJSON %>;


BX.ready(function(){ var processor = new Bitrix.treeProcessor({'variants': variants, 'productSelectHandler':ProductSearchOpen, 'sectionSelectHandler':SectionSearchOpen});
 processor.RenderTree(state, document.getElementById('mytest'), null, 0);});

</script>
	

	
</asp:Content>

