﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" AutoEventWireup="false"
    CodeFile="CatalogDiscountList.aspx.cs" Inherits="bitrix_admin_CatalogDiscountList" Title="<%$ LocRaw:PageTitle %>" %>

<%@ Import Namespace="Bitrix.DataLayer" %>
<%@ Import Namespace="Bitrix.Catalog" %>
<%@ Import Namespace="Bitrix.CommunicationUtility" %>
<%@ Register Src="~/bitrix/controls/Main/Calendar.ascx" TagName="Calendar" TagPrefix="bx" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <asp:UpdatePanel ID="UpdatePanel" runat="server">
        <ContentTemplate>
            <bx:BXAdminFilter ID="ItemFilter" runat="server" AssociatedGridView="ItemGrid">

                <bx:BXTextBoxStringFilter Key="Name" Text="<%$ LocRaw:FilterText.Name %>" Visibility="AlwaysVisible" />
                <bx:BXDropDownFilter ID="ActivityFilter" Key="Active" Text="<%$ LocRaw:FilterText.Active %>">
                    <asp:ListItem Text="<%$ LocRaw:Kernel.All %>" Value="" />
                    <asp:ListItem Text="<%$ LocRaw:Option.Active %>" Value="true" />
                    <asp:ListItem Text="<%$ LocRaw:Option.Inactive %>" Value="false" />
                </bx:BXDropDownFilter>
                <bx:BXDropDownFilter ID="SiteFilter" Key="SiteId" Text="<%$ LocRaw:FilterText.Site %>">
                </bx:BXDropDownFilter>
               <bx:BXTextBoxFilter Key="ID" Text="ID" ValueType="Integer" />
               <bx:BXTimeIntervalFilter ID="BXTimeIntervalFilter1" runat="server" Key="ActiveFromUtc" ConvertToUtc="true" Text="<%$ Loc:FilterText.ActiveFrom %>" />
               <bx:BXTimeIntervalFilter ID="BXTimeIntervalFilter2" runat="server" Key="ActiveToUtc" ConvertToUtc="true" Text="<%$ Loc:FilterText.ActiveTo %>" />
            </bx:BXAdminFilter>
            <bx:BXContextMenuToolbar ID="ItemListToolbar" runat="server">
                <Items>
                    <bx:BXCmSeparator SectionSeparator="true" />
                    <bx:BXCmImageButton ID="AddButton" Text="<%$ LocRaw:ActionText.Add %>" Title="<%$ LocRaw:ActionTitle.Add %>"
                        CssClass="context-button icon btn_new" Href="CatalogDiscountEdit.aspx" />
                </Items>
            </bx:BXContextMenuToolbar>
            <bx:BXPopupPanel ID="PopupPanelView" runat="server">
                <Commands>
                    <bx:CommandItem UserCommandId="edit" Default="True" IconClass="edit" ItemText="<%$ LocRaw:PopupText.Edit %>"
                        ItemTitle="<%$ LocRaw:PopupTitle.Edit %>" OnClickScript="window.location.href = 'CatalogDiscountEdit.aspx?id=' + UserData['ID']; return false;" />
                    <bx:CommandItem UserCommandId="delete" Default="True" IconClass="delete" ItemText="<%$ LocRaw:PopupText.Delete %>"
                        ItemTitle="<%$ LocRaw:PopupTitle.Delete %>" ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:PopupConfirmDialogText.Delete %>" />
                </Commands>
            </bx:BXPopupPanel>
            <bx:BXValidationSummary ID="ErrorMessage" runat="server" CssClass="errorSummary"
                HeaderText="<%$ Loc:Kernel.Error %>" ValidationGroup="GridView" />
            <br />
            <bx:BXGridView ID="ItemGrid" runat="server" ContentName="<%$ LocRaw:TableTitle %>"
                AllowSorting="True" AllowPaging="True" DataKeyNames="ID" SettingsToolbarId="ItemListToolbar"
                PopupCommandMenuId="PopupPanelView" ContextMenuToolbarId="MultiActionMenuToolbar"
                DataSourceID="ItemGrid" OnSelect="ItemGrid_Select" OnSelectCount="ItemGrid_SelectCount"
                OnDelete="ItemGrid_Delete" OnRowDataBound="ItemGrid_RowDataBound">
                <Columns>
                    <asp:BoundField DataField="ID" HeaderText="ID" SortExpression="ID" ReadOnly="True" />
                    <asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.Name %>" SortExpression="Name">
                        <ItemTemplate>
                            <%# BXWordBreakingProcessor.Break(((DiscountWrapper)Container.DataItem).Name, 30, true)%>
                        </ItemTemplate>
                    </asp:TemplateField>
					<asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.Site %>" SortExpression="SiteName">
                        <ItemTemplate>
                            <%# ((DiscountWrapper)Container.DataItem).SiteName %>
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.Active %>" SortExpression="Active">
                        <ItemTemplate>
                            <%# ((DiscountWrapper)Container.DataItem).ActiveString %>
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.ActiveFrom %>" SortExpression="ActiveFrom">
                        <ItemTemplate>
                            <%# ((DiscountWrapper)Container.DataItem).ActiveFromString%>
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.ActiveTo %>" SortExpression="ActiveTo">
                        <ItemTemplate>
                            <%# ((DiscountWrapper)Container.DataItem).ActiveToString%>
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.Value %>">
                        <ItemTemplate>
                            <%# ((DiscountWrapper)Container.DataItem).ValueString%>
                        </ItemTemplate>
                    </asp:TemplateField>
                    <asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.Sort %>" SortExpression="Sort">
                        <ItemTemplate>
                            <%# ((DiscountWrapper)Container.DataItem).Sort%>
                        </ItemTemplate>
                    </asp:TemplateField>
                </Columns>
                <AjaxConfiguration UpdatePanelId="UpdatePanel" />
            </bx:BXGridView>
            <bx:BXMultiActionMenuToolbar ID="MultiActionMenuToolbar" runat="server" ValidationGroup="GridView">
                <Items>
                    <bx:BXMamImageButton CommandName="delete" ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>"
                        ConfirmDialogTextAll="<%$ LocRaw:ActionConfirmDialogTextAll.Delete %>" EnabledCssClass="context-button icon delete"
                        DisabledCssClass="context-button icon delete-dis" Title="<%$ LocRaw:ActionTitle.Delete %>" />
                </Items>
            </bx:BXMultiActionMenuToolbar>
        </ContentTemplate>
    </asp:UpdatePanel>
</asp:Content>
