﻿<%@ Control Language="C#" AutoEventWireup="false" CodeFile="IBlockElementEditor.ascx.cs" Inherits="BXCatalogIBlockElementEditor" %>
<%@ Import Namespace="Bitrix.Catalog" %>
<%@ Import Namespace="System.Globalization" %>
<%@ Import Namespace="Bitrix.Services.Js" %>
<table class="edit-table" cellspacing="0" cellpadding="0" border="0" id="IBlockElementEditorTab" >
	<% if(SkuCatalog != null && Item != null && Item.ProductId == 0) {%>
	<tr valign="top">
        <td class="field-name" width="40%">
			<%= GetMessage("Offers") %>:
		</td>
		<td>
			<% if(Item.IBlockElementId > 0) {%>
			<table>
				<tbody>
					<% foreach(BXCatalogItem sku in SkuItems) {%>
					<tr>
						<td>
							<%= HttpUtility.HtmlEncode(sku.IBlockElement.Name) %>
						</td>
						<td>
							<a href="<%= HttpUtility.HtmlAttributeEncode(GetSKUModificationUrl(sku.Id)) %>"><%= GetMessage("EditOffer") %></a>
							<a href="<%= HttpUtility.HtmlAttributeEncode(GetSKUDeletionUrl(sku.Id)) %>" onclick="return confirm('<%= BXJSUtility.Encode(GetMessage("ConfirmOfOfferDetetion")) %>');"><%= GetMessage("DeleteOffer") %></a>
						</td>
					</tr>
					<%} %>
					<tr>
						<td>
							<a href="<%= HttpUtility.HtmlAttributeEncode(GetSKUCreationUrl()) %>"><%= GetMessage("CreateOffer") %></a>
						</td>
					</tr>
				</tbody>
			</table>
			<%} %>
			<% else {%>
				<%= GetMessage("Message.SaveNewProductBeforeCreateOffer") %>
			<%} %>
		</td>			
	</tr>
	<%} %>
    <tr valign="top">
        <td class="field-name" width="40%">
            <%= GetMessage("AvailableQuantity")%>:
        </td>
        <td>
            <asp:TextBox runat="server" ID="QuantityTbx" />
            <asp:RegularExpressionValidator runat="server" ID="QuantityValidator" ControlToValidate="QuantityTbx" ValidationExpression="^-?\d+$" Display="Dynamic" ValidationGroup="XXX">*</asp:RegularExpressionValidator>
        </td>
    </tr>
    <tr valign="top">
        <td class="field-name" width="40%">
            <%= GetMessage("Weight")%>:
        </td>
        <td>
            <asp:TextBox runat="server" ID="WeightTbx" />
            <asp:RegularExpressionValidator runat="server" ID="WeightValidator" ControlToValidate="WeightTbx" ValidationExpression="^\d+(\.\d+)?$" Display="Dynamic" ValidationGroup="XXX" >*</asp:RegularExpressionValidator>
        </td>
    </tr>    
    <tr valign="top">
        <td class="field-name" width="40%">
            <%= GetMessage("VATRate") %>:
        </td>
        <td>
            <asp:DropDownList runat="server" ID="VATRateList"></asp:DropDownList>
        </td>
    </tr>
    <tr valign="top">
        <td class="field-name" width="40%">
            <%= GetMessageRaw("VATIncluded") %>:
        </td>
        <td>
            <asp:CheckBox runat="server" ID="VATIncluded"/> 
        </td> 
    </tr>   
    <tr valign="top">
        <td class="field-name" width="40%">
            <%= GetMessageRaw("EnableTierPricing") %>:
        </td>
        <td>
            <asp:CheckBox runat="server" ID="EnableTierPricing"/> 
        </td> 
    </tr>     
</table>
<asp:HiddenField runat="server" ID="CatalogItemData" />

<script type="text/javascript">
    if (typeof (Bitrix) == "undefined") { var Bitrix = new Object(); }
    Bitrix.CatalogIBlockElementEditor = function() {
        this._isNew = true;
        this._priceTiers = [];
        this._zeroLevTier = null;
        this._tierPricingCbx = null;
        this._tierPricing = false;
        this._firstPriceRowInd = -1;
        this._btnAddTier = null;
        this._tierTable = null;
    }
    Bitrix.CatalogIBlockElementEditor.prototype = {
        initialize: function() {
        },
        toString: function() {
            var s = "", p = "";
            if(this._tierPricing) {
				for (var i = 0; i < this._priceTiers.length; i++) {
					if(p.length > 0) p += ", ";
					p += this._priceTiers[i].toString();
				}
				s += "priceTiers:[" + p + "]";            
            }
            else
				s += "priceTiers:[" + this._zeroLevTier.toString() + "]";                  
            return "{" + s + "}";
        },
        getTierPricing: function() { return this._tierPricing; },
        isNew: function() { return this._isNew; },
        _handleEnableTiersClick: function() {
            this._tierPricing = this._tierPricingCbx.checked;
            
            if(this._firstPriceRowInd >= 0) {
                var table = this._getContainerTable();
                while(table.rows.length - 1 >= this._firstPriceRowInd)
                    table.deleteRow(table.rows.length - 1);
            }
            this.createPriceHtml();          
        },
        _getContainerTable: function() { return document.getElementById("IBlockElementEditorTab"); },
        deleteTier: function(id) {
            var tiers = this._priceTiers;
            var ind = -1;
            for (var i = 0; i < tiers.length; i++) {
                var t = tiers[i];
                if(t.getId() != id) continue;
                ind = i;
                break;
            }
            if(ind < 0) return;
            var tier = tiers[ind];
            this._tierTable.deleteRow(tier.getCont().rowIndex);
            tiers.splice(ind, 1); 
            delete tear;           
        },
		fromObject: function(obj) {
		    this._priceTiers = [];
		    this._zeroLevTier = null;
            this._isNew = obj.isNew;
			for(var i = 0; i < obj.priceTiers.length; i++) {
                var t = Bitrix.CatalogPriceTier.createFromObject(i, obj.priceTiers[i]);	
                if(!this._zeroLevTier || t.isZeroLevel() || t.getQtyFrom() < this._zeroLevTier.getQtyFrom())
                    this._zeroLevTier = t;  			
                this._priceTiers.push(t);
            }
            
            if(!this._zeroLevTier) {
                this._zeroLevTier = Bitrix.CatalogPriceTier.create(0, 1);
                this._priceTiers.push(this._zeroLevTier);
            }
            this._zeroLevTier.setZeroLevel(true);
            
			this.createHtml();	
		},
        createHtml: function() {
		    var table = this._getContainerTable();
		    this._tierPricing = this._priceTiers.length > 1;
		    var tierCbx = this._tierPricingCbx = document.getElementById("<%= EnableTierPricing.ClientID %>");		    
		    tierCbx.checked = this._tierPricing;
	        tierCbx.onclick = Bitrix.TypeUtility.createDelegate(this, this._handleEnableTiersClick);		
	        this.createPriceHtml();
        },
        createPriceHtml:function() {           
            var table = this._getContainerTable();
	        this._firstPriceRowInd = table.rows.length;	
	        	         
	        var tierPricing = this.getTierPricing();
	        if(tierPricing) {
		        var r = table.insertRow(-1);
		        var c = r.insertCell(-1);
		        c.colSpan = 2;
		        c.align = "center";
		        var tierTable = this._tierTable = document.createElement("TABLE");
		        c.appendChild(tierTable);
		        
		        var hd = tierTable.insertRow(-1);
		        
		        var hdQty = hd.insertCell(-1);
		        hdQty.innerHTML = "<%= GetMessageJS("From") %>";		        
		        
		        var zeroLevelPrices = this._zeroLevTier.getPrices(); 
		        for(var k in zeroLevelPrices) {
		            var hdType = hd.insertCell(-1);
		            hdType.innerHTML = zeroLevelPrices[k].getTitle();		        
		        }                

		        var priceR = tierTable.insertRow(-1);
		        priceR.vAlign = "top";		            		        
		        this._zeroLevTier.createHtml(priceR, true);
		                        
		        for (var i = 0; i < this._priceTiers.length; i++) {
		            var t = this._priceTiers[i];
		            if(t.isZeroLevel()) continue;
		            priceR = tierTable.insertRow(-1);
		            priceR.vAlign = "top";		             		        
		            t.createHtml(priceR, true);                   
		        }
		        var hdAct = hd.insertCell(-1);
		        
		        var actR = tierTable.insertRow(-1);	
		        var actC = actR.insertCell(-1);
		        actC.colSpan = 3;
		        
                this._btnAddTier = document.createElement("A");
                this._btnAddTier.href = "";	             
                this._btnAddTier.innerHTML = "<%= GetMessageJS("CreatePriceTier") %>";
                this._btnAddTier.onclick = Bitrix.TypeUtility.createDelegate(this, this._handleAddTierBtnClick);			                        
                actC.appendChild(this._btnAddTier);
	        }
	        else {
	        	var prices = this._zeroLevTier.getPrices();            
                for (var i = 0; i < prices.length; i++) {
                    var p = prices[i];
			        var r = table.insertRow(-1);
                    r.vAlign = "top";	
			        var ttlC = r.insertCell(-1);
			        ttlC.className = "field-name";
			        ttlC.width = "40%";
			        //ttlC.vAlign = "top";
			        p.createHtmlForTitle(ttlC, true);
                    var cntC = r.insertCell(-1);	
			        //cntC.vAlign = "bottom";
			        p.createHtmlForContent(cntC, false);
			    }
			}            
        },
        _handleAddTierBtnClick: function() {
            if(!this.getTierPricing()) return;

            var qty = 10;
            if(this._priceTiers.length > 1) {
                if(this._priceTiers.length == 2)
                    qty = 2 * this._priceTiers[this._priceTiers.length - 1].getQtyFrom();
                else
                    qty = 2 * this._priceTiers[this._priceTiers.length - 1].getQtyFrom() - this._priceTiers[this._priceTiers.length - 2].getQtyFrom();
            }
            var t = Bitrix.CatalogPriceTier.create(this._priceTiers.length, qty > 0 ? qty : NaN);
            this._priceTiers.push(t);            
            var priceR = this._tierTable.insertRow(this._tierTable.rows.length - 1);
            priceR.vAlign = "bottom";		             		        
            t.createHtml(priceR, true);             
            return false;
        }		
    }
    Bitrix.CatalogIBlockElementEditor._instance = null;
    Bitrix.CatalogIBlockElementEditor.getInstance = function() {
        if (this._instance) return this._instance;
        (this._instance = new Bitrix.CatalogIBlockElementEditor()).initialize();
        return this._instance;
    }
    
    Bitrix.CatalogIBlockElementEditor.fromObject = function(obj) { return this.getInstance().fromObject(obj); }
    Bitrix.CatalogIBlockElementEditor.toString = function() { return this.getInstance().toString(); }
   
   
    Bitrix.CatalogExtra = function() {
        this._id = 0;
        this._value = 0.0;
		this._title = "";
    }

    Bitrix.CatalogExtra.prototype = {
        initialize: function(id, title, value) {
            this._id = id;
			this._title = title;
            this._value = value;
        },
        getId: function() { return this._id; },
        getValue: function() { return this._value; },
		getTitle: function() { return this._title; }
    }

    Bitrix.CatalogExtra._items = {}
	Bitrix.CatalogExtra.getItems = function() { return this._items; }	
    Bitrix.CatalogExtra.create = function(id, title, value) {
        var self = new Bitrix.CatalogExtra();
        self.initialize(id, title, value);
        this._items[id] = self;
        return self;
    }	
	
    Bitrix.CatalogExtra.getById = function(id) {
        return id in this._items ? this._items[id] : null;
    }

    <% foreach(BXCatalogExtra extra in Extras) {%>
    Bitrix.CatalogExtra.create(<%= string.Concat(extra.Id.ToString(), ", \"", string.Format(GetMessageJS("ExtraTitle"), extra.Name), "\",", extra.Value.ToString(System.Globalization.CultureInfo.InvariantCulture.NumberFormat)) %>);
    <%} %>

    Bitrix.CatalogPriceType = function() {
        this._id = 0;
        this._isBase = false;
        this._extraId = 0;
        this._title = "";
    }

    Bitrix.CatalogPriceType.prototype = {
        initialize: function(id, isBase, extraId, title) {
            this._id = id;
            this._isBase = isBase;
            this._extraId = extraId;
            this._title = title;
        },
        getId: function() { return this._id; },
        isBase: function() { return this._isBase; },
        getExtraId: function() { return this._extraId; },
        getTitle: function() { return this._title; }        
    }

    Bitrix.CatalogPriceType._items = {}
	Bitrix.CatalogPriceType.getItems = function() { return this._items; }	
    Bitrix.CatalogPriceType.create = function(id, isBase, extraId, title) {
        var self = new Bitrix.CatalogPriceType();
        self.initialize(id, isBase, extraId, title);
        this._items[id] = self;
        return self;
    }	
	
    Bitrix.CatalogPriceType.getById = function(id) {
        return id in this._items ? this._items[id] : null;
    }

    <% foreach(BXCatalogPriceType priceType in PriceTypes) {%>
    Bitrix.CatalogPriceType.create(<%= priceType.Id.ToString() %>, <%= priceType.IsBase.ToString().ToLowerInvariant() %>, <%= priceType.ExtraId.ToString() %>, "<%= BXJSUtility.Encode(string.Concat(priceType.GetLocalizedName(), ", ", priceType.Currency.GetSymbol())) %>");
    <%} %>

    Bitrix.CatalogPriceTier = function() {
        this._id = 0;
        this._basePrice = null;
        this._prices = [];
		this._qtyFrom = 0;
		this._isZeroLevel = false;
		this._qtyFromInp = this._errSpn = null;
        this._btnDel = null;
        this._cont = null;
    }
    
    Bitrix.CatalogPriceTier.prototype = {
        initialize: function(id, qtyFrom, prices, setByDefault) {
            this._id = id;
            this._qtyFrom = qtyFrom;

	        var priceTypes = Bitrix.CatalogPriceType.getItems();
            if(prices && prices.length > 0) {
	            for(var k in priceTypes) {
	                var pt = priceTypes[k];	
                    var p = null;
                    for(var i = 0; i < prices.length; i++) {
                        if(prices[i].typeId != pt.getId()) continue;
                        p = prices[i];
                        break;
                    }
                    if(p) 
                        this.addPrice(Bitrix.CatalogPrice.createFromObject(id, p));
                    else
                        this.addPrice(Bitrix.CatalogPrice.create(0, pt.getId(), id, NaN, pt.isBase(), setByDefault ? pt.getExtraId() : 0, qtyFrom));	            	              
	            }    	            
            }
            else {
	            for(var k in priceTypes) {
	                var pt = priceTypes[k];	
                    this.addPrice(Bitrix.CatalogPrice.create(0, pt.getId(), id, NaN, pt.isBase(), setByDefault ? pt.getExtraId() : 0, qtyFrom));	            	              
	            }
            }            
        },
        getCont: function() { return this._cont; },
        getId: function() { return this._id; },
        getQtyFrom: function() { return this._qtyFromInp ? (this._qtyFrom = parseInt(this._qtyFromInp.value)) : this._qtyFrom; },
        isZeroLevel: function() { return this._isZeroLevel; },
        setZeroLevel: function(isZeroLevel) { this._isZeroLevel = isZeroLevel; },
        getPrices: function() { return this._prices; },
        addPrice: function(price) {
            if(!price) return;
            if(price.isBasePrice()) {
                this._basePrice = price;
                for (var i = 0; i < this._prices.length; i++)
                    this._prices[i].setBasePrice(this._basePrice);                 
            }
            else if(this._basePrice)
                price.setBasePrice(this._basePrice);
                
            this._prices.push(price);            
        },
        toString: function() {
            var s = "", p = "";
            s += "qtyFrom:" + (this._isZeroLevel ? "1" : this.getQtyFrom().toString());
            for (var i = 0; i < this._prices.length; i++) {
                if(p.length > 0) p += ", ";
                p += this._prices[i].toString();
            }
            s += ", prices:[" + p + "]";                     
            return "{" + s + "}";
        },
        validate: function() {
            var v = this.getQtyFrom();
            var err = this._errSpn;
			if(err) err.style.visibility = !isNaN(v) && v > 0 ? "hidden" : "visible";
        },
        createHtml: function(cont, extraInPriceContent) { 
            this._cont = cont;                   

	        var qtyC = cont.insertCell(-1);      
            var qtyInp = this._qtyFromInp = document.createElement("INPUT");
            qtyInp.type = "text";
            qtyInp.value = !isNaN(this._qtyFrom) ? this._qtyFrom.toString() : "";
            qtyC.appendChild(qtyInp);		                        
            Bitrix.EventUtility.addEventListener(qtyInp, "change", Bitrix.TypeUtility.createDelegate(this, this._handleQtyFromChange));	
            qtyInp.focus();
            qtyInp.select();

		    var errSpn = this._errSpn = document.createElement("SPAN");
		    errSpn.style.color = "Red";
		    errSpn.innerHTML = "*";
            qtyC.appendChild(errSpn);

            for(var i = 0; i < this._prices.length; i++) {	            
                var priceC = cont.insertCell(-1);   
                this._prices[i].createHtmlForContent(priceC, extraInPriceContent);                            		                		                
            }

	        var actC = cont.insertCell(-1); 
            var btnDel = this._btnDel = document.createElement("INPUT");
            btnDel.type = "button";	             
            btnDel.value = "<%= GetMessageJS("Delete") %>";
            if(this.isZeroLevel()) btnDel.disabled = true;
	        actC.appendChild(btnDel);
            Bitrix.EventUtility.addEventListener(btnDel, "click", Bitrix.TypeUtility.createDelegate(this, this._handleDeleteBtnClick));

            this.validate();
        },
        _handleQtyFromChange: function() {
            var qty = this.getQtyFrom();
            for(var i = 0; i < this._prices.length; i++)  	            
                this._prices[i].setQtyFrom(qty); 
                
            this.validate();             
        },
        _handleDeleteBtnClick: function() { 
            if(!this.isZeroLevel()) Bitrix.CatalogIBlockElementEditor.getInstance().deleteTier(this._id); 
        }            
    }
    
    Bitrix.CatalogPriceTier.create = function(id, qtyFrom){
        var self = new Bitrix.CatalogPriceTier();
        self.initialize(id, qtyFrom, null, true);
        return self;    
    }
    
    Bitrix.CatalogPriceTier.createFromObject = function(id, obj) {
        var self = new Bitrix.CatalogPriceTier();
        self.initialize(id, obj.qtyFrom, obj.prices, false);      
        return self;
    }
    
    Bitrix.CatalogPrice = function() {
        this._id = 0;
        this._typeId = this._extraId = 0;
        this._tierId = 0;
        this._isBase = false;
        this._valueInp = this._extraSel = this._errSpn = this._extraBtn = null;
        this._changeEvent = null;
        this._basePrice = null;
		this._value = 0.00;
		this._extraId = 0;
		this._qtyFrom = 0;
    }
    Bitrix.CatalogPrice.prototype = {
        initialize: function(id, typeId, tierId, value, isBase, extraId, qtyFrom) {
            this._id = id;
            this._typeId = typeId;
            this._tierId = tierId;
			this._value = value;
            this._isBase = isBase;
			this._extraId = extraId;
			this._qtyFrom = qtyFrom;
            this._srcObj = null;
        },
        isBasePrice: function() { return this._isBase; },
        getTitle: function() {
            var type = Bitrix.CatalogPriceType.getById(this._typeId);
            return type ? type.getTitle() : "<?>";
        },
        getTypeId: function() { return this._typeId; },
        getTierId: function() { return this._tierId; },
        getExtraId: function() { return this._extraId; },
        getValue: function() { return this._valueInp ? parseFloat(this._valueInp.value) : this._value; },
        getQtyFrom: function() { return this._qtyFrom; },
        setQtyFrom: function(val) { this._qtyFrom = val; },
        setBasePrice: function(price) {
            if(this._isBase) return;
            this._basePrice = price;
            if (price) price.addChangeListener(Bitrix.TypeUtility.createDelegate(this, this._handleBasePriceChange));
        },
        getBasePrice: function() { return this._basePrice; },
        addChangeListener: function(listener) {
            (this._changeEvent ? this._changeEvent : (this._changeEvent = new Bitrix.EventPublisher())).addListener(listener);
        },
        removeChangeListener: function(listener) {
            if (this._changeEvent) this._changeEvent.removeListener(listener);
        },
		validate: function() {
			if(!this._errSpn) return;
			var v = this._value = this.getValue();
			var r = this._isBase ? !isNaN(v) && v > 0 : isNaN(v) || v >= 0;
			this._errSpn.style.visibility = r ? "hidden" : "visible";				
		},
		layout: function() {
			var b = this._extraBtn;
			if(!b) return;
            if(this._extraId > 0) {
				var extra = Bitrix.CatalogExtra.getById(this._extraId);
				b.value = extra ? "<%= GetMessageJS("ExtraValues") %>".replace(/\{0\}/mg, extra.getValue().toString()) : "<%= GetMessageJS("Extra") %>";
            }
            else
				b.value = "<%= GetMessageJS("Extra") %>";			
		},
        _handleChange: function() {	
            this._value = this.getValue();				
			this.validate();
            if (!this._changeEvent) return;
            try { this._changeEvent.fire(this, arguments); } catch (e) { }
        },
        _handleExtraChange: function() {
            if(!this._extraSel || !this._valueInp) return;
            this._valueInp.disabled = Bitrix.CatalogExtra.getById(parseInt(this._extraSel.value)) != null;            
            this.calculate();
        },
        _handleBasePriceChange: function() {
            this.calculate();
        },
        calculate: function() {
            if (this._isBase || !this._basePrice || !this._valueInp) return;
            var extra = Bitrix.CatalogExtra.getById(this._extraId);
            if (!extra) {
				this.layout();
				return;
			}
			this._value = this._basePrice.getValue() * (1 + extra.getValue() / 100);
            this._valueInp.value = !isNaN(this._value) ? this._value.toFixed(2) : "";
            this.layout();
			this.validate();
        },
        createHtmlForTitle: function(cont, extraInTitle) {
		    if(this._isBase) {
			    var requiredSpan = document.createElement("SPAN");
			    requiredSpan.className = "required";
			    requiredSpan.innerHTML = "*";
			    cont.appendChild(requiredSpan);
		    } 
		    
		    cont.appendChild(document.createTextNode(this.getTitle() + ":"));
		    if(this._isBase) {
		        cont.appendChild(document.createElement("BR"));
			    cont.appendChild(document.createTextNode("(<%= GetMessage("BasePrice")%>)"));
            }
        },
        createHtmlForContent: function(cont, extraInContent) {
		    var valInp = this._valueInp = document.createElement("INPUT");
		    valInp.type = "text";
		    valInp.value = !isNaN(this._value) ? this._value.toFixed(2) : this._srcObj ? this._srcObj.value : "";
		    valInp.disabled = this._extraId > 0 && Bitrix.CatalogExtra.getById(parseInt(this._extraId));
		    cont.appendChild(valInp);
            Bitrix.EventUtility.addEventListener(valInp, "change", Bitrix.TypeUtility.createDelegate(this, this._handleChange));	
		    var errSpn = this._errSpn = document.createElement("SPAN");
		    errSpn.style.color = "Red";
		    errSpn.innerHTML = "*";
		    cont.appendChild(errSpn);  

            if(!this._isBase) {				
                var extraBtn = this._extraBtn = document.createElement("INPUT");
                extraBtn.type = "button";					
                cont.appendChild(extraBtn);
                Bitrix.EventUtility.addEventListener(extraBtn, "click", Bitrix.TypeUtility.createDelegate(this, this._handleExtraBtnClick));
            }

			this.layout();
		    this.validate();      
        },
        _handleExtraBtnClick: function(e) {
		    if (!e && "event" in window) e = window.event;
		    Bitrix.EventUtility.stopEventPropagation(e);
            if(Bitrix.CatalogExtraPicker.getCaller() == this && Bitrix.CatalogExtraPicker.isVisible())
                Bitrix.CatalogExtraPicker.hide();
            else
                Bitrix.CatalogExtraPicker.show(this._extraId, this._extraBtn, this, Bitrix.TypeUtility.createDelegate(this, this._handleExtraPickerChange));
        },
        _handleExtraPickerChange: function(id, canceled) {
            if(!canceled) {
                this._extraId = id;
                this._valueInp.disabled = Bitrix.CatalogExtra.getById(id) != null;            
                this.calculate();
            }
            Bitrix.CatalogExtraPicker.hide();            
        },
		toString: function() {
			var s = "";
			s += "id:" + this._id.toString();
			s += ", typeId:" + this._typeId.toString();
			s += ", isBase:" + this._isBase.toString();
			s += ", extraId:" + this._extraId.toString();                
			s += ", value:\"" + Bitrix.HttpUtility.jsonEncode(this._valueInp ? this._valueInp.value : this._value.toString()) + "\"";
			s += ", qtyFrom:\"" + (!isNaN(this._qtyFrom) ? this._qtyFrom.toString() : "") + "\"";                
			return "{" + s + "}";
		}
    }
	
    Bitrix.CatalogPrice.create = function(id, typeId, tierId, value, isBase, extraId, qtyFrom) {
        var self = new Bitrix.CatalogPrice();
        self.initialize(id, typeId, tierId, value, isBase, extraId, qtyFrom);
        return self;
    }

    Bitrix.CatalogPrice.createFromObject = function(tierId, obj) {
        var self = new Bitrix.CatalogPrice();
        self.initialize(obj.id, obj.typeId, tierId, parseFloat(obj.value), obj.isBase, obj.extraId, parseInt(obj.qtyFrom));
        self._srcObj = obj;
        return self;        
    }

    Bitrix.CatalogExtraPicker = function() {
        this._cont = this._sel = this._caller = this._callback = null;
        this._changeHdlr = Bitrix.TypeUtility.createDelegate(this, this._handleChange);
        this._bdClickHdlr = Bitrix.TypeUtility.createDelegate(this, this._handleBodyClick);
        this._isVisible = false;
    }
    Bitrix.CatalogExtraPicker.prototype = {
        initialize: function() {
            var cont = this._cont = document.createElement("DIV");
            cont.style.position = "absolute";
            cont.style.zIndex = "1000";
            cont.style.overflow = "hidden";
            cont.style.zoom = "1";
            cont.style.border = "none";
            cont.style.padding = "0";
            cont.style.display = "none";

            document.body.appendChild(cont);

            var sel = this._sel = document.createElement("SELECT");
            sel.multiple = true;
            cont.appendChild(sel);
    		
	        var ary = [];
	        ary.push({ text:"<%= GetMessage("SetPriceManually")%>", value:"0" });
	        var extras = Bitrix.CatalogExtra.getItems();
	        for(var k in extras) {
		        var extra = extras[k];
		        ary.push({ text:extra.getTitle(), value:extra.getId().toString() });
	        }
	        Bitrix.DomHelper.addToSelect(sel, ary);
        },
        isVisible: function() { return this._isVisible; },
        show: function(id, anchor, caller, callback) {
            var sel = this._sel;            
	        Bitrix.DomHelper.selectOption(sel, id.toString());	
	        Bitrix.EventUtility.addEventListener(sel, "change", this._changeHdlr);
            Bitrix.EventUtility.addEventListener(document.body, "click", this._bdClickHdlr);

            var rect = Bitrix.ElementPositioningUtility.getElementRect(anchor);
            var cont = this._cont;
            cont.style.top = rect.top + rect.height;
            cont.style.left = rect.left;
            cont.style.display = "block";

            sel.focus();

            this._caller = caller;
            this._callback = callback;
            this._isVisible = true;
        },
        hide: function() {
            var sel = this._sel;
            Bitrix.EventUtility.removeEventListener(sel, "change", this._changeHdlr);
            Bitrix.EventUtility.removeEventListener(document.body, "click", this._bdClickHdlr);
            this._cont.style.display = "none";  
            this._callback = null;
            this._isVisible = false;          
        },
        getCaller: function() { return this._caller; },
        _handleChange: function() {
            if(this._callback) this._callback(parseInt(this._sel.value), false);
        },
        _handleBodyClick: function() { this.hide(); }
    }

    Bitrix.CatalogExtraPicker._instance = null;
    Bitrix.CatalogExtraPicker.getInstance = function() {
        if(!this._instance) {
            this._instance = new Bitrix.CatalogExtraPicker();
            this._instance.initialize();
        }
        return this._instance;
    },
    Bitrix.CatalogExtraPicker.isVisible = function() {
        return this.getInstance().isVisible();
    }
    Bitrix.CatalogExtraPicker.show = function(id, anchor, caller, callback) {
        this.getInstance().show(id, anchor, caller, callback);
    }
    Bitrix.CatalogExtraPicker.hide = function() {
        this.getInstance().hide();
    }
    Bitrix.CatalogExtraPicker.getCaller = function() {
        return this.getInstance().getCaller();
    }
</script>