﻿if (typeof (Bitrix) == "undefined") { var Bitrix = {}; }

Bitrix.CatalogSkuSelectDialog = function Bitrix$CatalogSkuSelector() {
    this.Bitrix$Dialog();
    this._selectElement = this._priceElement = this._qtyElement = this._add2CartBtn = this._priceCnt = this._add2CartCnr = this._qtyTtlCnt = this._qtyCnt = this._buttonTtlCnt = this._buttonCnt = this._cartInfoCnt = this._cartInfoElement = null;
    this._closeHandler = Bitrix.TypeUtility.createDelegate(this, this._handleSelfClose);
    this._selectChangeHandler = Bitrix.TypeUtility.createDelegate(this, this._handleSelectionChange);	
    this._add2CartHandler = Bitrix.TypeUtility.createDelegate(this, this._handleAdd2Cart);	
}
Bitrix.TypeUtility.copyPrototype(Bitrix.CatalogSkuSelectDialog, Bitrix.Dialog);
Bitrix.CatalogSkuSelectDialog.prototype.initialize = function(id, name, title, options) {
    this.Bitrix$Dialog.prototype.initialize.call(this, id, name, title, null, Bitrix.Dialog.buttonLayout.continueLayout, options);
    var content = new Array();

    var container = document.createElement("DIV");
    container.id = id + "_" + "container";
    container.className = this.getOption("_contentContainerClass");
    content.push(container);

	var legendCnr = document.createElement("DIV");
	legendCnr.className = this.getOption("_legendContainerClass");
	container.appendChild(legendCnr);
	
	var legend = document.createElement("SPAN");
	legend.className = this.getOption("_legendClass");
	legendCnr.appendChild(legend);	
	legend.innerHTML = this.getMessage("legend");
	
	var inputCnr = document.createElement("DIV");
	inputCnr.className = this.getOption("_inputContainerClass");
	container.appendChild(inputCnr);
	
	var input = this._selectElement = document.createElement("SELECT"); 
	input.className = this.getOption("_inputClass");
	inputCnr.appendChild(input);
	Bitrix.EventUtility.addEventListener(input, "change", this._selectChangeHandler);
	
	var add2CartCnr = this._add2CartCnr = document.createElement("DIV");
	add2CartCnr.className = this.getOption("_add2CartContainerClass");
	container.appendChild(add2CartCnr);

	var add2CartTab = document.createElement("TABLE");
	add2CartCnr.appendChild(add2CartTab);	
	
	var headR = add2CartTab.insertRow(-1);
	var dataR = add2CartTab.insertRow(-1);
			
	var priceLegend = document.createElement("SPAN");
	priceLegend.className = this.getOption("_priceLegendClass");
	var priceLegendCnt = headR.insertCell(-1);
	priceLegendCnt.align = "left";
	priceLegendCnt.appendChild(priceLegend);	
	priceLegend.innerHTML = this.getMessage("priceLegend");
	
	var price = this._priceElement = document.createElement("SPAN");
	price.className = this.getOption("_priceClass");
	this._priceCnt = dataR.insertCell(-1);
	this._priceCnt.align = "left";
	this._priceCnt.appendChild(price);		
					
	var qtyLegend = document.createElement("SPAN");
	qtyLegend.className = this.getOption("_qtyLegendClass");
	this._qtyTtlCnt = headR.insertCell(-1);
	this._qtyTtlCnt.align = "left";
	this._qtyTtlCnt.appendChild(qtyLegend);	
	qtyLegend.innerHTML = this.getMessage("qtyLegend");	
	
	var qty = this._qtyElement = document.createElement("INPUT"); 
	qty.type = "text";
	qty.className = this.getOption("_qtyClass");
	this._qtyCnt = dataR.insertCell(-1);
	this._qtyCnt.align = "right";
	this._qtyCnt.appendChild(qty);
		
	this._buttonTtlCnt = headR.insertCell(-1);
	var add2Cart = this._add2CartBtn = document.createElement("INPUT"); 
	add2Cart.type = "button";
	add2Cart.className = this.getOption("_buttonClass");
	add2Cart.value = this.getMessage("add2Cart");
	this._buttonCnt = dataR.insertCell(-1);
	this._buttonCnt.align = "right";
	this._buttonCnt.appendChild(add2Cart);
	Bitrix.EventUtility.addEventListener(add2Cart, "click", this._add2CartHandler);	
	
	var infoR = add2CartTab.insertRow(-1);
	var cartInfo = this._cartInfoElement = document.createElement("SPAN");
	this._cartInfoCnt = infoR.insertCell(-1);
	this._cartInfoCnt.align = "left";
	this._cartInfoCnt.appendChild(cartInfo);			

	this._loadData();	
    this.setContent(content);
}
Bitrix.CatalogSkuSelectDialog.prototype.construct = function() {
	if (this._isConstructed) return;
	this.Bitrix$Dialog.prototype.construct.call(this);
	this.addCloseListener(this._closeHandler);
}
Bitrix.CatalogSkuSelectDialog.prototype._loadData = function() {
	var input = this._selectElement;
	Bitrix.DomHelper.removeAllFromSelect(input);
	var skuItems = this.getOption("_skuItems");
	if(skuItems.length > 0) {
		var options = [];
		for(var i = 0; i < skuItems.length; i++)
			options.push({ "text":skuItems[i].name, "value":skuItems[i].id });
		Bitrix.DomHelper.addToSelect(input, options);
		Bitrix.DomHelper.selectOption(input, options[0].value);	
		
		this.setOption("_skuId", skuItems[0].id); 
		this._layout();
	}	
}
Bitrix.CatalogSkuSelectDialog.prototype._layout = function() {
	var selected = this.getOption("_skuId", "");
	var skuItems = this.getOption("_skuItems");
	if(skuItems.length == 0) return;
	var curItem = null;
	for(var i = 0; i < skuItems.length; i++) {
		if(skuItems[i].id != selected) continue;
		curItem = skuItems[i];
		break;
	}
	if(!curItem) return;				
	
	if(this.getOption("_mode") != "add2Cart")
		this._add2CartCnr.style.display = "none";	
	else {
		this._add2CartCnr.style.display = "";
		this._priceCnt.style.display = "";
		this._priceElement.innerHTML = curItem.sellingPriceHtml;
			
		if(curItem.quantityInCart > 0) {
			if(this.getOption("_acceptQuantity", false)) {
				this._qtyTtlCnt.style.display = "none";
				this._qtyCnt.style.display = "none";			
			}
			this._buttonTtlCnt.style.display = "none";
			this._buttonCnt.style.display = "none";
			this._cartInfoElement.innerHTML = this.getMessage("alreadyInCart").replace(/\#QTY\#/i, curItem.quantityInCart.toString());
			this._cartInfoElement.className = this.getOption("_cartInfoClassInCart");
			this._cartInfoCnt.style.display = "";		
		}
		else if(curItem.isInStock && curItem.sellingPriceHtml.length > 0) {
			if(this.getOption("_acceptQuantity", false)) {
				this._qtyTtlCnt.style.display = this._qtyCnt.style.display = "";
				var qty = this.getOption("quantity", -1);
				if(qty <= 0 || isNaN(qty)) qty = this.getOption("_initQuantity", -1);
				if(qty <= 0 || isNaN(qty)) qty = 1;
				this._qtyElement.value = qty.toString();
			}
			else 
				this._qtyTtlCnt.style.display = this._qtyCnt.style.display = "none";
				
			this._buttonTtlCnt.style.display =  this._buttonCnt.style.display = "";
			this._cartInfoCnt.style.display = "none";
		}
		else {
			if(this.getOption("_acceptQuantity", false)) this._qtyTtlCnt.style.display = this._qtyCnt.style.display = "none";			
			this._buttonTtlCnt.style.display =  this._buttonCnt.style.display = "none";
			
			this._cartInfoCnt.style.display = "";			
			this._cartInfoElement.innerHTML = curItem.isInStock ? this.getMessage("notAvailable") : this.getMessage("emptyStock");
			this._cartInfoElement.className = this.getOption("_cartInfoClassUnAvailable");					
		}
	}	
}
Bitrix.CatalogSkuSelectDialog.prototype.getSkuId = function() { return this._selectElement ? this._selectElement.value : this.getOption("_skuId");  }
Bitrix.CatalogSkuSelectDialog.prototype.setSkuId = function(val) { 
	this.setOption("_skuId", val); 
	if(this._selectElement) Bitrix.DomHelper.selectOption(this._selectElement, val);  
}
Bitrix.CatalogSkuSelectDialog.prototype.getOption = function(name, defaultValue) {
	if(!Bitrix.TypeUtility.isNotEmptyString(name)) return defaultValue;
	if (this._options && name in this._options) return this._options[name];
	else if (name in Bitrix.CatalogSkuSelectDialog.defaults) return Bitrix.CatalogSkuSelectDialog.defaults[name];	
	else if (name in Bitrix.Dialog.defaults) return Bitrix.Dialog.defaults[name];
	else return defaultValue;
}
Bitrix.CatalogSkuSelectDialog.prototype._handleSetOptions = function() { this._loadData(); }
Bitrix.CatalogSkuSelectDialog.prototype._getAdditionalContainerWrapperClasses = function() { return this.getOption("_containerWrapperClass"); }
Bitrix.CatalogSkuSelectDialog.prototype._getMessageKeyPrefix = function() { return ""; }
Bitrix.CatalogSkuSelectDialog.prototype._getMessageContainerName = function() { return "CATALOG_SKU_SELECT_DIALOG_MSG"; }
Bitrix.CatalogSkuSelectDialog.prototype._handleSelfClose = function(e) { if(this._selectElement) this.setOption("_skuId", this._selectElement.value); }
Bitrix.CatalogSkuSelectDialog.prototype._handleSelectionChange = function() {
	this.setOption("_skuId", this._selectElement.value); 
	this._layout();
}
Bitrix.CatalogSkuSelectDialog.prototype._handleAdd2Cart = function() {
	var add2CartCallback = this.getOption("add2CartCallback");
	if(!add2CartCallback) return;
	var qty = this.getOption("_acceptQuantity", false) ? parseInt(this._qtyElement.value) : this.getOption("_initQuantity", 1);
	add2CartCallback(this._selectElement.value, { "quantity":qty, "callback":Bitrix.TypeUtility.createDelegate(this, this._handleAdd2CartCompletion) });
}
Bitrix.CatalogSkuSelectDialog.prototype._handleAdd2CartCompletion = function(res) {
	if(!res) return;
	if(!("isInCart" in res && res.isInCart)) {
		alert(this.getMessage("adding2CartFailed"));
		return;
	}
	
	var selected = this.getOption("_skuId", "");
	var skuItems = this.getOption("_skuItems");
	if(skuItems.length == 0) return;
	var curItem = null;
	for(var i = 0; i < skuItems.length; i++) {
		if(skuItems[i].id != selected) continue;
		curItem = skuItems[i];
		break;
	}
	if(curItem) curItem.quantityInCart = "addedQty" in res ? res.addedQty : 0;
	this._layout();
}

Bitrix.CatalogSkuSelectDialog.create = function(id, name, title, options) {
	if(this._items && id in this._items) throw "Item '"+ id +"' already exists!";
	var self = new Bitrix.CatalogSkuSelectDialog();
	self.initialize(id, name, title, options);
	Bitrix.Dialog._addItem(self);
	return self;
}

Bitrix.CatalogSkuSelectDialog.defaults = {
	_containerWrapperClass:"bx-catalog-sku-select-dialog-container-wrapper",
	_contentContainerClass:"bx-catalog-sku-select-dialog-content-container",
	_legendContainerClass:"bx-catalog-sku-select-dialog-legend-container",
	_inputContainerClass:"bx-catalog-sku-select-dialog-input-container",
	_add2CartContainerClass:"bx-catalog-sku-select-dialog-add2cart-container",
	_priceLegendClass:"bx-catalog-sku-price-dialog-price-legend",
	_qtyLegendClass:"bx-catalog-sku-price-dialog-qty-legend",
	_legendClass:"bx-catalog-sku-select-dialog-legend",
	_inputClass:"bx-catalog-sku-select-dialog-input",
	_priceClass:"bx-catalog-sku-select-dialog-price",
	_qtyClass:"bx-catalog-sku-select-dialog-qty",
	_buttonClass:"bx-catalog-sku-select-dialog-button",
	_cartInfoClassUnAvailable: "bx-catalog-sku-select-dialog-cart-info-unavailable",
	_cartInfoClassInCart:"bx-catalog-sku-select-dialog-cart-info-already-in-cart"
}