﻿if (typeof (Bitrix) != "object")
	Bitrix = {};

Bitrix.DiscountDeleteButton = function(state, parentState, removeContainer, processor) {
	this.state = state;
	this.parentState = parentState;
	this.removeContainer = removeContainer;
	//this.img = document.createElement('IMG');
	//this.img.src = "../themes/.default/images/discount/icon-delete.gif";
	this.button = document.createElement('A');
	this.button.className = "rule-prop-delete";
	this.button.innerHTML = "&nbsp;&nbsp;&nbsp;";
	//this.button.appendChild(this.img);
	BX.bind(this.button, 'click', BX.delegate(
		function() {
			processor.DeleteTree(this.state, this.parentState);
			this.removeContainer.parentNode.removeChild(this.removeContainer);
		},
	this));
	this.removeContainer.appendChild(this.button);
}

Bitrix.DiscountCreateButton = function(parent, parentContainer, selectListLabel, defaultSelectLabel, processor, parentVariant) {
	this.parent = parent;
	this.parentContainer = parentContainer;
	this.container = document.createElement('DIV');
	this.container.className = "create-container";
	this.img = document.createElement('IMG');
	this.img.src = "../themes/.default/images/discount/icon-plus.gif";
	this.link = document.createElement('A');
	this.link.className = "rule-prop-add";
	this.link.innerHTML = "";
	this.select = document.createElement('SELECT');

	var op = document.createElement('OPTION');
	op.innerHTML = defaultSelectLabel;
	op.value = "";
	this.select.appendChild(op);

	//debugger;
	for (var i = 0; i < processor.variants.length; i++) {

		if (typeof (processor.variants[i].showInTypes) == "object") {

			if (!processor.variants[i].showInTypes[parentVariant.name])
				continue;
		}
		op = document.createElement('OPTION');
		op.innerHTML = processor.variants[i].label;
		op.value = processor.variants[i].name;
		this.select.appendChild(op);
	}
	this.select.style.display = "none";

	BX.bind(this.select, 'change', BX.delegate(
		function() {

			if (this.select.selectedIndex == 0) return;

			//create new condition
			var newState = {};
			newState.children = [];
			newState.values = {};
			newState.typeId = this.select.options[this.select.selectedIndex].value;
			this.parent.children.push(newState);
			processor.RenderTree(newState, this.parentContainer, this.parent, this.parent.children.length);

			this.link.style.display = "";
			this.select.style.display = "none";
			this.select.selectedIndex = 0;
		}, this));

	BX.bind(this.link, 'click', BX.delegate(
		function() {
			this.link.style.display = "none";
			this.select.style.display = "";
			this.select.focus();
		}, this));

	BX.bind(this.select, 'blur', BX.delegate(
		function() {

			if (this.select.style.display == "") {
				this.select.style.display = "none";
				this.link.style.display = "";
			}
		}, this));

	this.link.appendChild(this.img);
	this.container.appendChild(this.link);
	this.container.appendChild(this.select);
	this.parentContainer.appendChild(this.container);
}

/***************************** Discount control - Catalog selector *****************************/
Bitrix.DiscountControlCatalogSelector = function(parentContainer, id, state, selectLabel, clickHandler) {
	this.typeId = id;
	this.state = state;
	this.valuesContainer = state.values;
	this.input = document.createElement('INPUT');
	this.input.type = "hidden";
	this.input.id = parentContainer.id + "_input";
	this.input.typeId = id;
	this.input.valuesContainer = state.values;

	this.showLink = document.createElement('A');
	this.showLink.id = this.input.id + "_link";
	BX.bind(this.showLink, 'click', function() { return false; });

	if (typeof (this.valuesContainer[this.typeId]) != "undefined") {
		this.input.value = this.valuesContainer[this.typeId];
	}
	
	parentContainer.appendChild(this.showLink);
	if (typeof (this.valuesContainer[this.typeId]) != "undefined") {
		this.input.value = this.valuesContainer[this.typeId];
		this.showLink.innerHTML = this.valuesContainer[this.typeId + "Name"];
	}
	
	parentContainer.appendChild(this.input);
	BX.bind(this.input, 'change', BX.delegate(
		function() {
			this.valuesContainer[this.typeId] = this.input.value;
			this.valuesContainer[this.typeId + "Name"] = this.showLink.innerHTML;
		}, this));
	parentContainer.appendChild(document.createTextNode(' '));
	this.link = document.createElement('A');
	this.link.className = "rule-prop";
	this.link.innerHTML = selectLabel;
	BX.bind(this.link, 'click', BX.delegate(function() {
		if (clickHandler) { clickHandler(this.input.id); }

	}, this));
	parentContainer.appendChild(this.link);

}

/***************************** Discount control - Section selector *****************************/
Bitrix.DiscountControlSectionSelector = function(parentContainer, id, state, selectLabel, clickHandler) {
	this.typeId = id;
	this.state = state;
	this.valuesContainer = state.values;
	this.input = document.createElement('INPUT');
	this.input.type = "hidden";
	this.input.id = parentContainer.id + "_input";
	this.input.typeId = id;
	this.input.valuesContainer = state.values;

	this.showLink = document.createElement('A');
	this.showLink.id = this.input.id + "_link";
	BX.bind(this.showLink, 'click', function() { return false; });

	if (typeof (this.valuesContainer[this.typeId]) != "undefined") {
		this.input.value = this.valuesContainer[this.typeId];
	}
	
	parentContainer.appendChild(this.showLink);
	if (typeof (this.valuesContainer[this.typeId]) != "undefined") {
		this.input.value = this.valuesContainer[this.typeId];
		this.showLink.innerHTML = this.valuesContainer[this.typeId + "Name"];
	}
	
	parentContainer.appendChild(this.input);
	BX.bind(this.input, 'change', BX.delegate(
		function() {
			this.valuesContainer[this.typeId] = this.input.value;
			this.valuesContainer[this.typeId + "Name"] = this.showLink.innerHTML;
		}, this));
	parentContainer.appendChild(document.createTextNode(' '));
	this.link = document.createElement('A');
	this.link.className = "rule-prop";
	this.link.innerHTML = selectLabel;
	BX.bind(this.link, 'click', BX.delegate(function() {
		if (clickHandler) { clickHandler(this.input.id); }

	}, this));
	parentContainer.appendChild(this.link);

}

/***************************** Discount control - Product selector *****************************/
Bitrix.DiscountControlProductSelector = function(parentContainer, id, state, selectLabel, clickHandler) {

	this.typeId = id;
	this.state = state;
	this.valuesContainer = state.values;
	this.clickHandler = clickHandler;

	this.showLink = document.createElement('A');

	BX.bind(this.showLink, 'click', function() { return false; });
	this.input = document.createElement('INPUT');
	this.input.type = "hidden";
	this.input.valuesContainer = state.values;
	this.input.typeId = id;
	this.input.id = parentContainer.id + "_input";
	this.showLink.id = this.input.id + "_link";
	parentContainer.appendChild(this.showLink);
	if (typeof (this.valuesContainer[this.typeId]) != "undefined") {
		this.input.value = this.valuesContainer[this.typeId];
		this.showLink.innerHTML = this.valuesContainer[this.typeId + "Name"];
	}

	parentContainer.appendChild(this.input);
	BX.bind(this.input, 'change', BX.delegate(
		function() {
			this.valuesContainer[this.typeId] = this.input.value;
			this.valuesContainer[this.typeId + "Name"] = this.showLink.innerHTML;
		}, this));
	parentContainer.appendChild(document.createTextNode(' '));
	this.link = document.createElement('A');
	this.link.className = "rule-prop";
	this.link.innerHTML = selectLabel;
	BX.bind(this.link, 'click', BX.delegate(function() {
		if (this.clickHandler) { this.clickHandler(this.input.id); }

	}, this));
	//	BX.bind(this.link, 'click', BX.delegate(function() {
	//		window.open('SaleProductSearch.aspx?site=<%= JSEncode(UrlEncode(siteId ?? "")) %>&currency=<%= currencyCode %>&onselect=ProductSearchSelect&returnparams=' + this.input.id, '', 'scrollbars=yes,resizable=yes,width=600,height=500,top=' + parseInt((screen.height - 500) / 2 - 14) + ',left=' + parseInt((screen.width - 600) / 2 - 5));
	//	}, this));
	parentContainer.appendChild(this.link);

}

/***************************** Discount control - input *****************************/
Bitrix.DiscountControlInput = function(parentContainer, id, state) {
	this.typeId = id;

	this.valuesContainer = state.values;
	this.input = document.createElement('INPUT');
	this.input.className = "discount-input";
	parentContainer.appendChild(this.input);
	if (this.valuesContainer[this.typeId]) {
		this.input.value = this.valuesContainer[this.typeId];
	}
	BX.bind(this.input, 'change', BX.delegate(
		function() {
			this.valuesContainer[this.typeId] = this.input.value;
		}, this));
}
/***************************** Discount control - select *****************************/
Bitrix.DiscountControlSelect = function(parentContainer, id, state, values, labels, selectDefaultLabel) {

	this.typeId = id;
	this.valuesContainer = state.values;
	this.values = values;
	this.labels = labels;

	this.select = document.createElement('SELECT');

	parentContainer.appendChild(this.select);

	var op = document.createElement('OPTION');
	op.innerHTML = selectDefaultLabel;
	op.value = "";
	this.select.appendChild(op);
	for (var i = 0; i < values.length; i++) {
		op = document.createElement('OPTION');
		op.innerHTML = labels[i];
		op.value = values[i];
		this.select.appendChild(op);
	}

	this.link = document.createElement('A');
	this.link.className = "rule-prop";
	this.select.style.display = "none";

	this.InitValue();

	parentContainer.appendChild(this.link);

	BX.bind(this.select, 'change', BX.delegate(
		function() {
			if (this.select.selectedIndex == 0) return true;
			this.valuesContainer[this.typeId] = this.select.options[this.select.selectedIndex].value;
			this.link.innerHTML = this.select.options[this.select.selectedIndex].text;
			this.link.style.display = "";
			this.select.style.display = "none";
		}, this));

	BX.bind(this.link, 'click', BX.delegate(
		function() {
			this.link.style.display = "none";
			this.select.style.display = "";
			this.select.focus();
		}, this));

	BX.bind(this.select, 'blur', BX.delegate(
		function() {

			if (this.select.style.display == "") {
				this.select.style.display = "none";
				this.link.style.display = "";
			}
		}, this));

}

Bitrix.DiscountControlSelect.prototype.InitValue = function()
{

	if(this.valuesContainer[this.typeId]){

		for(var i=0;i<this.select.options.length;i++)
		{
			if(this.select.options[i].value == this.valuesContainer[this.typeId])
				this.select.selectedIndex = i;
			
		}
		this.link.innerHTML = this.labels[this.select.selectedIndex-1];
	}
	else // init with default value
	{
			this.link.innerHTML = this.labels[0];
			this.select.selectedIndex = 1;
			this.valuesContainer[this.typeId] = this.values[0];
	}
}
/*****************************tree processing functions *****************************/

Bitrix.treeProcessor = function(settings) {
	if (settings) {
		this.productSelectHandler = settings.productSelectHandler;
		this.sectionSelectHandler = settings.sectionSelectHandler;
		this.saleProductSelectHandler = settings.saleProductSelectHandler;
		this.catalogSelectHandler = settings.catalogSelectHandler;
		this.variants = settings.variants;
	}
}

Bitrix.treeProcessor.prototype.FindControlVariant = function( typeId)
{
	for ( var i =0; i< this.variants.length; i++)
		if ( this.variants[i].name == typeId )
			return this.variants[i];
	return null; 
}


Bitrix.treeProcessor.prototype.DeleteTree = function(state, parent)
{
	
	if(state.children)
		for(var i =0; i < state.children.length; i++)
			this.DeleteTree(state.children[i]);

	if(parent)
	{

		if(parent.children){
			for(var j=0; j< parent.children.length;j++)
			{
				if(parent.children[j] == state){
					parent.children.splice(j,1);
					break;
				}
			}
		}
	}
}


Bitrix.treeProcessor.prototype.RenderTree = function(state, initialContainer, parent, num) {
	var div = document.createElement('DIV');
	div.id = initialContainer.id + "_" + num;
	div.className = "condition-container";

	if (initialContainer.childNodes.length == 0)
		initialContainer.appendChild(div);
	else
		initialContainer.insertBefore(div, initialContainer.childNodes[initialContainer.childNodes.length - 1]);

	var variant = this.FindControlVariant(state.typeId);

	for (var i = 0; i < variant.control.length; i++) {
		var item = variant.control[i];
		if (typeof (item) == "object") {
			var element;
			switch (item.type) {
				case "select":
					element = new Bitrix.DiscountControlSelect(div, item.id, state, item.values, item.labels, variant.defaultSelectLabel);
					break;
				case "input":
					element = new Bitrix.DiscountControlInput(div, item.id, state, item.labels);
					break;
				case "prodSelector":

					element = new Bitrix.DiscountControlProductSelector(div, item.id, state, variant.defaultSelectLabel, this.productSelectHandler);
					break;
				case "sectSelector":
					element = new Bitrix.DiscountControlSectionSelector(div, item.id, state, variant.defaultSelectLabel, this.sectionSelectHandler);
					break;
				case "catalogSelector":

					element = new Bitrix.DiscountControlCatalogSelector(div, item.id, state, variant.defaultSelectLabel, this.catalogSelectHandler);
					break;
			}
			div.appendChild(document.createTextNode(' '));
		}
		else if (typeof (item) == "string") {
			div.appendChild(document.createTextNode(item));
		}

	}

	//create delete button
	if (typeof (state.showDeleteButton) == "undefined" || state.showDeleteButton == true) {
		var deleteButton = new Bitrix.DiscountDeleteButton(state, parent, div, this);
	}

	//add createButton
	if (variant.group == true) {
		if (state.typeId == "ConditionGroup")
			div.className = "condition-container"
		else 
		div.className = "condition-container condition-list";
		var button = new Bitrix.DiscountCreateButton(state, div, variant.defaultSelectLabel, variant.defaultSelectLabel, this, variant);
	}

	for (var j = 0; j < state.children.length; j++)
		this.RenderTree(state.children[j], div, state, j);
}
// tree serialization
Bitrix.treeProcessor.SerializeTree = function(state, parent, parentId, number) {
	//parent, operators, values

	var id;
	if (typeof (parentId) != "undefined" && parentId != null)
		id = parentId + "_" + number;
	else
		id = "el_0";

	var opStr = "";
	if (parent == null)
		opStr += "<root>";
	var groupStr = "";

	if (state.typeId == "ConditionGroup" || state.typeId == "SumGroup" || state.typeId == "QuantityGroup")
		groupStr = 'group="true"';
	else
		groupStr = 'group="false"';

	opStr += '<op typeId="' + state.typeId + '" ' + groupStr + ' parentId="' + parentId + '" id="' + id + '"><values>';

	for (var item in state.values)
		opStr += '<value type="' + item + '">' + state.values[item] + '</value>';
	opStr += '</values>';

	for (var i = 0; i < state.children.length; i++)
		opStr += Bitrix.treeProcessor.SerializeTree(state.children[i], state, id, i);

	opStr += '</op>'
	if (parent == null)
		opStr += "</root>";

	return opStr;
}




