﻿<%@ Reference VirtualPath="~/bitrix/components/bitrix/rating.vote/component.ascx" %>
<%@ Control Language="C#" ClassName="template" AutoEventWireup="false" Inherits="Bitrix.CommunicationUtility.Components.RatingVoteTemplate" %>
<script runat="server">
    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        ClientScriptManager sm = Page.ClientScript;
        if (sm == null)
            return;
        
        StringBuilder sb = new StringBuilder();
        sb.Append("totalsContainer:\"").Append(ClientID).Append("_result\"");
		sb.Append(", ratingContainer:\"").Append(ClientID).Append("_rating\"");
		sb.Append(", plusLink:\"").Append(ClientID).Append("_plus\"");
		sb.Append(", minusLink:\"").Append(ClientID).Append("_minus\"");
        sb.Append(", isAllowed:").Append(Component.IsVotingAllowed.ToString().ToLowerInvariant());
        sb.Append(", titleTemplate:\"").AppendFormat(JSEncode(GetMessageRaw("TitleTemplate.Standard")), "#votes#", "#posVotes#", "#negVotes#").Append("\"");
        sb.Append(", noVotesMsg:\"").Append(GetMessageRaw("TitleTemplate.NoVotes")).Append("\"");
        sb.Append(", callBackScript:\"");
        sb.Append(
            JSEncode(
                sm.GetCallbackEventReference(
                    Component,
                    "action",
                    "Bitrix.RatingVoting.receiveServerData",
                    "Bitrix.RatingVoting.showServerError",
                    true
                    )
                )
            );
        sb.Append("\"");
        sb.Append(", totals:").Append(Component.VotingTotalsToJson());
        sb.Append("}").Insert(0, "{");
        string options = sb.ToString();
        sb.Length = 0;
        sb.AppendFormat("Bitrix.RatingVoting.create(\"{0}\", {1});", Component.ClientID, options);
          
        sm.RegisterStartupScript(
            Component.GetType(),
            Component.ClientID,
            sb.ToString(),
            true
            );
    }   
</script><% if(Component.ComponentError != Bitrix.CommunicationUtility.Components.RatingVoteComponentError.None) 
	   return;
	
bool showButtons = Component.IsVotingAllowed && !Component.HasVoted; %><span class="rating-vote<%= (showButtons ? "" : " rating-vote-disabled") %>"  id="<%= ClientID + "_rating" %>"><% 
	if (showButtons) 
	{
		%><a href="" title="<%= GetMessage("TitleTemplate.Love") %>" class="rating-vote-plus" id="<%= ClientID + "_plus" %>" onclick="<%= GetVoteClientClick(true) %>"></a><a href="" title="<%= GetMessage("TitleTemplate.Hate") %>" id="<%= ClientID + "_minus" %>" class="rating-vote-minus" onclick="<%= GetVoteClientClick(false) %>"></a><%
	} 
	else 
	{
		%><a href="" title="<%= GetMessage("TitleTemplate.Love") %>" class="rating-vote-plus" id="<%= ClientID + "_plus" %>" onclick="return false;"></a><a href="" title="<%= GetMessage("TitleTemplate.Hate") %>" onclick="return false;" id="<%= ClientID + "_minus" %>" class="rating-vote-minus"></a><%
	} 
%><span title="<%= (Component.TotalVotes > 0 ? GetMessageFormat("TitleTemplate.Standard", Component.TotalVotes, Component.TotalPositiveVotes, Component.TotalNegativeVotes) : GetMessage("TitleTemplate.NoVotes")) %>" class="rating-vote-result <%= (Component.CurrentValue >= 0 ? "rating-vote-result-plus" : "rating-vote-result-minus") %>" ID="<%= ClientID + "_result" %>"><%= Component.CurrentValue.ToString() %></span></span>