﻿IF OBJECT_ID (N'b_Currency', N'U') IS NULL
BEGIN
	CREATE TABLE b_Currency
	(
		ID INT IDENTITY(1,1) NOT NULL,
		Iso4217AlphaCode CHAR(3) NOT NULL,
		IsNational BIT NOT NULL,
		IsBase BIT NOT NULL,
		Sort INT NOT NULL,		
		CreatedUtc DATETIME NOT NULL,
		LastUpdatedUtc DATETIME NOT NULL,
		LocalizationXml XML NULL,
		XmlId VARCHAR(256) NULL,
		CONSTRAINT PK_b_Currency PRIMARY KEY CLUSTERED(ID ASC)		
	)
END
GO

IF OBJECT_ID (N'b_CurrencyExchRate', N'U') IS NULL
BEGIN
	CREATE TABLE b_CurrencyExchRate
	(
		ID INT IDENTITY(1,1) NOT NULL,
		CurrencyId INT NOT NULL,
		Value DECIMAL(18,5) NOT NULL,
		Issued DATETIME NOT NULL,
		CreatedUtc DATETIME NOT NULL,
		LastUpdatedUtc DATETIME NOT NULL,
		XmlId VARCHAR(256) NULL,
		CONSTRAINT PK_b_CurrencyExchRate PRIMARY KEY CLUSTERED(ID ASC)		
	)
END
GO

IF OBJECT_ID (N'Currency_SynchronizeCurrency', N'P') IS NOT NULL
	DROP PROCEDURE Currency_SynchronizeCurrency;
GO

CREATE PROCEDURE Currency_SynchronizeCurrency 
	@NationalId INT
AS
BEGIN
	SET NOCOUNT ON;
	IF EXISTS(SELECT ID FROM b_Currency WHERE ID = @NationalId AND IsNational = 1)
	BEGIN
		UPDATE b_Currency SET IsNational = 0 WHERE IsNational = 1 AND ID <> @NationalId;
	END
END
GO

IF OBJECT_ID(N'CurrencyExchRate_Delete', N'P') IS NOT NULL 
	DROP PROCEDURE CurrencyExchRate_Delete;
GO

CREATE PROCEDURE CurrencyExchRate_Delete
	@CurrencyId INT
AS
BEGIN
	DELETE FROM b_CurrencyExchRate WHERE  CurrencyId = @CurrencyId;
END
GO