﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" 
	AutoEventWireup="false" CodeFile="CurrencyEdit.aspx.cs" Inherits="bitrix_admin_CurrencyEdit" EnableViewState="false"%>
	
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
	<bx:BXContextMenuToolbar ID="CatalogMainToolbar" runat="server" OnCommandClick="OnToolBarButtonClick">
		<Items>
			<bx:BXCmSeparator ID="ListButton" runat="server" SectionSeparator="true" />
			<bx:BXCmImageButton CssClass="context-button icon btn_list" CommandName="list"
				Text="<%$ LocRaw:ActionText.GoBack %>" Title="<%$ LocRaw:ActionTitle.GoBack %>" Href="CurrencyList.aspx" />
		
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton ID="AddButton"
				CommandName="add" Text="<%$ LocRaw:Kernel.Add %>" Title="<%$ LocRaw:ActionTitle.Add %>"
				CssClass="context-button icon btn_new" Href="CatalogMain.aspx" />
				
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton ID="DeleteButton"
				CommandName="delete" Text="<%$ LocRaw:Kernel.Delete %>" Title="<%$ LocRaw:ActionTitle.Delete %>"
				CssClass="context-button icon btn_delete" ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>" />
		</Items>
	</bx:BXContextMenuToolbar>
	<bx:BXValidationSummary ID="errorMessage" runat="server" CssClass="errorSummary" HeaderText="<%$ Loc:Kernel.Error %>" ValidationGroup="Main" />
	<bx:BXAdminNote ID="AdminNote1" runat="server">
		<%= GetMessageRaw("LegendHint")%>
    </bx:BXAdminNote> 
	<bx:BXTabControl ID="TabControl" runat="server" OnCommand="OnCurrencyEditCommand" ValidationGroup="Main">
		<bx:BXTabControlTab ID="MainSettingsTab" runat="server" Selected="True" Text="<%$ LocRaw:TabText.Currency %>" Title="<%$ LocRaw:TabTitle.Currency %>">
			<bx:BXAdminNote ID="BXAdminNote1" runat="server">
				<%= GetMessageRaw("IsNationalHint")%>
			</bx:BXAdminNote> 		
			<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
				<%if (EntityId > 0){ %>
					<tr valign="top"><td class="field-name">ID:</td><td><%= EntityId %></td></tr>
				<%} %>
				
				<tr valign="top" title="<%= GetMessage("FieldTooltip.IsoCode") %>">
					<td class="field-name"><span class="required">*</span><a name="IsoCode" href="#IsoCodeLegend"><%= GetMessage("FieldLabel.IsoCode") %></a>:</td>
					<td>
						<asp:TextBox ID="IsoCode" runat="server" Width="50px" />
						<asp:RequiredFieldValidator ID="IsoCodeRequiredValidator" runat="server" ValidationGroup="Main" ControlToValidate="IsoCode" ErrorMessage="<%$ Loc:Message.IsoCodeIsNotSpecified %>" Display="Dynamic">*</asp:RequiredFieldValidator>
					    <asp:RegularExpressionValidator runat="server" ID="IsoCodeValidator" ValidationExpression="^[a-zA-Z]{3}$" ControlToValidate="IsoCode" ValidationGroup="Main" ErrorMessage="<%$ LocRaw:Message.IncorrectIsoCode %>" Display="Dynamic">*</asp:RegularExpressionValidator>						
					</td>
				</tr>
				<tr valign="top" title="<%= GetMessage("FieldTooltip.IsNational") %>">
					<td class="field-name"><a name="IsNational" href="#IsNationalLegend"><%= GetMessage("FieldLabel.IsNational")%></a>:</td>
					<td>
					    <asp:CheckBox runat="server" ID="IsNational" />
					</td>
				</tr>				
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Sort") %>">
					<td class="field-name"><%= GetMessage("FieldLabel.Sort") %>:</td>
					<td>
					    <asp:TextBox ID="Sort" runat="server" Width="50px" />
					    <asp:RegularExpressionValidator runat="server" ID="SortValidator" ValidationExpression="^[\d]*$" ControlToValidate="Sort" ValidationGroup="Main" ErrorMessage="<%$ LocRaw:Message.IncorrectSortIndex %>" Display="Dynamic">*</asp:RegularExpressionValidator>
					</td>
				</tr>
				<tr valign="top" title="<%= GetMessage("FieldTooltip.XmlId") %>" >
					<td class="field-name"><%= GetMessage("FieldLabel.XmlId") %>:</td>
					<td>
						<asp:TextBox Rows="7" ID="XmlId"  runat="server" Width="350px" />						
					</td>
				</tr>				
				
				<%if(CurrentLocalizationInfo != null) {%>
				<tr class="heading">
					<td colspan="2"><%= Encode(CurrentLocalizationInfo.LocaleName) %></td>
				</tr>
				<tr valign="top" title="<%= GetMessage("FieldTooltip.LocalizationInfoName") %>" >
					<td class="field-name"><%= GetMessage("FieldLabel.LocalizationInfoName") %>:</td>
					<td>
						<input type="text" name="<%= UniqueID + "$LocalizationInfoName$" + CurrentLocalizationInfo.LocaleName %>" value="<%= Encode(CurrentLocalizationInfo.Name) %>"/>						
					</td>
				</tr>				
				<tr valign="top" title="<%= GetMessage("FieldTooltip.LocalizationInfoFormat") %>" >
					<td class="field-name"><a name="Format" href="#FormatLegend"><%= GetMessage("FieldLabel.LocalizationInfoFormat") %></a>:</td>
					<td>
						<input type="text" name="<%= UniqueID + "$LocalizationInfoFormat$" + CurrentLocalizationInfo.LocaleName %>" value="<%= CurrentLocalizationInfo.Format %>"/>						
					</td>
				</tr>					
				<tr valign="top" title="<%= GetMessage("FieldTooltip.LocalizationInfoSymbol") %>" >
					<td class="field-name"><a name="Symbol" href="#SymbolLegend"><%= GetMessage("FieldLabel.LocalizationInfoSymbol") %></a>:</td>
					<td>
						<input type="text" name="<%= UniqueID + "$LocalizationInfoSymbol$" + CurrentLocalizationInfo.LocaleName %>" value="<%= Encode(CurrentLocalizationInfo.Symbol) %>"/>						
					</td>
				</tr>								
				<%} %>
				<%foreach(CurrencyLocalizationInfoWrapper locInfo in LocalizationInfos) {%>
				<%if(locInfo == CurrentLocalizationInfo) continue;%>
				<tr class="heading">
					<td colspan="2"><%= Encode(locInfo.LocaleName) %></td>
				</tr>
				<tr valign="top" title="<%= GetMessage("FieldTooltip.LocalizationInfoName") %>" >
					<td class="field-name"><%= GetMessage("FieldLabel.LocalizationInfoName") %>:</td>
					<td>
						<input type="text" name="<%= UniqueID + "$LocalizationInfoName$" + locInfo.LocaleName %>" value="<%= Encode(locInfo.Name) %>"/>						
					</td>
				</tr>	
				<tr valign="top" title="<%= GetMessage("FieldTooltip.LocalizationInfoFormat") %>" >
					<td class="field-name"><%= GetMessage("FieldLabel.LocalizationInfoFormat") %>:</td>
					<td>
						<input type="text" name="<%= UniqueID + "$LocalizationInfoFormat$" + locInfo.LocaleName %>" value="<%= locInfo.Format %>"/>						
					</td>
				</tr>							
				<tr valign="top" title="<%= GetMessage("FieldTooltip.LocalizationInfoSymbol") %>" >
					<td class="field-name"><%= GetMessage("FieldLabel.LocalizationInfoSymbol") %>:</td>
					<td>
						<input type="text" name="<%= UniqueID + "$LocalizationInfoSymbol$" + locInfo.LocaleName %>" value="<%= locInfo.Symbol %>"/>						
					</td>
				</tr>									
				<%} %>
																			
			</table>
		</bx:BXTabControlTab>
	</bx:BXTabControl>
	<bx:BXAdminNote ID="AdminNote3" runat="server">
		<%= GetMessageRaw("Legend")%>
	</bx:BXAdminNote>	
</asp:Content>