﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Bitrix.Security;
using Bitrix.Components;
using System.Collections.Generic;
using Bitrix;
using Bitrix.UI;

using Bitrix.IBlock;
using Bitrix.Services;
using Bitrix.DataLayer;
using Bitrix.Services.Text;
using Bitrix.DataTypes;
using Bitrix.IO;
using Bitrix.Configuration;

public partial class bitrix_components_bitrix_catalogsection_component : BXComponent
{
    //int IBlockTypeId = 0, IBlockId = 0;
    //string SectionURL, SectionPageURL, ElementURL;
    //string ParamPageId, ParamElementId, ParamSectionId, ParamSectionCode, ParamElementCode;
    //string AliasSectionId, AliasElementId, AliasPageId, AliasSectionCode, AliasElementCode;

    int SectionId = 0, PageId = 0;
    string ElementCode = String.Empty, SectionCode = String.Empty;
    string SortBy1, SortOrder1;

    int PerPageCount, PerLineCount;
    bool ShowSubelements;

    List<string> Properties = null;

    #region UrlTemplates

    public string SectionURL
    {
        get
        {
            if (EnableSef)
            {
                return Parameters.Get<string>("SEF_URL_TEMPLATES_section", "#SECTION_ID#/");
            }
            else
            {
                return Parameters.Get<string>("SectionURL", String.Format("?{0}=#SECTION_ID#", AliasSectionId));
            }
        }
    }

    public string SectionPageURL
    {
        get
        {
            if (EnableSef)
            {
                return Parameters.Get<string>("SEF_URL_TEMPLATES_section_page", "#SECTION_ID#/Page/#PAGE_ID#/");
            }
            else
            {
                return Parameters.Get<string>("SectionPageURL",
                                       String.Format("?{0}=#SECTION_ID#&{1}=#PAGE_ID#", AliasSectionId, AliasPageId));
            }
        }
    }

    public string ElementURL
    {
        get
        {
            if (EnableSef)
            {
                return Parameters.Get<string>("SEF_URL_TEMPLATES_element", "#SECTION_ID#/#ELEMENT_ID#/");
            }
            else
            {
                return Parameters.Get<string>("ElementURL",
                                       String.Format("?{0}=#SECTION_ID#&{1}=#ELEMENT_ID#", AliasSectionId,
                                                     AliasElementId));
            }
        }
    }
    #endregion

    #region UrlParams

    public string ParamSectionId
    {
        get
        {
            return Parameters.Get<string>("ParamSectionId", "section_id");
        }
    }

    public string ParamElementId
    {
        get
        {
            return Parameters.Get<string>("ParamElementId", "element_id");
        }
    }

    public string ParamPageId
    {
        get
        {
            return Parameters.Get<string>("ParamPageId", "page_id");
        }
    }

    public string ParamSectionCode
    {
        get
        {
            return Parameters.Get<string>("ParamSectionCode", "section_code");
        }
    }

    public string ParamElementCode
    {
        get
        {
            return Parameters.Get<string>("ParamElementCode", "element_code");
        }
    }

    public string AliasSectionId
    {
        get
        {
            return Parameters.Get<string>("VARIABLE_ALIASES_SECTION_ID", "SECTION_ID");
        }
    }

    public string AliasElementId
    {
        get
        {
            return Parameters.Get<string>("VARIABLE_ALIASES_ELEMENT_ID", "ELEMENT_ID");
        }
    }

    public string AliasPageId
    {
        get
        {
            return Parameters.Get<string>("VARIABLE_ALIASES_PAGE_ID", "PAGE_ID");
        }
    }

    public string AliasSectionCode
    {
        get
        {
            return Parameters.Get<string>("VARIABLE_ALIASES_SECTION_CODE", "SECTION_CODE");
        }
    }

    public string AliasElementCode
    {
        get
        {
            return Parameters.Get<string>("VARIABLE_ALIASES_ELEMENT_CODE", "ELEMENT_CODE");
        }
    }

    #endregion

    public string SEFFolder
    {
        get
        {
            return Parameters.Get<string>("SEFFolder", "/catalog");
        }
    }

    public int IBlockTypeId
    {
        get
        {
            return Parameters.Get("IBlockTypeId", 0);
        }
    }

    public int IBlockId
    {
        get
        {
            return Parameters.Get("IBlockId", 0);
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        #region SetupParameters
        SectionId = Parameters.Get("SectionId", 0);

        ShowSubelements = Parameters.Get("ShowSubelements", true);

        SortBy1 = Parameters.Get("SortBy1", "sort");
        SortOrder1 = Parameters.Get("SortOrder1", "Desc");

        PerPageCount = Parameters.Get("PerPageCount", 30);
        PerLineCount = Parameters.Get("PerLineCount", 3);
        Properties = Parameters.GetListString("Properties");

        string PropertyKeywords = Parameters.Get("PropertyKeywords", "-");
        string PropertyDescription = Parameters.Get("PropertyDescription", "-");
        bool AddAdminPanelButtons = Parameters.Get("AddAdminPanelButtons", false);
        bool ShowCompareButton = Parameters.Get("ShowCompareButton", false);
        bool SetPageTitle = Parameters.Get("SetPageTitle", true);
        bool CacheOnFilter = Parameters.Get("CacheOnFilter", false);

		Parameters["PagingAllowAll"] = false.ToString();
        /*bool PagerOverList = Parameters.GetBool("PagerOverList", false);
        bool PagerUnderList = Parameters.GetBool("PagerUnderList", false);
        string CategoryTitle = Parameters.GetString("CategoryTitle", "");
        bool PagerAlways = Parameters.GetBool("PagerAlways", true);
        string TemplateTitle = Parameters.GetString("TemplateTitle", "");
        bool UseInvertedNavigation = Parameters.GetBool("UseInvertedNavigation", false);
        int CacheTimeOnInvertedNavigation = Parameters.GetInt("CacheTimeOnInvertedNavigation", 36000);*/
        #endregion
        
        #region HackUnSef
        string PageKey = String.Empty;

        BXParamsBag<object> request = new BXParamsBag<object>();
        BXParamsBag<string> urlToPage = new BXParamsBag<string>();
        urlToPage.Add("SectionPage", SectionPageURL);
        urlToPage.Add("Section", SectionURL);
        
        if (EnableSef)
        {
            PageKey = MapVariable(SEFFolder, urlToPage, request, String.Empty);

            Results["ParamSectionId"] = ParamSectionId;
            Results["ParamElementId"] = ParamElementId;
            Results["ParamPageId"] = ParamPageId;
            Results["ParamElementCode"] = ParamElementCode;
            Results["ParamSectionCode"] = ParamSectionCode;
        }
        else
        {
            BXParamsBag<string> variableAliases = new BXParamsBag<string>();
			variableAliases.Add(ParamSectionId, AliasSectionId);
			variableAliases.Add(ParamElementId, AliasElementId);
			variableAliases.Add(ParamPageId, AliasPageId);
			variableAliases.Add(ParamSectionCode, AliasSectionCode);
			variableAliases.Add(ParamElementCode, AliasElementCode);
            MapVariable(variableAliases, request);

            Results["ParamSectionId"] = AliasSectionId;
            Results["ParamElementId"] = AliasElementId;
            Results["ParamPageId"] = AliasPageId;
            Results["ParamElementCode"] = AliasElementCode;
            Results["ParamSectionCode"] = AliasSectionCode;
        }

        SectionId = request.Get(ParamSectionId, SectionId);
        //ElementId = request.Get(ParamElementId, ElementId);
        PageId = request.Get(ParamPageId, PageId);
        ElementCode = request.Get<string>(ParamElementCode, ElementCode);
        SectionCode = request.Get<string>(ParamSectionCode, SectionCode);

        // Rewrite default variables
        request.Add(ParamSectionId, SectionId);
        //request.Add(ParamElementId, ElementId);
        request.Add(ParamElementCode, ElementCode);
        request.Add(ParamSectionCode, SectionCode);

        if (!EnableSef)
        {
            if (PageId > 0) PageKey = "SectionPage";
            //else if (ElementId > 0 || !String.IsNullOrEmpty(ElementCode)) PageKey = "Element";
            else if (SectionId > 0 || !String.IsNullOrEmpty(SectionCode)) PageKey = "Section";
        }

        Results["SectionURL"] = SectionURL;
        Results["SectionPageURL"] = SectionPageURL;
        Results["ElementURL"] = ElementURL;

        Results["SectionId"] = SectionId;
        //Results["ElementId"] = ElementId;
        Results["PageId"] = PageId;
        Results["ElementCode"] = ElementCode;
        Results["SectionCode"] = SectionCode;

        Results["PageKey"] = PageKey;
        #endregion

        if (!IsCached(IBlockTypeId, IBlockId, SectionId, PageId, SectionCode))
        {
			if (IBlockId > 0)
			{
				#region MakeComponentDataFilter
				BXIBlockElementCollection es = null;

				BXFilter esf = new BXFilter();
				BXOrderBy eso = new BXOrderBy();

				esf.Add(new BXFilterItem(BXIBlockElement.Fields.Active, BXSqlFilterOperators.Equal, "Y"));

				eso.Add(BXIBlockElement.Fields, String.Format("{0} {1}", SortBy1, SortOrder1));

				if (IBlockId > 0)
				{
					esf.Add(new BXFilterItem(BXIBlockElement.Fields.IBlock.ID, BXSqlFilterOperators.Equal, IBlockId));
				}
				if (!String.IsNullOrEmpty(SectionCode))
				{
					esf.Add(new BXFilterItem(BXIBlockElement.Fields.Sections.Section.Code, BXSqlFilterOperators.Equal, SectionCode));
					if (ShowSubelements)
					{
						esf.Add(new BXFilterItem(BXIBlockElement.Fields.IncludeParentSections, BXSqlFilterOperators.Equal, "Y"));
					}
				}
				else if (SectionId > 0)
				{
					esf.Add(new BXFilterItem(BXIBlockElement.Fields.Sections.Section.ID, BXSqlFilterOperators.Equal, SectionId));
					if (ShowSubelements)
					{
						esf.Add(new BXFilterItem(BXIBlockElement.Fields.IncludeParentSections, BXSqlFilterOperators.Equal, "Y"));
					}
				}
				else
				{
					if (ShowSubelements)
					{
						esf.Add(new BXFilterItem(BXIBlockElement.Fields.IncludeParentSections, BXSqlFilterOperators.Equal, "Y"));
					}
					else
						esf.Add(new BXFilterItem(BXIBlockElement.Fields.Sections.Section.ID, BXSqlFilterOperators.Equal, "0"));
				}
				#endregion

				#region Paging Operations
				string PageUrlTemplate = String.Empty;
				string DefaultPageUrl = String.Empty;
				if (EnableSef)
				{
					DefaultPageUrl = BXComponentManager.MakeLink(SEFFolder, SectionURL);
					PageUrlTemplate = BXComponentManager.MakeLink(SEFFolder, SectionPageURL);
				}
				else
				{
					DefaultPageUrl = SectionURL;
					PageUrlTemplate = SectionPageURL;
				}

				BXQueryParams queryParams = PreparePaging(
					delegate
					{
						return BXIBlockElement.Count(esf);
					},
					request,
					Results.Get<string>("ParamPageId"),
					false,
					DefaultPageUrl,
					PageUrlTemplate,
					string.Empty
				);
				es = BXIBlockElement.GetList(esf, eso, null, queryParams);

				#endregion

				#region SetPageTitle
				if (SetPageTitle)
				{
					string PageTitle = Parameters.Get<string>("SectionTitle", String.Empty);
					if (String.IsNullOrEmpty(PageTitle))
					{
						BXIBlockSection rootSection = null;
						if (!String.IsNullOrEmpty(SectionCode))
						{
							BXFilter sParentFilter = new BXFilter(
									new BXFilterItem(BXIBlockSection.Fields.Code, BXSqlFilterOperators.Equal, SectionCode),
									new BXFilterItem(BXIBlockSection.Fields.Active, BXSqlFilterOperators.Equal, "Y")
									);

							BXIBlockSectionCollection sCol = BXIBlockSection.GetList(sParentFilter, null);
							if (sCol != null && sCol.Count > 0)
								rootSection = sCol[0];
						}
						else if (SectionId > 0)
							rootSection = BXIBlockSection.GetById(SectionId);

						if (rootSection != null)
							PageTitle = rootSection.Name;
						else
						{
							BXIBlock iblock = BXIBlock.GetById(IBlockId);
							if (iblock != null)
								PageTitle = iblock.Name;
						}
					}

					Results["SectionName"] = PageTitle;
				}
				#endregion

				if (es != null)
				{
					Results["DataVolume"] = es.Count;
				}

				if (es != null && es.Count > 0)
				{
					List<Dictionary<string, string>> data = new List<Dictionary<string, string>>();
					foreach (BXIBlockElement el in es)
					{
						Dictionary<string, string> v = new Dictionary<string, string>();

						string imageUrl = String.Empty;
						BXFile image = el.DetailImageId > 0 ? el.DetailImage : el.PreviewImage;

						if (image != null)
							imageUrl = String.Format(
							"{0}ImageResizer.ashx?path={1}&width={2}&height={3}&fit={4}",
							BXUri.ToAbsoluteUri("~/bitrix/handlers/Main/"),
							UrlEncode(image.FileVirtualPath),
							Parameters.Get("PreviewWidth", 150),
							Parameters.Get("PreviewHeight", 150),
							!Parameters.Get<bool>("FlickrMode", false));

						v.Add("Id", el.Id.ToString());
						v.Add("Title", el.Name);
						v.Add("PreviewText", el.PreviewText);
						v.Add("PreviewTextType", el.PreviewTextType.ToString());
						v.Add("PreviewImage", imageUrl);

						request.Add(ParamElementId, el.Id);
						request.Add(ParamElementCode, String.IsNullOrEmpty(el.Code) ? String.Empty : el.Code);
						if (EnableSef)
							v.Add("ElementLink", BXStringUtility.HtmlEncodeEx(MakeLink(SEFFolder, ElementURL, request)));
						else
							v.Add("ElementLink", BXStringUtility.HtmlEncodeEx(MakeLink(ElementURL, request)));

						data.Add(v);

						Dictionary<string, BXCustomProperty> v2 = new Dictionary<string, BXCustomProperty>();
						BXCustomPropertyCollection props = el.Properties;
						if (props != null)
							foreach (KeyValuePair<string, BXCustomProperty> kcs in props)
								if (Properties.Exists(delegate(string x)
								{
									return x.Equals(kcs.Key, StringComparison.InvariantCultureIgnoreCase);
								}))
									v2[kcs.Key] = kcs.Value;

						Results["DataProperties_" + el.Id] = v2;
					}

					Results["Data"] = data;
				}

				Results["EnableAjaxA"] = Parameters.Get<bool>("EnableAjax", false) ? "EnableAjax=\"True\"" : "";
			}
			IncludeComponentTemplate();
        }

		if (SetPageTitle && Results.ContainsKey("SectionName") && Results["SectionName"] != null)
		{
			string PageTitle = Results.Get<string>("SectionName");

			if (Page is BXPublicPage)
				(Page as BXPublicPage).BXTitle = PageTitle;
		}
	}

    protected override void PreLoadComponentDefinition()
	{
        Title = GetMessage("Title");
        Description = GetMessage("Description");
        Icon = "images/cat_list.gif";

        //Group = new BXComponentGroup("catalog", GetMessage("Group"), 100, BXComponentGroup.Content);

        ParamsDefinition.Add(BXParametersDefinition.Cache);
        ParamsDefinition.Add(BXParametersDefinition.Paging);
		ParamsDefinition.Remove("PagingAllowAll");
		Parameters["PagingAllowAll"] = false.ToString();

        ParamsDefinition.Add(
            "IBlockTypeId",
            new BXParamSingleSelection(
                GetMessageRaw("InfoBlockType"),
                String.Empty,
                BXCategory.Main
            )
        );

        ParamsDefinition.Add(
            "IBlockId",
            new BXParamSingleSelection(
                GetMessageRaw("InfoBlockCode"),
                String.Empty,
                BXCategory.Main
            )
        );

        ParamsDefinition.Add(
            "SectionId",
            new BXParamText(
                GetMessageRaw("SectionID_1"),
                "0",
                BXCategory.Main
            ));

        ParamsDefinition.Add(
            "SortBy1",
            new BXParamSingleSelection(
                GetMessageRaw("SortBy"),
                "sort",
                BXCategory.DataSource
            )
        );

        ParamsDefinition.Add(
            "SortOrder1",
            new BXParamSort(
                GetMessageRaw("SortOrder"),
                BXCategory.DataSource
            )
        );

        ParamsDefinition.Add(
            "ShowSubelements",
            new BXParamYesNo(
                GetMessageRaw("DisplaySubsectionElements"),
                true,
                BXCategory.DataSource
            ));

        ParamsDefinition.Add(
            "PerPageCount",
            new BXParamText(
                GetMessageRaw("ElementsPerPage"),
                "30",
                BXCategory.AdditionalSettings
            ));

        ParamsDefinition.Add(
            "PerLineCount",
            new BXParamText(
                GetMessageRaw("ElementPerTableRow"),
                "3",
                BXCategory.AdditionalSettings
            ));

        ParamsDefinition.Add(
            "Properties",
            new BXParamMultiSelectionWithText(
                GetMessageRaw("Properties"),
                "-",
                BXCategory.AdditionalSettings
            ));

        ParamsDefinition.Add(
            "SEF_URL_TEMPLATES_section",
            new BXParamText(
                GetMessageRaw("Section"),
                "#SECTION_ID#/",
                BXCategory.Sef
            ));

        ParamsDefinition.Add(
            "SEF_URL_TEMPLATES_section_page",
            new BXParamText(
                GetMessageRaw("SectionPage"),
                "#SECTION_ID#/Page/#PAGE_ID#/",
                BXCategory.Sef
            ));

        ParamsDefinition.Add(
            "SEF_URL_TEMPLATES_element",
            new BXParamText(
                GetMessageRaw("DetailedInfo"),
                "#SECTION_ID#/#ELEMENT_ID#",
                BXCategory.Sef
            ));

        ParamsDefinition.Add(
            "VARIABLE_ALIASES_SECTION_ID",
            new BXParamText(
                GetMessageRaw("SectionID_2"),
                "SECTION_ID",
                BXCategory.Sef
            ));

        ParamsDefinition.Add(
            "VARIABLE_ALIASES_ELEMENT_ID",
            new BXParamText(
                GetMessageRaw("ElementID"),
                "ELEMENT_ID",
                BXCategory.Sef
            ));

        ParamsDefinition.Add(
            "VARIABLE_ALIASES_PAGE_ID",
            new BXParamText(
                GetMessageRaw("PageID"),
                "PAGE_ID",
                BXCategory.Sef
            ));

        ParamsDefinition.Add(
            "VARIABLE_ALIASES_ELEMENT_CODE",
            new BXParamText(
                GetMessageRaw("ElementMnemonicCodeID"),
                "ELEMENT_CODE",
                BXCategory.Sef
            ));

        ParamsDefinition.Add(
            "VARIABLE_ALIASES_SECTION_CODE",
            new BXParamText(
                GetMessageRaw("SectionMnemonicCodeID"),
                "SECTION_CODE",
                BXCategory.Sef
            ));

        ParamsDefinition.Add(
            "PropertyKeywords",
            new BXParamSingleSelectionWithText(
                GetMessageRaw("SetPageKeywordsFromProperty"),
                "-",
                BXCategory.AdditionalSettings
            ));
        ParamsDefinition.Add(
            "PropertyDescription",
            new BXParamSingleSelectionWithText(
                GetMessageRaw("SetPageDescriptionFromProperty"),
                "-",
                BXCategory.AdditionalSettings
            ));
        ParamsDefinition.Add(
            "AddAdminPanelButtons",
            new BXParamYesNo(
                GetMessageRaw("AddButtonsForThisComponentToAdminPanel"),
                false,
                BXCategory.AdditionalSettings
            ));

        ParamsDefinition.Add(
            "SetPageTitle",
            new BXParamYesNo(
                GetMessageRaw("SetPageTitle"),
                true,
                BXCategory.AdditionalSettings
            ));
        ParamsDefinition.Add(
			"CacheOnFilter",
            new BXParamYesNo(
                GetMessageRaw("CacheIfFilterEnabled"),
                false,
                BXCategory.AdditionalSettings
            ));
	}

    protected override void LoadComponentDefinition()
    {
        #region MainGroup

        List<BXParamValue> types = new List<BXParamValue>();
        types.Add(new BXParamValue("-", ""));
        BXIBlockTypeCollection typeCollection = BXIBlockType.GetList(null, new BXOrderBy(new BXOrderByPair(BXIBlockType.Fields.Sort, BXOrderByDirection.Asc)));
        foreach (BXIBlockType t in typeCollection)
            types.Add(new BXParamValue(t.Translations[BXLoc.CurrentLocale].Name, t.Id.ToString()));

        ParamsDefinition["IBlockTypeId"].Values = types;
        ParamsDefinition["IBlockTypeId"].RefreshOnDirty = true;

        BXFilter iblockFilter = new BXFilter();
        if (Parameters.ContainsKey("IBlockTypeId"))
        {
            int typeId;
            int.TryParse(Parameters["IBlockTypeId"], out typeId);
            if (typeId > 0)
				iblockFilter.Add(new BXFilterItem(BXIBlock.Fields.Type.ID, BXSqlFilterOperators.Equal, typeId));
        }
        if (!string.IsNullOrEmpty(DesignerSite))
			iblockFilter.Add(new BXFilterItem(BXIBlock.Fields.Sites.SiteId, BXSqlFilterOperators.Equal, DesignerSite));

        List<BXParamValue> iblocks = new List<BXParamValue>();
        BXIBlockCollection iblockCollection = BXIBlock.GetList(iblockFilter, new BXOrderBy(new BXOrderByPair(BXIBlock.Fields.Sort, BXOrderByDirection.Asc)));
        foreach (BXIBlock b in iblockCollection)
            iblocks.Add(new BXParamValue(b.Name, b.Id.ToString()));

        ParamsDefinition["IBlockId"].Values = iblocks;
        ParamsDefinition["IBlockId"].RefreshOnDirty = true;
        #endregion

        #region DataSource
        List<BXParamValue> sortFields = new List<BXParamValue>();
        sortFields.Add(new BXParamValue("ID", "ID"));
        sortFields.Add(new BXParamValue(GetMessageRaw("Title"), "name"));
        sortFields.Add(new BXParamValue(GetMessageRaw("DateOfModification"), "updatedate"));
        sortFields.Add(new BXParamValue(GetMessageRaw("SortIndex"), "sort"));
        sortFields.Add(new BXParamValue(GetMessageRaw("QuantityOfViewsAvg"), "sort")); /// ?
        sortFields.Add(new BXParamValue(GetMessageRaw("ActiveFromDate"), "activefromdate"));
        sortFields.Add(new BXParamValue(GetMessageRaw("ActiveUntilDate"), "activetodate"));

        ParamsDefinition["SortBy1"].Values = sortFields;
        #endregion

        #region View
        

        List<BXParamValue> properties = new List<BXParamValue>();
        if (Parameters.ContainsKey("IBlockId"))
        {
            int iblockId;
            int.TryParse(Parameters["IBlockId"], out iblockId);
            if (iblockId > 0)
            {
                BXCustomFieldCollection cfCollection = BXCustomEntityManager.GetFields("IBlock_" + iblockId);
                foreach (BXCustomField f in cfCollection)
                    properties.Add(new BXParamValue(f.EditFormLabel, f.Name));
            }
        }

        ParamsDefinition["Properties"].Values = properties;
        #endregion

        #region Additional
        ParamsDefinition["PropertyKeywords"].Values = properties;
        ParamsDefinition["PropertyDescription"].Values = properties;
        #endregion
    }
}
