﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="template.ascx.cs" Inherits="bitrix_components_bitrix_catalog_section_templates_default_template" %>
<%@ Import Namespace="Bitrix" %>

<%@ Import Namespace="System.Collections.Generic" %>
<div class="catalog-section">
    <%
        int x, y = 0,
            x_max = Parameters.Get<int>("PerLineCount", 3),
            y_max = Parameters.Get<int>("PerPageCount", 30),
            data_count = 0;

        bool PagerSeen = false;

        List<Dictionary<string, string>> data = null;
        if (Results.ContainsKey("data"))
            data = Results["data"] as List<Dictionary<string, string>>;

        if (data != null)
        {
            data_count = Results.Get<int>("TotalRecordCount", 0);
        }
        else
            y_max = 0;

        if (data_count <= y_max && Parameters.Get<bool>("PagerAlways", true))
            PagerSeen = true;

        if (data_count > y_max)
            PagerSeen = true;

        if (data != null && data.Count < y_max)
            y_max = data.Count;        

        if (data_count == 0)
            PagerSeen = false;
    %>
    <%
        if (IsComponentDesignMode && (data == null || data.Count == 0 ))
        {
    %><%= GetMessage("Text.YouMayAdjustOutputOfCatalogueItemList") %><% 
		}
		if (Results.Get<bool>("PagingShow") && !"bottom".Equals(Parameters.Get<string>("PagingPosition"), StringComparison.InvariantCultureIgnoreCase))
		{  %>
        <bx:IncludeComponent 
        runat="server" 
        ID="HeaderPager" 
        ComponentName="bitrix:system.pager" 
        Template="<%$ Parameters:PagingTemplate %>"
         />
    <%	} %>

    <table cellspacing="0" cellpadding="0" border="0">
    <tbody>
    <%  
        while (y < y_max)
        {
            %>
            <tr>
            <% 
            for (x = 0; x < x_max; x++)
            {                
                int x_width = (int)(100.0 / x_max);
                Dictionary<string, string> v = data[y];
                %>
                    <td width="<%= x_width %>%" valign="top">
                    <table cellspacing="2" cellpadding="0" border="0">
                    <tbody>
                    <tr>
                    <% if (!String.IsNullOrEmpty(v["PreviewImage"])) { %>
                    <td valign="top">
                    <a href="<%= v["ElementLink"] %>" <%=Results["EnableAjaxA"] %> ><img src="<%= v["PreviewImage"] %>"
                     alt="<%= v["Title"] %>" style="border: none;" /></a>
                    </td>
                    <% } %>
                    <td valign="top">
                    <a href="<%= v["ElementLink"] %>" <%=Results["EnableAjaxA"] %> ><%= v["Title"] %></a>
                    <%
                        if (Results.ContainsKey("DataProperties_" + v["Id"]))
                        {
                            Dictionary<string, BXCustomProperty> prop = (Dictionary<string, BXCustomProperty>)Results["DataProperties_" + v["Id"]];
                            if (prop != null)
                            {
                                %><br /><%
                                foreach (KeyValuePair<string, BXCustomProperty> kp in prop)
                                {
                                    string showName = Encode(kp.Value.UserLikeName);
                                    string showValue = String.Empty;

                                    if (kp.Value.Value != null)
                                    {
                                        if (kp.Value.IsFile)
                                        {
                                            Bitrix.IO.BXFile file = Bitrix.IO.BXFile.GetById(kp.Value.Value);
                                            if (file != null)
                                                showValue = string.Format("{0}&nbsp;({1}{2})", Encode(file.FileNameOriginal), file.FileSize.ToString(), GetMessage("Byte"));
                                        }
                                        else
                                            showValue = Encode(kp.Value.Value.ToString());
                                    }
                                    if (String.IsNullOrEmpty(showValue.Trim())) continue;
                                    %><%= showName+ ":" %>&nbsp;<%= showValue%><br /><%
                                }
                            }
                        }
                    %>
                    <br /><%= v["PreviewText"] %>
                    </td>
                    </tr>
                    </tbody>
                    </table>
                    </td>
                <%
                y++;
                if (y >= y_max) break;
            }
            %>
            </tr>
        <%
        }
         %>
         
    </tbody>
    </table>
    <br />
    <% if (Results.Get<bool>("PagingShow") 
           && !"top".Equals(Parameters.Get<string>("PagingPosition"), StringComparison.InvariantCultureIgnoreCase))
	  {  %>
   <bx:IncludeComponent 
    runat="server" 
    ID="FooterPager" 
    ComponentName="bitrix:system.pager" 
    Template="<%$ Parameters:PagingTemplate %>"
     />
   <% } %>
</div>
