﻿if(typeof(Bitrix) == "undefined") {
	var Bitrix = new Object();
}
Bitrix.CatalogueElementDetail = function Bitrix$CatalogueElementDetail() {
	this._id = "";
	this._redirectToCart = false;
	this._options = {};
}
Bitrix.CatalogueElementDetail.prototype = {
    initialize: function(id, options) {
        this._id = id;
        this._options = options;
		
		var add2cartBtn = this.getElement("add2CartBtnId"); 
		if(add2cartBtn)
			Bitrix.EventUtility.addEventListener(add2cartBtn, "click", Bitrix.TypeUtility.createDelegate(this, this._handleAdd2CartBtnClick));
			
		var buyBtn = this.getElement("buyBtnId"); 
		if(buyBtn)
			Bitrix.EventUtility.addEventListener(buyBtn, "click", Bitrix.TypeUtility.createDelegate(this, this._handleBuyBtnClick));				
    },
	getOption: function(name, defVal) { return this._options && name in this._options ? this._options[name] : defVal; },
	setOption: function(name, val) {
		if(!this._options) this._options = {};
		this._options[name] = val;
	},
	getElement: function(opt) { 
		var id = this.getOption(opt);
		return id ? document.getElementById(id) : null;
	},
	add2Cart: function() {
		var elementId = this.getOption("elementId");
		if(!elementId) return;
		
		var qty = 0;
		var qtyTbx = this.getElement("qtyTbxId"); 
		if(qtyTbx) qty = parseInt(qtyTbx.value);
		if(isNaN(qty) || qty <= 0) qty = 1;
		
        var callBack = this.getOption("callBackScript");
        if (!callBack) return;	
		callBack += "&" + this.getOption("qtyParamName", "qty") + "=" + qty.toString();
		var request = Bitrix.HttpUtility.createXMLHttpRequest();
		request.open("GET", callBack, true);
		
		request.onreadystatechange = function() {
			if(request.readyState != 4) return;

			try {
				var r = eval("(" + request.responseText + ")"); 
				if("error" in r) return;
		
				var item  = "id" in r ? Bitrix.CatalogueElementDetail.get(r.id) : null;
				if(!item) return;
			
				if(!("action" in r)) return;
				var res = r.result ? r.result : {};
				if(r.action == "ADD2CART") { 
					if(Bitrix.CatalogueElementDetail._putInCartListener)
						Bitrix.CatalogueElementDetail._putInCartListener.fire(item, res);				
					item._handleAddActionCompletion("ADD2CART", "isInCart" in res ? res.isInCart : false, "addedQty" in res ? res.addedQty: 0);				
				}				
			}
			catch(e) {}
		};
		request.send(); 
	},
	_handleAdd2CartBtnClick: function() { this.add2Cart(); },
	_handleBuyBtnClick: function() {
		if(this.getOption("isInCart", false)){
			window.location.href = this.getOption("userCartUrl", "");
			return;
		}
		this._redirectToCart = true;	
		this.add2Cart();
	},
	_handleAddActionCompletion: function(name, isInCart, addedQty) { 
		if(this._redirectToCart) window.location.href = this.getOption("userCartUrl", "");
	}	
}
Bitrix.CatalogueElementDetail._items = null;
Bitrix.CatalogueElementDetail.create = function(id, options) {
	if(this._items != null && (id in this._items))
		return this._items[id];
	
	var self = (this._items ? this._items : (this._items = new Object()))[id] = new Bitrix.CatalogueElementDetail();
	self.initialize(id, options);
	return self;
}
Bitrix.CatalogueElementDetail.get = function(id) {
	return this._items != null && (id in this._items) ? this._items[id] : null;
}
Bitrix.CatalogueElementDetail._putInCartListener = null;
Bitrix.CatalogueElementDetail.addPutInCartListener = function(listener) {
	(this._putInCartListener ? this._putInCartListener : (this._putInCartListener = new Bitrix.EventPublisher())).addListener(listener);
}
Bitrix.CatalogueElementDetail.removePutInCartListener = function(listener) {
	if(this._putInCartListener) this._putInCartListener.removeListener(listener);
}