﻿<%@ Page Language="C#" %>
<%@ Reference VirtualPath="controls/Main/AdminWizardHost.ascx" %>
<%@ Register Src="controls/Main/AdminWizard.ascx" TagName="Wizard" TagPrefix="bx" %>
<bx:Wizard ID="Wizard" runat="server" WizardPath="~/bitrix/modules/Main/solution_wizard" OnFinish="Installer_Finish" OnInitState="Installer_InitState" />
<script runat="server">
	protected override void OnPreInit(EventArgs e)
	{
		base.OnPreInit(e);
		if (!Bitrix.Security.BXPrincipal.Current.IsCanOperate(Bitrix.Security.BXRoleOperation.Operations.ProductSettingsManage)
			|| !Bitrix.Security.BXPrincipal.Current.IsCanOperate(Bitrix.Security.BXRoleOperation.Operations.SystemMaintenance))
		{
			Bitrix.Security.BXAuthentication.AuthenticationRequired();
			return;
		}
			
		Wizard.Locale = Bitrix.Services.BXLoc.CurrentLocale;
		Wizard.Url = Request.Url.PathAndQuery;
	}
	
	protected override void OnPreRender(EventArgs e)
	{
		base.OnPreRender(e);
		
		Response.Cache.SetExpires(DateTime.UtcNow.AddDays(-1));
		Response.Cache.SetValidUntilExpires(false); 
		Response.Cache.SetRevalidation(HttpCacheRevalidation.AllCaches);
		Response.Cache.SetCacheability(HttpCacheability.NoCache);
		Response.Cache.SetNoStore();
	}
	
	void Installer_InitState(object sender, Bitrix.UI.AdminWizardHostInitStateEventArgs e)
	{
 		string siteId = Request.QueryString["site"];
		if (!string.IsNullOrEmpty(siteId))
		{
			e.State["Installer.SiteId"] = siteId;
			if (Request.QueryString["act"] == "setup")
				e.State["Installer.Solution"] = Bitrix.Configuration.BXOptionManager.GetOptionString("main", "InstalledSolution", null, siteId);
				
		}
		e.State["Installer.UserId"] = Bitrix.Security.BXIdentity.Current.Id;
	}
	
	void Installer_Finish(object sender, Bitrix.UI.AdminWizardHostFinishEventArgs e)
	{
 		string returnUrl = Request.QueryString[Bitrix.Configuration.BXConfigurationUtility.Constants.BackUrl];
		if (returnUrl == null)
		{
			string siteId = e.State.GetString("Installer.SiteId");
			Bitrix.BXSite site;
			if (!string.IsNullOrEmpty(siteId) && (site = Bitrix.BXSite.GetById(siteId)) != null)
				returnUrl = site.DirectoryAbsolutePath;
		}
		
		if (returnUrl == null)
			returnUrl = VirtualPathUtility.ToAbsolute("~/bitrix/admin/");
		e.CancelDefaultFinish = true;
		Response.Redirect(returnUrl);
	}
</script>