﻿<%@ Control Language="C#" AutoEventWireup="false" EnableViewState="false" CodeFile="Options.ascx.cs" Inherits="bitrix_modules_Sale_Options" %>
<%@ Register Src="~/bitrix/admin/controls/Sale/OrderMappingEditor.ascx" TagName="OrderMappingEditor" TagPrefix="bx" %>
<%@ Import Namespace="Bitrix.Sale" %>
<bx:BXValidationSummary ID="errorMessage" runat="server" CssClass="errorSummary"
	ValidationGroup="InnerForm" HeaderText="<%$ Loc:Kernel.Error %>" />
<bx:BXMessage ID="successMessage" runat="server" CssClass="ok" IconClass="ok" Title="<%$ Loc:Kernel.Information %>"
	Visible="False" Content="<%$ Loc:Message.SettingsHasBeenSavedSuccessfully %>" />

<input type="hidden" name="sale_options_postback" value="true" />

<bx:BXTabControl ID="tabContainer" ValidationGroup="InnerForm" runat="server" OnCommand="OnTabCommand">
	<bx:BXTabControlTab ID="SaleTab" runat="server" Selected="True" Text="<%$ Loc:TabText.Address %>"
		Title="<%$ Loc:TabTitle.Address %>">
		<table border="0" cellpadding="0" cellspacing="0" class="edit-table">
			<tbody>
				<tr>
					<td align="right" valign="top">
						<%= GetMessage("Site") %>:
					</td>
					<td valign="top">
						<asp:DropDownList runat="server" ID="SiteList">
						</asp:DropDownList>
					</td>
				</tr>
				<tr>
					<td align="right" valign="top">
						<%= GetMessage("Country") %>:
					</td>
					<td valign="top">
						<asp:DropDownList runat="server" ID="CountryList">
						</asp:DropDownList>
					</td>
				</tr>
				<tr>
					<td align="right" valign="top">
						<%= GetMessage("PostalCode") %>:
					</td>
					<td valign="top">
						<asp:TextBox runat="server" ID="PostalCodeTbx" />
					</td>
				</tr>
				<tr>
					<td align="right" valign="top">
						<%= GetMessage("LocationName") %>:
					</td>
					<td valign="top">
						<asp:TextBox runat="server" ID="LocationNameTbx" />
					</td>
				</tr>				
			</tbody>
		</table>
	</bx:BXTabControlTab>
	<bx:BXTabControlTab Text="<%$ LocRaw:TabText.1CExport %>" Title="<%$ LocRaw:TabTitle.1CExport %>">
		<script type="text/javascript">
		function SwitchMapping(id, value)
		{
			BX('mapping_' + id + '_phys').style.display = (value == 'PHYS') ? '' : 'none';
			BX('mapping_' + id + '_jur').style.display = (value == 'JUR') ? '' : 'none';
		}
		</script>
		<% if (false) { %>
		<asp:Repeater runat="server" ID="BindingControls" OnItemDataBound="BindingControls_ItemDataBound">
		<ItemTemplate>
			<table border="0" cellpadding="0" cellspacing="5" width="0%">
			<tr>
				<td><%= GetMessage("Label.Select1CCustomerType") %>:</td>
				<td>
					<select onchange="SwitchMapping('<%# Eval("Id") %>', this.value);" name="saleOrderMappingType$<%# Eval("Id")%>">
						<option value="PHYS" <%# GetMappingSelected(((BXSaleCustomerType)Container.DataItem).Id, true) %> ><%= GetMessage("Option.NaturalPerson") %></option>
						<option value="JUR" <%# GetMappingSelected(((BXSaleCustomerType)Container.DataItem).Id, false) %> ><%= GetMessage("Option.LegalPerson") %></option>
					</select>
				</td>
			</tr>
			</table>
			<br/>
			<div id="mapping_<%# Eval("Id")%>_phys" <%# GetMappingStyle(((BXSaleCustomerType)Container.DataItem).Id, true) %> ><bx:OrderMappingEditor runat="server" ID="PhysicalMapping" /></div>				
			<div id="mapping_<%# Eval("Id")%>_jur"  <%# GetMappingStyle(((BXSaleCustomerType)Container.DataItem).Id, false) %> ><bx:OrderMappingEditor runat="server" ID="JuristicMapping" /></div>
		</ItemTemplate>
		</asp:Repeater>
		<% } %>
		<table border="0" cellpadding="0" cellspacing="0" class="edit-table"><tr><td>
			<bx:BXViewTabControl runat="server" ID="Bindings" />
		</td></tr></table>
	</bx:BXTabControlTab>
</bx:BXTabControl>

<script type="text/javascript">
	Bitrix.SaleModuleOptions = function Bitrix$SaleModuleOptions() {
	}
	Bitrix.SaleModuleOptions.prototype = {
		layout: function() {
			Bitrix.EventUtility.addEventListener(this.getSiteSelEl(), "change", Bitrix.TypeUtility.createDelegate(this, this._handleSiteChange));
		},
		getSiteSelEl: function() {
			return document.getElementById("<%= SiteList.ClientID %>");
		},
		_handleSiteChange: function() {
			window.location.href = "<%= SiteConfigUrlTemplate %>".replace(/__BX_SITE_ID__/, this.getSiteSelEl().value);
		}
	}

	Bitrix.SaleModuleOptions._instance = null;
	Bitrix.SaleModuleOptions.getInstance = function() {
		return this._instance ? this._instance : (this._instance = new Bitrix.SaleModuleOptions());
	}
	Bitrix.SaleModuleOptions.getInstance().layout();
</script>

