﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" AutoEventWireup="true" CodeFile="SaleCustomerTypeList.aspx.cs" Inherits="Bitrix.Sale.AdminPages.CustomerTypeList" Title="<%$ LocRaw:PageTitle %>" %>
<%@ Import Namespace="Bitrix.DataLayer" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
		<bx:BXAdminFilter ID="AdminFilter" runat="server" AssociatedGridView="GridView">
			<bx:BXDropDownFilter ID="SiteFilter" Key="Site.Id" Text="<%$ LocRaw:FilterText.Site %>" Visibility="AlwaysVisible">
				<asp:ListItem Text="<%$ LocRaw:Kernel.All %>" Value="" />
			</bx:BXDropDownFilter>
		</bx:BXAdminFilter>
		<bx:BXContextMenuToolbar ID="ContextMenuToolbar" runat="server">
			<Items>
				<bx:BXCmSeparator SectionSeparator="true" />
				<bx:BXCmImageButton ID="AddButton" Text="<%$ LocRaw:ActionText.New %>"
					Title="<%$ LocRaw:ActionTitle.New %>" CssClass="context-button icon btn_new"
					Href="SaleCustomerTypeEdit.aspx" />
			</Items>
		</bx:BXContextMenuToolbar>
		<bx:BXPopupPanel ID="PopupPanelView" runat="server">
			<Commands>
				<bx:CommandItem UserCommandId="edit" Default="True" IconClass="edit" 
					ItemText="<%$ LocRaw:PopupText.Edit %>" ItemTitle="<%$ LocRaw:PopupTitle.Edit %>" 
					OnClickScript="window.location.href = 'SaleCustomerTypeEdit.aspx?id=' + UserData['Id']; return false;"  
				/>
				<bx:CommandItem UserCommandId="delete" Default="True" IconClass="delete" 
					ItemText="<%$ LocRaw:Kernel.Delete %>" ItemTitle="<%$ LocRaw:PopupTitle.Delete %>" 
					ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:PopupConfirmDialogText.Delete %>" 
				/>
			</Commands>
		</bx:BXPopupPanel>
		
		<bx:BXValidationSummary ID="ErrorMessage" runat="server" CssClass="errorSummary" HeaderText="<%$ Loc:Kernel.Error %>" ValidationGroup="GridView"/>
		<br />
		<bx:BXGridView ID="GridView" runat="server"
			ContentName="<%$ LocRaw:PageTitle %>" 
			AllowSorting="True" AllowPaging="True" DataKeyNames="Id"  
			SettingsToolbarId="ContextMenuToolbar"
			PopupCommandMenuId="PopupPanelView"
			ContextMenuToolbarId="MultiActionMenuToolbar"
			
			DataSourceID="GridView" 
			OnSelect="GridView_Select" 
			OnSelectCount="GridView_SelectCount"
			OnRowDataBound="GridView_RowDataBound"
			OnDelete="GridView_Delete"
		>
				<Columns>
					<asp:BoundField DataField="Id" HeaderText="ID" SortExpression="Id" ReadOnly="True" />
					<asp:BoundField DataField="Name" HeaderText="<%$ LocRaw:ColumnHeaderText.Name %>" SortExpression="Name" ReadOnly="True" />
					<asp:BoundField DataField="Code" HeaderText="<%$ LocRaw:ColumnHeaderText.Code %>" SortExpression="Code" ReadOnly="True" />
					<asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.Site %>" SortExpression="Site.Name">
					<ItemTemplate>
						<%# 
							((Bitrix.Sale.BXSaleCustomerType)Container.DataItem).Site != null
							? Encode(((Bitrix.Sale.BXSaleCustomerType)Container.DataItem).Site.Name)
							: "&nbsp;"				
						%>
					</ItemTemplate>
					</asp:TemplateField>
				</Columns>					
		</bx:BXGridView>
		
		<bx:BXMultiActionMenuToolbar ID="MultiActionMenuToolbar" runat="server" ValidationGroup="GridView">
			<Items>
				<bx:BXMamImageButton 
					CommandName="delete" ShowConfirmDialog="true" 
					ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>" 
					ConfirmDialogTextAll="<%$ LocRaw:ActionConfirmDialogTextAll.Delete %>" 
					Title="<%$ LocRaw:ActionTitle.Delete %>"
					EnabledCssClass="context-button icon delete"
					DisabledCssClass="context-button icon delete-dis" 
				/>
			</Items>
		</bx:BXMultiActionMenuToolbar>			
</asp:Content>