﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" 
	AutoEventWireup="false" CodeFile="SaleDeliveryHandlerEdit.aspx.cs" Inherits="bitrix_admin_SaleDeliveryHandlerEdit" %>
	
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
	<bx:BXContextMenuToolbar ID="EditToolbar" runat="server">
		<Items>
			<bx:BXCmSeparator ID="ListButton" runat="server" SectionSeparator="true" />
			<bx:BXCmImageButton CssClass="context-button icon btn_list" CommandName="list"
				Text="<%$ LocRaw:ActionText.GoBack %>" Title="<%$ LocRaw:ActionTitle.GoBack %>" Href="SaleDeliveryHandlerList.aspx" />
		</Items>
	</bx:BXContextMenuToolbar>
	<bx:BXValidationSummary ID="errorMessage" runat="server" CssClass="errorSummary" HeaderText="<%$ Loc:Kernel.Error %>" ValidationGroup="Main" />
    <bx:BXAdminNote runat="server" ID="DescriptionMsg">
	    <%= DescriptionHtml %>
	</bx:BXAdminNote>
	<bx:BXTabControl ID="TabControl" runat="server" OnCommand="OnTabControlCommand" ValidationGroup="Main">
		<bx:BXTabControlTab ID="MainSettingsTab" Runat="server" Selected="True" Text="<%$ LocRaw:TabText.MainSettings %>" Title="<%$ LocRaw:TabTitle.MainSettings %>">
			<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
		        <tr valign="top">
		            <td class="field-name" width="25%"><%= GetMessage("FieldLabel.ServiceName") %>:</td>
		            <td width="30%"><%= ServiceName %></td>
		        </tr>
		        <tr valign="top">
		            <td class="field-name"><%= GetMessage("FieldLabel.TargetSite") %>:</td>
		            <td>
		               <asp:DropDownList ID="TargetSite" runat="server"></asp:DropDownList> 
		            </td>
		        </tr>		        
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Active") %>">
					<td class="field-name"><%= GetMessage("FieldLabel.Active") %>:</td>
					<td><asp:CheckBox ID="Active" runat="server" /></td>
				</tr>				
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Name") %>">
					<td class="field-name"><%= GetMessage("FieldLabel.Name") %>:</td>
					<td><asp:TextBox ID="Name" runat="server" Width="350px" /></td>
				</tr>														
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Description") %>">
					<td class="field-name"><%= GetMessage("FieldLabel.Description") %>:</td>
					<td><asp:TextBox ID="Description" runat="server" Width="350px" TextMode="MultiLine" /></td>
				</tr>
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Extra") %>">
					<td class="field-name"><%= GetMessage("FieldLabel.Extra") %>:</td>
					<td><asp:TextBox ID="Extra" runat="server" Width="50px" /></td>
				</tr>								
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Sort") %>">
					<td class="field-name"><%= GetMessage("FieldLabel.Sort") %>:</td>
					<td><asp:TextBox ID="Sort" runat="server" Width="50px" /></td>
				</tr>					
			</table>
			<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
			    <tr class="heading">
			        <td><%= GetMessage("DeliveryServiceSettings.Header") %></td>
			    </tr>
			</table>			
			<table id="saleDeliveryHandlerEditorConfigTable" class="edit-table" cellspacing="0" cellpadding="0" border="0">
			</table>
			<asp:HiddenField ID="ConfigData" runat="server" />							
		</bx:BXTabControlTab>
	</bx:BXTabControl>
	
<script  type="text/javascript" language="javascript">
    if (typeof (Bitrix) == "undefined") {
        var Bitrix = new Object();
    }

    Bitrix.SaleDeliveryHandlerEditor = function Bitrix$SaleDeliveryHandlerEditor() {
		this._copyMode = <%= IsCopyMode.ToString().ToLowerInvariant() %>;
        this._configDataElId = "<%= ConfigData.ClientID %>";
        this._targetSiteElId = "<%= TargetSite.ClientID %>";
        this._selfUrl = "<%= VirtualPathUtility.ToAbsolute("~/bitrix/admin/SaleDeliveryHandlerEdit.aspx") %>";
        this._containerTableElId = "saleDeliveryHandlerEditorConfigTable";
        this._configEditor = null;
        this._serviceName = "";
    }

    Bitrix.SaleDeliveryHandlerEditor.prototype = {
        getConfigDataEl: function() { return document.getElementById(this._configDataElId); },
        getTargetSiteEl: function() { return document.getElementById(this._targetSiteElId); },
        getContainerTableEl: function() { return document.getElementById(this._containerTableElId); },
        getConfigData: function() {
            var dataEl = this.getConfigDataEl();
            return dataEl ? eval("(" + dataEl.value + ")") : {};
        },
        layout: function() {
            var data = this.getConfigData();
            if ("serviceName" in data) this._serviceName = data.serviceName;

            var tbl = this.getContainerTableEl();
            if (!tbl) return;

            while (tbl.rows.length > 0) tbl.deleteRow(0);
            if (!tbl) return;

            if (data && "constructor" in data) {
                var constructor = null;
                try {
                    constructor = eval("(" + data.constructor + ")");
                }
                catch (e) { }
                if (constructor != null) {
                    var ed = this._configEditor = constructor.construct("config" in data ? data.config : {}, tbl);
                    this._paramRows = [];
                    for (var i = 0; i < ed.getParamCount(); i++) {
                        var r = tbl.insertRow(-1);
                        this._paramRows.push(r);
                        r.vAlign = "top";
                        var ttlC = r.insertCell(-1);
                        ttlC.className = "field-name";
                        ttlC.width = "25%";
                        var lbl = document.createElement("LABEL");
                        ttlC.appendChild(lbl);
                        ed.constructParamHint(i, ttlC);
                        lbl.innerHTML = ed.getParamTitle(i) + ":";
                        var dataC = r.insertCell(-1);
                        dataC.width = "30%";
                        ed.constructParamControls(i, dataC);
                    }
                }
            }
            Bitrix.EventUtility.addEventListener(this.getTargetSiteEl(), "change", Bitrix.TypeUtility.createDelegate(this, this._handleTargetSiteChange));
        },
        _handleTargetSiteChange: function() {
            var el = this.getTargetSiteEl();
            if (!el) return;
            var url = this._selfUrl + "?serviceName=" + this._serviceName + "&siteId=" + el.value;
            if(this._copyMode)
				url += "&copy=";
            window.location.href = url;
        },
        save: function() {
            var r = "";
            var dataEl = this.getConfigDataEl();
            if (dataEl) {
                r += "\"serviceName\":\"" + this._serviceName + "\"";
                r += ", \"config\":";
                var ed = this._configEditor;
                r += ed ? ed.getConfigJson() : "{}";
            }
            dataEl.value = "{" + r + "}";
        }
    }
    Bitrix.SaleDeliveryHandlerEditor._instance = null;
    Bitrix.SaleDeliveryHandlerEditor.getInstance = function() { return this._instance != null ? this._instance : (this._instance = new Bitrix.SaleDeliveryHandlerEditor()); }
    
    Bitrix.SaleDeliveryHandlerEditor.getInstance().layout();
</script>	
</asp:Content>