﻿<%@ Page Language="C#" MasterPageFile="AdminMasterPage.master" AutoEventWireup="true"
    CodeFile="SaleDiscountEdit.aspx.cs" Inherits="bitrix_admin_SaleDiscountEdit" %>    


<%@ Register Assembly="Main" Namespace="Bitrix.UI" TagPrefix="bx" %>
<%@ Register Src="~/bitrix/controls/Main/TimeInterval.ascx" TagName="TimeInterval" TagPrefix="ti" %>
<%@ Import Namespace="Bitrix.Services" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
	<bx:BXContextMenuToolbar ID="SaleDiscountCouponEditToolbar" runat="server" OnCommandClick="OnToolBarButtonClick">
		<Items>
			<bx:BXCmSeparator ID="BXCmSeparator1" runat="server" SectionSeparator="true" />
			<bx:BXCmImageButton CssClass="context-button icon btn_list" CommandName="list"
				Text="<%$ LocRaw:ActionText.GoBack %>" Title="<%$ LocRaw:ActionTitle.GoBack %>" Href="SaleDiscountList.aspx" />
		
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton ID="AddButton"
				CommandName="add" Text="<%$ LocRaw:Kernel.Add %>" Title="<%$ LocRaw:ActionTitle.Add %>"
				CssClass="context-button icon btn_new" Href="SaleDiscountEdit.aspx" />
				
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton ID="DeleteButton"
				CommandName="delete" Text="<%$ LocRaw:Kernel.Delete %>" Title="<%$ LocRaw:ActionTitle.Delete %>"
				CssClass="context-button icon btn_delete" ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>" />
		</Items>
	</bx:BXContextMenuToolbar>
	<bx:BXValidationSummary ID="Summary" runat="server" CssClass="errorSummary" HeaderText="<%$ Loc:Kernel.Error %>" ValidationGroup="Main" />
	<bx:BXTabControl ID="TabControl" runat="server" OnCommand="OnEditCommand" ValidationGroup="Main">
		<bx:BXTabControlTab ID="MainSettingsTab" runat="server" Selected="True" Text="<%$ LocRaw:TabText.MainSettings %>" Title="<%$ LocRaw:TabTitle.MainSettings %>">	
			<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
				
				<tr valign="top">
					<td class="field-name">ID:</td>
					<td width="60%"><%= (Discount != null ? Discount.Id.ToString() : "") %></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><span class="required">*</span><%=GetMessage("Label.Name") %>:</td>
					<td width="60%"><asp:TextBox ID="Name" runat="server"></asp:TextBox>
					<asp:RequiredFieldValidator ID="NameRV" runat="server" ValidationGroup="Main" 
					ControlToValidate="Name" ErrorMessage="<%$ Loc:Error.NameIsRequired %>" Display="Dynamic">*</asp:RequiredFieldValidator></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><span class="required">*</span><%=GetMessage("Label.Site") %>:</td>
					<td width="60%"><asp:DropDownList ID="Site" runat="server"></asp:DropDownList></td>
				</tr>
	
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.Active") %>:</td>
					<td width="60%"><asp:CheckBox ID="Active" runat="server" Checked="true" /></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name" width="40%">
						<%= GetMessage("Label.ActivePeriod") + ":" %></td>
					<td width="60%">
						<ti:TimeInterval ID="tiActive" runat="server" />
					</td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.Sort") %>:</td>
					<td width="60%"><asp:TextBox ID="Sort" runat="server"></asp:TextBox></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.DiscountType") %>:</td>
					<td width="60%"><asp:DropDownList ID="DiscountType" runat="server"></asp:DropDownList></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><span class="required">*</span><%=GetMessage("Label.DiscountValue") %>:</td>
					<td width="60%"><asp:TextBox ID="Value" runat="server"></asp:TextBox>
					<asp:RequiredFieldValidator ID="ValueRV" runat="server" ValidationGroup="Main" 
					ControlToValidate="Value" ErrorMessage="<%$ Loc: Error.ValueIsRequired %>" Display="Dynamic">*</asp:RequiredFieldValidator>
					<asp:RegularExpressionValidator ID="ValueRegV" runat="server" ValidationGroup="Main" 
					ControlToValidate="Value" ErrorMessage="<%$ Loc:Error.ValueHaveToBeDecimal %>" Display="Dynamic" ValidationExpression="[0-9]+([\.,][0-9][0-9]?)?">*
					</asp:RegularExpressionValidator>
					</td>
				</tr>	
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.DiscountCurrency") %>:</td>
					<td width="60%"><asp:DropDownList ID="Currency" runat="server"></asp:DropDownList></td>
				</tr>
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.MaxSum") %>:</td>
					<td width="60%">
						<asp:TextBox ID="MaxSum" runat="server"></asp:TextBox>
						<asp:RegularExpressionValidator ID="RegularExpressionValidator1" runat="server" ValidationGroup="Main" 
					ControlToValidate="MaxSum" ErrorMessage="<%$ Loc:Error.MaxSumMustToBeDecimal %>" Display="Dynamic" ValidationExpression="[0-9]+([\.,][0-9][0-9]?)?">*
					</asp:RegularExpressionValidator>
					</td>
				</tr>	
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.MaxElementsCount")%>:</td>
					<td width="60%"><asp:TextBox ID="MaxElementsCount" runat="server"></asp:TextBox></td>
				</tr>	
				
				<tr valign="top">
					<td class="field-name"><%=GetMessage("Label.Description") %>:</td>
					<td width="60%"><asp:TextBox TextMode="MultiLine" ID="Description" runat="server"></asp:TextBox></td>
				</tr>			
				<tr class="heading">
					<td colspan="2"><%=GetMessage("Label.DiscountApplyTo") %></td>
				</tr>
				<tr>
					<td colspan="2">
						<div id="applyContainer"></div>
						<asp:HiddenField ID="hdApply" runat="server"/>
					</td>
				</tr>									
			</table>

		</bx:BXTabControlTab>
		<bx:BXTabControlTab ID="ConditionsTab" runat="server" Text="<%$ LocRaw:TabText.Conditions %>" Title="<%$ LocRaw:TabTitle.Conditions %>">	
		<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
			<tr class="heading">
				<td colspan="2"><%=GetMessage("Label.Coupons") %></td>
			</tr>
			<tr valign="top">
				<td class="field-name"><%=GetMessage("Label.UseCoupons") %>:</td>
				<td  width="60%">
					<asp:CheckBox ID="UseCoupons" runat="server" Checked = "false"/>
				</td>
			</tr>
			<tr valign="top">
				<td class="field-name"><%=GetMessage("Label.Coupon") %>:</td>
				<td  width="60%">
					<table runat="server" ID = "TCoupons">
					<tr>
						<td>
							<asp:RadioButton runat="server" ID = "MultiCoupon" GroupName="Coupon" Checked="true" />
							<label for="<%=MultiCoupon.ClientID %>"><%=GetMessage("Label.IsMultiCoupon") %></label>
						</td>
					</tr>
					<tr id="ID_TR_COUPON1">
						<td>
						<asp:TextBox runat="server" ID="MultiCouponCode" Width="160"></asp:TextBox>
						<asp:RegularExpressionValidator ID="RegMCC" runat="server" ValidationGroup="Main" 
									ControlToValidate="MultiCouponCode" ErrorMessage="<%$ Loc: Error.CodeMustBeLatinNumeric %>" Display="Dynamic" ValidationExpression="[a-zA-Z0-9\-]+">*</asp:RegularExpressionValidator>
						<input type="button" value="<%= GetMessage("Label.Generate") %>" id="CouponBtn" onclick="GenerateCouponCode();"/>
						</td>
					</tr>
					<tr>
						<td>
							<br />
							<asp:RadioButton runat="server" ID = "ManyOneTimeCoupons" GroupName="Coupon" />
							
							<label for="<%=ManyOneTimeCoupons.ClientID %>"><%=GetMessage("Label.ManyOneTimeCoupons")%></label>
						</td>
					</tr>
					<tr id="ID_TR_COUPON2">
						<td>
							<a href="SaleDiscountCouponList.aspx<%= (Discount != null ? "?filter_DiscountId=" + Discount.Id.ToString() : "") %>"><%=GetMessage("Label.GoToCouponList") %></a>
							<br />
							<br />
							<asp:Label runat="server" ID ="InfoBeforeGen"></asp:Label>
							<asp:TextBox runat="server" ID= "CouponsToGenerate" MaxLength="6" Width="50" Enabled="false" Text="0"></asp:TextBox>
							<asp:Label runat="server" ID ="InfoAfterGen"></asp:Label>
						</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr class="heading">
				<td colspan="2"><%=GetMessage("Label.UserRolesPriceTypes") %></td>
			</tr>
			<tr valign="top">
				<td class="field-name"><%=GetMessage("Label.UserRoles") %>:</td>
				<td width="60%"><asp:ListBox runat="server" ID="UserRoles" SelectionMode = "Multiple" Rows="6" ></asp:ListBox></td>
			</tr>
			<tr class="heading">
				<td colspan="2"><%=GetMessage("Label.DiscountConditions") %></td>
			</tr>
			<tr>
				<td colspan="2">
					<div id="mytest"></div>
					<asp:HiddenField ID="hdDiscountTree" runat="server"/>
				</td>
			</tr>
		</table>
		</bx:BXTabControlTab>
	</bx:BXTabControl>
	
	
<script type="text/javascript">

function CouponSelectorClicked(val, flag)
{
    var bCanChange = true;
    if (flag && (val == 1))
    {
        bCanChange = false;
        if (confirm('<%= GetMessage("Label.ConfrimMultiCoupon") %> '))
            bCanChange = true;
    }

    var fl;
    if (val == 1)
        fl = true;
    else
        fl = false;

    if (!bCanChange)
        fl = !fl;

    document.getElementById("<%=MultiCouponCode.ClientID %>").disabled = !fl;
    document.getElementById("CouponBtn").disabled = !fl;
    document.getElementById("<% =ID_TR_COUPON1.ClientID%>").disabled = !fl;
    document.getElementById("<%=MultiCoupon.ClientID %>").checked = fl;

    document.getElementById('<%=CouponsToGenerate.ClientID %>').disabled = fl;
    document.getElementById("<% =ID_TR_COUPON2.ClientID%>").disabled = fl;
    document.getElementById("<%=ManyOneTimeCoupons.ClientID %>").checked = !fl;
}

document.getElementById('<%=MultiCoupon.ClientID %>').onclick = function() { CouponSelectorClicked(1, true) };
document.getElementById('<%=ManyOneTimeCoupons.ClientID %>').onclick = function() { CouponSelectorClicked(2, true) };


function GenerateCouponCode()
{
	var oCoupon = document.getElementById('<%= MultiCouponCode.ClientID %>');

	var allchars = 'ABCDEFGHIJKLNMPQRSTUVWXYZ123456789';
	var string1 = '';
	var string2 = '';
	for (var i = 0; i < 5; i++)
		string1 = string1 + allchars.substr(Math.round((Math.random())*(allchars.length-1)), 1);

	for (var i = 0; i < 7; i++)
		string2 = string2 + allchars.substr(Math.round((Math.random())*(allchars.length-1)), 1);

	oCoupon.value = "CPN-"+string1+"-"+string2;
} 

function ProductSearchOpen(id)
{
	window.open('SaleProductSearch.aspx?site=<%= JSEncode(UrlEncode(siteId ?? "")) %>&currency=<%= currencyCode %>&onselect=ProductSearchSelect&returnparams='+id, '', 'scrollbars=yes,resizable=yes,width=600,height=500,top='+parseInt((screen.height - 500)/2-14)+',left='+parseInt((screen.width - 600)/2-5));
}
					
function ProductSearchSelect(data, params)
{
	var input = BX(params);
	input.value = data.id;
	input.valuesContainer[input.typeId] = data.id;
	
	var link = BX(params+"_link");
	link.innerHTML = data.name;
	input.valuesContainer[input.typeId+"Name"] = data.name;
	return true;
}

function CatalogSearchOpen(id)
{
	window.open('CatalogSearch.aspx?site=<%= JSEncode(UrlEncode(siteId ?? "")) %>&currency=<%= currencyCode %>&onselect=CatalogSearchSelect&returnparams='+id, '', 'scrollbars=yes,resizable=yes,width=600,height=500,top='+parseInt((screen.height - 500)/2-14)+',left='+parseInt((screen.width - 600)/2-5));
}
					
function CatalogSearchSelect(data, params)
{
	var input = BX(params);
	input.value = data.id;
	input.valuesContainer[input.typeId] = data.id;
	
	var link = BX(params+"_link");
	link.innerHTML = data.name;
	input.valuesContainer[input.typeId+"Name"] = data.name;
	return true;
}

function SectionSearchOpen(id)
{
	window.open('CatalogSectionSearch.aspx?site=<%= JSEncode(UrlEncode(siteId ?? "")) %>&onselect=SectionSearchSelect&returnparams='+id, '', 'scrollbars=yes,resizable=yes,width=600,height=500,top='+parseInt((screen.height - 500)/2-14)+',left='+parseInt((screen.width - 600)/2-5));
}

function SectionSearchSelect(data, params)
{
	var input = BX(params);
	input.value = data.id;
	input.valuesContainer[input.typeId] = data.id;
	
	var link = BX(params+"_link");
	link.innerHTML = data.name;
	input.valuesContainer[input.typeId+"Name"] = data.name;
	return true;
}
	
var variants = <%= VariantsJSON %>;
var applyVariants = <%= ApplyVariantsJSON %>;

var discountState = <%= DiscountJSON %>;
var applyState = <%= ApplyDiscountJSON %>;

BX.ready(function () { CouponSelectorClicked(<%= (IsMultiCoupon ? "1":"2") %>, false); });
BX.ready(function () { var condProcessor = new Bitrix.treeProcessor({'variants':variants, 'productSelectHandler':ProductSearchOpen,'catalogSelectHandler':CatalogSearchOpen, 'sectionSelectHandler':SectionSearchOpen}); condProcessor.RenderTree(discountState, document.getElementById('mytest'), null, 0);});

BX.ready(function() {var applyProcessor = new Bitrix.treeProcessor({'variants':applyVariants,'productSelectHandler':ProductSearchOpen,'catalogSelectHandler':CatalogSearchOpen, 'sectionSelectHandler':SectionSearchOpen}); applyProcessor.RenderTree(applyState, document.getElementById('applyContainer'), null, 0);});

</script>
	

	
</asp:Content>

