﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" AutoEventWireup="true"
	CodeFile="SaleOrderEdit.aspx.cs" Inherits="Bitrix.Sale.AdminPages.OrderEdit" 
	EnableViewState="false"
%>
<%@ Import Namespace="Bitrix.Services.Text" %>
<%@ Import Namespace="Bitrix.Sale" %>

<%@ Register Src="~/bitrix/controls/Main/Calendar.ascx" TagName="Calendar" TagPrefix="bx" %>

<asp:Content ID="Content" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
	<bx:BXContextMenuToolbar ID="ActionBar" runat="server"  OnCommandClick="ActionBar_CommandClick">
		<Items>
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton CssClass="context-button icon btn_list" 
				Text="<%$ LocRaw:ActionText.GoBack %>" Title="<%$ LocRaw:ActionTitle.GoBack %>" 
				Href="SaleOrderList.aspx"
			/>
							
			<bx:BXCmSeparator />
			<bx:BXCmImageButton ID="ViewButton"
				CssClass="context-button icon btn_view"
				Text="<%$ LocRaw:ActionText.View %>" Title="<%$ LocRaw:ActionTitle.View %>"			
			/>
							
			<bx:BXCmSeparator />
			<bx:BXCmImageButton ID="DeleteButton" 
				CssClass="context-button icon btn_delete" CommandName="delete"
				Text="<%$ LocRaw:ActionText.Delete %>" Title="<%$ LocRaw:ActionTitle.Delete %>"
				ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>"
				Href="javascript:void(0);"
			/>
		</Items>
	</bx:BXContextMenuToolbar>
	<bx:BXValidationSummary ID="ErrorMessage" runat="server" CssClass="errorSummary" HeaderText="<%$ LocRaw:Kernel.Error %>" ValidationGroup="EditForm" />
	<bx:BXMessage ID="SuccessMessage" runat="server" Content="<%$ LocRaw:Message.Success %>"
		CssClass="ok" IconClass="ok" Title="<%$ LocRaw:Kernel.Information %>" Visible="False"
		Width="438px" 
	/>
	<bx:BXTabControl ID="TabControl" runat="server" ButtonsMode="Hidden">
		<Tabs>
			<bx:BXTabControlTab ID="MainTab" runat="server" Selected="True" Text="<%$ LocRaw:TabText.Order %>" Title="<%$ LocRaw:TabTitle.Order %>" >
				<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
					<tr class="heading">
						<td colspan="2"><%= string.Format(GetMessageRaw("Heading.Order"), Item.Id, Item.Created.ToString("g")) %></td>
					</tr>
					<tr valign="top">
						<td class="field-name" style="width:40%"><%= GetMessage("Label.LastUpdated") %>:</td>
						<td><%= Item.LastUpdated.ToString("g") %></td>
					</tr>
					<tr valign="top">
						<td class="field-name" style="width:40%"><%= GetMessage("Label.Site") %>:</td>
						<td>
							<select name="site" onchange="<%= Encode(ClientScript.GetPostBackEventReference(this, "change_site")) %>">
							<% foreach (var s in Bitrix.BXSite.GetAllSitesReadOnly().Where(x => x.Active)) { %>
								<option value="<%= s.Id %>" <% if (string.Equals(s.TextEncoder.Decode(s.Id), siteId)) { %>selected="selected"<% } %> ><%= s.Name %></option>
							<% } %>
							</select>
						</td>
					</tr>
					<tr valign="top">
						<td class="field-name"><%= GetMessage("Label.Status") %>:</td>
						<td>
							<% if (Status.Items.Count > 1) { %>
								<asp:DropDownList runat="server" ID="Status" />
							<% } else { %>
								[<%= Encode(Item.Status.XmlId) %>] <%= Encode(Item.Status.LocalizedName) %>
							<% } %>
						</td>
					</tr>
					<tr valign="top">
						<td class="field-name"><%= GetMessage("Label.Sum") %>:</td>
						<td><%= Encode(Item.Currency.MoneyToString(Item.Sum)) %></td>
					</tr>
					<tr valign="top">
						<td class="field-name"><%= GetMessage("Label.SumPaid") %>:</td>
						<td style="white-space:nowrap">
							<asp:TextBox runat="server" ID="SumPaid" />
							<asp:CompareValidator 
								runat="server" 
								ID="SumPaidValidator" 
								ValidationGroup="EditForm"
								ControlToValidate="SumPaid" 
								Operator="DataTypeCheck" 
								Type="Currency" 
								Text="*" 
								ErrorMessage="<%$ LocRaw:Message.SumPaidIncorrect %>"
							/>
							<%= Encode(Item.Currency.Iso4217AlphaCode) %>
						</td>
					</tr>
					<% 
						var canCancel = BXUser.IsCanOperate(BXSaleModule.Operations.OrderCancel, BXSaleModuleConfiguration.Id, Item.StatusId); 
						Cancelled.Enabled =  canCancel;
						ReasonCancelled.Enabled = canCancel;
					%>
					<tr valign="top">
						<td class="field-name">&nbsp;</td>
						<td><asp:CheckBox runat="server" ID="Cancelled" Text="<%$ LocRaw:CheckBoxText.Cancelled %>" /></td>
					</tr>
					<tr valign="top">
						<td class="field-name"><%= GetMessage("Label.ReasonCancelled") %>:</td>
						<td><asp:DropDownList runat="server" ID="ReasonCancelled" /></td>
					</tr>
					
					<tr class="heading">
						<td colspan="2"><%= GetMessage("Heading.User") %></td>
					</tr>
					<tr valign="top">
						<td class="field-name"><%= GetMessage("Label.User") %>:</td>
						<td>
							<bx:BXAutoCompleteFilter
								ID="User" 
								runat="server" 
								Url="~/bitrix/handlers/Main/UsersHandler.ashx" 
								TextBoxWidth="350px"
							/>
						</td>
					</tr>
				</table>
			</bx:BXTabControlTab>
			
			<bx:BXTabControlTab ID="PropertiesTab" runat="server" Text="<%$ LocRaw:TabText.Properties %>" Title="<%$ LocRaw:TabTitle.Properties %>" >
				<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
					<tr valign="top">
						<td class="field-name" style="width:40%"><%= GetMessage("Label.CustomerType") %>:</td>
						<td>
							<select name="customerType" onchange="<%= Encode(ClientScript.GetPostBackEventReference(this, "change_customer_type")) %>">
							<% foreach (var ct in customerTypes) { %>
								<option value="<%= ct.Id %>" <% if (ct == currentCustomerType) { %>selected="selected"<% } %> ><%= Encode(ct.Name) %></option>
							<% } %>
							</select>
						</td>						
					</tr>													
					<tr class="heading">
						<td colspan="2"><%= GetMessage("Heading.Properties") %></td>
					</tr>
													
					<% foreach(var f in fields) { %>
					<tr valign="top">
						<td class="field-name" style="width:40%"><% if (f.Field.Required) { %><span class="required">*</span><% } %><%= f.Field.Name %>:</td>
						<td><%= f.Editor.Render(f.FormFieldName, f.ClientId) %></td>
					</tr>
					<% } %>
					
					<tr>
						<td class="field-name" style="width:40%; vertical-align:top"><%= GetMessage("Label.Comment") %>:</td>
						<td><asp:TextBox runat="server" ID="CustomerComments" TextMode="MultiLine" Columns="40" Rows="2" /></td>
					</tr>
				</table>
			</bx:BXTabControlTab>
			
			<bx:BXTabControlTab ID="DeliveryTab" runat="server" Text="<%$ LocRaw:TabText.PaymentDelivery %>" Title="<%$ LocRaw:TabText.PaymentDelivery %>" >
				<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
					<tr class="heading">
						<td colspan="2"><%= GetMessage("Heading.Payment") %></td>
					</tr>
					<tr valign="top">
						<td class="field-name" style="width:40%"><%= GetMessage("Label.PaymentSystem") %>:</td>
						<td>
							<select name="paymentSystem">
								<option value="" <% if (paymentSystem == null) { %>selected="selected"<% } %> ><%= GetMessage("Option.NotSet") %></option>
								<% foreach (var ps in PaymentSystems) { %>
								<option value="<%= ps.Id %>" <% if (paymentSystem == ps) { %>selected="selected"<% } %> >[<%= ps.Id %>] <%= Encode(ps.Name) %></option>
								<% } %>
							</select>
						</td>						
					</tr>	
					<tr valign="top">
						<td class="field-name" style="width:40%">&nbsp;</td>
						<td><asp:CheckBox runat="server" ID="Paid" Text="<%$ LocRaw:CheckBoxText.Paid %>" /></td>						
					</tr>	
					<tr valign="top">
						<td class="field-name" style="width:40%"><%= GetMessage("Label.PaymentDocument") %>:</td>
						<td><asp:TextBox runat="server" ID="PaymentDocument" /></td>						
					</tr>
					<tr valign="top">
						<td class="field-name" style="width:40%"><%= GetMessage("Label.PaymentDocumentDate") %>:</td>
						<td style="white-space:nowrap">
							<asp:TextBox runat="server" ID="PaymentDocumentDateInput" />
							<bx:Calendar runat="server" ID="PaymentDocumentDate" TextBoxId="PaymentDocumentDateInput" />
						</td>						
					</tr>										
					
					<tr class="heading">
						<td colspan="2"><%= GetMessage("Heading.Delivery") %></td>
					</tr>
					<tr valign="top">
						<td class="field-name" style="width:40%">&nbsp;</td>
						<td><asp:CheckBox runat="server" ID="AllowShipping" Text="<%$ LocRaw:CheckBoxText.AllowShipping %>" /></td>						
					</tr>	
					<tr valign="top">
						<td class="field-name" style="width:40%"><%= GetMessage("Label.ShippingDocument") %>:</td>
						<td><asp:TextBox runat="server" ID="ShippingDocument" /></td>						
					</tr>
					<tr valign="top">
						<td class="field-name" style="width:40%"><%= GetMessage("Label.ShippingDocumentDate") %>:</td>
						<td style="white-space:nowrap">
							<asp:TextBox runat="server" ID="ShippingDocumentDateInput" />
							<bx:Calendar runat="server" ID="ShippingDocumentDate" TextBoxId="ShippingDocumentDateInput" />
						</td>						
					</tr>
					<tr class="heading">
						<td colspan="2"><%= GetMessage("Heading.DeliveryServices") %></td>
					</tr>
					<tr>
						<td class="field-name" style="width:40%"><%= GetMessage("Label.TargetCountry") %>:</td>
						<td>
							<select onchange="recalcDelivery();" name="destinationCountryCode" id="destinationCountryCode">
								<% foreach(var c in Bitrix.Services.Location.BXCountry.GetAll().Select(x => new { Code = x.Iso3166NumericCode, Title = x.GetLocalizedName(Bitrix.Services.BXLoc.CurrentLocale) }).OrderBy(x => x.Title)) { %>
								<option value="<%= c.Code %>" <% if (c.Code == destinationCountryCode) { %>selected="selected"<% } %>><%= Encode(c.Title) %></option>
								<% } %>													
							</select>
							<br />
							<small><%= GetMessage("DeliveryRecalcComment") %></small>
						</td>
					</tr>
					<tr>
						<td class="field-name" style="width:40%" ><%= GetMessage("Label.TargetPostalCode") %>:</td>
						<td>
							<input type="text" name="postCode" id="postCode" value="<%= Encode(postCode) %>" onchange="recalcDelivery();" />
							<br />
							<small><%= GetMessage("DeliveryRecalcComment") %></small>
						</td>
					</tr>
					<tr>
						<td class="field-name" style="width:40%"><%= GetMessage("Label.DeliveryVariant") %>:</td>
						<td>
							<%
								var variants = new List<BXSaleDeliveryVariant>();
								foreach (var d in Deliveries)
								{
									d.Context.Response.ClearVariants();
									d.Process(); 
									variants.AddRange(d.Context.Response.Variants);
								}
								var selectedDelivery = variants.Find(x => x.Id == deliveryVariant);
							%>
							
							<script type="text/javascript">
								var DeliveryVariants = {};
								<% foreach (var v in variants) { %>
								DeliveryVariants['<%= JSEncode(v.Id) %>'] = '<%= JSEncode(Bitrix.Currency.BXCurrency.ConvertMoney(v.Cost, v.Currency, Item.Currency).ToString("F2")) %>';
								<% } %>
							</script>
						
							<select onchange="setDelivery(this.value)" name="deliveries" id="deliveries">
								<option value="" <% if (selectedDelivery == null) { %>selected="selected"<% } %>><%= GetMessage("Option.NotSet") %></option>
								<% foreach (var v in variants) { %>
								<option value="<%= JSEncode(v.Id) %>" <% if (selectedDelivery == v) { %>selected="selected"<% } %>><%= v.GetTitleHtml() %></option>
								<% } %>
							</select>
							
						</td>
					</tr>
					<tr>
						<td class="field-name" style="width:40%"><%= GetMessage("Label.DeliveryCost") %>:</td>
						<td width="60%">
							<script type="text/javascript">
								function setDelivery(variant) 
								{
									var value = DeliveryVariants[variant];
									document.getElementById("deliveryCost").value = value || '<%= JSEncode(0m.ToString("F2")) %>';
								}
								function recalcDelivery() 
								{
									BX('recalculating').style.display = '';
									
									var weight = 0.0;
									for(var i = 0; i < productIds.length; i++)
									{
										var weightField = BX('product_' + productIds[i] + '_weight');
										var quantityField = BX('product_' + productIds[i] + '_quantity');
										if (!weightField || !quantityField)
											continue;
										
										var unitWeight = Number.parseLocale(weightField.value);
										if (unitWeight == null || isNaN(unitWeight) || unitWeight <= 0.0)
											continue;
											
										var quantity = parseInt(quantityField.value);
										if (quantity == null || isNaN(quantity) || quantity < 1)
											continue;
											
										weight += unitWeight * quantity;										
									}
																		
									
									BX.ajax.loadJSON(
										'SaleOrderEdit.aspx?id=<%= Item.Id %>'
										+ '&action=delivery' 
										+ '&site=<%= JSEncode(UrlEncode(siteId)) %>'
										+ '&country=' + BX('destinationCountryCode').value
										+ '&postalcode=' + BX('postCode').value
										+ '&weight=' + weight.toString(),  
										function(data) 
										{
											BX('recalculating').style.display = 'none';
											if (!(data instanceof Array))
												return;
																			
											DeliveryVariants = {};
											for(var i = 0; i < data.length; i++)
											{
												var item = data[i];
												DeliveryVariants[item.value] = item.cost;
											}
											
											var select = BX('deliveries');
											var value = select.value;
											while (select.options.length > 1)
												select.removeChild(select.options[1]);
																																								
											for(var i = 0; i < data.length; i++)
											{
												var item = data[i];
												var option = document.createElement('OPTION');
												option.value = item.value;
												option.text = item.text;
												select.appendChild(option);
											}
																					
											for (var i = select.options.length - 1; i >= 0; i--)
											{
												if (select.options[i].value != value && i > 0)
													continue;
												select.selectedIndex = i;
												break;										
											}
											
											if (BX('<%= Recalculate.ClientID %>').checked)
												setDelivery(select.value);
										}
									);
								}
							</script>

							<div>
								<input 
									type="text" 
									value="<%= 
										Encode(
											Recalculate.Checked
											? (
												selectedDelivery != null 
												? Bitrix.Currency.BXCurrency.ConvertMoney(selectedDelivery.Cost, selectedDelivery.Currency, Item.Currency)
												: 0m
											).ToString("F2")
											: (IsPostBack ? Request.Form["deliveryCost"] : Item.DeliveryCost.ToString("F2"))
										)
									%>"
									id="deliveryCost"
									name="deliveryCost" 
									<% if (Recalculate.Checked) { %>disabled="disabled"<% } %>
								/> 
								<%= Encode(Item.Currency.Iso4217AlphaCode) %>
								<a href="javascript:recalcDelivery();"><%= GetMessage("Recalculate") %></a>
							</div>
							<div id="recalculating" style="display:none"><%= GetMessage("Recalculating") %></div>
						</td>
					</tr>											
				</table>
			</bx:BXTabControlTab>
						
			<bx:BXTabControlTab ID="FieldsTab" runat="server" Text="<%$ LocRaw:TabText.Items %>" Title="<%$ LocRaw:TabText.Items %>" >
				<table cellspacing="0" cellpadding="0" border="0" class="edit-table">
					<tr><td colspan="2">
					<table class="internal" id="productsTable" border="0" cellpadding="3" cellspacing="1" width="100%">
						<tr class="heading">
							<td><%= GetMessage("Column.Name") %></td>
							<td><%= GetMessage("Column.XmlId") %></td>
							<td><%= GetMessage("Column.Quantity") %></td>
							<td><%= GetMessage("Column.Price") %></td>
							<td>&nbsp;</td>
						</tr>
						<% 
							int i = 0; 
							var ids = new List<string>();				
						%>
						<% foreach (var p in ProductInfos) { %>
							
							<tr id="productRow_<%= i %>">
								<td><div id="productRow_<%= i %>_name"><%= Encode(p.Name) %></div></td>
								<td><div id="productRow_<%= i %>_cartelementcode"><%= Encode(p.CartElementCode) %></div></td>
								<td><div id="productRow_<%= i %>_quantity"><%= p.Quantity %></div></td>
								<td><div id="productRow_<%= i %>_price"><%= Encode(p.Price) %> <%= Encode(Item.Currency.GetSymbol()) %></div></td>
								<td id="productRow_<%= i %>_controls">
									<a href="javascript: ShowProductEdit(<%= i %>);"><%= GetMessage("Edit") %></a><br/>
									<a href="javascript: DeleteProduct(<%= i %>);"><%= GetMessage("Kernel.Delete") %></a>
									<% if (p.Id != null) { %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_id"), p.Id) %>
									<% } %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_cartelementid"), p.CartElementId) %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_cartelementcode"), p.CartElementCode) %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_cartcatalogcode"), p.CartCatalogCode) %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_name"), p.Name) %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_url"), p.Url) %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_price"), p.Price) %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_weight"), p.Weight) %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_quantity"), p.Quantity) %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_vat"), p.Vat) %>
									<%= Hidden(string.Concat("product_", i.ToString(), "_vatincluded"), p.VatIncluded) %>
								</td>
							</tr>
							<% 
								ids.Add(i.ToString());
								i++;
							%>
						<% } %>
					</table>
					<div id="productsAdditionalFields">
						<%= Hidden("productsCount", i.ToString()) %>
						<%= Hidden("productsIds", string.Join("|", ids.ToArray())) %>
					</div>
					<script type="text/javascript">
					<!--
					var cartFields = ['CartElementId', 'Name', 'CartElementCode', 'CartCatalogCode', 'Url', 'Price', 'Weight', 'Quantity', 'Vat', 'VatIncluded'];
					var productIds = [<%= string.Join(", ", ids.ToArray()) %>];
					var cartTotalWeight = 0;
								
					function DeleteProduct(id)
					{
						var table = BX('productsTable');
						ind = -1;
						for (var i = 0; i < table.rows.length; i++)
						{
							if (table.rows[i].id == 'productRow_' + id)
							{
								ind = i;
								break;
							}
						}
						if (ind >= 0)
							table.deleteRow(ind);
			            
						var ind = BX.util.array_search(id, productIds);
						if (ind >= 0)
						{
							productIds.splice(ind, 1);
							BX('productsIds').value = productIds.join('|');
						}
						recalcDelivery();
					}
										
					function pJCFloatDiv() 
					{
						var _this = this;
						this.floatDiv = null;
						this.x = this.y = 0;

						this.Show = function(div, left, top)
						{
							var zIndex = parseInt(div.style.zIndex);
							if(zIndex <= 0 || isNaN(zIndex))
								zIndex = 100;
							div.style.zIndex = zIndex;
							div.style.left = left + "px";
							div.style.top = top + "px";

							if(jsUtils.IsIE())
							{
								var frame = document.getElementById(div.id+"_frame");
								if(!frame)
								{
									frame = document.createElement("IFRAME");
									frame.src = "javascript:''";
									frame.id = div.id+"_frame";
									frame.style.position = 'absolute';
									frame.style.zIndex = zIndex-1;
									document.body.appendChild(frame);
								}
								frame.style.width = div.offsetWidth + "px";
								frame.style.height = div.offsetHeight + "px";
								frame.style.left = div.style.left;
								frame.style.top = div.style.top;
								frame.style.visibility = 'visible';
							}
						}
							
						this.Close = function(div)
						{
							if(!div)
								return;

							var frame = document.getElementById(div.id+"_frame");
							if(frame)
								frame.style.visibility = 'hidden';
						}
							
					}
					var pjsFloatDiv = new pJCFloatDiv();

					/************************************************/

					function SaleBasketEdit()
					{
						var _this = this;
						this.active = null;
						
						this.PopupShow = function(div, pos)
						{
							this.PopupHide();
							if(!div)
								return;
							if (typeof(pos) != "object")
								pos = {};
								
							this.active = div.id;
							div.ondrag = jsUtils.False;
							
							jsUtils.addEvent(document, "keypress", _this.OnKeyPress);
							
							div.style.width = div.offsetWidth + 'px';
							div.style.visibility = 'visible';
							
							var res = jsUtils.GetWindowSize();
							pos['top'] = parseInt(res["scrollTop"] + res["innerHeight"]/2 - div.offsetHeight/2);
							pos['left'] = parseInt(res["scrollLeft"] + res["innerWidth"]/2 - div.offsetWidth/2);
							if(pos['top'] < 5)
								pos['top'] = 5;				
							if(pos['left'] < 5)
								pos['left'] = 5;

							pjsFloatDiv.Show(div, pos["left"], pos["top"]);
						}

						this.PopupHide = function()
						{
							var div = document.getElementById(_this.active);
							if(div)
							{
								pjsFloatDiv.Close(div);
								div.parentNode.removeChild(div);
							}

							this.active = null;
							jsUtils.removeEvent(document, "keypress", _this.OnKeyPress);
						}

						this.OnKeyPress = function(e)
						{
							if(!e) e = window.event
							if(!e) return;
							if(e.keyCode == 27)
								_this.PopupHide();
						},

						this.IsVisible = function()
						{
							return (document.getElementById(this.active).style.visibility != 'hidden');
						}
					}


					function SaveProduct()
					{
						var error = '';
						if(BX.util.trim(BX('dialogProductCartElementId').value).length <= 0)
							error += '<%= GetMessageJS("JS.ItemIdRequired") %><br />';
						else if (ValidatorConvert(BX('dialogProductCartElementId').value, "Integer", {}) == null)
							error += '<%= GetMessageJS("JS.ItemIdIncorrect") %><br />';						
						
						if(BX.util.trim(BX('dialogProductName').value).length <= 0)
							error += '<%= GetMessageJS("JS.ItemNameRequired") %><br />';			
						
						if (BX.util.trim(BX('dialogProductPrice').value).length <= 0)
							error += '<%= GetMessageJS("JS.ItemPriceRequired") %><br />';
						else if (ValidatorConvert(BX('dialogProductPrice').value, "Currency", BX('<%= SumPaidValidator.ClientID %>')) == null)
							error += '<%= GetMessageJS("JS.ItemPriceIncorrect") %><br />';
							
						if (BX.util.trim(BX('dialogProductVat').value).length > 0)
						{
							var val = Number.parseLocale(BX.util.trim(BX('dialogProductVat').value));
							if (val == null || isNaN(val))
								error += '<%= GetMessageJS("JS.ItemVatIncorrect") %><br />';
							else if (val < 0)
								error += '<%= GetMessageJS("JS.ItemVatNegative") %><br />';
						}
						
						if(BX.util.trim(BX('dialogProductWeight').value).length > 0)
						{
							var val = Number.parseLocale(BX.util.trim(BX('dialogProductWeight').value));
							if (val == null || isNaN(val))
								error += '<%= GetMessageJS("JS.ItemWeightIncorrect") %><br />';
							else if (val < 0.0)
								error += '<%= GetMessageJS("JS.ItemWeightNegative") %><br />';
						}
						
						if(BX.util.trim(BX('dialogProductQuantity').value).length <= 0)
							error += '<%= GetMessageJS("JS.ItemQuantityRequired") %><br />';
						else
						{
							var val = ValidatorConvert(BX('dialogProductQuantity').value, "Integer", {});
							if (val == null)
								error += '<%= GetMessageJS("JS.ItemQuantityIncorrect") %><br />';
							else if (val < 1)
								error += '<%= GetMessageJS("JS.ItemQuantityNotPositive") %><br />';
						}
										
						if(error.length > 0)
						{
							BX('cartError').style.display = 'block';
							BX('cartErrorText').innerHTML = error;
							return;
						}
						
						var isNew = (currentProductId == null);
						var id = currentProductId;
						if (isNew)
						{
							id = parseInt(BX('productsCount').value);
							BX('productsCount').value = id + 1;
							var ind = BX.util.array_search(id, productIds);
							if (ind < 0)
							{
								productIds.push(id);
								BX('productsIds').value = productIds.join('|');
							}
							
							var table = BX('productsTable');
							var row = table.insertRow(-1);
							row.id = 'productRow_' + id;

							row.insertCell(-1).appendChild(BX.create({
								tag: 'DIV',
								props: { id: 'productRow_' + id + '_name' }
							}));
							row.insertCell(-1).appendChild(BX.create({
								tag: 'DIV',
								props: { id: 'productRow_' + id + '_cartelementcode' }
							}));
							row.insertCell(-1).appendChild(BX.create({
								tag: 'DIV',
								props: { id: 'productRow_' + id + '_quantity' }
							}));
							row.insertCell(-1).appendChild(BX.create({
								tag: 'DIV',
								props: { id: 'productRow_' + id + '_price' }
							}));
							
												
							var controls = row.insertCell(-1);
							controls.id = 'productRow_' + id + '_controls';
							
							controls.appendChild(BX.create({
								tag: 'A',
								props: { href: 'javascript: ShowProductEdit(' + id + ');' },
								text: '<%= GetMessageJS("Edit") %>'
							}));
							controls.appendChild(BX.create({ tag: 'BR' }));
							controls.appendChild(BX.create({
								tag: 'A',
								props: { href: 'javascript: DeleteProduct(' + id + ');' },
								text: '<%= GetMessageJS("Kernel.Delete") %>'
							}));
						}
						
						//values
						var controls = BX('productRow_' + id + '_controls');
						
						for (i = 0; i < cartFields.length; i++)
						{
							var targetName = 'product_' + id + '_' + cartFields[i].toLowerCase()
							var target = BX(targetName);
							if (!target)
							{
								controls.appendChild(target = BX.create({
									tag: 'INPUT',
									props: {
										type: 'hidden',
										id: targetName,
										name: targetName,
										value: ''
									}
								}));
							}
							
							var source = BX('dialogProduct' + cartFields[i]);
							if(source)
							{
								if (source.type == 'checkbox')
									target.value = source.checked ? 'Y' : '';
								else 
									target.value = source.value;							
							}
						}
											
						//visible values
						BX('productRow_' + id + '_name').innerHTML = BX.util.htmlspecialchars(BX('dialogProductName').value);
						BX('productRow_' + id + '_cartelementcode').innerHTML = BX.util.htmlspecialchars(BX('dialogProductCartElementCode').value);
						BX('productRow_' + id + '_quantity').innerHTML = BX.util.htmlspecialchars(BX('dialogProductQuantity').value);
						BX('productRow_' + id + '_price').innerHTML = BX.util.htmlspecialchars(BX('dialogProductPrice').value+ ' <%= JSEncode(Item.Currency.GetSymbol()) %>');
						
						SaleBasketEditTool.PopupHide();
						recalcDelivery();
					}

					SaleBasketEditTool = new SaleBasketEdit();
							
					
					function ProductSearchOpen(index)
					{
						window.open('SaleProductSearch.aspx?site=<%= JSEncode(UrlEncode(siteId ?? "")) %>&currency=<%= Item.Currency.Iso4217AlphaCode %>&onselect=ProductSearchSelect', '', 'scrollbars=yes,resizable=yes,width=600,height=500,top='+parseInt((screen.height - 500)/2-14)+',left='+parseInt((screen.width - 600)/2-5));
					}
					
					function ProductSearchSelect(data)
					{
						BX('dialogProductCartElementId').value = data.id;
						BX('dialogProductCartElementCode').value = data.code;
						BX('dialogProductCartCatalogCode').value = data.catalogcode;
						BX('dialogProductName').value = data.name;
						BX('dialogProductUrl').value = data.url;
						BX('dialogProductPrice').value = data.price;
						BX('dialogProductVat').value = data.vat;
						BX('dialogProductVatIncluded').checked = data.vatincluded;
						BX('dialogProductWeight').value = data.weight;
						BX('dialogProductQuantity').focus();
						return true;
					}
							
					function ShowProductEdit(id)
					{
						currentProductId = id;
					
						<%
							string dialogData;
							using (var s = new System.IO.StringWriter())
							using (var html = new HtmlTextWriter(s))
							{	
								AddProductDialog.Visible = true;
								AddProductDialog.RenderControl(html);
								AddProductDialog.Visible = false;
								dialogData = s.ToString();
							}
						%>
									
						var data = BX.processHTML('<%= JSEncode(dialogData) %>');
						for (var i = 0; i < data.SCRIPT.length; i++)
							if (!data.SCRIPT[i].isInternal)
								BX.loadScript(data.SCRIPT[i].JS);
								
						for (var i = 0; i < data.SCRIPT.length; i++)
							if (data.SCRIPT[i].isInternal && data.SCRIPT[i].bRunFirst)
								BX.evalGlobal(data.SCRIPT[i].JS);
						
									
						var div = BX.create({
							tag: 'DIV',
							props: { 
								id: "product_edit",
								innerHTML: data.HTML
							},
							style: {
								visible: 'hidden',
								position: 'absolute'
							}
						});
						
						document.body.appendChild(div);
						
						for (var i = 0; i < data.SCRIPT.length; i++)
							if (data.SCRIPT[i].isInternal && !data.SCRIPT[i].bRunFirst)
								BX.evalGlobal(data.SCRIPT[i].JS);
									
						SaleBasketEditTool.PopupShow(div);
						document.getElementById('cartError').style.display = 'none';
						
						if(id != null)
						{
							for (i = 0; i < cartFields.length; i++)
							{
								var source = BX('product_' + id + '_' + cartFields[i].toLowerCase());
								var target = BX('dialogProduct' + cartFields[i]);
								if(source && target && source.value)
								{
									if (target.type == "checkbox")
										target.checked = (source.value == "Y");
									else
										target.value = source.value;					
								}
							}				
						}
						else 
						{
							for (i = 0; i < cartFields.length; i++)
							{
								var target = BX('dialogProduct' + cartFields[i]);
								if(target)
								{
									if (target.type == "checkbox")
										target.checked = true;
									else
										target.value ='';					
								}
							}	
						}
					}
					//-->
					</script>
		<asp:PlaceHolder runat="server" ID="AddProductDialog" Visible="false">
		<table class="edit-table" style="background-color: #F8F9FC; border: 1px solid #B8C1DD; width: 600px;" >
			<tr class="heading"><td colspan="2"><%= GetMessage("Heading.ItemEdit") %></td></tr>
			<tr><td colspan="2" align="center">
				<div id="cartError" style="display: none;">
					<table class="message message-error" border="0" cellpadding="0" cellspacing="0">
					<tr><td>
						<table class="content" border="0" cellpadding="0" cellspacing="0">
						<tr>
							<td valign="top"><div class="icon-error"></div></td>
							<td>
								<span class="message-title"><%= GetMessage("Kernel.Error") %></span><br>
								<div class="empty" style="height: 5px;"></div>
								<div id="cartErrorText"></div>
							</td>
						</tr>
						</table>
					</td></tr>
					</table>
				</div>
			</td></tr>
			<tr>
				<td width="200" class="field-name"><span class="required">*</span><%= GetMessage("Label.ItemResolver") %>:</td>
				<td width="400"><%= GetMessage("ItemResolverDummy") %></td>
			</tr>
			<tr>
				<td class="field-name"><span class="required">*</span><%= GetMessage("Label.ItemId") %>:</td>
				<td>
					<input 
						id="dialogProductCartElementId" 
						value="" 
						size="5" 
						type="text"
					/>&nbsp;<input
						type="button"
						value="..." 
						onclick="ProductSearchOpen()"						
					/>
				</td>
			</tr>
			<tr>
				<td class="field-name"><span class="required">*</span><%= GetMessage("Label.ItemName") %>:</td>
				<td><input size="40" id="dialogProductName" type="text" value="" /></td>
			</tr>
			<tr>
				<td class="field-name"><%= GetMessage("Label.ItemDetailUrl") %>:</td>
				<td><input id="dialogProductUrl" value="" size="40"	type="text" /></td>
			</tr>
			<tr>
				<td class="field-name"><%= GetMessage("Label.ItemCode") %>:</td>
				<td><input id="dialogProductCartElementCode" value="" size="40" type="text" /></td>
			</tr>
			<tr>
				<td class="field-name"><%= GetMessage("Label.ItemCatalogCode") %>:</td>
				<td><input id="dialogProductCartCatalogCode" value="" size="40" type="text" /></td>
			</tr>
			<tr>
				<td class="field-name"><span class="required">*</span><%= GetMessage("Label.ItemPrice") %>:</td>
				<td style="white-space:nowrap">
					<input id="dialogProductPrice" size="10" maxlength="20" value="" type="text" />
					<%= Item.Currency.Iso4217AlphaCode %>
				</td>
			</tr>
			<tr>
				<td class="field-name" style="vertical-align:top"><%= GetMessage("Label.ItemVatRate") %>:</td>
				<td style="white-space:nowrap">
					<input id="dialogProductVat" size="10" maxlength="20" value="" type="text" /> %
					<br />
					<input type="checkbox" id="dialogProductVatIncluded" />
					<label for="dialogProductVatIncluded"><%= GetMessage("Label.ItemVatIncluded") %></label>
				</td>
			</tr>
			<tr>
				<td class="field-name"><%= GetMessage("Label.ItemWeight") %>:</td>
				<td><input id="dialogProductWeight" size="4" maxlength="20" value="" type="text" /></td>
			</tr>
			<tr>
				<td class="field-name"><span class="required">*</span><%= GetMessage("Label.ItemQuantity") %>:</td>
				<td><input id="dialogProductQuantity" size="4" maxlength="20" value="" type="text" /></td>
			</tr>
			<tr>
				<td colspan="2" align="center">
					<input value="<%= GetMessage("Kernel.Apply") %>" onclick="SaveProduct();" type="button">
					<input value="<%= GetMessage("Kernel.Cancel") %>" onclick="SaleBasketEditTool.PopupHide();" type="button">
				</td>
			</tr>
		</table>
		</asp:PlaceHolder>
			
				</td></tr>
				
					<tr><td valign="top" align="center" colspan="2">
						<input type="button" onclick="ShowProductEdit(null);" value="<%= GetMessage("Button.AddItem") %>" />
					</td></tr>
				</table>
			</bx:BXTabControlTab>
			
			<bx:BXTabControlTab ID="CommentsTab" runat="server" Text="<%$ LocRaw:TabText.Comments %>" Title="<%$ LocRaw:TabTitle.Comments %>" >
				<table cellspacing="0" cellpadding="0" border="0" class="edit-table">
					<tr class="heading">
						<td colspan="2"><%= GetMessage("Heading.AdditionalInfo") %></td>
					</tr>
					<tr>
						<td class="field-name" style="width:40%; vertical-align:top"><%= GetMessage("Label.AdditionalInfo") %>:</td>
						<td><asp:TextBox runat="server" ID="AdditionalInfo" TextMode="MultiLine" Columns="60" Rows="3" /></td>
					</tr>
					<tr class="heading">
						<td colspan="2"><%= GetMessage("Heading.Comment") %></td>
					</tr>
					<tr>
						<td class="field-name" style="width:40%; vertical-align:top"><%= GetMessage("Label.EmployeeComment") %>:<br /><small><%= GetMessage("Description.Comment") %></small></td>
						<td><asp:TextBox runat="server" ID="EmployeeComments" TextMode="MultiLine" Columns="60" Rows="3" /></td>
					</tr>
				</table>				
			</bx:BXTabControlTab>			
		</Tabs>
		<ButtonsBar>
			<script type="text/javascript">
			<!--
			function recalculateParameters()
			{
				var check = BX('<%= Recalculate.ClientID %>');
				var bCanChange = true;
				
				if (check.checked)
				{
					bCanChange = false;
					if (confirm('<%= JSEncode(GetMessageRaw("Confirm.RecalcMode")) %>'))
						bCanChange = true;
				}

				if (bCanChange)
				{
					var cost = BX('deliveryCost');
					if (cost)
						cost.disabled = check.checked;
				}
				else
				check.checked = !check.checked;
				
				
				if (check.checked)
					setDelivery(BX('deliveries').value);
			}
			//-->
			</script>

			<table>
				<tr><td>
					<small>
						<asp:CheckBox runat="server" ID="Recalculate" onclick="recalculateParameters();" /> 
						<label for="<%= Recalculate.ClientID %>"><%= GetMessage("CheckBox.Recalc") %><sup>1)</sup></label>
					</small>
				</td></tr>
			</table>
			<br />
			
			<asp:Button runat="server" ID="Save" OnClick="Order_Save" Text="<%$ LocRaw:Kernel.Save %>" ToolTip="<%$ LocRaw:ButtonToolTip.Save %>" ValidationGroup="EditForm" />
			&nbsp;
			<asp:Button runat="server" ID="Apply" OnClick="Order_Apply" Text="<%$ LocRaw:Kernel.Apply %>" ToolTip="<%$ LocRaw:ButtonToolTip.Apply %>" ValidationGroup="EditForm" />
			&nbsp;
			<asp:Button runat="server" ID="Cancel" OnClick="Order_Cancel" Text="<%$ LocRaw:Kernel.Cancel %>" ToolTip="<%$ LocRaw:ButtonToolTip.Cancel %>" CausesValidation="false" />
		</ButtonsBar>
	</bx:BXTabControl>
	<bx:BXAdminNote runat="server" ID="Note">
		<%= GetMessageRaw("Note") %>		
	</bx:BXAdminNote>
</asp:Content>
