﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" AutoEventWireup="true"
	CodeFile="SaleOrderFieldEdit.aspx.cs" Inherits="Bitrix.Sale.AdminPages.OrderFieldEdit" 
	EnableViewState="false"
%>

<asp:Content ID="Content" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
	<bx:BXContextMenuToolbar ID="ActionBar" runat="server"  OnCommandClick="ActionBar_CommandClick">
		<Items>
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton CssClass="context-button icon btn_list" CommandName="list"
				Text="<%$ LocRaw:ActionText.GoBack %>" Title="<%$ LocRaw:ActionTitle.GoBack %>" 
				Href="SaleOrderFieldList.aspx" 
			/>
							
			<bx:BXCmSeparator />
			<bx:BXCmImageButton ID="AddButton"
				CssClass="context-button icon btn_new"
				Text="<%$ LocRaw:Kernel.Add %>" Title="<%$ LocRaw:ActionTitle.Add %>" 
				Href="SaleOrderFieldEdit.aspx"
			/>
			
			<bx:BXCmSeparator />
			<bx:BXCmImageButton ID="DeleteButton" 
				CssClass="context-button icon btn_delete" CommandName="delete"
				Text="<%$ LocRaw:Kernel.Delete %>" Title="<%$ LocRaw:ActionTitle.Delete %>"
				ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>"
			/>
		</Items>
	</bx:BXContextMenuToolbar>
	<bx:BXValidationSummary ID="ErrorMessage" runat="server" CssClass="errorSummary" HeaderText="<%$ LocRaw:Kernel.Error %>" ValidationGroup="EditForm" />
	<bx:BXMessage ID="SuccessMessage" runat="server" Content="<%$ LocRaw:Message.Success %>"
		CssClass="ok" IconClass="ok" Title="<%$ LocRaw:Kernel.Information %>" Visible="False"
		Width="438px" />
	<bx:BXTabControl ID="TabControl" runat="server" OnCommand="TabControl_Command" ValidationGroup="EditForm">
		<bx:BXTabControlTab ID="BXTabControlTab1" runat="server" Selected="True" Text="<%$ LocRaw:TabText.Parameters %>" Title="<%$ LocRaw:TabTitle.Parameters %>" >
			<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
			<% if (Item == null) { %>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.CustomerType") %>:</td>
					<td>
						<asp:DropDownList ID="CustomerType" runat="server" />
						<br />
						<small><a href="SaleCustomerTypeEdit.aspx" target="_blank"><%= GetMessage("CreateNewCustomerType") %></a></small>
					</td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.FieldType") %>:</td>
					<td><asp:DropDownList ID="CustomType" runat="server" /></td>
				</tr>
			<% } else { %>
				<tr valign="top">
					<td class="field-name">ID:</td>
					<td><%= Item.Id %></td>
				</tr>				
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.CustomerType") %>:</td>
					<td><%= Encode(Item.CustomerType.Name) %></td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.FieldType") %>:</td>
					<td><%= Encode(Item.CustomType.Title) %></td>
				</tr>
			<% } %>
				<tr valign="top">
					<td class="field-name"><span class="required">*</span><%= GetMessage("Label.Name") %>:</td>
					<td>
						<asp:TextBox runat="server" ID="Name" Columns="40" />
						<asp:RequiredFieldValidator runat="server" ID="NameRequired" ControlToValidate="Name" ValidationGroup="EditForm" ErrorMessage="<%$ LocRaw:Message.NameRequired %>" >*</asp:RequiredFieldValidator>
					</td>
				</tr>
				<tr valign="top">
					<td class="field-name"><span class="required">*</span><%= GetMessage("Label.Code") %>:</td>
					<td>
						<asp:TextBox runat="server" ID="Code" Columns="40" onchange="this.value=this.value.toUpperCase();" />
						<asp:RequiredFieldValidator runat="server" ID="CodeRequired" ControlToValidate="Code" ValidationGroup="EditForm" ErrorMessage="<%$ LocRaw:Message.CodeRequired %>" >*</asp:RequiredFieldValidator>
						<asp:RegularExpressionValidator runat="server" ID="CodeRegex" ValidationExpression="^[A-Za-z][A-Za-z0-9_]*$" ControlToValidate="Code" ValidationGroup="EditForm" ErrorMessage="<%$ LocRaw:Message.CodeValidator %>" Text="*" />
						<br /><small><%= GetMessageRaw("Description.Code") %></small>
					</td>
				</tr>
				<tr valign="top">
					<td class="field-name">&nbsp;</td>
					<td><asp:CheckBox runat="server" ID="Required" Text="<%$ LocRaw:CheckBoxText.Required %>" /></td>
				</tr>
				<tr valign="top">
					<td class="field-name">&nbsp;</td>
					<td><asp:CheckBox runat="server" ID="Multiple" Text="<%$ LocRaw:CheckBoxText.Multiple %>" /></td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.Sort") %>:</td>
					<td>
						<asp:TextBox runat="server" ID="Sort" />
						<asp:CompareValidator runat="server" ID="SortType" Operator="DataTypeCheck" Type="Integer" ControlToValidate="Sort" ValidationGroup="EditForm" ErrorMessage="<%$ LocRaw:Message.SortNegative %>" >*</asp:CompareValidator>
					</td>
				</tr>
				<tr valign="top">
					<td class="field-name">&nbsp;</td>
					<td><asp:CheckBox runat="server" ID="UseAsPostalCode" Text="<%$ LocRaw:CheckBoxText.UseAsPostalCode %>" /></td>
				</tr>
				<tr valign="top">
					<td class="field-name">&nbsp;</td>
					<td><asp:CheckBox runat="server" ID="UseAsLocation" Text="<%$ LocRaw:CheckBoxText.UseAsLocation %>" /></td>
				</tr>
				<tr valign="top">
					<td class="field-name">&nbsp;</td>
					<td><asp:CheckBox runat="server" ID="UseAsProfileName" Text="<%$ LocRaw:CheckBoxText.UseAsProfileName %>" /></td>
				</tr>
				<tr valign="top">
					<td class="field-name">&nbsp;</td>
					<td><asp:CheckBox runat="server" ID="UseAsEmail" Text="<%$ LocRaw:CheckBoxText.UseAsEmail %>" /></td>
				</tr>
				<tr valign="top">
					<td class="field-name">&nbsp;</td>
					<td><asp:CheckBox runat="server" ID="ShowInFilter" Text="<%$ LocRaw:CheckBoxText.ShowInFilter %>" /></td>
				</tr>
				<% if (Item != null) { %>
					<% if (settings != null) { %>
					<tr class="heading">
						<td colspan="2"><%= GetMessage("Heading.Settings") %></td>
					</tr>
					<tr>
						<td colspan="2"><asp:PlaceHolder runat="server" ID="SettingsPlaceholder" /></td>
					</tr>
					<% } %>
					
					<% if (advancedSettings != null) { %>
					<tr class="heading">
						<td colspan="2"><%= GetMessage("Heading.Additional") %></td>
					</tr>
					<tr>
						<td colspan="2"><asp:PlaceHolder runat="server" ID="AdvancedSettingsPlaceholder" /></td>
					</tr>
					<% } %>
				<% } %>
			</table>
		</bx:BXTabControlTab>
	</bx:BXTabControl>
</asp:Content>
