﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" AutoEventWireup="true" CodeFile="SaleOrderFieldList.aspx.cs" Inherits="Bitrix.Sale.AdminPages.OrderFieldList" %>
<%@ Import Namespace="Bitrix.Sale" %>	
<%@ Import Namespace="Bitrix.DataLayer" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
		<bx:BXAdminFilter ID="AdminFilter" runat="server" AssociatedGridView="GridView">
			<bx:BXDropDownFilter ID="CustomerTypeFilter" Key="CustomerTypeId" Text="<%$ LocRaw:FilterText.CustomerType %>" ValueType="Integer" Visibility="AlwaysVisible">
				<asp:ListItem Text="<%$ LocRaw:Kernel.All %>" Value="" />
			</bx:BXDropDownFilter>
			<bx:BXDropDownFilter ID="CustomTypeFilter" Key="CustomTypeId" Text="<%$ LocRaw:FilterText.FieldType %>">
				<asp:ListItem Text="<%$ LocRaw:Kernel.All %>" Value="" />
			</bx:BXDropDownFilter>
			<bx:BXTextBoxFilter ID="CodeFilter" Key="Code" Text="<%$ LocRaw:FilterText.Code %>" />
		</bx:BXAdminFilter>
		<asp:UpdatePanel runat="server" ID="AjaxPanel">
		<ContentTemplate>
		<bx:BXContextMenuToolbar ID="ContextMenuToolbar" runat="server">
			<Items>
				<bx:BXCmSeparator SectionSeparator="true" />
				<bx:BXCmImageButton ID="AddButton" Text="<%$ LocRaw:ActionText.Add %>"
					Title="<%$ LocRaw:ActionTitle.Add %>" CssClass="context-button icon btn_new"
					Href="SaleOrderFieldEdit.aspx" />
			</Items>
		</bx:BXContextMenuToolbar>
		<bx:BXPopupPanel ID="PopupPanelView" runat="server">
			<Commands>
				<bx:CommandItem UserCommandId="edit" Default="True" IconClass="edit" 
					ItemText="<%$ LocRaw:PopupText.Edit %>" ItemTitle="<%$ LocRaw:PopupTitle.Edit %>" 
					OnClickScript="window.location.href = 'SaleOrderFieldEdit.aspx?id=' + UserData['Id']; return false;"  
				/>
				<bx:CommandItem UserCommandId="delete" Default="True" IconClass="delete" 
					ItemText="<%$ LocRaw:Kernel.Delete %>" ItemTitle="<%$ LocRaw:PopupTitle.Delete %>" 
					ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:PopupConfirmDialogText.Delete %>" 
				/>
			</Commands>
		</bx:BXPopupPanel>
		
		<bx:BXValidationSummary ID="ErrorMessage" runat="server" CssClass="errorSummary" HeaderText="<%$ Loc:Kernel.Error %>" ValidationGroup="GridView"/>
		<br />
		<bx:BXGridView ID="GridView" runat="server"
			ContentName="<%$ LocRaw:TableTitle %>" 
			AllowSorting="True" AllowPaging="True" DataKeyNames="Id"  
			SettingsToolbarId="ContextMenuToolbar"
			PopupCommandMenuId="PopupPanelView"
			ContextMenuToolbarId="MultiActionMenuToolbar"
			AjaxConfiguration-UpdatePanelId="AjaxPanel"
			
			DataSourceID="GridView" 
			OnSelect="GridView_Select" 
			OnSelectCount="GridView_SelectCount"
			OnRowDataBound="GridView_RowDataBound"
			OnDelete="GridView_Delete"
		>
				<Columns>
					<asp:BoundField DataField="Id" HeaderText="ID" SortExpression="Id" ReadOnly="True" />
										
					<asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.CustomerType %>" SortExpression="CustomerType.Name">
						<ItemTemplate>[<%# Encode(Eval("CustomerType.Id").ToString()) %>] <%# Encode((string)Eval("CustomerType.Name")) %> (<%# Encode((string)Eval("CustomerType.SiteId")) %>)</ItemTemplate>
					</asp:TemplateField>
					
					<asp:BoundField DataField="Name" HeaderText="<%$ LocRaw:ColumnHeaderText.Name %>" SortExpression="Name" ReadOnly="True" />
					<asp:BoundField DataField="Code" HeaderText="<%$ LocRaw:ColumnHeaderText.Code %>" SortExpression="Code" ReadOnly="True" />
					<asp:BoundField DataField="Sort" HeaderText="<%$ LocRaw:ColumnHeaderText.Sort %>" SortExpression="Sort" ReadOnly="True" />
										
					<asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.Type %>" SortExpression="CustomTypeId">
						<ItemTemplate><%# Encode((string)Eval("CustomType.Title")) %></ItemTemplate>
					</asp:TemplateField>
					
					<asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.PostalCode %>" SortExpression="UseAsPostalCode" Visible="false" >
						<ItemTemplate><%# (bool)Eval("UseAsPostalCode") ? GetMessageRaw("Kernel.Yes") : GetMessageRaw("Kernel.No") %></ItemTemplate>
					</asp:TemplateField>
					<asp:TemplateField HeaderText="Email" SortExpression="UseAsEmail" Visible="false" >
						<ItemTemplate><%# (bool)Eval("UseAsEmail") ? GetMessageRaw("Kernel.Yes") : GetMessageRaw("Kernel.No") %></ItemTemplate>
					</asp:TemplateField>
					<asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.ProfileName %>" SortExpression="UseAsProfileName" Visible="false" >
						<ItemTemplate><%# (bool)Eval("UseAsProfileName") ? GetMessageRaw("Kernel.Yes") : GetMessageRaw("Kernel.No") %></ItemTemplate>
					</asp:TemplateField>
					<asp:TemplateField HeaderText="<%$ LocRaw:ColumnHeaderText.ShowInFilter %>" SortExpression="ShowInFilter" Visible="false" >
						<ItemTemplate><%# (bool)Eval("ShowInFilter") ? GetMessageRaw("Kernel.Yes") : GetMessageRaw("Kernel.No") %></ItemTemplate>
					</asp:TemplateField>
				</Columns>					
		</bx:BXGridView>
		
		<bx:BXMultiActionMenuToolbar ID="MultiActionMenuToolbar" runat="server" ValidationGroup="GridView">
			<Items>
				<bx:BXMamImageButton 
					CommandName="delete" ShowConfirmDialog="true" 
					ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>" 
					ConfirmDialogTextAll="<%$ LocRaw:ActionConfirmDialogTextAll.Delete %>" 
					Title="<%$ LocRaw:ActionTitle.Delete %>"
					EnabledCssClass="context-button icon delete"
					DisabledCssClass="context-button icon delete-dis" 
				/>
			</Items>
		</bx:BXMultiActionMenuToolbar>
		</ContentTemplate>
		</asp:UpdatePanel>		
</asp:Content>