﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" AutoEventWireup="true" CodeFile="SaleOrderList.aspx.cs" Inherits="Bitrix.Sale.AdminPages.OrderList" %>
<%@ Import Namespace="Bitrix.Sale" %>	
<%@ Import Namespace="Bitrix.DataLayer" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
	<bx:BXAdminFilter ID="AdminFilter" runat="server" AssociatedGridView="GridView">
		<bx:BXTimeIntervalFilter Text="<%$ LocRaw:FilterText.Created %>" Key="CreatedUtc" ConvertToUtc="True" Visibility="AlwaysVisible" />  
		<bx:BXTimeIntervalFilter Text="<%$ LocRaw:FilterText.LastUpdated %>" Key="LastUpdatedUtc" ConvertToUtc="True" />
		<bx:BXBetweenFilter Text="<%$ LocRaw:FilterText.Id %>" Key="Id" ValueType="Integer" />
		<bx:BXCustomAdminFilter 
			Text="<%$ LocRaw:FilterText.SiteCurrency %>" 
			OnOnBuildFilter="SiteCurrency_OnBuildFilter"
			OnOnLoadState="SiteCurrency_OnLoadState"
			OnOnSaveState="SiteCurrency_OnSaveState"
			OnOnReset="SiteCurrency_OnReset"
		>
			<asp:DropDownList runat="server" ID="SiteFilter" /> / <asp:DropDownList runat="server" ID="CurrencyFilter" />
		</bx:BXCustomAdminFilter>
		<bx:BXListBoxFilter Text="<%$ LocRaw:FilterText.Status %>" Key="StatusId" runat="server" ID="StatusFilter" />
		<bx:BXTimeIntervalFilter Text="<%$ LocRaw:FilterText.StatusSetDate %>" Key="StatusSetDateUtc" ConvertToUtc="True" />
		<bx:BXDropDownFilter Text="<%$ LocRaw:FilterText.Paid %>" Key="Paid" ValueType="Boolean">
			<asp:ListItem Text="<%$ LocRaw:Kernel.All %>" Value="" />
			<asp:ListItem Text="<%$ LocRaw:Kernel.Yes %>" Value="True" />
			<asp:ListItem Text="<%$ LocRaw:Kernel.No %>" Value="False" />
		</bx:BXDropDownFilter>
		<bx:BXTimeIntervalFilter Text="<%$ LocRaw:FilterText.PaidDate %>" Key="PaidDateUtc" ConvertToUtc="True" />
		<bx:BXDropDownFilter Text="<%$ LocRaw:FilterText.Cancelled %>" Key="Cancelled" ValueType="Boolean">
			<asp:ListItem Text="<%$ LocRaw:Kernel.All %>" Value="" />
			<asp:ListItem Text="<%$ LocRaw:Kernel.Yes %>" Value="True" />
			<asp:ListItem Text="<%$ LocRaw:Kernel.No %>" Value="False" />
		</bx:BXDropDownFilter>
		<bx:BXTimeIntervalFilter Text="<%$ LocRaw:FilterText.CancelledDate %>" Key="CancelledDateUtc" ConvertToUtc="True" />
		<bx:BXListBoxFilter Text="<%$ LocRaw:FilterText.CustomerType %>" Key="CustomerTypeId" runat="server" ID="CustomerTypeFilter" />
		<bx:BXListBoxFilter Text="<%$ LocRaw:FilterText.PaymentSystem %>" Key="PaymentSystemId" runat="server" ID="PaymentSystemFilter" />
		<bx:BXAutoCompleteFilter 
			    ID="UserFilter" 
			    runat="server" 
			    Text="<%$ LocRaw:FilterText.User %>"
			    Key="User.UserId" 
			    Url="~/bitrix/handlers/Main/UsersHandler.ashx" 
			    TextBoxWidth="350px"
		/>
		<bx:BXTextBoxStringFilter Text="<%$ LocRaw:FilterText.UserEmail %>" Key="User.Email" />
	</bx:BXAdminFilter>
	<asp:UpdatePanel ID="UP" runat="server" UpdateMode="Conditional" ChildrenAsTriggers="true">
	<ContentTemplate>
		<bx:BXContextMenuToolbar ID="ContextMenuToolbar" runat="server">
			<Items>
				<bx:BXCmSeparator SectionSeparator="true" />
				<bx:BXCmImageButton ID="AddButton" Text="<%$ LocRaw:ActionText.Add %>"
					Title="<%$ LocRaw:ActionTitle.Add %>" CssClass="context-button icon btn_new"
					Href="SaleOrderEdit.aspx" />
			</Items>
		</bx:BXContextMenuToolbar>
		<bx:BXPopupPanel ID="PopupPanelView" runat="server">
			<Commands>
				<bx:CommandItem UserCommandId="view" Default="True" IconClass="view" 
					ItemText="<%$ LocRaw:PopupText.View %>" ItemTitle="<%$ LocRaw:PopupTitle.View %>" 
					OnClickScript="window.location.href = 'SaleOrderView.aspx?id=' + UserData['Id']; return false;"  
				/>
				<bx:CommandItem UserCommandId="edit" Default="True" IconClass="edit" 
					ItemText="<%$ LocRaw:PopupText.Edit %>" ItemTitle="<%$ LocRaw:PopupTitle.Edit %>" 
					OnClickScript="window.location.href = 'SaleOrderEdit.aspx?id=' + UserData['Id']; return false;"  
				/>
				<bx:CommandItem UserCommandId="delete" Default="True" IconClass="delete" 
					ItemText="<%$ LocRaw:Kernel.Delete %>" ItemTitle="<%$ LocRaw:PopupTitle.Delete %>" 
					ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:PopupConfirmDialogText.Delete %>" 
				/>
			</Commands>
		</bx:BXPopupPanel>
		
		<bx:BXValidationSummary ID="ErrorMessage" runat="server" CssClass="errorSummary" HeaderText="<%$ Loc:Kernel.Error %>" ValidationGroup="GridView"/>
		<br />
		<bx:BXGridView ID="GridView" runat="server"
			ContentName="<%$ LocRaw:TableTitle %>" 
			AllowSorting="True" AllowPaging="True" DataKeyNames="Id"  
			SettingsToolbarId="ContextMenuToolbar"
			PopupCommandMenuId="PopupPanelView"
			ContextMenuToolbarId="MultiActionMenuToolbar"
			
			DataSourceID="GridView" 
			OnSelect="GridView_Select" 
			OnSelectCount="GridView_SelectCount"
			OnRowDataBound="GridView_RowDataBound"
			OnDelete="GridView_Delete"
			
			AjaxConfiguration-UpdatePanelId="UP"
		>
				<Columns>
					<asp:BoundField DataField="IdInfo" HeaderText="ID" SortExpression="Id" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField DataField="Paid" HeaderText="<%$ LocRaw:ColumnHeaderText.Paid %>" SortExpression="Paid, PaidDateUtc" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField DataField="Cancelled" HeaderText="<%$ LocRaw:ColumnHeaderText.Cancelled %>" SortExpression="Cancelled, CancelledDateUtc" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField DataField="Status" HeaderText="<%$ LocRaw:ColumnHeaderText.Status %>" SortExpression="StatusSetDateUtc" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField DataField="Sum" HeaderText="<%$ LocRaw:ColumnHeaderText.Sum %>" SortExpression="Sum" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField DataField="User" HeaderText="<%$ LocRaw:ColumnHeaderText.Customer %>" SortExpression="UserId" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField DataField="PaymentSystem" HeaderText="<%$ LocRaw:ColumnHeaderText.PaymentSystem %>" SortExpression="PaymentSystemId" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField DataField="Products" HeaderText="<%$ LocRaw:ColumnHeaderText.Products %>"  ReadOnly="True" HtmlEncode="false" />
					
					<asp:BoundField Visible="False" DataField="Site" HeaderText="<%$ LocRaw:ColumnHeaderText.Site %>" SortExpression="CustomerType.SiteId" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField Visible="False" DataField="CustomerType" HeaderText="<%$ LocRaw:ColumnHeaderText.CustomerType %>" SortExpression="CustomerTypeId" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField Visible="False" DataField="DeliveryCost" HeaderText="<%$ LocRaw:ColumnHeaderText.DeliveryCost %>" SortExpression="DeliveryCost" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField Visible="False" DataField="DeliveryVariant" HeaderText="<%$ LocRaw:ColumnHeaderText.DeliveryVariant %>" SortExpression="DeliveryVariant" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField Visible="False" DataField="LastUpdated" HeaderText="<%$ LocRaw:ColumnHeaderText.LastUpdated %>" SortExpression="LastUpdatedUtc" ReadOnly="True" HtmlEncode="false" />
					
					<asp:BoundField Visible="False" DataField="Comments" HeaderText="<%$ LocRaw:ColumnHeaderText.Comments %>" ReadOnly="True" HtmlEncode="false" />
					
					<asp:BoundField Visible="False" DataField="ProductNames" HeaderText="<%$ LocRaw:ColumnHeaderText.ProductName %>" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField Visible="False" DataField="ProductIds" HeaderText="<%$ LocRaw:ColumnHeaderText.ProductId %>" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField Visible="False" DataField="ProductPrices" HeaderText="<%$ LocRaw:ColumnHeaderText.ProductPrice %>" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField Visible="False" DataField="ProductQuantities" HeaderText="<%$ LocRaw:ColumnHeaderText.ProductQuantity %>" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField Visible="False" DataField="ProductWeights" HeaderText="<%$ LocRaw:ColumnHeaderText.ProductWeight %>" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField Visible="False" DataField="ProductCodes" HeaderText="<%$ LocRaw:ColumnHeaderText.ProductCode %>" ReadOnly="True" HtmlEncode="false" />
					<asp:BoundField Visible="False" DataField="ProductVatRates" HeaderText="<%$ LocRaw:ColumnHeaderText.Vat %>" ReadOnly="True" HtmlEncode="false" />
		
				</Columns>					
		</bx:BXGridView>
		
		<bx:BXMultiActionMenuToolbar ID="MultiActionMenuToolbar" runat="server" ValidationGroup="GridView">
			<Items>
				<bx:BXMamImageButton 
					CommandName="delete" ShowConfirmDialog="true" 
					ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>" 
					ConfirmDialogTextAll="<%$ LocRaw:ActionConfirmDialogTextAll.Delete %>" 
					Title="<%$ LocRaw:ActionTitle.Delete %>"
					EnabledCssClass="context-button icon delete"
					DisabledCssClass="context-button icon delete-dis" 
				/>
			</Items>
		</bx:BXMultiActionMenuToolbar>
		</ContentTemplate>
	</asp:UpdatePanel>			
</asp:Content>