﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" AutoEventWireup="true"
    CodeFile="SaleOrderStatusEdit.aspx.cs" Inherits="bitrix_admin_SaleOrderStatusEdit" Title="#"
    Trace="false" %>
<%@ Register Src="~/bitrix/controls/Main/OperationsEdit.ascx" TagName="OperationsEdit" TagPrefix="bx" %>
<%@ Import Namespace="Bitrix.Services" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <asp:UpdatePanel ID="LangUpdatePanel" runat="server" ChildrenAsTriggers="true" UpdateMode="Conditional">
        <ContentTemplate>
            <bx:BXContextMenuToolbar ID="BXContextMenuToolbar1" runat="server" OnCommandClick="BXContextMenuToolbar1_CommandClick">
                <Items>
                    <bx:BXCmSeparator SectionSeparator="true" />
                    <bx:BXCmImageButton ID="BXCmImageButton1" runat="server" CssClass="context-button icon btn_list" CommandName="getlist"
                        Text="<%$ Loc:List %>" Href="SaleOrderStatusList.aspx" Title="<%$ Loc:ListDesc %>"
                        />
                    <bx:BXCmSeparator ID="AddSeparator" />
                    <bx:BXCmImageButton ID="AddAction" CssClass="context-button icon btn_new" CommandName="new"
                        Text="<%$ Loc:Add %>" Href="SaleOrderStatusEdit.aspx" Title="<%$ Loc:AddDesc %>"
                     />
                    <bx:BXCmSeparator ID="DeleteSeparator" />
                    <bx:BXCmImageButton ID="DeleteAction" runat="server" CssClass="context-button icon btn_delete" CommandName="delete"
                        Text="<%$ Loc:Delete %>" Title="<%$ Loc:DeleteDesc %>" ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>"
                     />
                </Items>
            </bx:BXContextMenuToolbar>
            <bx:BXValidationSummary ID="errorMessage" runat="server" CssClass="errorSummary" HeaderText="<%$ Loc:Kernel.Error %>"/>
            <bx:BXTabControl ID="BXTabControl1" runat="server" OnCommand="BXTabControl1_Command">
                <bx:BXTabControlTab runat="server" Selected="True" ID="edittab0" Title="<%$ Loc:EditTitle %>"
                    Text="<%$ Loc:Parameters %>">
                    <table id="Table1" class="edit-table" cellspacing="0" cellpadding="0" border="0">
                        <tbody>
                            <tr valign="top">
                                <td style="width: 40%" class="field-name">
                                    <%= GetMessage("Label.Code") + ":" %></td>
                                <td style="width: 60%">
                                    <asp:TextBox runat="server" ID="txtCode"></asp:TextBox>
                                </td>
                            </tr>
                            <tr valign="top">
                                <td style="width: 40%" class="field-name">
                                    <%= GetMessage("Label.IsFinal") + ":" %></td>
                                <td style="width: 60%">
                                    <asp:CheckBox runat="server" ID="IsFinal"></asp:CheckBox>
                                </td>
                            </tr>
                            <tr valign="top">
                                <td class="field-name">
                                    <%= GetMessage("Label.Sort") + ":" %></td>
                                <td>
                                     <asp:TextBox runat="server" ID="txtSort" Text="100"></asp:TextBox>
                                </td>
                            </tr>
                            <% foreach (var lang in Languages)
							   { 
								   string name = String.Empty; string desc = String.Empty;
								   if (status != null)
								   {
									   name = status.GetLocalizedName(lang.Id);
									   desc = status.GetLocalizedDescription(lang.Id);
								   }
								   
								   %>
								<tr class="heading">
									<td colspan="2">[<%= lang.Id %>]&nbsp;<%= lang.Name %></td>
								</tr>
								<tr valign="top">
									<td class="field-name">
										<span class="required">*</span><%= GetMessage("Label.Name") %>:
									</td>
									<td>
										<input type="text" style="width:304px;" value="<%= name %>" name="locname_<%=lang.Id %>"/>
									</td>
								</tr>
								<tr valign="top">
									<td class="field-name">
										<%= GetMessage("Label.Desc") %>:
									</td>
									<td>
										<textarea rows="3" cols="35" name="locdesc_<%=lang.Id %>"><%= desc %></textarea>
									</td>
								</tr>
                            <%} %>
                        </tbody>
                    </table>
                </bx:BXTabControlTab>
                <bx:BXTabControlTab ID="edittab1" runat="server" Text="<%$ LocRaw:TabText.Access %>" Title="<%$ LocRaw:TabTitle.Access %>" >
					<bx:OperationsEdit 
						runat="server" 
						ID="AccessEdit" 
						AllowedStates="AllButDenied" 
						ShowLegend="true"
						LegendText-Allow="<%$ LocRaw:Legend.Allow %>" 
						LegendText-InheritAllow="<%$ LocRaw:Legend.InheritAllow %>"
						LegendText-InheritDeny="<%$ LocRaw:Legend.InheritDeny %>" 
					/>
                </bx:BXTabControlTab>
            </bx:BXTabControl>
        </ContentTemplate>
    </asp:UpdatePanel>
</asp:Content>

