﻿using System;
using System.Text;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Collections.ObjectModel;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Bitrix.UI;
using Bitrix.Services;
using Bitrix.Main;
using System.Collections.Generic;
using Bitrix;
using Bitrix.Security;
using Bitrix.DataLayer;
using Bitrix.Services.Text;
using Bitrix.Sale;

public partial class bitrix_admin_SaleOrderStatusList : Bitrix.UI.BXAdminPage
{
	private bool currentUserCanModify = false;

	protected void Page_Init(object sender, EventArgs e)
	{
		if (!this.BXUser.IsCanOperate(BXSaleModule.Operations.AdminManagement))
			BXAuthentication.AuthenticationRequired();

		currentUserCanModify = this.BXUser.IsCanOperate(BXSaleModule.Operations.AdminManagement);
		AddButton.Visible = currentUserCanModify;
		if (!currentUserCanModify)
			GridView.PopupCommandMenuId = PopupPanelView.ID;
	}
	protected void Page_Load(object sender, EventArgs e)
	{
		Title = GetMessage("PageTitle");
		((BXAdminMasterPage)Master).Title = GetMessage("MasterTitle");
	}

	protected void GridView_PopupMenuClick(object sender, BXPopupMenuClickEventArgs e)
	{
		BXGridView grid = sender as BXGridView;
		DataKey drv = grid.DataKeys[e.EventRowIndex];
		if (drv == null)
			return;

		switch (e.CommandName)
		{
			case "edit":
				Response.Redirect(string.Format("SaleOrderStatusEdit.aspx?id={0}", drv.Value));
				break;
		}
	}
	protected void Toolbar_CommandClick(object sender, CommandEventArgs e)
	{
		switch (e.CommandName.ToLower())
		{
			case "add":
				Response.Redirect("SaleOrderStatusEdit.aspx");
				break;
			default:
				break;
		}
	}
	protected void GridView_Select(object sender, BXSelectEventArgs e)
	{
		e.Data = BXSaleOrderStatus.GetList(
			null,
			new BXOrderBy(BXSaleOrderStatus.Fields, e.SortExpression),
			null,
			new BXQueryParams(e.PagingOptions),
			BXTextEncoder.EmptyTextEncoder
		);
	}
	protected void GridView_SelectCount(object sender, BXSelectCountEventArgs e)
	{
		e.Count = BXSaleOrderStatus.Count(null);
	}
	protected void GridView_Delete(object sender, BXDeleteEventArgs e)
	{
		if (!currentUserCanModify)
		{
			Summary.AddErrorMessage(GetMessageRaw("Exception.YouDontHaveRightsToPerformThisOperation"));
			return;
		}

		if (e.Keys != null)
		{
			try
			{
				BXSaleOrderStatus.Delete(e.Keys["Id"]);
				e.DeletedCount++;
			}
			catch (Exception ex)
			{
				Summary.AddErrorMessage(ex.Message);
			}
		}
		else
		{
			var statuses = 	BXSaleOrderStatus.GetList(null, null);
			foreach ( var status in statuses )
				try
				{
					status.Delete();
					e.DeletedCount++;
				}
				catch (Exception ex1)
				{
					Summary.AddErrorMessage(ex1.Message);
				}
		}

		successMessage.Visible = true;
		successMessage.Content = String.Format(GetMessageRaw("SuccessfullyDeleted"), e.DeletedCount);
	}
}