﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" AutoEventWireup="true"
	CodeFile="SaleOrderView.aspx.cs" Inherits="Bitrix.Sale.AdminPages.OrderView" 
	EnableViewState="false"
%>
<%@ Import Namespace="Bitrix.Services.Text" %>
<%@ Import Namespace="Bitrix.Sale" %>

<%@ Register Src="~/bitrix/controls/Main/Calendar.ascx" TagName="Calendar" TagPrefix="bx" %>

<asp:Content ID="Content" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
	<bx:BXContextMenuToolbar ID="ActionBar" runat="server"  OnCommandClick="ActionBar_CommandClick">
		<Items>
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton CssClass="context-button icon btn_list" CommandName="list"
				Text="<%$ LocRaw:ActionText.GoBack %>" Title="<%$ LocRaw:ActionTitle.GoBack %>" 
				Href="SaleOrderList.aspx"
			/>
			
			<bx:BXCmSeparator />
			<bx:BXCmImageButton ID="EditButton" 
				CssClass="context-button icon btn_edit" CommandName="delete"
				Text="<%$ LocRaw:ActionText.Edit %>" Title="<%$ LocRaw:ActionTitle.Edit %>"
			/>
							
			<bx:BXCmSeparator />
			<bx:BXCmImageButton ID="DeleteButton" 
				CssClass="context-button icon btn_delete" CommandName="delete"
				Text="<%$ LocRaw:ActionText.Delete %>" Title="<%$ LocRaw:ActionTitle.Delete %>"
				ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>"
				Href="javascript:void(0);"
			/>
		</Items>
	</bx:BXContextMenuToolbar>
	<bx:BXValidationSummary ID="ErrorMessage" runat="server" CssClass="errorSummary" HeaderText="<%$ LocRaw:Kernel.Error %>" ValidationGroup="EditForm" />
	<bx:BXMessage ID="SuccessMessage" runat="server" Content="<%$ LocRaw:Message.Success %>"
		CssClass="ok" IconClass="ok" Title="<%$ LocRaw:Kernel.Information %>" Visible="False"
		Width="438px" />
	<bx:BXTabControl ID="TabControl" runat="server" ButtonsMode="Hidden">
		<bx:BXTabControlTab ID="MainTab" runat="server" Selected="True" Text="<%$ LocRaw:TabText.Order %>" Title="<%$ LocRaw:TabTitle.Order %>" >
			<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
				<tr class="heading">
					<td colspan="2"><%= GetMessage("Heading.Order") %></td>
				</tr>
				<tr valign="top">
					<td class="field-name" style="width:40%"><%= GetMessage("Label.Id") %></td>
					<td><%= Item.Id %></td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.Created") %></td>
					<td><%= Encode(Item.Created.ToString("g")) %></td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.LastUpdated") %></td>
					<td><%= Encode(Item.LastUpdated.ToString("g")) %></td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.Site") %></td>
					<td>
						[<a href="SiteEdit.aspx?id=<%= Encode(UrlEncode(Item.SiteId)) %>"><%= Encode(Item.SiteId) %></a>]
						<%= Encode(Item.Site.Name) %>
					</td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.Status") %></td>
					<td>
						<% NewStatusPanel.Visible = NewStatus.Items.Count > 0; %>
						<% if (NewStatusPanel.Visible) { %>
						<script type="text/javascript">
						<!--
						var statusBoxVisible = false;
						function ShowHideStatus()
						{
							var viewStatusDIV = document.getElementById("<%= StatusPanel.ClientID %>");
							var editStatusDIV = document.getElementById("<%= NewStatusPanel.ClientID %>");
							if (statusBoxVisible)
							{
								viewStatusDIV.style["display"] = "";
								editStatusDIV.style["display"] = "none";
								statusBoxVisible = false;
							}
							else
							{
								viewStatusDIV.style["display"] = "none";
								editStatusDIV.style["display"] = "";
								statusBoxVisible = true;
							}
						}
						//--> 
						</script>
						<% } %>
						<asp:Panel runat="server" ID="StatusPanel">
							[<a href="SaleOrderStatusEdit.aspx?id=<%= Item.StatusId %>"><%= Encode(Item.Status.XmlId) %></a>]
							<%= Encode(Item.Status.LocalizedName) %>
							<%= Encode(Item.StatusSetDate.ToString("g")) %>
							
							<% if (NewStatusPanel.Visible) { %>
							&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
							<a href="javascript:ShowHideStatus();" style="white-space:nowrap"><%= GetMessage("ChangeStatus") %></a>
							<% } %>
						</asp:Panel>
						
						<asp:Panel runat="server" ID="NewStatusPanel" style="display: none;" DefaultButton="SetNewStatus">
							<asp:DropDownList runat="server" ID="NewStatus" />
							<asp:Button runat="server" ID="SetNewStatus" Text="<%$ LocRaw:ButtonText.Edit %>" OnClick="Order_SetStatus" />
							<br/><br/>
							<a href="javascript:ShowHideStatus();" style="white-space:nowrap"><%= GetMessage("BackToView") %></a>
						</asp:Panel>
					</td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.Sum") %></td>
					<td>
						<b><%= Encode(Item.Currency.MoneyToString(Item.Sum)) %></b>
						<% if (Item.SumPaid != 0m) { %>
							<%= string.Format(GetMessageRaw("PaidFraction"), Encode(Item.Currency.MoneyToString(Item.SumPaid))) %>
						<% } %>
					</td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.Cancelled") %></td>
					<td>
						<% NewCancelledPanel.Visible = BXUser.IsCanOperate(BXSaleModule.Operations.OrderCancel, BXSaleModuleConfiguration.Id, Item.StatusId); %>
						<% if (NewCancelledPanel.Visible) { %>
						<script type="text/javascript">
						<!--
						var cancelBoxVisible = false;
						function ShowHideCancel() {
							var viewCancelDIV = document.getElementById("<%= CancelledPanel.ClientID %>");
							var editCancelDIV = document.getElementById("<%= NewCancelledPanel.ClientID %>");
							if (cancelBoxVisible) {
								viewCancelDIV.style["display"] = "";
								editCancelDIV.style["display"] = "none";
								cancelBoxVisible = false;
							}
							else {
								viewCancelDIV.style["display"] = "none";
								editCancelDIV.style["display"] = "";
								cancelBoxVisible = true;
							}
						}
						//-->
						</script>
						<% } %>
						<asp:Panel runat="server" ID="CancelledPanel" >
							<%= Item.Cancelled ? GetMessageRaw("Kernel.Yes") : GetMessageRaw("Kernel.No") %>
							<input type="hidden" name="<%= UniqueID %>$CancelledFlag" value="<%= Item.Cancelled ? "Y" : "N" %>" />
							
							<% if (Item.CancelledDateUtc != DateTime.MinValue) { %>
							&nbsp;&nbsp;
							<%= Encode(Item.CancelledDate.ToString("g")) %>
							<% } %>
							
							<% if (Item.CancelledEmployee != null) { %>
							&nbsp;&nbsp;
							[<a href="AuthUsersEdit.aspx?id=<%= Item.CancelledEmployeeId %>"><%= Item.CancelledEmployeeId %></a>]
							<%= Encode(Item.CancelledEmployee.UserName) %>
							<% } %>
							
							<% if (NewCancelledPanel.Visible) { %>
							&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
							<a href="javascript:ShowHideCancel();" style="white-space:nowrap"><%= Item.Cancelled ? GetMessageRaw("Uncancell") : GetMessageRaw("Cancell") %></a>
							<% } %>
							
							<% if (Item.Cancelled && Item.ReasonCancelled != null) { %>
							<br />
							<%= BXStringUtility.HtmlEncodeEx(BXSaleOrderCancelReasonLocalization.GetLocalizedName(Item.ReasonCancelled.Value)) %>
							<% } %>
						</asp:Panel>
						<asp:Panel runat="server" ID="NewCancelledPanel" style="display:none" DefaultButton="SetCancelled" >
							<%= string.Format(
								GetMessageRaw("FlagChange"),
								Item.Cancelled ? GetMessageRaw("Flag.Cancelled") : GetMessageRaw("Flag.NotCancelled"),
								!Item.Cancelled ? GetMessageRaw("Flag.Cancelled") : GetMessageRaw("Flag.NotCancelled")										
							) %>
							<br/><br/>
							<%= GetMessage("Label.ReasonCancelled") %>:
							<br/>
							<asp:DropDownList runat="server" ID="ReasonCancelled" /> 
							<br/>
							<% SetCancelled.Text = Item.Cancelled ? GetMessageRaw("ButtonText.Uncancell") : GetMessageRaw("Kernel.Cancel"); %>
							<asp:Button runat="server" ID="SetCancelled" OnClick="Order_SetCancelled" />
							<br/><br/>
							<a href="javascript:ShowHideCancel();" style="white-space:nowrap"><%= GetMessage("BackToView") %></a>							
						</asp:Panel>
					</td>
				</tr>
				
				<% if (Item.User != null) { %>
				<tr class="heading">
					<td colspan="2"><%= GetMessage("Heading.Customer") %></td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.Customer") %></td>
					<td>
						[<a href="AuthUsersEdit.aspx?id=<%= Item.UserId %>"><%= Item.UserId %></a>]
						<%= Encode(Item.User.UserName) %>
					</td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.CustomerEmail") %></td>
					<td>
						<a href="mailto:<%= Encode(Item.User.Email) %>"><%= Encode(Item.User.Email) %></a>			
					</td>
				</tr>
				<% } %>
				
				<tr class="heading">
					<td colspan="2"><%= GetMessage("Heading.Parameters") %></td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.CustomerType") %></td>
					<td>
						[<a href="SaleCustomerTypeEdit.aspx?id=<%= Item.CustomerTypeId %>"><%= Item.CustomerTypeId %></a>]
						<%= Encode(Item.CustomerType.Name) %> 
						(<%= Encode(Item.CustomerType.SiteId) %>)
					</td>
				</tr>
				
				<% var orderProperties = GetCustomProperties(); %>
				<% if (orderProperties.Count > 0) { %>
				<tr class="heading">
					<td colspan="2"><%= GetMessage("Heading.Properties") %></td>
				</tr>
				<% foreach (var p in orderProperties) { %>
				<tr valign="top">
					<td class="field-name"><%= p.TitleHtml %></td>
					<td><%= p.ValueHtml %></td>
				</tr>
				<% } %>
				<% } %>
				
				<% if (!BXStringUtility.IsNullOrTrimEmpty(Item.CustomerComments)) { %>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.CustomerComment") %></td>
					<td><%= BXStringUtility.HtmlEncodeEx(Item.CustomerComments) %></td>
				</tr>
				<% } %>
				
				<tr class="heading">
					<td colspan="2"><%= GetMessage("Heading.Payment") %></td>
				</tr>
				<% if (Item.PaymentSystem != null) { %>
				<% 
					string response = null; 
					if (Item.PaymentSystemResponse != null)
						response = Item.PaymentSystemResponse.ToHtml();
					response = BXStringUtility.IsNullOrTrimEmpty(response) ? null : response.Trim();					
				%>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.Payment") %></td>
					<td>
						[<a href="SalePaymentSystemEdit.aspx?id=<%= Item.PaymentSystemId %>"><%= Item.PaymentSystemId %></a>]
						<%= Encode(Item.PaymentSystem.Name) %> 
						(<%= Encode(Item.PaymentSystem.SiteId) %>)
						<% if (response != null) { %>
						<a href="javascript:void(0);" onclick="var d = BX('<%= ClientID %>_psresponse'); d.style.display = (d.style.display == 'none') ? '' : 'none';"><%= GetMessageRaw("ShowPaymentSystemResponse") %></a>
						<div id="<%= ClientID %>_psresponse" style="display: none"><%= response %></div>
						<% } %>
					</td>					
				</tr>
				<% } %>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.Paid") %></td>
					<td>
						<% NewPaidPanel.Visible = BXUser.IsCanOperate(BXSaleModule.Operations.OrderPay, BXSaleModuleConfiguration.Id, Item.StatusId); %>
						<% if (NewPaidPanel.Visible) { %>
						<script type="text/javascript">
						<!--
							var payBoxVisible = false;
							function ShowHidePay() {
								var viewPayDIV = document.getElementById("<%= PaidPanel.ClientID %>");
								var editPayDIV = document.getElementById("<%= NewPaidPanel.ClientID %>");
								if (payBoxVisible) {
									viewPayDIV.style["display"] = "block";
									editPayDIV.style["display"] = "none";
									payBoxVisible = false;
								}
								else {
									viewPayDIV.style["display"] = "none";
									editPayDIV.style["display"] = "block";
									payBoxVisible = true;
								}
							}
						//-->
						</script>
						<% } %>
						<asp:Panel runat="server" ID="PaidPanel" >
							<%= Item.Paid ? GetMessageRaw("Kernel.Yes") : GetMessageRaw("Kernel.No") %>
							<input type="hidden" name="<%= UniqueID %>$PaidFlag" value="<%= Item.Paid ? "Y" : "N" %>" />
							
							<% if (Item.PaidDateUtc != DateTime.MinValue) { %>
							&nbsp;&nbsp;
							<%= Encode(Item.PaidDate.ToString("g")) %>
							<% } %>
							
							<% if (Item.PaidEmployee != null) { %>
							&nbsp;&nbsp;
							[<a href="AuthUsersEdit.aspx?id=<%= Item.PaidEmployeeId %>"><%= Item.PaidEmployeeId %></a>]
							<%= Encode(Item.PaidEmployee.UserName) %>
							<% } %>
							
							<% if (NewPaidPanel.Visible) { %>
							&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
							<a href="javascript:ShowHidePay();" style="white-space:nowrap"><%= Item.Paid ? GetMessageRaw("CancelPayment") : GetMessageRaw("SetPayment") %></a>
							<% } %>
							
							<% if (Item.Paid && (!BXStringUtility.IsNullOrTrimEmpty(Item.PaymentDocument) || Item.PaymentDocumentDateUtc != DateTime.MinValue)) { %>
							<br />
							<%= GetMessage("PaymentDocument") %>
							<% if (!BXStringUtility.IsNullOrTrimEmpty(Item.PaymentDocument)) { %> <%= string.Format(GetMessageRaw("DocumentNumber"), Encode(Item.PaymentDocument)) %> <% } %>
							<% if (Item.PaymentDocumentDateUtc != DateTime.MinValue) { %> <%= string.Format(GetMessageRaw("DocumentDate"), Item.PaymentDocumentDate.ToString("g")) %> <% } %>
							<% } %>
						</asp:Panel>
						<asp:Panel runat="server" ID="NewPaidPanel" style="display:none" DefaultButton="SetPaid" >
							<%= string.Format(
								GetMessageRaw("FlagChange"),
								Item.Paid ? GetMessageRaw("Flag.Paid") : GetMessageRaw("Flag.NotPaid"),
								!Item.Paid ? GetMessageRaw("Flag.Paid") : GetMessageRaw("Flag.NotPaid")							
							) %>
							<br/><br/>
							<table cellspacing="1" cellpadding="3" border="0">
							<tr>
								<td width="0%" style="white-space: nowrap"><%= GetMessage("Label.PaymentDocument") %>:</td>
								<td><asp:TextBox runat="server" ID="PaymentDocument" Columns="20" /></td>
							</tr>
							<tr>
								<td width="0%" style="white-space: nowrap"><%= GetMessage("Label.PaymentDocumentDate") %>:</td>
								<td>
									<span style="white-space: nowrap;">
										<asp:TextBox runat="server" ID="PaymentDocumentDateInput" Columns="20" />
										<bx:Calendar runat="server" ID="PaymentDocumentDate" TextBoxId="PaymentDocumentDateInput" />
									</span>										
								</td>
							</tr>
							</table>
							<br/>
							<% SetPaid.Text = Item.Paid ? GetMessageRaw("ButtonText.CancelPayment") : GetMessageRaw("ButtonText.SetPayment"); %>
							<asp:Button runat="server" ID="SetPaid" OnClick="Order_SetPaid" />
							<br/><br/>
							<a href="javascript:ShowHidePay();" style="white-space:nowrap"><%= GetMessage("BackToView") %></a>							
						</asp:Panel>
					</td>
				</tr>
				
				<% if (!Item.Paid && NewPaidPanel.Visible && BXSalePaymentManager.IsPaymentCheckSupported(Item.Id)) { %>
				<tr valign="top">
					<td class="field-name">&nbsp;</td>
					<td><asp:LinkButton runat="server" ID="CheckPayment" OnClick="Order_CheckPayment" ><%= GetMessage("CheckPayment") %></asp:LinkButton></td>
				</tr>
				<% } %>
				
				<tr class="heading">
					<td colspan="2"><%= GetMessage("Heading.DeliveryService") %></td>
				</tr>
											
				<% string deliveryVariant; %>
				<% if (BXSaleDeliveryManager.TryGetVariantDescription(Item.DeliveryVariant, out deliveryVariant)) { %>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.DeliveryVariant") %></td>
					<td><%= Encode(deliveryVariant) %></td>
				</tr>
				<% } %>
								
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.AllowShipping") %></td>
					<td>
						<% NewAllowShippingPanel.Visible = BXUser.IsCanOperate(BXSaleModule.Operations.OrderAllowShipping, BXSaleModuleConfiguration.Id, Item.StatusId); %>
						<% if (NewAllowShippingPanel.Visible) { %>
						<script type="text/javascript">
						<!--
						var deliveryBoxVisible = false;
						function ShowHideDelivery() {
							var viewDeliveryDIV = document.getElementById("<%= AllowShippingPanel.ClientID %>");
							var editDeliveryDIV = document.getElementById("<%= NewAllowShippingPanel.ClientID %>");
							if (deliveryBoxVisible) {
								viewDeliveryDIV.style["display"] = "block";
								editDeliveryDIV.style["display"] = "none";
								deliveryBoxVisible = false;
							}
							else {
								viewDeliveryDIV.style["display"] = "none";
								editDeliveryDIV.style["display"] = "block";
								deliveryBoxVisible = true;
							}
						}
						//-->
						</script>
						<% } %>
						<asp:Panel runat="server" ID="AllowShippingPanel" >
							<%= Item.AllowShipping ? GetMessageRaw("Kernel.Yes") : GetMessageRaw("Kernel.No") %>
							<input type="hidden" name="<%= UniqueID %>$AllowShippingFlag" value="<%= Item.AllowShipping ? "Y" : "N" %>" />
							
							<% if (Item.AllowShippingDateUtc != DateTime.MinValue) { %>
							&nbsp;&nbsp;
							<%= Encode(Item.AllowShippingDate.ToString("g")) %>
							<% } %>
							
							<% if (Item.AllowShippingEmployee != null) { %>
							&nbsp;&nbsp;
							[<a href="AuthUsersEdit.aspx?id=<%= Item.AllowShippingEmployeeId %>"><%= Item.AllowShippingEmployeeId %></a>]
							<%= Encode(Item.AllowShippingEmployee.UserName) %>
							<% } %>
							
							<% if (NewAllowShippingPanel.Visible) { %>
							&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
							<a href="javascript:ShowHideDelivery();" style="white-space:nowrap"><%= Item.AllowShipping ? GetMessageRaw("AllowShipping") : GetMessageRaw("DisallowShipping") %></a>
							<% } %>
							
							<% if (Item.AllowShipping && (!BXStringUtility.IsNullOrTrimEmpty(Item.ShippingDocument) || Item.ShippingDocumentDateUtc != DateTime.MinValue)) { %>
							<br />
							<%= GetMessage("ShippingDocument") %>
							<% if (!BXStringUtility.IsNullOrTrimEmpty(Item.ShippingDocument)) { %> <%= string.Format(GetMessageRaw("DocumentNumber"), Encode(Item.ShippingDocument)) %> <% } %>
							<% if (Item.ShippingDocumentDateUtc != DateTime.MinValue) { %> <%= string.Format(GetMessageRaw("DocumentDate"), Item.ShippingDocumentDate.ToString("g")) %> <% } %>
							<% } %>
						</asp:Panel>
						<asp:Panel runat="server" ID="NewAllowShippingPanel" style="display:none" DefaultButton="SetAllowShipping" >
							<%= string.Format(
								GetMessageRaw("FlagChange"),
								Item.AllowShipping ? GetMessageRaw("Flag.ShippingAllowed") : GetMessageRaw("Flag.ShippingDisallowed"),
								!Item.AllowShipping ? GetMessageRaw("Flag.ShippingAllowed") : GetMessageRaw("Flag.ShippingDisallowed")
							) %>							
							<br/><br/>
							<table cellspacing="1" cellpadding="3" border="0">
							<tr>
								<td width="0%" style="white-space: nowrap"><%= GetMessage("Label.ShippingDocument") %>:</td>
								<td><asp:TextBox runat="server" ID="ShippingDocument" Columns="20" /></td>
							</tr>
							<tr>
								<td width="0%" style="white-space: nowrap"><%= GetMessage("Label.ShippingDocumentDate") %>:</td>
								<td>
									<span style="white-space: nowrap;">
										<asp:TextBox runat="server" ID="ShippingDocumentDateInput" Columns="20" />
										<bx:Calendar runat="server" ID="ShippingDocumentDate" TextBoxId="ShippingDocumentDateInput" />
									</span>										
								</td>
							</tr>
							</table>
							<br/>
							<% SetAllowShipping.Text = Item.AllowShipping ? GetMessageRaw("ButtonText.Deny") : GetMessageRaw("ButtonText.Allow"); %>
							<asp:Button runat="server" ID="SetAllowShipping" OnClick="Order_SetAllowShipping" />
							<br/><br/>
							<a href="javascript:ShowHideDelivery();" style="white-space:nowrap"><%= GetMessage("BackToView") %></a>							
						</asp:Panel>
					</td>
				</tr>
				
				<% if (!BXStringUtility.IsNullOrTrimEmpty(Item.AdditionalInfo)) { %>
				<tr class="heading">
					<td colspan="2"><%= GetMessage("Heading.AdditionalInfo") %></td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.AdditionalInfo") %></td>
					<td><%= BXStringUtility.HtmlEncodeEx(Item.AdditionalInfo) %></td>
				</tr>
				<% } %>
				
				
				<% NewEmployeeCommentsPanel.Visible = BXUser.IsCanOperate(BXSaleModule.Operations.OrderManage, BXSaleModuleConfiguration.Id, Item.StatusId); %>
				<% if (!BXStringUtility.IsNullOrTrimEmpty(Item.EmployeeComments) || NewEmployeeCommentsPanel.Visible) { %>
				<tr class="heading">
					<td colspan="2"><%= GetMessage("Heading.Comment") %></td>
				</tr>
				<tr valign="top">
					<td class="field-name"><%= GetMessage("Label.EmployeeComment") %></td>
					<td>
						<% if (NewEmployeeCommentsPanel.Visible) { %>
						<script type="text/javascript">
						<!--
						var employeeCommentsBoxVisible = false;
						function ShowHideEmployeeComments() {
							var viewEmployeeCommentsDIV = document.getElementById("<%= EmployeeCommentsPanel.ClientID %>");
							var editEmployeeCommentsDIV = document.getElementById("<%= NewEmployeeCommentsPanel.ClientID %>");
							if (employeeCommentsBoxVisible) {
								viewEmployeeCommentsDIV.style["display"] = "block";
								editEmployeeCommentsDIV.style["display"] = "none";
								employeeCommentsBoxVisible = false;
							}
							else {
								viewEmployeeCommentsDIV.style["display"] = "none";
								editEmployeeCommentsDIV.style["display"] = "block";
								employeeCommentsBoxVisible = true;
							}
						}
						//-->
						</script>
						<% } %>
						<asp:Panel runat="server" ID="EmployeeCommentsPanel" >
							<%= BXStringUtility.HtmlEncodeEx(Item.EmployeeComments) %>
							<% if (NewEmployeeCommentsPanel.Visible) { %>
							<br />
							<a href="javascript:ShowHideEmployeeComments();" style="white-space:nowrap"><%= GetMessage("EditComment") %></a>
							<% } %>
						</asp:Panel>
						<asp:Panel runat="server" ID="NewEmployeeCommentsPanel" style="display:none" DefaultButton="SetEmployeeComments" >
							<asp:TextBox runat="server" ID="EmployeeComments" TextMode="MultiLine" Columns="60" Rows="3" />
							<br />
							<asp:Button runat="server" ID="SetEmployeeComments" OnClick="Order_SetEmployeeComments" Text="<%$ LocRaw:ButtonText.Edit %>" />
							<br/><br/>
							<a href="javascript:ShowHideEmployeeComments();" style="white-space:nowrap"><%= GetMessage("BackToView") %></a>							
						</asp:Panel>
					</td>
				</tr>
				<% } %>
			</table>
		</bx:BXTabControlTab>
		
		<bx:BXTabControlTab ID="ProductsTab" runat="server" Text="<%$ LocRaw:TabText.Items %>" Title="<%$ LocRaw:TabTitle.Items %>" >
			<table cellspacing="0" cellpadding="0" border="0" class="edit-table">
				<tr><td colspan="2">
					<table width="100%" cellspacing="1" cellpadding="3" border="0" class="internal">
						<tr class="heading">
							<td><%= GetMessage("Column.Name") %></td>
							<td><%= GetMessage("Column.Weight") %></td>
							<td><%= GetMessage("Column.Quantity") %></td>
							<td><%= GetMessage("Column.DiscountName") %></td>
							<td><%= GetMessage("Column.Discount") %></td>
							<td><%= GetMessage("Column.Price") %></td>

						</tr>
						<%
							decimal weight = 0;	
						%>
						<% foreach (var p in Products) {  %>
						<tr>
							<td valign="top"><a href="<%= Encode(p.DetailUrl) %>"><%= Encode(p.Name) %></a></td>
							<%--<td valign="top"> </td>
							<td valign="top"> </td>
							<td valign="top"> </td>--%>
							<td valign="top"><%= Encode(p.Weight.ToString()) %></td>
							<td valign="top"><%= p.Quantity %></td>
							<td valign="top" align="right"><%= p.DiscountName %></td>
							<td valign="top" align="right"><%= Item.Currency.MoneyToString(p.DiscountValue) %></td>
							<td valign="top" align="right"><%= Item.Currency.MoneyToString(p.GetUnitCost())%></td>

						</tr>
						<%
							weight += p.Weight;
						%>
						<% } %>
						<tr>
							<td align="right"><b><%= GetMessage("Totals.Weight") %>:</b></td>
							<td align="right" colspan="5"><%= Encode(weight.ToString()) %></td>
						</tr>
						<tr>
							<td align="right"><b><%= GetMessage("Totals.DeliveryCost") %>:</b></td>
							<td align="right" colspan="5"><%= Encode(Item.Currency.MoneyToString(Item.DeliveryCost)) %></td>
						</tr>
						<tr>
							<td align="right"><b><%= GetMessage("Totals.Total") %>:</b></td>
							<td align="right" colspan="5"><%= Encode(Item.Currency.MoneyToString(Item.Sum)) %></td>
						</tr>
					</table>
				</td></tr>
			</table>
		</bx:BXTabControlTab>
	</bx:BXTabControl>
</asp:Content>
