﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" AutoEventWireup="false" CodeFile="SalePaymentSystemEdit.aspx.cs" Inherits="bitrix_admin_SalePaymentSystemEdit" Title="<%$ LocRaw:PageTitle %>" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
	<bx:BXContextMenuToolbar ID="Toolbar" runat="server" OnCommandClick="OnToolBarButtonClick">
		<Items>
			<bx:BXCmSeparator ID="ListButton" runat="server" SectionSeparator="true" />
			<bx:BXCmImageButton CssClass="context-button icon btn_list" CommandName="list"
				Text="<%$ LocRaw:ActionText.GoBack %>" Title="<%$ LocRaw:ActionTitle.GoBack %>" Href="SalePaymentSystemList.aspx" />
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton ID="AddButton"
				CommandName="add" Text="<%$ LocRaw:Kernel.Add %>" Title="<%$ LocRaw:ActionTitle.Add %>"
				CssClass="context-button icon btn_new" Href="SaleCustomDeliveryEdit.aspx" />	
			<bx:BXCmSeparator SectionSeparator="true" />
			<bx:BXCmImageButton ID="DeleteButton"
				CommandName="delete" Text="<%$ LocRaw:Kernel.Delete %>" Title="<%$ LocRaw:ActionTitle.Delete %>"
				CssClass="context-button icon btn_delete" ShowConfirmDialog="true" ConfirmDialogText="<%$ LocRaw:ActionConfirmDialogText.Delete %>"/>
		</Items>
	</bx:BXContextMenuToolbar>
	<bx:BXValidationSummary ID="errorMessage" runat="server" CssClass="errorSummary" HeaderText="<%$ Loc:Kernel.Error %>" ValidationGroup="Main" />
	<bx:BXTabControl ID="TabControl" runat="server" ValidationGroup="Main" OnCommand="OnCommand">
        <bx:BXTabControlTab ID="MainSettingsTab" Runat="server" Selected="True" Text="<%$ LocRaw:TabText.Main %>" Title="<%$ LocRaw:TabTitle.Main %>">
			<table class="edit-table" cellspacing="0" cellpadding="0" border="0">
				<% if (EntityId > 0) { %>
				    <tr valign="top"><td class="field-name">ID:</td><td><%= EntityId %></td></tr>
				<% }%>
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Active") %>">
					<td class="field-name" width="40%"><%= GetMessage("FieldLabel.Active") %>:</td>
					<td width="60%">
					    <asp:CheckBox ID="ActiveChkBx" runat="server" />
					</td>
				</tr>
				<%if(EditorMode == SalePaymentSystemEditorMode.Creation) {%>    					
                <tr valign="top" title="<%= GetMessage("FieldTooltip.Site") %>">
					<td class="field-name" width="40%"><span class="required">*</span><%= GetMessage("FieldLabel.Site") %>:</td>
					<td>
                        <asp:DropDownList runat="server" ID="SiteList" CausesValidation="true" AutoPostBack="true" Width="350px"></asp:DropDownList>
                        <asp:CustomValidator runat="server" ID="SiteValidator" ValidationGroup="Main" ControlToValidate="SiteList" ErrorMessage="<%$ Loc:Message.SiteNotSpecified %>" Display="Dynamic" EnableClientScript="true" ValidateEmptyText="true" OnServerValidate="OnSiteListValidate" ClientValidationFunction="Bitrix.SalePaymentSystemEditor.validateSiteList">*</asp:CustomValidator>
					</td>                    
				</tr>						
				<%} else {%>
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Site") %>">
					<td class="field-name" width="40%"><%= GetMessage("FieldLabel.Site") %>:</td>
					<td><%= EntitySite != null ? "[" + EntitySite.Id + "] " + EntitySite.Name : ""  %></td>
				</tr>
				<%} %>	
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Name") %>">
					<td class="field-name" width="40%"><span class="required">*</span><%= GetMessage("FieldLabel.Name") %>:</td>
					<td width="60%">
					    <asp:TextBox ID="NameTbx" runat="server" Width="350px"/>
						<asp:RequiredFieldValidator ID="NameValidator" runat="server" ValidationGroup="Main" ControlToValidate="NameTbx" ErrorMessage="<%$ Loc:Message.NameNotSpecified %>" Display="Dynamic">*</asp:RequiredFieldValidator>					    
                    </td>
				</tr>																										
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Description") %>" >
					<td class="field-name" width="40%"><%= GetMessage("FieldLabel.Description") %>:</td>
					<td>
						<asp:TextBox Rows="7" ID="DescriptionTbx"  TextMode="MultiLine" runat="server" Width="350px" />						
					</td>
				</tr>													
				<tr valign="top" title="<%= GetMessage("FieldTooltip.Sort") %>">
					<td class="field-name" width="40%"><%= GetMessage("FieldLabel.Sort") %>:</td>
					<td>
					    <asp:TextBox ID="SortTbx" runat="server" Width="50px" />
					    <asp:RegularExpressionValidator runat="server" ID="SortValidator" ValidationExpression="^[\d]*$" ControlToValidate="SortTbx" ValidationGroup="Main" ErrorMessage="<%$ Loc:Message.InvalidSortIndex %>" Display="Dynamic">*</asp:RegularExpressionValidator>
					</td>
				</tr>
				<tr valign="top" title="<%= GetMessage("FieldTooltip.XmlId") %>" >
					<td class="field-name" width="40%"><%= GetMessage("FieldLabel.XmlId") %>:</td>
					<td>
						<asp:TextBox Rows="7" ID="XmlIdTbx"  runat="server" Width="350px" />						
					</td>
				</tr>		
			</table>
		</bx:BXTabControlTab>
        <bx:BXTabControlTab ID="BXTabControlTab1" Runat="server" Text="<%$ LocRaw:TabText.Bindings %>" Title="<%$ LocRaw:TabTitle.Bindings %>">
			<table id="bindingTable" class="edit-table" cellspacing="0" cellpadding="0" border="0">
			</table>
			<div id="bindingStub" style="display:none;">
				<p><%= string.Format(GetMessage("ClientTypesNotFoundForSite") , TargetSiteId) %></p>
				<p><a href="<%= VirtualPathUtility.ToAbsolute("~/bitrix/admin/SaleCustomerTypeEdit.aspx") + "?siteId=" + UrlEncode(TargetSiteId) + "&back_url=" + UrlEncode(PrepareBackUrl()) %>"><%= GetMessage("CreateCustomerType") %></a></p>
			</div>
	    </bx:BXTabControlTab>				
	</bx:BXTabControl>
	<asp:HiddenField runat="server" ID="EditorData" />
<script  type="text/javascript" language="javascript">
    if (typeof (Bitrix) == "undefined") {
        var Bitrix = {};
    }
    
    Bitrix.SaleCustomerType = {}
    Bitrix.SaleCustomerType.getById = function(id) {
        for(var k in this.all)
            if(this.all[k].id == id)
                return this.all[k];
        return null;
    }
    Bitrix.SaleCustomerType.all = <%= CustomerTypeJson %>;
    
    Bitrix.SalePaymentSystemConfig = {} 
    Bitrix.SalePaymentSystemConfig.getByCustomerTypeId = function(id) {
        for(var k in this.all)
            if(this.all[k].customerTypeId == id)
                return this.all[k];
        return null;        
    }
    Bitrix.SalePaymentSystemConfig.all = <%= PaymentSysConfigJson %>;
    
    Bitrix.SalePaymentControllerInfo = {}
    Bitrix.SalePaymentControllerInfo.getByControllerTypeId = function(id) {
        for(var k in this.all)
            if(this.all[k].controllerTypeId == id)
                return this.all[k];
        return null;
    }     
    Bitrix.SalePaymentControllerInfo.all = <%= PaymentControllerInfoJson %>;    
    <%= SaleOrderFieldJson %>
    
    Bitrix.SalePaymentSystemEditor = function Bitrix$SalePaymentSystemEditor() {
        this._data = {};
        this._configEditors = {};
    }
    
    Bitrix.SalePaymentSystemEditor.prototype = {
        layout: function() {            
            var tbl = document.getElementById("bindingTable");
            if(!tbl) return;
            
            while(tbl.rows.length > 0)
                tbl.deleteRow(0);
            
            var headingR = tbl.insertRow(-1);
            headingR.className = "heading";
            
            var headingC = headingR.insertCell(-1);
            headingC.colSpan = 3;
            headingC.innerHTML = "<%= GetMessageRaw("BindingWhoAndHow") %>";
            
            var gapC = tbl.insertRow(-1).insertCell(-1);
            gapC.colSpan = 3;					
            gapC.className = "sale-payment-sys-customer-type-gap"; 
  
			if(Bitrix.SaleCustomerType.all.length > 0)
				for(var k in Bitrix.SaleCustomerType.all) {
					var type = Bitrix.SaleCustomerType.all[k];
					var ed = Bitrix.SalePaymentSystemConfigEditor.create(type, tbl);
					ed.layout();
					this._configEditors[type.id] = ed;	                     		                      
				}
			else
				document.getElementById("bindingStub").style.display = "";                                    
        },
        save: function() {
            var r = "";
            for(var k in this._configEditors) {
                var s = this._configEditors[k].toJson();
                if(!Bitrix.TypeUtility.isNotEmptyString(s)) continue;
                if(r.length > 0) r += ","; 
                r += s;
            }
            document.getElementById("<%= EditorData.ClientID %>").value = r.length > 0 ? "[" + r + "]" : "";
        }
    }
    
    Bitrix.SalePaymentSystemEditor._instance = null; 
    Bitrix.SalePaymentSystemEditor.getInstance = function(){
        return this._instance ? this._instance : (this._instance = new Bitrix.SalePaymentSystemEditor());    
    }
    
    Bitrix.SalePaymentSystemEditor.validateSiteList = function(source, arguments) {
        arguments.IsValid = Bitrix.TypeUtility.isNotEmptyString(arguments.Value);
    }

    Bitrix.SalePaymentSystemConfigEditor = function Bitrix$SalePaymentSystemConfigEditor() {
        this._data = this._customerType = this._ctrlEd = this._container = this._cbx = this._nameContainer = this._ctrlSwContainer = this._ctrlParamHeadContainer = this._selCtrlSw = this._name = this._ctrlParamsGap = null;
        this._visible = false;
    }    
    
    Bitrix.SalePaymentSystemConfigEditor.prototype = {
        initialize: function(customerType, container) {
            this._customerType = customerType;
            this._data = Bitrix.SalePaymentSystemConfig.getByCustomerTypeId(this._customerType.id);
            this._conainer = container;    
        },
        layout: function() {
            var type = this._customerType;
            if(!type) return;
            
            var c = this._conainer;
            if(!c) return;
            
            this._visible = this._data != null;
            
		    var rH = c.insertRow(-1);
    	    rH.className = "heading-left";
	        var cH = rH.insertCell(-1);
	        cH.colSpan = 3;  
	        
		    var cbx = this._cbx = document.createElement("INPUT");
    	    cbx.type = "checkbox";
            cH.appendChild(cbx);                
            cbx.id = "customerTypeSwitch_" + type.id.toString();
            cbx.checked = this._visible;
		    Bitrix.EventUtility.addEventListener(cbx, "change", Bitrix.TypeUtility.createDelegate(this, this._handleSwitchChange));
                        
		    var lbl = document.createElement("LABEL");
		    cH.appendChild(lbl);
            lbl.htmlFor = cbx.id;
            lbl.innerHTML = type.name; 
            
		    var rName = this._nameContainer = c.insertRow(-1);
	        var cNameTtl = rName.insertCell(-1);
		    cNameTtl.className = "field-name";
		    cNameTtl.setAttribute("width", "40%");	        
		    var lblName = document.createElement("LABEL");
		    cNameTtl.appendChild(lblName);
            lblName.innerHTML = "<%= GetMessageJS("JS.Name") %>"; 
	        
	        var cName = rName.insertCell(-1);
	        cName.colSpan = 2;
		    var name = this._name = document.createElement("INPUT");
    	    name.type = "text";
    	    name.style.width = "400px";
	        cName.appendChild(name);
	        if(this._data) name.value = this._data.name;
	        
		    var rCtrlSw = this._ctrlSwContainer = c.insertRow(-1);
	        var cCtrlSwTtl = rCtrlSw.insertCell(-1);
	        cCtrlSwTtl.className = "field-name";
		    cCtrlSwTtl.setAttribute("width", "40%");
		    var lblCtrlSw = document.createElement("LABEL");
		    cCtrlSwTtl.appendChild(lblCtrlSw);
            lblCtrlSw.innerHTML = "<%= GetMessageJS("JS.Handler") %>"; 
            
	        var cCtrlSw = rCtrlSw.insertCell(-1);
	        cCtrlSw.colSpan = 2;
		    var selCtrlSw = this._selCtrlSw = document.createElement("SELECT");                        	                       
		    selCtrlSw.style.width = "400px";
		    cCtrlSw.appendChild(selCtrlSw);
		    
		    var infoAry = [];
            infoAry.push({ "value":"", "text":"<%= GetMessageJS("JS.SelectHandler") %>"});
		    for(var i = 0; i < Bitrix.SalePaymentControllerInfo.all.length; i++){
		        var info = Bitrix.SalePaymentControllerInfo.all[i];
		        infoAry.push({ "value":info.controllerTypeId, "text":info.name });
            }
		    Bitrix.DomHelper.addToSelect(selCtrlSw, infoAry);
		    Bitrix.EventUtility.addEventListener(selCtrlSw, "change", Bitrix.TypeUtility.createDelegate(this, this._handleCtrlChange));
		    Bitrix.DomHelper.selectOption(selCtrlSw, this._data ? this._data.controllerTypeId : "");
		    
            var rCtrlParamHead = this._ctrlParamHeadContainer = c.insertRow(-1);
            rCtrlParamHead.className = "heading";
            
            var cCtrlParamHead = rCtrlParamHead.insertCell(-1);
            cCtrlParamHead.colSpan = 3;
            cCtrlParamHead.innerHTML = "<%= GetMessageJS("JS.HandlerSettings") %>";
            
            
            var gapC = (this._ctrlParamsGap = c.insertRow(-1)).insertCell(-1);
            gapC.colSpan = 3;					
            gapC.className = "sale-payment-sys-controller-params-gap"; 		    
               
		    this._constructEditor();
		    this.setVisible(this._visible);
        },
        getPaymentSystemId: function() {
            return this._data ? this._data.paymentSystemId : 0;
        },
        setVisible: function(visible) {
            this._visible = visible;
            
            if(this._nameContainer) this._nameContainer.style.display = visible ? "" : "none";
            if(this._ctrlSwContainer) this._ctrlSwContainer.style.display = visible ? "" : "none";
            if(this._ctrlParamHeadContainer) this._ctrlParamHeadContainer.style.display = visible ? "" : "none";
            if(this._ctrlEd) this._ctrlEd.setVisible(visible); 
        },
        _constructEditor: function() {
            if(this._ctrlEd) {
                this._ctrlEd.free();
                delete this._ctrlEd;
                this._ctrlEd = null;
            }
            var ctrlTypeId = this._selCtrlSw.value;
            var info = Bitrix.SalePaymentControllerInfo.getByControllerTypeId(ctrlTypeId);
            if(!info) return;
            if(info.constructor) {
                var cfg = null;
                var cfgAll = Bitrix.SalePaymentSystemConfig.all;
                for(var i = 0; i < cfgAll.length; i++) {
                if(cfgAll[i].customerTypeId != this._customerType.id || cfgAll[i].controllerTypeId != ctrlTypeId)
                    continue;
                cfg = cfgAll[i];
                break;
            }   
            var constr = eval("(" + info.constructor + ")");
            this._ctrlEd =  constr.construct(this._customerType.id, cfg ? cfg.controllerSettings : {}, this._conainer, this._ctrlParamsGap);   
            if(this._ctrlEd) this._ctrlEd.layout();
           }
        },
        _handleCtrlChange: function() { this._constructEditor(); },
        _handleSwitchChange: function() {
            if(this._cbx) this.setVisible(this._cbx.checked);
        },
        toJson: function() {
            if(!this._visible) return "";
            var r = "";
            r += "\"paymentSystemId\":" + this.getPaymentSystemId().toString();
            r += ", \"customerTypeId\":" + this._customerType.id.toString();
            if(this._name) r += ", \"name\":\"" + this._name.value + "\"";
            if(this._ctrlEd) {
                r += ", \"controllerTypeId\":\"" + this._ctrlEd.getControllerTypeId() + "\"";
                r += ", \"controllerSettings\":" + this._ctrlEd.toJson();
            }
            return "{" + r + "}";
        }        
    }
    Bitrix.SalePaymentSystemConfigEditor.create = function(customerType, container) {
        var self = new Bitrix.SalePaymentSystemConfigEditor();
        self.initialize(customerType, container);
        return self;
    }

    Bitrix.SalePaymentSystemEditor.getInstance().layout();  
</script>	
</asp:Content>
