﻿<%@ Control Language="C#" AutoEventWireup="false" CodeFile="OrderMappingEditor.ascx.cs" Inherits="Bitrix.Sale.UI.OrderMappingEditor" %>
<%@ Import Namespace="Bitrix.Sale" %>
<%@ Import Namespace="Bitrix.Services.Js" %>
<script runat="server">
	string BuildMapperJson(IEnumerable<BXSaleOrderMapper> mappers)
	{
		var json = new StringBuilder();
		foreach (var m in mappers) 
		{ 
			if (json.Length > 0)
				json.Append(',');
			json.Append("{id:'");
			json.Append(BXJSUtility.Encode(m.Key));
			json.Append("',title:'");
			json.Append(BXJSUtility.Encode(m.Title));
			json.Append("'}");		
		}
		return json.ToString();
	}
</script>
<%
	var userPropertiesMappers = BXSaleOrderMappingManager.GetUserPropertiesMappers();
	var orderPropertiesMappers = BXSaleOrderMappingManager.GetOrderPropertiesMappers(CustomerTypeId);
%>
<script type="text/javascript">
<!--
var <%= ClientID %> = 
{	
	fields: <%= BXJSUtility.BuildJSArray(Fields.ConvertAll(x => x.Key)) %>,
	userFields: [<%= BuildMapperJson(BXSaleOrderMappingManager.UserFieldMappers) %>],
	userProperties: [<%= BuildMapperJson(userPropertiesMappers) %>],
	orderFields: [<%= BuildMapperJson(BXSaleOrderMappingManager.OrderFieldMappers) %>],
	orderProperties: [<%= BuildMapperJson(orderPropertiesMappers) %>]
}

function <%= ClientID %>_SetSelect(data, key, value)
{
	BX('<%= ClientID %>_f_' + key + '_value2').style["display"] = "none";
	var valDropDown = BX('<%= ClientID %>_f_' + key + '_value1');
	valDropDown.style["display"] = "block";

	for (i = 0; i < data.length; i++)
	{
		var newoption = new Option(data[i].title, data[i].id, data[i].id === value, data[i].id === value);
		valDropDown.options[i] = newoption;
	}
	
	while (valDropDown.options.length > data.length)
		valDropDown.remove(valDropDown.options.length - 1);
		
	valDropDown.selectedIndex = 0;
}

function <%= ClientID %>_PropertyTypeChange(select, key, value)
{
	var typeVal = select.value;
	if (typeVal == "user")
		<%= ClientID %>_SetSelect(<%= ClientID %>.userFields, key, value);
	else if (typeVal == "user_property")
		<%= ClientID %>_SetSelect(<%= ClientID %>.userProperties, key, value);
	else if (typeVal == "order")
		<%= ClientID %>_SetSelect(<%= ClientID %>.orderFields, key, value);
	else if (typeVal == "order_property")
		<%= ClientID %>_SetSelect(<%= ClientID %>.orderProperties, key, value);
	else
	{
		var valText = BX('<%= ClientID %>_f_' + key + '_value2');
		valText.value =  value || '';
		
		BX('<%= ClientID %>_f_' + key + '_value1').style["display"] = "none";
		valText.style["display"] = "block";
	}	
}
//-->
</script>
<input type="hidden" name="<%= Encode(UniqueID) %>" value="" />
<table width="0%" cellspacing="0" cellpadding="0" border="0" class="internal">
	<tr class="heading">
		<td align="center"><%= GetMessage("Column.Name") %></td>
		<td align="center"><%= GetMessage("Column.Type") %></td>
		<td align="center"><%= GetMessage("Column.Value") %></td>
	</tr>
	<% foreach (var f in Fields) { %>
	<%
		BXSaleOrderFieldMapping m;
		if (!mappings.TryGetValue(f.Key, out m))
			m = new BXSaleOrderFieldMapping();
		
	%>
	<tr>
		<td><%= Encode(f.Value) %></td>
		<td>
			<select onchange="<%= ClientID %>_PropertyTypeChange(this, '<%= f.Key %>');" id="<%= ClientID %>_f_<%= f.Key %>_type" name="<%= UniqueID %>$f$<%= f.Key %>$type">
				<option value="" <% if (m.Type == BXSaleOrderFieldMappingType.DirectValue) { %>selected="selected"<% } %> ><%= GetMessage("Type.DirectValue") %></option>
				<option value="user" <% if (m.Type == BXSaleOrderFieldMappingType.UserField) { %>selected="selected"<% } %> ><%= GetMessage("Type.UserField") %></option>
				<option value="user_property" <% if (m.Type == BXSaleOrderFieldMappingType.UserProperty) { %>selected="selected"<% } %> ><%= GetMessage("Type.UserProperty") %></option>
				<option value="order" <% if (m.Type == BXSaleOrderFieldMappingType.OrderField) { %>selected="selected"<% } %> ><%= GetMessage("Type.OrderField") %></option>
				<option value="order_property" <% if (m.Type == BXSaleOrderFieldMappingType.OrderProperty) { %>selected="selected"<% } %> ><%= GetMessage("Type.OrderProperty") %></option>
			</select>
		</td>
		<td>
			<select style="display: <%= m.Type == BXSaleOrderFieldMappingType.DirectValue ? "none" : "block" %>;" id="<%= ClientID %>_f_<%= f.Key %>_value1" name="<%= UniqueID %>$f$<%= f.Key %>$value1" >
			<% 
				IEnumerable<BXSaleOrderMapper> mappers = null;
				if (m.Type == BXSaleOrderFieldMappingType.UserField)
					mappers =  BXSaleOrderMappingManager.UserFieldMappers;
				else if (m.Type == BXSaleOrderFieldMappingType.UserProperty)
					mappers = userPropertiesMappers;
				else if (m.Type == BXSaleOrderFieldMappingType.OrderField)
					mappers = BXSaleOrderMappingManager.OrderFieldMappers;
				else if (m.Type == BXSaleOrderFieldMappingType.OrderProperty) 
					mappers = orderPropertiesMappers;
			%>
				<% if (mappers != null) foreach (var v in mappers) { %>
				<option value="<%= Encode(v.Key) %>" <% if (v.Key == m.Value) { %>selected="selected"<% } %> ><%= Encode(v.Title) %></option>
				<% } %>
			</select>
			<input type="text" size="40" style="display: <%= m.Type != BXSaleOrderFieldMappingType.DirectValue ? "none" : "block" %>;" id="<%= ClientID %>_f_<%= f.Key %>_value2" name="<%= UniqueID %>$f$<%= f.Key %>$value2" <% if (m.Type == BXSaleOrderFieldMappingType.DirectValue) { %>value="<%= Encode(m.Value) %>"<% } %> />			
		</td>
	</tr>
	<% } %>	
</table>