﻿using Bitrix.UI;
using System;
using Bitrix.Sale.Components;
using System.Collections.Generic;
using Bitrix.DataTypes;
using Bitrix.Services;
using Bitrix.Security;
using Bitrix.Sale;
using System.Web;
using System.Web.UI.WebControls;

public partial class bitrix_components_bitrix_sale_order_cancel_templates__default_template : BXComponentTemplate<SaleOrderCancelComponent>
{

	protected void CancelOrderClick(object sender, EventArgs e)
	{
		var errors = new List<string>();
		var cParams = new BXParamsBag<object>();
		cParams.Add("reason", ddlReasons.SelectedValue);
		if (Component.ProcessCommand("CancelOrder", cParams, errors))
		{
			try
			{
				Response.Redirect(Component.OrderListUrl);
			}
			catch { }
		}
		else
		{
			foreach (var err in errors)
				errorMessage.AddErrorMessage(err);
		}
	}

	public string DeleteOrderLinkHtml
	{
		get
		{

			return String.Format(
				"{0}&nbsp;<a href=\"{1}\">{2}</a>",
				GetMessage("Label.ReallyCancelOrder"),
				Component.OrderDetailUrl,
				String.Format(
					GetMessage("Label.Order"),
					Component.OrderId
					)
				);
		}
	}

	protected void Page_Init(object sender, EventArgs e)
	{
		ddlReasons.ValidationGroup = ClientID;
		rqReasons.ValidationGroup = ClientID;
		CancelOrder.ValidationGroup = ClientID;
		rqReasons.ErrorMessage = GetMessage("Error.PleaseSetCancelReason");
	}

	protected void Page_Load(object sender, EventArgs e)
	{
		ddlReasons.Items.Add(new ListItem(GetMessage("Label.SelectReason"), ""));
		foreach (var pair in Component.CancelReasons)
			ddlReasons.Items.Add(new ListItem(pair.Value,pair.Key)); 
	}

	protected void Page_PreRender(object sender, EventArgs e)
	{
		if (Component.Error != SaleOrderCancelComponentError.None)
			errorMessage.AddErrorMessage(Component.GetErrorMessage());
	}
}
