﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="template.ascx.cs" Inherits="bitrix_components_bitrix_sale_order_form_templates__default_template" %>
<%@ Register Src="controls/properties.ascx" TagName="Properties" TagPrefix="bxcomp" %>
<%@ Register Src="controls/delivery.ascx" TagName="Delivery" TagPrefix="bxcomp" %>
<%@ Register Src="controls/payment.ascx" TagName="Payment" TagPrefix="bxcomp" %>
<%@ Reference Control="~/bitrix/components/bitrix/sale.order.form/component.ascx"%>

<bx:BXValidationSummary ID="errorMessage" runat="server" CssClass="errortext" ValidationGroup="" HeaderText="<%$ Loc:Kernel.Error %>" />

<% if (orderIsCreated || Component.ShowSuccessMessage)
   { %>
<div class="note-text">
	<%= Component.SuccessMessageHtml%>
</div>
<%}
   else if (Component.Products.Count >0) 
   { %>
<div class="order-checkout">
<bxcomp:Properties runat="server" ID="Properties" />
<bxcomp:Delivery runat="server" ID="Delivery" />
<bxcomp:Payment runat="server" ID="Payment" />

<div class="order-item">
	<div class="order-title">
		<b class="r2"></b><b class="r1"></b><b class="r0"></b>
		<div class="order-title-inner">
			<span><%=GetMessage("Label.SummaryTitle")%></span>
		</div>
	</div>
	<div class="order-info">

	<table class="cart-items" cellspacing="0">
	<thead>
		<tr>
				<td class="cart-itemname"><%= GetMessage("Label.SummaryItemName")%></td>
				<td class="cart-itemprice"><%= GetMessage("Label.SummaryPrice")%></td>
				<td class="cart-itemprice"><%= GetMessage("Label.SummaryDiscount")%></td>
				<td class="cart-itemquantity"><%= GetMessage("Label.SummaryQuantity")%></td>
		</tr>
	</thead>
	<tbody>
	<%
	   Dictionary<string, decimal> discounts = new Dictionary<string,decimal>();
foreach (var prod in Component.Products)
{
	
		%>
		<tr>
			<td class="cart-itemname"><%=HttpUtility.HtmlEncode(prod.Name)%></td>
			<td class="cart-itemprice"><%=prod.PriceCurrency.MoneyToString(prod.GetTotalCost())%></td>
			<td class="cart-itemdiscount">
			<% if(prod.DiscountValueNationalCurrency >0){ 
				if(!discounts.ContainsKey(prod.DiscountName))
					discounts.Add(prod.DiscountName,0);
				discounts[prod.DiscountName] += Bitrix.Currency.BXCurrency.NationalCurrency.ConvertMoney(prod.DiscountValueNationalCurrency,Component.Currency.Id);
										%>
			<%=prod.PriceCurrency.MoneyToString(Bitrix.Currency.BXCurrency.NationalCurrency.ConvertMoney(prod.DiscountValueNationalCurrency, prod.PriceCurrency.Id))%>
			<%} %>
			</td>
			<td class="cart-itemquantity"><%=prod.QuantityInCart.ToString()%></td>
		</tr>
		<%
}
if (Component.FullOrderDiscount != null)
{
	
	discounts.Add(Component.FullOrderDiscount.Discounts[0].Name, Bitrix.Currency.BXCurrency.ConvertMoney(Component.FullOrderDiscount.Value, Bitrix.Currency.BXCurrency.NationalCurrency, Component.Currency));
}
	%>
	</tbody>
	<tfoot>
	    <tr>
		<td class="cart-itemname"> 
			<p><%= GetMessage("ProductsSum") %>: </p>
			 <% foreach (var key in discounts.Keys){ %>
				<p><%=key %>:</p>
			 <%} %>
			<p><%= GetMessage("DeliverySum") %>: </p>
			<p><b><%= GetMessage("TotalSum") %>: </b></p>
		</td>	
	       
	    <td class="cart-itemprice">
	        <p><%= Component.Currency.MoneyToString(Component.GetTotalCost())%></p> 
	        <% foreach (var value in discounts.Values){ %>
	        <p><%=Component.Currency.MoneyToString(value) %></p>
	        <%} %>    
	        <p><%= Component.Currency.MoneyToString(DeliveryInfo.DeliveryCost)%></p>
	        <p><b><%= Component.Currency.MoneyToString(Component.GetTotalCost() + DeliveryInfo.DeliveryCost - Component.GetTotalDiscount())%></b></p>
	     </td>	
	     <td class="cart-itemquantity">&nbsp;</td>       
	    </tr>	    
	</tfoot>
</table>
</div></div>

<div class="order-item">
	<div class="order-title">
		<b class="r2"></b><b class="r1"></b><b class="r0"></b>
		<div class="order-title-inner">
			<span><%=GetMessage("Label.AdditionalComment")%></span>
		</div>
	</div>
	<div class="order-info">
		<div align="center">
			<asp:TextBox TextMode="MultiLine" runat="server" Rows="7" ID = "CustomerComments" Width="95%"></asp:TextBox>
		</div>
	</div>
</div>
<div class="order-buttons">
	<asp:Button runat="server" ID = "FormOrder" Text="<%$ Loc:Label.FormOrder %>" OnClick = "FormOrderClick" />
</div>
</div>
<%} %>