﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="template.ascx.cs" Inherits="bitrix_components_bitrix_sale_order_list_templates__default_template" %>
<%@ Register Assembly="Main" Namespace="Bitrix.UI" TagPrefix="cc1" %>
<%@ Reference Control="~/bitrix/components/bitrix/sale.order.list/component.ascx"%>
<bx:BXValidationSummary ID="errorMessage" runat="server" CssClass="errortext" ValidationGroup="" HeaderText="<%$ Loc:Kernel.Error %>" />
<% 
	if (Component.Error == Bitrix.Sale.Components.SaleOrderListComponentError.None)
{ %>
<div class="order-list">
	<div class="inline-filter order-filter">
		<label><%=GetMessage("Label.ShowOrders")%>:</label>
		<asp:PlaceHolder ID = "Filter" runat="server"></asp:PlaceHolder>
	</div>
	
			<bx:IncludeComponent runat="server" ID="HeaderPager" ComponentName="bitrix:system.pager" 
		Template="<%$ Parameters:PagingTemplate %>" CurrentPosition="top" CssClassPrefix="order-" />
			<%		
			foreach ( var order in Component.Orders )
			{
				%>
				<div class="order-item">
					<div class="order-title">
						<b class="r2"></b><b class="r1"></b><b class="r0"></b>
						<div class="order-title-inner">
							<span><%=GetMessage("Label.OrderNumber")%><%= order.Order.Id.ToString() %>&nbsp;<%=GetMessage("Label.DateFrom")%>&nbsp;<%=order.Order.Created.ToString("g") %></span>
							<a title="<%= GetMessage("ShowDetail")%>" href="<%=order.DetailUrl %>"><%= GetMessage("ShowDetail")%></a>
						</div>
					</div>
					<div class="order-info">
						<div class="order-details">
							<div class="order-props">
								<p><label><%= GetMessage("Label.OrderSum")%></label>&nbsp;<span><%=Component.Currency.MoneyToString(order.Order.GetConvertedSum(Component.Currency))%></span></p>
								<p><label><%= GetMessage("Label.IsPaid")%></label>&nbsp;<span><%=GetMessage(order.Order.Paid ? "Order.Paid":"Order.NotPaid") %></span></p>
							</div>

							
							<div class="order-items">
								<label><%= GetMessage("Label.OrderContent")%></label>
								<ol>
									<%
									foreach(var item in order.Products)
									{
										%>
										<li>												
											<%
											if (!String.IsNullOrEmpty(item.DetailUrl)){
												%><a href="<%= item.DetailUrl%>">
												<%}%><%=item.Name%>
											<%
											if (!String.IsNullOrEmpty(item.DetailUrl)){
												%>
											</a> 
											<%}%>
										</li>
										<%
									}
									%>
								</ol>

							</div>
						</div>
						
						<div class="order-status-info">
							<% if ( order.Order.Cancelled ){ %>
	
								<div class="order-status-date"><%=order.Order.CancelledDate.ToString("g")%></div>
								<div class="order-status order-status-deny"><%=GetMessage("Order.Cancelled") %></div>
							<%} else {

								%>
								<div class="order-status-date"><%=order.Order.StatusSetDate.ToString("g")%></div>
								<div class="order-status order-status-<%=order.StatusClassName%>"><%=order.LocalizedStatusName%></div>
							<%}%>
						
								
							<div class="order-status-links">
								<%if (!order.Order.Cancelled && !order.Order.Status.IsFinal){	%>
									<a title="<%= GetMessage("Label.CancelOrder") %>" href="<%=order.CancelUrl%>"><%= GetMessage("Label.CancelOrder") %></a>
								<%}%>
								<a title="<%= GetMessage("Label.CopyOrder") %>" href="<%=order.CopyUrl%>"><%=GetMessage("Label.CopyOrder") %></a>
							</div>
						</div>
					</div>		
				</div>
				<%
			}

			if (Component.Orders.Count == 0)
			{
				%><%= GetMessage("Label.NoOrders")%><%
			}
			%>
			
			<bx:IncludeComponent runat="server" ID="IncludeComponent1" ComponentName="bitrix:system.pager" Template="<%$ Parameters:PagingTemplate %>" CurrentPosition="bottom" CssClassPrefix="order-" />
</div>

<%} %>
