﻿using Bitrix.UI;
using System;
using Bitrix.Sale.Components;
using System.Collections.Generic;
using Bitrix.DataTypes;
using Bitrix.Services;
using Bitrix.Security;
using Bitrix.Sale;
using System.Web;
using System.Web.UI.WebControls;

public partial class bitrix_components_bitrix_sale_order_list_templates__default_template : BXComponentTemplate<SaleOrderListComponent>
{
    protected void Page_Init(object sender, EventArgs e)
    {
		var showMode = SaleOrderListComponentMode.Active;

		if (!String.IsNullOrEmpty(Request.QueryString["mode"]) && Enum.IsDefined(typeof(SaleOrderListComponentMode), Request.QueryString["mode"]))
			try
			{
			showMode = ((SaleOrderListComponentMode)Enum.Parse(typeof(SaleOrderListComponentMode), Request.QueryString["mode"])); 
			}
			catch {
				showMode = SaleOrderListComponentMode.Active;
			}

		var curCaption = new Literal();
		
		foreach (Bitrix.Sale.Components.SaleOrderListComponentMode mode in Enum.GetValues(typeof(Bitrix.Sale.Components.SaleOrderListComponentMode)))
		{
			if ( mode == showMode )
			{
				curCaption.Text = String.Format("<b>{0}</b>",GetMessage("Enum."+mode.ToString()));
				Filter.Controls.Add(curCaption);
			}
			else 
			{
				var button = new LinkButton();
				button.Click += SetNewMode;
				button.CommandArgument = mode.ToString();
				button.Text = GetMessage("Enum." + mode.ToString());
				Filter.Controls.Add(button);
			}
		}

		Component.Parameters["mode"] = showMode.ToString();
	}

	protected void Page_PreRender(object sender, EventArgs e)
	{
		if (Component.Error != SaleOrderListComponentError.None)
			errorMessage.AddErrorMessage(Component.GetErrorMessage());
	}

	// редирект на себя get-запросом, уберем параметр постранички page
	protected void SetNewMode(object sender, EventArgs e)
	{
		var btn = sender as LinkButton;
		if (btn == null)
			return;

		SaleOrderListComponentMode newMode = SaleOrderListComponentMode.Active;

		var queryParams = HttpUtility.ParseQueryString(BXSefUrlManager.CurrentUrl.Query);

		var argument = btn.CommandArgument;

		if (!String.IsNullOrEmpty(argument) && Enum.IsDefined(typeof(SaleOrderListComponentMode), argument))
			try
			{
				newMode = ((SaleOrderListComponentMode)Enum.Parse(typeof(SaleOrderListComponentMode), argument));
			}
			catch
			{
				newMode = SaleOrderListComponentMode.Active;
			}
		// если изменился режим вывода, нужно сбросить постраничку
		string newPath = BXSefUrlManager.CurrentUrl.AbsolutePath;
		if ( newMode != Component.Mode )
		{
			if (Component.EnableSef)
			{
				var index = Component.PagingIndexTemplate.IndexOf("?");
				newPath = Component.PagingIndexTemplate;
				if ( index > 0 )
				{
					queryParams = HttpUtility.ParseQueryString(Component.PagingIndexTemplate.Substring(index));
					newPath = Component.PagingIndexTemplate.Substring(0,index);
				}
				else 
				{
					newPath = Component.PagingIndexTemplate;
				}
			}

			string strParam = Component.Parameters["PagingPageTemplate"];
			string key = string.Empty;
			int ind = strParam.IndexOf('?');
			if (ind != -1)
			{
				var oldParams = HttpUtility.ParseQueryString(strParam.Substring(ind + 1, strParam.Length - ind - 1));
				if (oldParams.Count > 0)
				{
					foreach (String name in oldParams.AllKeys)
						if (oldParams[name].Equals("#PageId#", StringComparison.OrdinalIgnoreCase))
							key = name;
				}
			}

			queryParams.Remove(Component.Parameters.GetString("PageVariable","page"));
			queryParams["mode"] = newMode.ToString();
			if (key != string.Empty)
				queryParams.Remove(key);
					
		}

		try 
		{
			Response.Redirect(newPath+"?"+queryParams.ToString());
		}
		catch{}
	}
}
