﻿<%@ Control Language="C#" AutoEventWireup="false" CodeFile="bill.ascx.cs" Inherits="BXBillPaymentController" %>
<%@ Import Namespace="Bitrix.Sale" %>
<html>
<head>
<title>Счет</title>
</head>
<body bgColor="#ffffff">
<p>
    <b>ПОСТАВЩИК:</b>
    <%= SellerName %><br />
    <span>Адрес: </span><%= SellerAddress %><br />
    <span>Телефон: </span><%= SellerPhone %><br />
    <span>ИНН: </span><%= SellerINN %> / <span>КПП: </span><%= SellerKPP %><br />
    <span>Банковские реквизиты: </span><br />
    <%= SellerSettlementAccount %><br />
    <span>к/с </span><%= SellerCorrespondentAccount %><br />
    <span>БИК </span><%= SellerBIC %>
</p>
<p>
    <b>ЗАКАЗЧИК:</b>
    <%= BuyerName %><br />
    <span>ИНН: </span><%= BuyerINN %><br />
    <span>Адрес: </span><%= BuyerAddress %><br />
    <span>Телефон: </span><%= BuyerPhone %><br />
    <span>Факс: </span><%= BuyerFax %><br />
    <span>Контактное лицо: </span><%= BuyerContactPerson %><br />
</p>
<p>
    <span>Платежная система: </span><%= PaymentSystemName %>
</p>
<p>
    <b>СЧЕТ №:</b> <%= OrderId.ToString() %><span> от </span><%= OrderCreationDate %>
</p>
<%if(Products.Count > 0) {%>
<table border="0" cellspacing="0" cellpadding="2" width="100%">
     <tr bgcolor="#E2E2E2">
	    <td align="center" style="border: 1pt solid #000000; border-right:none;">№</td>
	    <td align="center" style="border: 1pt solid #000000; border-right:none;">Предмет счета</td>
	    <td nowrap align="center" style="border: 1pt solid #000000; border-right:none;">Кол-во</td>
	    <td nowrap align="center" style="border: 1pt solid #000000; border-right:none;">Цена, <%= CurrencySymbol %></td>
	    <td nowrap align="center" style="border: 1pt solid #000000;">Сумма, <%= CurrencySymbol %></td>
     </tr> 
    <%for(int i = 0; i < Products.Count; i++) {%>
    <%BXSaleProduct product = Products[i]; %>   
	<tr valign="top">
		<td bgcolor="#ffffff" style="border: 1pt solid #000000; border-right:none; border-top:none;">
		    <%= (i + 1).ToString() %>
		</td>
		<td bgcolor="#ffffff" style="border: 1pt solid #000000; border-right:none; border-top:none;">
		    <%= product.Name %>
		</td>
		<td align="right" bgcolor="#ffffff" style="border: 1pt solid #000000; border-right:none; border-top:none;">
		    <%= product.Quantity.ToString() %>
		</td>
		<td align="right" bgcolor="#ffffff" style="border: 1pt solid #000000; border-right:none; border-top:none;">
			<%= FormatMoney(product.Price) %>
		</td>
		<td align="right" bgcolor="#ffffff" style="border: 1pt solid #000000; border-top:none;">
		    <%= FormatMoney(product.GetTotalCost()) %>
		</td>
	</tr>    
    <%} %>
    <%if(DeliveryCost != 0m) {%>
	<tr>
		<td bgcolor="#ffffff" style="border: 1pt solid #000000; border-right:none; border-top:none;">
			<%= (Products.Count + 1).ToString() %>
		</td>
		<td bgcolor="#ffffff" style="border: 1pt solid #000000; border-right:none; border-top:none;">
		    <span>Доставка </span><%= DeliveryVariantDescription %>
		</td>
		<td valign="top" align="right" bgcolor="#ffffff" style="border: 1pt solid #000000; border-right:none; border-top:none;">
		    <span>1</span>
		</td>
		<td align="right" bgcolor="#ffffff" style="border: 1pt solid #000000; border-right:none; border-top:none;">
		    <%= FormatMoney(DeliveryCost) %>
		</td>
		<td align="right" bgcolor="#ffffff" style="border: 1pt solid #000000; border-top:none;">
		    <%= FormatMoney(DeliveryCost) %>
		</td>
	</tr>
	<%} %>    
	<tr>
		<td align="right" bgcolor="#ffffff" colspan="4" style="border: 1pt solid #000000; border-right:none; border-top:none;">
		    <span>Итого: </span>
		</td>
		<td align="right" bgcolor="#ffffff" style="border: 1pt solid #000000; border-top:none;">
		    <%= FormatMoney(OrderTotal) %>
		</td>
	</tr>
	<%if(VATSum > 0m) {%>
	<tr>
		<td align="right" bgcolor="#ffffff" colspan="4" style="border: 1pt solid #000000; border-right:none; border-top:none;">
		    <span>В том числе НДС: </span>
		</td>
		<td align="right" bgcolor="#ffffff" style="border: 1pt solid #000000; border-top:none;">
		    <%= FormatMoney(VATSum) %>
		</td>
	</tr>	
	<%} %>
</table>
<%} %>
<p>
    <b>Итого к оплате: </b>
    <%= string.Concat(FormatMoney(OrderTotal), " ", CurrencySymbol) %>
</p>
<div align="right" style="padding-right:30px;"><%= OrderCreationDate %></div>
<%if(!string.IsNullOrEmpty(PathToStamp)) {%>
<div>
    <img alt="Печать магазина" align="right" src="<%= PathToStamp %>" />
</div>
<%} %>
<p>
<font size="2">В случае непоступления средств на расчетный счет продавца в течение пяти
банковских дней со дня выписки счета, продавец оставляет за собой право
пересмотреть отпускную цену товара в рублях пропорционально изменению курса доллара
и выставить счет на доплату.
<br />
<br />
В платежном поручении обязательно указать - "Оплата по счету № <%= OrderId.ToString() %> от <%= OrderCreationDate %>".
<br />
<br />
Получение товара только после прихода денег на расчетный счет компании.
</font>
</p>

<p>&nbsp;</p>

</body>
</html>