﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Bitrix.Sale;
using Bitrix.UI;

public partial class BXStubPaymentController : BXControl, IBXSalePaymentController
{
    #region IBXSalePaymentController Members
    public string DisplayName
    {
        get { return BXSaleModule.GetMessage("StubPaymentController.DisplayName", false); }
    }

    private BXSaleOrder order = null;
    private BXSalePaymentSystemConfig conf = null;
    private BXSalePaymentControllerSettings settings = null;
    public void InitializeData(BXSaleOrder order, BXSalePaymentSystemConfig conf)
    {
        this.order = order;
        this.conf = conf;
        if(conf != null)
            this.settings = conf.ControllerSettings;
    }
    #endregion

    public string PaymentSystemName
    {
        get { return this.conf != null ? this.conf.Name : string.Empty; }
    }

    public string ErroMessage
    {
        get 
        {
            string msg = string.Empty;
            if(this.order == null)
                msg = GetMessageRaw("OrderNotFound");
            else if(this.conf == null)
                msg = GetMessageRaw("NotAvailable");
            else 
                msg = string.Format(GetMessageRaw("UnableToLoad"), this.conf.Name);

            return HttpUtility.HtmlEncode(msg);
        }
    }
}
