﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Bitrix.Sale;
using System.Globalization;
using Bitrix.Currency;
using Bitrix.Services;
using System.Collections.Specialized;
using System.IO;
using System.Text;

namespace Bitrix.Sale
{
	public partial class BXYandexMoneyPaymentController : UserControl, IBXSalePaymentController
	{
		protected BXSaleOrder order;
		protected BXSalePaymentSystemConfig conf;
		protected BXSalePaymentControllerSettings settings;

		public int OrderId
		{
			get { return 0; }
		}
		internal enum ControllerRenderingMode
		{
			Frame = 1,
			Form = 2
		}

		private ControllerRenderingMode renderingMode = ControllerRenderingMode.Frame;
		internal ControllerRenderingMode RenderingMode
		{
			get { return this.renderingMode; }
		}

		public string GetStrParam(string name)
		{
			return GetStrParam(name, "");
		}

		public string GetStrParam(string name, string defaultValue)
		{
			if (this.settings == null)
				return defaultValue;

			return this.settings.GetString(name, defaultValue);
		}

		public string GetFormRenderingUrl()
		{
			Uri url = BXSefUrlManager.CurrentUrl;
			NameValueCollection qsParams = HttpUtility.ParseQueryString(url.Query);
			qsParams["yandexMoneyPayForm"] = "Y";
			return HttpUtility.HtmlAttributeEncode(string.Concat(url.AbsolutePath, "?", qsParams.ToString()));
		}

		public override void RenderControl(HtmlTextWriter writer)
		{
			if (this.renderingMode == ControllerRenderingMode.Frame)
			{
				base.RenderControl(writer);
				return;
			}

			Response.ContentEncoding = Encoding.GetEncoding("Windows-1251");
			Response.Charset = "windows-1251";
			writer.Flush();
			Response.Clear();
			base.RenderControl(writer);
			Response.End();
		}

		#region IBXSalePaymentController Members

		public string DisplayName
		{
			get { return "1213123123"; }
		}

		public void InitializeData(BXSaleOrder order, BXSalePaymentSystemConfig conf)
		{
			if (order == null)
				throw new ArgumentNullException("order");

			this.order = order;
			this.conf = conf;
			if (conf != null)
			{
				this.settings = conf.ControllerSettings;
				this.settings.Order = order;
			}
			this.renderingMode = string.Equals(Request.QueryString["yandexMoneyPayForm"], "Y", StringComparison.OrdinalIgnoreCase) ? ControllerRenderingMode.Form : ControllerRenderingMode.Frame;
		}

		#endregion
	}
}
