﻿if(typeof(Bitrix) == "undefined"){ var Bitrix = new Object(); }
Bitrix.AssistPaymentControllerEditor = function Bitrix$AssistPaymentControllerEditor() {	
	this._container = this._anchor = this._settings = null;
	this._customerTypeId = 0;
}
Bitrix.TypeUtility.copyPrototype(Bitrix.AssistPaymentControllerEditor, Bitrix.PaymentControllerEditor);
Bitrix.AssistPaymentControllerEditor.prototype.initialize = function(customerTypeId, settings, container, anchor) {
	this._customerTypeId = customerTypeId;
	this._settings = settings;
	this._container = container;
	this._anchor = anchor;
}
Bitrix.AssistPaymentControllerEditor.prototype.getCustomerTypeId = function() { return this._customerTypeId; }
Bitrix.AssistPaymentControllerEditor.prototype.getContainer = function() { return this._container; }
Bitrix.AssistPaymentControllerEditor.prototype.getAnchor = function() { return this._anchor; }
Bitrix.AssistPaymentControllerEditor.prototype.getSettings = function() { return this._settings; }
Bitrix.AssistPaymentControllerEditor.prototype.getControllerTypeId = function() { return "Bitrix.Sale.Assist"; }
Bitrix.AssistPaymentControllerEditor.prototype.getParameters = function() {
	var ary = [];
	ary.push(Bitrix.PaymentControllerParameter.create("shopIdp", "Код магазина", "Код магазина, который получен от Assist.ru"));
	ary.push(Bitrix.PaymentControllerParameter.create("login", "Логин", "Логин, который получен от Assist.ru"));
	ary.push(Bitrix.PaymentControllerParameter.create("password", "Пароль", "Пароль, который получен от Assist.ru"));	
	ary.push(Bitrix.PaymentControllerParameter.create("sum", "Сумма к оплате", ""));	
	ary.push(Bitrix.PaymentControllerParameter.create("currency", "Валюта оплаты", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("orderId", "Номер заказа", "Номер заказа в вашем Интернет-магазине"));
	ary.push(Bitrix.PaymentControllerParameter.create("created", "Дата создания заказа", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("successUrl", "Адрес при успешной оплате", "URL скрипта (на веб-сайте продавца) обрабатывающего оповещения о результате платежа"));
	ary.push(Bitrix.PaymentControllerParameter.create("failUrl", "Адрес при ошибке оплаты", "URL (на веб-сайте продавца) для перенаправления плательщика при неуспешном платеже"));
	ary.push(Bitrix.PaymentControllerParameter.create("firstName", "Имя покупателя", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("middleName", "Отчество покупателя", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("lastName", "Фамилия покупателя", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("email", "E-mail покупателя", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("address", "Адрес покупателя", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("phone", "Телефон покупателя", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("cardPayment", "Использовать авторизационные страницы ASSIST для авторизации", "1 - использовать, 0 - не использовать"));
	ary.push(Bitrix.PaymentControllerParameter.create("webMoneyPayment", "Использовать платежную систему WebMoney Transfer", "1 - использовать, 0 - не использовать"));
	ary.push(Bitrix.PaymentControllerParameter.create("rapidaPayment", "Использовать платежную систему Rapida", "1 - использовать, 0 - не использовать"));
	ary.push(Bitrix.PaymentControllerParameter.create("ePortPayment", "Использовать платежную систему E-Port", "1 - использовать, 0 - не использовать"));
	ary.push(Bitrix.PaymentControllerParameter.create("kreditPilotPayment", "Использовать платежную систему KreditPilot", "1 - использовать, 0 - не использовать"));
	ary.push(Bitrix.PaymentControllerParameter.create("payCashPayment", "Использовать платежную систему PayCash", "1 - использовать, 0 - не использовать"));
	ary.push(Bitrix.PaymentControllerParameter.create("assistIDCCPayment", "Использовать оплату кредитной картой с использованием Assist®ID", "1 - использовать, 0 - не использовать"));
	ary.push(Bitrix.PaymentControllerParameter.create("epBeelinePayment", "Использовать мобильный кошелек Билайн", "1 - использовать, 0 - не использовать"));
	ary.push(Bitrix.PaymentControllerParameter.create("demoResult", "Работа в тестовом режиме", "Когда магазин находится в тестовом режиме, авторизации в Платежный Центр не поступают, а сервер ASSIST ожидает от магазина передачи обязательного параметра DemoResult, в котором содержится желаемый результат платежа (Response_Code), который и генерируется в ответе покупателю."));
	
	return ary;
}

Bitrix.AssistPaymentControllerEditor.create = function(customerTypeId, settings, container, anchor) {
	var self = new Bitrix.AssistPaymentControllerEditor();
	self.initialize(customerTypeId, settings, container, anchor);
	return self;
}
