﻿if(typeof(Bitrix) == "undefined"){ var Bitrix = new Object(); }
Bitrix.EmsDeliveryServiceConfigEditor = function() {
	this._config = this._urlInput = this._enableIntPostageInput = this._cargoTypeInput = this._insuranceRateInput = null;
	
}
Bitrix.EmsDeliveryServiceConfigEditor.prototype = {
    initialize: function(config) {
        this._config = config;
    },
    getParamCount: function() { return 4; },
    getParamTitle: function(index) {
        switch (index) {
            case 0: return this.getMsg("ServiceUrl.Label");
			case 1: return this.getMsg("EnableIntPostage.Label");
			case 2: return this.getMsg("CargoType.Label");
			case 3: return this.getMsg("InsuranceRate.Label");
        }
        return null;
    },
    constructParamHint: function(index, container) {
		var str = null;
        switch (index) {
            case 0: {
				str = this.getMsg("ServiceUrl.Hint");
				break;
			}
			case 1: {
				str = this.getMsg("EnableIntPostage.Hint");
				break;				
			}
			case 2: {
				str = this.getMsg("CargoType.Hint");
				break;				
			}			
			case 3: {
				str = this.getMsg("InsuranceRate.Hint");
				break;				
			}			
        }
		if(!str) return;
		var sp = document.createElement("SPAN");
		sp.appendChild(document.createTextNode(" "));
		sp.appendChild((new BXHint(str)).oIcon);				
		container.appendChild(sp);		
    },	
    constructParamControls: function(index, container) {
		var cfg = this._config;
        switch (index) {
            case 0:
                {
                    var input = this._urlInput = document.createElement("INPUT");
                    input.type = "text";
                    if ("serviceUrl" in cfg) input.value = cfg.serviceUrl;
                    container.appendChild(input);				
                }
                break;
            case 1:
                {
                    var input = this._enableIntPostageInput = document.createElement("INPUT");
					input.type = "checkbox";
					container.appendChild(input);
                    if ("enableIntPostage" in cfg) input.checked = cfg.enableIntPostage;
                }
                break;			
            case 2:
                {
                    var input = this._cargoTypeInput = document.createElement("SELECT");
                    if ("cargoTypeOptions" in cfg) {
						var opts = [];
                        for(var key in cfg.cargoTypeOptions) {
							var cargoType = cfg.cargoTypeOptions[key];
							opts.push( { 'text': cargoType.title, 'value': cargoType.value } );
						}
						Bitrix.DomHelper.addToSelect(input, opts);
						if("cargoType" in cfg)
							Bitrix.DomHelper.selectOption(input, cfg.cargoType);
                    }				
					container.appendChild(input);
                }
                break;
            case 3:
                {
                    var input = this._insuranceRateInput = document.createElement("INPUT");
                    input.type = "text";
                    if ("insuranceRate" in cfg) input.value = cfg.insuranceRate;
                    container.appendChild(input);	
                }
                break;					
        }
    },
    getConfigJson: function() {
        var r = "";
        var input = this._urlInput;
        if (input != null && Bitrix.TypeUtility.isNotEmptyString(input.value)) 
			r += "\"serviceUrl\":\"" + input.value + "\"";
		input = this._enableIntPostageInput;
        if (input != null) { 
			if(r.length > 0) r += ", "
			r += "\"enableIntPostage\":" + input.checked.toString();		
		}
		input = this._cargoTypeInput;
		if(input != null && Bitrix.TypeUtility.isNotEmptyString(input.value)) {
			if(r.length > 0) r += ", "
			r += "\"cargoType\":\"" + input.value + "\"";					
		}
		input = this._insuranceRateInput;
		if(input != null) {
			if(r.length > 0) r += ", "
			r += "\"insuranceRate\":\"" + (Bitrix.TypeUtility.isNotEmptyString(input.value) ? input.value : "0") + "\"";
		}
		
        return r.length > 0 ? "{" + r + "}" : "";
    },
    getMsg: function(key) {
        var c = window.SALE_EMS_DELIVERY_SERVICE_CFG_ED_MSG;
        return typeof (c) != "undefined" && key in c ? c[key] : key;
    }
}

Bitrix.EmsDeliveryServiceConfigEditor.create = function(config) {
	var self = new Bitrix.EmsDeliveryServiceConfigEditor();
	self.initialize(config);
	return self;
}