﻿if(typeof(Bitrix) == "undefined"){ var Bitrix = new Object(); }
Bitrix.RussianPostDeliveryServiceConfigEditor = function() {
	this._config = this._urlInput = this._postingTypeInput = this._deliveryTypeInput = null;
	
}
Bitrix.RussianPostDeliveryServiceConfigEditor.prototype = {
    initialize: function(config) {
        this._config = config;
    },
    getParamCount: function() { return 3; },
    getParamTitle: function(index) {
        switch (index) {
            case 0: return this.getMsg("ServiceUrl.Label");
			case 1: return this.getMsg("PostingType.Label");
			case 2: return this.getMsg("DeliveryType.Label");
        }
        return null;
    },
    constructParamHint: function(index, container) {
		var str = null;
        switch (index) {
            case 0: {
				str = this.getMsg("ServiceUrl.Hint");
				break;
			}
			case 1: {
				str = this.getMsg("PostingType.Hint");
				break;
			}
			case 2: {
				str = this.getMsg("DeliveryType.Hint");
				break;
			}
        }
		if(!str) return;
		var sp = document.createElement("SPAN");
		sp.appendChild(document.createTextNode(" "));
		sp.appendChild((new BXHint(str)).oIcon);				
		container.appendChild(sp);		
    },	
    constructParamControls: function(index, container) {
		var cfg = this._config;
        switch (index) {
            case 0:
                {
                    var input = this._urlInput = document.createElement("INPUT");
                    input.type = "text";
                    if ("serviceUrl" in cfg) input.value = cfg.serviceUrl;
                    container.appendChild(input);				
                }
                break;
            case 1:
                {
                    var input = this._postingTypeInput = document.createElement("SELECT");
                    if ("postingTypeOptions" in cfg) {
						var opts = [];
                        for(var key in cfg.postingTypeOptions) {
							var postingType = cfg.postingTypeOptions[key];
							opts.push( { 'text': postingType.title, 'value': postingType.value } );
						}
						Bitrix.DomHelper.addToSelect(input, opts);
						if("postingType" in cfg)
							Bitrix.DomHelper.selectOption(input, cfg.postingType);
                    }
					container.appendChild(input);
                }
                break;
            case 2:
                {
                    var input = this._deliveryTypeInput = document.createElement("SELECT");
					input.multiple = true;
                    if ("deliveryTypeOptions" in cfg) {
						var opts = [];
                        for(var key in cfg.deliveryTypeOptions) {
							var deliveryType = cfg.deliveryTypeOptions[key];
							opts.push( { 'text': deliveryType.title, 'value': deliveryType.value } );
						}
						Bitrix.DomHelper.addToSelect(input, opts);
						if("deliveryType" in cfg)
							Bitrix.DomHelper.selectOption(input, cfg.deliveryType);
						else if("deliveryTypes" in cfg) 
							Bitrix.DomHelper.selectOptions(input, cfg.deliveryTypes);							
                    }
					container.appendChild(input);
                }
                break;				
        }
    },
    getConfigJson: function() {
        var r = "";
        var input = this._urlInput;
        if (input != null && Bitrix.TypeUtility.isNotEmptyString(input.value)) 
			r += "\"serviceUrl\":\"" + input.value + "\"";
		input = this._postingTypeInput;
        if (input != null && Bitrix.TypeUtility.isNotEmptyString(input.value)) { 
			if(r.length > 0) r += ", "
			r += "\"postingType\":\"" + input.value + "\"";		
		}
		input = this._deliveryTypeInput;
        if (input != null && Bitrix.TypeUtility.isNotEmptyString(input.value)) {
			var v = "";
			for(var i = 0; i < input.options.length; i++) {
				var o = input.options[i];
				if(!o.selected) continue;
				if(v.length > 0) v += ",";
				v += o.value;
			}
			if(r.length > 0) r += ", "
			r += "\"deliveryTypes\":[" + v + "]";
		}
        return r.length > 0 ? "{" + r + "}" : "";
    },
    getMsg: function(key) {
        var c = window.SALE_RUSSIAN_POST_DELIVERY_SERVICE_CFG_ED_MSG;
        return typeof (c) != "undefined" && key in c ? c[key] : key;
    }
}

Bitrix.RussianPostDeliveryServiceConfigEditor.create = function(config) {
	var self = new Bitrix.RussianPostDeliveryServiceConfigEditor();
	self.initialize(config);
	return self;
}