﻿if(typeof(Bitrix) == "undefined"){ var Bitrix = new Object(); }
Bitrix.BillPaymentControllerEditor = function Bitrix$BillPaymentControllerEditor() {	
	this._container = this._anchor = this._settings = null;
	this._customerTypeId = 0;
}
Bitrix.TypeUtility.copyPrototype(Bitrix.BillPaymentControllerEditor, Bitrix.PaymentControllerEditor);
Bitrix.BillPaymentControllerEditor.prototype.initialize = function(customerTypeId, settings, container, anchor) {
	this._customerTypeId = customerTypeId;
	this._settings = settings;
	this._container = container;
	this._anchor = anchor;
}
Bitrix.BillPaymentControllerEditor.prototype.getCustomerTypeId = function() { return this._customerTypeId; }
Bitrix.BillPaymentControllerEditor.prototype.getContainer = function() { return this._container; }
Bitrix.BillPaymentControllerEditor.prototype.getAnchor = function() { return this._anchor; }
Bitrix.BillPaymentControllerEditor.prototype.getSettings = function() { return this._settings; }
Bitrix.BillPaymentControllerEditor.prototype.getControllerTypeId = function() { return "Bitrix.Sale.Bill"; }
Bitrix.BillPaymentControllerEditor.prototype.getParameters = function() {
	var ary = [];
	ary.push(Bitrix.PaymentControllerParameter.create("orderCreationDate", "Дата заказа", "Дата оформления заказа"));
	ary.push(Bitrix.PaymentControllerParameter.create("sellerName", "Название компании-поставщика", "Название компании-поставщика (продавца)"));
	ary.push(Bitrix.PaymentControllerParameter.create("sellerAddress", "Адрес компании-поставщика", "Адрес компании-поставщика (продавца)"));
	ary.push(Bitrix.PaymentControllerParameter.create("sellerPhone", "Телефон компании-поставщика", "Телефон компании-поставщика (продавца)"));
	ary.push(Bitrix.PaymentControllerParameter.create("sellerInn", "ИНН компании-поставщика", "ИНН компании-поставщика (продавца)"));	
	ary.push(Bitrix.PaymentControllerParameter.create("sellerKpp", "КПП компании-поставщика", "КПП компании-поставщика (продавца)"));
	ary.push(Bitrix.PaymentControllerParameter.create("sellerSettlementAccount", "Расчетный счет компании-поставщика", "Расчетный счет компании-поставщика (продавца) с указанием банка и города"));	
	ary.push(Bitrix.PaymentControllerParameter.create("sellerCorrespondentAccount", "Корреспондентский счет компании-поставщика", "Корреспондентский счет компании-поставщика (продавца)"));
	ary.push(Bitrix.PaymentControllerParameter.create("sellerBic", "БИК компании-поставщика", "БИК компании-поставщика (продавца)"));
	ary.push(Bitrix.PaymentControllerParameter.create("buyerName", "Название компании-заказчика", "Название компании-заказчика (покупателя)"));	
	ary.push(Bitrix.PaymentControllerParameter.create("buyerInn", "ИНН компании-заказчика", "ИНН компании-заказчика (покупателя)"));	
	ary.push(Bitrix.PaymentControllerParameter.create("buyerAddress", "Адрес компании-заказчика", "Адрес компании-заказчика (покупателя)"));
	ary.push(Bitrix.PaymentControllerParameter.create("buyerPhone", "Телефон компании-заказчика", "Телефон компании-заказчика (покупателя)"));	
	ary.push(Bitrix.PaymentControllerParameter.create("buyerFax", "Факс компании-заказчика", "Факс компании-заказчика (покупателя)"));	
	ary.push(Bitrix.PaymentControllerParameter.create("buyerContactPerson", "Контактное лицо компании-заказчика", "Контактное лицо компании-заказчика (покупателя)"));	
	ary.push(Bitrix.PaymentControllerParameter.create("pathToStamp", "Печать", "Путь к изображению печати поставщика на сайте"));
	return ary;
}

Bitrix.BillPaymentControllerEditor.create = function(customerTypeId, settings, container, anchor) {
	var self = new Bitrix.BillPaymentControllerEditor();
	self.initialize(customerTypeId, settings, container, anchor);
	return self;
}
