﻿if(typeof(Bitrix) == "undefined"){ var Bitrix = new Object(); }
Bitrix.PaymentControllerParameter = function() {	
	this.id = this.name = this.descr = "";
}

Bitrix.PaymentControllerParameter.prototype = {
	initialize: function(id, name, descr) {
		this.id = id;
		this.name = name;
		this.descr = descr;
	}
}

Bitrix.PaymentControllerParameter.create = function(id, name, descr) {
	var self = new Bitrix.PaymentControllerParameter();
	self.initialize(id, name, descr);
	return self;
}

Bitrix.PaymentControllerParameterEditor = function() {	
	this._parameter = this._settings = this._container = this._wrapper = this._typeSel = this._input = this._userFieldSel = this._orderFieldSel = this._orderPropSel = null;
	this._mode = "";
	this._customerTypeId = 0;
}

Bitrix.PaymentControllerParameterEditor.prototype = {
	initialize: function(parameter, settings, customerTypeId, container) {
		this._parameter = parameter; 
		this._settings = settings;
		this._customerTypeId = customerTypeId;
		this._container = container;
	},
	layout: function(startIndex) {
		if(!startIndex) startIndex = -1;
		var p = this._parameter;
		var c = this._container;
		if(!p || !c) return 0;
		var r = this._wrapper = c.insertRow(startIndex);
		var cTtl = r.insertCell(-1);
		cTtl.className = "field-name";
		cTtl.setAttribute("width", "40%");
		var lbl = document.createElement("LABEL");
		cTtl.appendChild(lbl);
		lbl.innerHTML = p.name + ":"; 
		
		if(Bitrix.TypeUtility.isNotEmptyString(p.descr)) {
			cTtl.appendChild(document.createElement("BR"));
			var sml = document.createElement("SMALL");
			sml.innerHTML = p.descr;
			cTtl.appendChild(sml);
		}
		
		var cType = r.insertCell(-1);
		var typeSel = this._typeSel = document.createElement("SELECT");
		typeSel.style.width = "200px";
		
		cType.appendChild(typeSel);
		var typeValueAry = 
		[
			{ "value":"", "text":this.getMsg("UserValue.PresetsTitle") }, 
			{ "value":"U", "text":Bitrix.UserFieldPresets.getTitle() },
			{ "value":"O", "text":Bitrix.OrderFieldPresets.getTitle() },
		];
		
		if(this._customerTypeId > 0 && typeof(Bitrix.SaleOrderField) != "undefined")
			typeValueAry.push({ "value":"P", "text":this.getMsg("OrderProperty.PresetsTitle") });
		
		Bitrix.DomHelper.addToSelect(typeSel, typeValueAry);
		Bitrix.EventUtility.addEventListener(typeSel, "change", Bitrix.TypeUtility.createDelegate(this, this._handleTypeChange));
		
		var cData = r.insertCell(-1);
		cData.setAttribute("width", "90%");
		var input = this._input = document.createElement("INPUT");
		input.type = "text";
		cData.appendChild(input);
		input.style.width = "200px";
		
		var userFieldSel = this._userFieldSel = document.createElement("SELECT");
		cData.appendChild(userFieldSel);		
		userFieldSel.style.width = "200px";
		var userFieldAry = [];
		for(var k in Bitrix.UserFieldPresets.all) {
			var item = Bitrix.UserFieldPresets.all[k]
			userFieldAry.push({"value":item.getId().toString(), "text":item.getTitle()});
		}
		Bitrix.DomHelper.addToSelect(userFieldSel, userFieldAry);
		
		var orderFieldSel = this._orderFieldSel = document.createElement("SELECT");
		orderFieldSel.style.width = "200px";
		cData.appendChild(orderFieldSel);		
		var orderFieldAry = [];
		for(var k in Bitrix.OrderFieldPresets.all) {
			var item = Bitrix.OrderFieldPresets.all[k]
			orderFieldAry.push({"value":item.getId().toString(), "text":item.getTitle()});
		}
		Bitrix.DomHelper.addToSelect(orderFieldSel, orderFieldAry);	

		if(this._customerTypeId > 0 && typeof(Bitrix.SaleOrderField) != "undefined") {		
			var orderPropSel = this._orderPropSel = document.createElement("SELECT");
			orderPropSel.style.width = "200px";
			cData.appendChild(orderPropSel);		
			var orderPropAry = [];
			for(var k in Bitrix.SaleOrderField[this._customerTypeId]) {
				var item = Bitrix.SaleOrderField[this._customerTypeId][k]
				orderPropAry.push({"value":item.code, "text":item.name});
			}
			Bitrix.DomHelper.addToSelect(orderPropSel, orderPropAry);			
		}
		
		var mode = "", value = "";
		if(this._settings && this._settings.params) {
			var id = this._parameter.id.toUpperCase();
			var pars = this._settings.params;
			for(var s in pars) {
				if(s.toUpperCase() != id) continue;
				var par = pars[s];
				var parts = par.split(":");
				if(parts.length > 1) {
					mode = parts[0];
					value = parts[1];
				}
				else 
					value = parts[0];
				break;
			}
		}
		Bitrix.DomHelper.selectOption(typeSel, mode.toUpperCase());
		this._switchInput(mode, value);
		return 1;
	},
	free: function() {
		if(this._container && this._wrapper)
			this._container.deleteRow(this._wrapper.rowIndex);
	},
	setVisible: function(visible) {
		if(this._wrapper) this._wrapper.style.display = visible ? "" : "none";
	},
	_switchInput: function(mode, val) {
		this._mode = mode = mode ? mode.toUpperCase() : "";
		if(mode == "U") {
			this._input.style.display = "none"; 
			this._orderFieldSel.style.display = "none";
			if(this._orderPropSel) this._orderPropSel.style.display = "none";
			this._userFieldSel.style.display = "";
			if(val) Bitrix.DomHelper.selectOption(this._userFieldSel, val, true);
		}
		else if(mode == "O") {
			this._input.style.display = "none"; 
			this._orderFieldSel.style.display = "";
			this._userFieldSel.style.display = "none";
			if(this._orderPropSel) this._orderPropSel.style.display = "none";
			if(val) Bitrix.DomHelper.selectOption(this._orderFieldSel, val, true);
		}
		else if(mode == "P") {
			this._input.style.display = "none"; 
			this._orderFieldSel.style.display = "none";
			this._userFieldSel.style.display = "none";
			if(this._orderPropSel) this._orderPropSel.style.display = "";
			if(val) Bitrix.DomHelper.selectOption(this._orderPropSel, val, true);
		}			
		else {
			this._input.style.display = ""; 
			this._orderFieldSel.style.display = "none";
			this._userFieldSel.style.display = "none";	
			if(this._orderPropSel) this._orderPropSel.style.display = "none";
			if(val) this._input.value = val;
		}		
	},
	_handleTypeChange: function(){
		if(!this._typeSel) return;
		this._switchInput(this._typeSel.value, null);
	},
	getParameter: function(){ return this._parameter; },
	getValue: function() {
		if(this._mode == "U")
			return "U:" + this._userFieldSel.value;
		else if(this._mode == "O")
			return "O:" + this._orderFieldSel.value;
		else if(this._mode == "P")
			return "P:" + this._orderPropSel.value;			
		return this._input.value;
	},
	getMsg: function(key) {
	    var c = window.SALE_PAYMENT_CONTROLLER_ED_MSG;
	    return typeof(c) != "undefined" && key in c ? c[key] : key; 
	}	
}

Bitrix.PaymentControllerParameterEditor.create = function(parameter, settings, customerTypeId, container) {
	var self = new Bitrix.PaymentControllerParameterEditor();
	self.initialize(parameter, settings, customerTypeId, container);
	return self;
}

Bitrix.PaymentControllerEditor = function() {	
	this._editors = null;
}

Bitrix.PaymentControllerEditor.prototype = {
	getCustomerTypeId: function() { return 0; },
	getContainer: function() { return null; },
	getAnchor: function() { return null; },
	getSettings: function() { return {}; },
	getControllerTypeId: function() { return ""; },
	getParameters: function() { return []; },
	layout: function() {
		var startIndex = this.getAnchor() ? this.getAnchor().rowIndex : -1;
		this._editors = [];
		var paramAry = this.getParameters();
		for(var i = 0; i < paramAry.length; i++) {
			var ed = Bitrix.PaymentControllerParameterEditor.create(paramAry[i], this.getSettings(), this.getCustomerTypeId(), this.getContainer());
			var count = ed.layout(startIndex);
			if(startIndex > 0) startIndex += count;
			this._editors.push(ed);
		}
	},
	free: function() {
		if(!this._editors) return;
		for(var i = 0; i < this._editors.length; i++)
			this._editors[i].free();
	},
	setVisible: function(visible) {
		if(!this._editors) return;
		for(var i = 0; i < this._editors.length; i++)
			this._editors[i].setVisible(visible);
	},
	toJson: function() {
		var r = "";
		for(var i = 0; i < this._editors.length; i++) {
			if(i > 0) r += ",";
			r += "\"" + this._editors[i].getParameter().id + "\":\"" + Bitrix.HttpUtility.jsonEncode(this._editors[i].getValue()) + "\"";
		}
		return "{\"params\":{" + r + "}}";
	}
}

Bitrix.PaymentControllerParamPreset = function Bitrix$PaymentControllerParamPreset() {
	this._id =  this._ttlPrefix = "";
}
Bitrix.PaymentControllerParamPreset.prototype = {
	initialize: function(id, ttlPrefix) {
		this._id = id;
		this._ttlPrefix = ttlPrefix ? ttlPrefix : "";
	},
	getId: function() { return this._id; },
	getTitle: function() {
		var key = this._ttlPrefix + this._id;
	    var c = window.SALE_PAYMENT_CONTROLLER_ED_MSG;
	    return typeof(c) != "undefined" && key in c ? c[key] : key; 
	}
}
Bitrix.PaymentControllerParamPreset.create = function(id, ttlPrefix) {
	var self = new Bitrix.PaymentControllerParamPreset();
	self.initialize(id, ttlPrefix);
	return self;
}

Bitrix.UserFieldPresets = {}	
Bitrix.UserFieldPresets.all = {
	"Id": 			Bitrix.PaymentControllerParamPreset.create("Id", "UserField."),
	"UserName": 	Bitrix.PaymentControllerParamPreset.create("UserName", "UserField."),
	"FirstName": 	Bitrix.PaymentControllerParamPreset.create("FirstName", "UserField."),
	"SecondName": 	Bitrix.PaymentControllerParamPreset.create("SecondName", "UserField."),
	"LastName": 	Bitrix.PaymentControllerParamPreset.create("LastName", "UserField."),
	"Email": 		Bitrix.PaymentControllerParamPreset.create("Email", "UserField."),
	"SiteId": 		Bitrix.PaymentControllerParamPreset.create("SiteId", "UserField."),
	"Gender": 		Bitrix.PaymentControllerParamPreset.create("Gender", "UserField.")
}
Bitrix.UserFieldPresets.getTitle = function() {
	key = "UserField.PresetsTitle";
	var c = window.SALE_PAYMENT_CONTROLLER_ED_MSG;
	return typeof(c) != "undefined" && key in c ? c[key] : key; 	
}
Bitrix.OrderFieldPresets = {}	
Bitrix.OrderFieldPresets.all = {
	"Id": 				Bitrix.PaymentControllerParamPreset.create("Id", "OrderField."),
	"Created": 			Bitrix.PaymentControllerParamPreset.create("Created", "OrderField."),
	"Sum": 				Bitrix.PaymentControllerParamPreset.create("Sum", "OrderField."),
	"CurrencyId":		Bitrix.PaymentControllerParamPreset.create("CurrencyId", "OrderField."),
	"SiteId": 			Bitrix.PaymentControllerParamPreset.create("SiteId", "OrderField."),
	"DeliveryCost": 	Bitrix.PaymentControllerParamPreset.create("DeliveryCost", "OrderField."),
	"DeliveryVariant": 	Bitrix.PaymentControllerParamPreset.create("DeliveryVariant", "OrderField."),
	"PaymentSystemId": 	Bitrix.PaymentControllerParamPreset.create("PaymentSystemId", "OrderField."),
	"UserId": 			Bitrix.PaymentControllerParamPreset.create("UserId", "OrderField.")
}
Bitrix.OrderFieldPresets.getTitle = function() {
	key = "OrderField.PresetsTitle";
	var c = window.SALE_PAYMENT_CONTROLLER_ED_MSG;
	return typeof(c) != "undefined" && key in c ? c[key] : key; 	
}
