﻿if(typeof(Bitrix) == "undefined"){ var Bitrix = new Object(); }
Bitrix.SberbankPaymentControllerEditor = function Bitrix$SberbankPaymentControllerEditor() {	
	this._container = this._settings = this._anchor = null;
	this._customerTypeId = 0;
}
Bitrix.TypeUtility.copyPrototype(Bitrix.SberbankPaymentControllerEditor, Bitrix.PaymentControllerEditor);
Bitrix.SberbankPaymentControllerEditor.prototype.initialize = function(customerTypeId, settings, container, anchor) {
	this._customerTypeId = customerTypeId;
	this._settings = settings;
	this._container = container;
	this._anchor = anchor;
}
Bitrix.SberbankPaymentControllerEditor.prototype.getCustomerTypeId = function() { return this._customerTypeId; }
Bitrix.SberbankPaymentControllerEditor.prototype.getContainer = function() { return this._container; }
Bitrix.SberbankPaymentControllerEditor.prototype.getAnchor = function() { return this._anchor; }
Bitrix.SberbankPaymentControllerEditor.prototype.getSettings = function() { return this._settings; }
Bitrix.SberbankPaymentControllerEditor.prototype.getControllerTypeId = function() { return "Bitrix.Sale.Sberbank"; }
Bitrix.SberbankPaymentControllerEditor.prototype.getParameters = function() {
	var ary = [];
	ary.push(Bitrix.PaymentControllerParameter.create("companyName", "Наименование получателя платежа", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("inn", "ИНН получателя платежа", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("kpp", "КПП получателя платежа", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("settlementAccount", "Номер счета получателя платежа", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("bankName", "Наименование банка", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("bic", "Банковские реквизиты", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("correspondentAccount", "Номер кор./сч. банка получателя платежа", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("orderId", "Номер заказа", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("orderCreationDate", "Дата создания заказа", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("customerFullName", "Ф.И.О. плательщика", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("customerPostalCode", "Почтовый индекс плательщика", ""));
	//ary.push(Bitrix.PaymentControllerParameter.create("customerCountryCode", "Страна плательщика", ""));
	//ary.push(Bitrix.PaymentControllerParameter.create("customerCity", "Город плательщика", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("customerAddress", "Адрес плательщика", ""));
	ary.push(Bitrix.PaymentControllerParameter.create("sum", "Сумма к оплате", ""));
	
	return ary;
}

Bitrix.SberbankPaymentControllerEditor.create = function(customerTypeId, settings, container, anchor) {
	var self = new Bitrix.SberbankPaymentControllerEditor();
	self.initialize(customerTypeId, settings, container, anchor);
	return self;
}
