﻿<%@ Page Language="C#" MasterPageFile="~/bitrix/admin/AdminMasterPage.master" AutoEventWireup="true" CodeFile="SecurityFilter.aspx.cs" Inherits="bitrix_admin_SecurityFilter" Title="<%$ LocRaw:PageTitle %>" ValidateRequest="false" %>

<%@ Register Src="~/bitrix/admin/controls/Main/AdminImageField.ascx" TagName="AdminImageField" TagPrefix="uc2" %>
<%@ Register Src="~/bitrix/controls/Main/TimeInterval.ascx" TagName="TimeInterval" TagPrefix="ti" %>
<%@ Register Src="~/bitrix/controls/Main/CustomFieldList.ascx" TagName="CustomFieldList" TagPrefix="uc1" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" Runat="Server">
			<bx:BXTabControl ID="BXTabControl1" runat="server" OnCommand="BXTabControl1_Command" ValidationGroup="ElementEdit">
				<bx:BXTabControlTab ID="BXTabControlTab1" runat="server" Selected="True" Text="<%$ LocRaw:TabText.Main %>" Title="<%$ LocRaw:TabTitle.Main %>">
					<table id="Table4" border="0" cellpadding="0" cellspacing="0" class="edit-table">
					    <tr valign="top">
							<td id="Td1" width="60%" >
								<span style="color:<%= (IsSecurityEnabled ? "green":"red" )%>"><b>
								<%= IsSecurityEnabled ? GetMessage("MessageText.SecurityEnabled") : GetMessage("MessageText.SecurityDisabled") %></b></span>
							</td>
						</tr>
						<% if (IsExclusionsSet && IsSecurityEnabled)
                        { %>
						<tr valign="top">
							<td id="Td3" width="60%" >
								<span style="color:red"><b>
								<%= GetMessage("MessageText.ExclusionsAreSet")%></b></span>
							</td>
						</tr>
						<%} %>
						 <tr valign="top" id="tr2" >
							<td id="Td2" width="60%">&nbsp;</td>
						</tr>
						<tr valign="top">
							<td width="60%" runat="server">
								<asp:Button ID="btnSecurity" runat="server" OnCommand="ManageSecurity_Command"></asp:Button>
							</td>
						</tr>
					
					</table>
					<br />
					<bx:BXAdminNote ID="BXAdminNote1" runat="server"><%= GetMessageRaw("Note.Security") %></bx:BXAdminNote>
				</bx:BXTabControlTab>
				<bx:BXTabControlTab ID="BXTabControlTab2" runat="server" Text="<%$ LocRaw:TabText.Reaction %>" Title="<%$ LocRaw:TabTitle.Reaction %>">
					<table id="Table5" border="0" cellpadding="0" cellspacing="0" class="edit-table">

						<tr valign="top">
						    <td align="right">
						    <%=GetMessage("Label.Reaction") %>
						    </td>
							<td>
								<asp:RadioButtonList ID="rblSettings" runat="server" RepeatDirection="Vertical">
									<asp:ListItem value="safe" Text="<%$ Loc:RadioButtonText.MakeDataSafe %>" />
									<asp:ListItem value="clear"  Text="<%$Loc:RadioButtonText.ClearDangerousData %>" />
									<asp:ListItem value="leave"  Text="<%$Loc:RadioButtonText.LeaveDangerousData %>" />
								</asp:RadioButtonList>		
							</td>
						</tr>
						<tr>
						<td>&nbsp;</td>
						<td>
							<% cbLogAttacks.Checked = Bitrix.Security.BXSecurityModuleConfiguration.LogAttacks; %>
							<asp:CheckBox runat="server" ID="cbLogAttacks" Text="<%$ LocRaw: CheckBoxText.LogAttacks %>" />
						</td>
						</tr>
					</table>
					<bx:BXAdminNote runat="server" ID="BXAdminNote2">
						<span id="filter_remark_1" class="required" style="vertical-align: super;">1</span>
						<%= GetMessageRaw("Note.FilterRemark1") %>
					</bx:BXAdminNote>
				</bx:BXTabControlTab>
				<bx:BXTabControlTab ID="BXTabControlTab3" runat="server" Text="<%$ LocRaw:TabText.Exclusions %>" Title="<%$ LocRaw:TabTitle.Exclusions %>">
					<table id="Table6" border="0" cellpadding="0" cellspacing="0" class="edit-table">
						<tr valign="top">
							<td class="field-name" width="25%"><%= GetMessageRaw("Label.ExclusionMasks") %></td>
						    <td width="75%">
						    <table id="Table1" border="0" cellpadding="0" cellspacing="0" style="width: 100%" >
								<% int i = 0; %>
								<% 
								    foreach (Bitrix.Security.BXSecurityFilterMask rInfo in Masks) 
           { %>
								<tr>
									<td style="white-space:nowrap">
										<input type="hidden" id="hf_<%= i %>" name="hfregexid" value="<%=rInfo.Id %>" />
										<input type="text" value="<%= rInfo.Mask %>" name="txtmask" id="tbExclusionMask_<%=i %>" size="45" />
									<%= GetMessage("Label.ForSite") %>
									<select id="ddSites_<%= i %>" name="selsite">
						                <option value="" ><%= GetMessage("Option.All") %></option>
						                <% foreach (Bitrix.BXSite site in Sites) { %>
                                        <option <%= (site.Id == rInfo.SiteId ? "selected":String.Empty) %> value="<%= Encode(site.Id) %>"><%= Encode(site.Name) %></option>
                                        <% } %>
 									</select>
							        </td>
							    </tr>
							    <% i++; %>
								<% } %>
							</table>
							</td>
						</tr>
					</table>
					<input type="button" id="btnAddExclusion" onclick="CloneTableRow('Table1')" value ="<%= GetMessage("Label.ButtonAddExclusion") %>" />
				</bx:BXTabControlTab>

			</bx:BXTabControl>
</asp:Content>
